#include <AL/al.h>
#include <AL/alc.h>
#include <AL/alut.h>
#include <SDL/SDL_audio.h>

#define NUM_SOUNDS 32  // ÷̵  
#define NUM_WAVES 512  //  ε ̺ 

int  SDL_audio=0;

struct sample {
	int active;
	ALuint	source;
	Object	*object;
	float position[3];
	float direction[3];
	float speed;
} sounds[NUM_SOUNDS];

// εǾ ̺
struct waves {
	char 	name[64];
	ALuint 	al_name;
	Uint32 	loaded;
} waves[NUM_WAVES];
int wave_n=0;

ALfloat zeroes[] = { 0.0f, 0.0f,  0.0f };

//int player_sound_n=0;

// player ϶ ȣѴ. 
void set_listener()
{
	ALfloat orient[]  = { 0.0f, 0.0f, -1.0f, 0.0f, 1.0f, 0.0f };

	orient[0]=Camera->view_direction[0];
	orient[1]=Camera->view_direction[1];
	orient[2]=Camera->view_direction[2];

//	GetSourcei( uint sourceName , SOURCE_STATE , T * values );

	alListenerfv(AL_VELOCITY, zeroes );
	alListenerfv(AL_ORIENTATION, orient );
	alListenerfv(AL_POSITION, Camera->center );  
}

void do_Sound()
{
	int i;
	int full;
	ALint	state;
	Object *obj;

	if(arg_server) return;
	set_listener();

	full=0;

	// terminate  sounds which play over.
	for ( i= 0 ; i< NUM_SOUNDS ; i++)
	{
		if(sounds[i].active==1) 
		{
			if(alIsSource(sounds[i].source)==0)
			{
				printf("wrong al_source!!\n");
				continue;
			}
			state=AL_INITIAL;
			alGetSourcei(sounds[i].source, AL_SOURCE_STATE,&state);
//			if(state==AL_PLAYING)
			if(state==AL_PLAYING || state == AL_PAUSED)
			{
				//full++;
				continue;
			}
			else
			{	

		
				alDeleteSources(1,&sounds[i].source);
				sounds[i].active=0; 
			}
		}
	}


///	if(1) return;
	/// if(NUM_SOUNDS==full) DEBUGB("full sounds\n");
	
	//sound obj move to new position
	for ( i= 0 ; i< NUM_SOUNDS ; i++)
	{
		if(sounds[i].active==1) 
		{
			alGetSourcei(sounds[i].source, AL_SOURCE_STATE,&state);
			if(state==AL_PLAYING || state ==AL_PAUSED)
			{
				obj=sounds[i].object;
				alSourcefv(sounds[i].source , AL_POSITION, obj->center );
			}
		}
	}

}


void Object_soundPlay_base(Object *obj,int id,float amp,int loop)
{
	
	ALuint multis;
	ALint	state;
	float	dist,roll;
	float	velocity[3];
	int	i;


	
	if(arg_server) return;
	if(id<0) return;
///	if(waves[id].al_name>60000) ERROR("sound...d.d.d.d");
//	void GetFloatv ( enum paramName , float * dest );
//	alGetFloatv ( AL_REFERENCE_DISTANCE, &dist);
//	alGetFloatv ( AL_ROLLOFF_FACTOR, &roll);
//	printf(" AL_REFERENCE_DISTANCE=%f  AL_ROLLOFF_FACTOR=%f \n",dist,roll);

	//󽽷ã 
	for ( i= 0 ; i< NUM_SOUNDS ; i++)
		if(sounds[i].active==0) break;
	
	if(i>=NUM_SOUNDS) { DEBUGB("sounds full!!"); return; }

	sounds[i].active=1; 

	alGenSources(1, &(sounds[i].source) );

	alSourcefv(sounds[i].source , AL_POSITION, obj->center );
	alSourcef (sounds[i].source , AL_REFERENCE_DISTANCE, 200.0  );
	
	if(loop) alSourcei (sounds[i].source , AL_LOOPING, AL_TRUE);
	else alSourcei (sounds[i].source , AL_LOOPING, AL_FALSE);


	alSourcei (sounds[i].source , AL_BUFFER, waves[id].al_name ); // *******
    alSourcef (sounds[i].source , AL_GAIN,   amp  );
	//alSourcef (Source, AL_PITCH,    1.0f     );

//	vectorCopy(velocity,obj->move_direction);
//	vectorScale(velocity,obj->move_speed);
	alSourcefv(sounds[i].source , AL_VELOCITY, zeroes   );
	sounds[i].object=obj;

	alSourcePlay(sounds[i].source);
}

void Object_soundPlay(Object *obj,int id)
{
	Object_soundPlay_base(obj,id,1.0,0);
}

void Object_soundPlay2(Object *obj,int id,int loop)
{
	Object_soundPlay_base(obj,id,1.0,loop);
}


void Object_soundPlayLoop(Object *obj,int id)
{
	Object_soundPlay_base(obj,id,1.0,1);
}

//return: sound index
int LoadWave2(char *file)
{
	int index;
	SDL_AudioSpec wave_spec;
	Uint8 *data;
	Uint32 dlen;
	Uint16 format;	
  	ALuint bname;
	
	if(arg_server) return 0;
	/* ִ ̺ ã´. */
	for ( index=0; index< NUM_WAVES ; index++) 
		if(  waves[index].loaded == 0 ) break;

	if ( index >= NUM_WAVES )
		ERROR("need more waves data struct!!");


	/*   εϿ 22kHz 16-bit ׷ ȯѴ. */
	if ( SDL_LoadWAV(get_pahtname(file), &wave_spec, &data, &dlen) == NULL ) 
		ERROR("Couldn't load %s: %s\n");

	if(wave_spec.channels==2) ERROR(" stero wave 1!!");

	switch(wave_spec.format)
	{
		case AUDIO_U8: //Unsigned 8-bit samples
		case AUDIO_S8:	//Signed 8-bit samples
			format=AL_FORMAT_MONO8;
		//	ERROR(" 8-bit wave");
			break;
		case AUDIO_U16:
		//case AUDIO_U16LSB: //Unsigned 16-bit little-endian samples
			
		case AUDIO_S16 :
		//case AUDIO_S16LSB://Signed 16-bit little-endian samples

		case AUDIO_U16MSB:  // Unsigned 16-bit big-endian samples
			
		case AUDIO_S16MSB: // Signed 16-bit big-endian samples
		//case AUDIO_U16SYS: // Either AUDIO_U16LSB or AUDIO_U16MSB depending on you systems endianness
		//case AUDIO_S16SYS: // Either AUDIO_S16LSB or AUDIO_S16MSB depending on you systems endianness		
			ERROR(" 16-bit wave");
			break;

		default:
			ERROR(" what foramt ???");
	}

	alGenBuffers( 1, &bname );
	// AL_FORMAT_MONO8, AL_FORMAT_MONO16, AL_FORMAT_STEREO8, AL_FORMAT_STEREO16
	alBufferData(bname,format,data,dlen,wave_spec.freq);

//	printf(" filename =%s   al_name=%d \n",file,bname);

	waves[index].al_name=bname;
	waves[index].loaded=1; 
    	wave_n++;
	
	SDL_FreeWAV(data);

	OKARG("[%s]",file);
	return index;
}


static ALCcontext *context_id=NULL;
ALCdevice *dev=NULL;

void Init_Audio()
{
	int i;

	for ( i= 0 ; i< NUM_WAVES ; i++)
	{	
		waves[i].loaded=0;
		waves[i].al_name=900000;
	}


	for ( i= 0 ; i< NUM_SOUNDS ; i++)
	{
		sounds[i].active=0;
	}


	dev = alcOpenDevice( NULL );
	if( dev == NULL ) 
		ERROR(" you need Sound Device !!! \n "
			" OSS , ALSA, sound need ...\n"
				
			);

	/* Initialize ALUT. */
	context_id = alcCreateContext( dev, NULL);
	if(context_id == NULL) {
		alcCloseDevice( dev );
		ERROR("error");
	}
	alcMakeContextCurrent( context_id ); //̰ǹ 
	OK();
}



void CloseAudio()
{
	int i;
	
	if(dev!=NULL){
		alcCloseDevice( dev );
		alcDestroyContext(context_id);
	}

}


