
//#include "libSIMD/single/simds.h"


#ifdef WIN32
	#define CTIME " "
	#define NOGDI
#endif 


#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include <SDL/SDL_net.h>
#include <GL/glu.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#ifndef true
#define true 1
#endif /* true */
#ifndef false
#define false 0
#endif /* false */


#ifndef _DEFINE_
#define _DEFINE_

//#define EPSILON 0.1
#define EPSILON 0.00001
#define EPSILON_MAP 0.001 // ******

#define UNIT	100   // 1 meter ?
#define METER	40


//del #define ID_OBJECT	0

#ifdef _MSC_VER
	#define inline
	#define START_PACK_STRUCTS 		pack(push, 1)
	#define END_PACK_STRUCTS     	pack(pop)
	#define PACK_STRUCT
#else 
	#define START_PACK_STRUCTS 	
	#define END_PACK_STRUCTS     	
	#define PACK_STRUCT 		__attribute__((packed))
#endif

# define M_PI		3.14159265358979323846	/* pi */
# define M_PI_2		1.57079632679489661923	/* pi/2 */
# define M_PI_4		0.78539816339744830962	/* pi/4 */

#define RADIAN(x) 	( (float )(M_PI/180.0) * x)
#define DEGREE(x) 	( (float )(180.0 /M_PI )* x)



#define WIRE_MODE 		0
#define POLYGON_MODE 		1
#define TEXTURE_MODE 		2

#define FALSE 0
#define TRUE  1


// Vertex Ÿ  uvؽ  ִ. 
typedef struct {
    float x,y,z;
    float u,v;
} Vertex;


typedef struct {
    float x,y,z;
} Position;



#define  Vector Vertex

typedef float vector; 
//float[3] vector;


typedef struct {
    int x,y;
} Point;


typedef struct {
    float x,y;
} Position2D;


#define texture_name texture_id

                                                                                    
typedef struct                                                                                            
{                                                                                                         
    Vector          normal;
    Vector          origin;
    Vector          onPoint;
} Line;
                                                                                   
typedef struct                                                                                            
{                                                                                                         
    vector          normal[3];
    vector          onPoint[3];
} line;


        
                                                                                       
typedef struct                                                                                            
{                                                                                                         
    Vector          normal;                                                                               
    Vector          origin;
    Vector          onPoint;
    float           distance;
    //planetypes      type;                                                                                 
} Plane;


#include "rax.h"



typedef struct sCell 
{
    int 	uid;

    int		level;

    unsigned long	FrameID;
    unsigned long	Hidden;
    int 	triangle_n;
    int 	hasToDraw;
   
    GLuint	calllist;
    Shape	*shape;
    int	    	position;
    float	distance;
    float	distanceFromCamera;
   
    float 	cx,cy,cz;

    Vector 	Center;
    float 	center[3]; // x,y,z
    float 	conner[8][3];

    float 	min_x,min_y,min_z,max_x,max_y,max_z;
    float 	radius;

    struct sCell  *parent;
    struct sCell  *child[16];

    int		dynamic_item_n;
    Shape	*dynamic_item[256]; 

} Cell; 


typedef struct {
	Vector vertex[8];
	Vector Max,Min;
	float  max_y;
	float  min_y;
	float  radius;
}  Bound;



typedef struct {
	Shape 	*shape;
	int	nextKey;
	Uint32	Time;
	Uint32	leftTime;
	int 	which; // loadedani ߿  shape n ° ִϸ̼ ϳ 
	int 	action; // ȣ 

	int	state;
	int	IE; //Interrupt Enable
	int  	testBit;
	void 	(*CallFunc)();
// ܺ joint[64]  ?
// ϸ̼ Ư Ѱ ƯshapeؼǱ⶧  
}  Animation;   


typedef struct Gun_s {
	Uint32 	time_trigger;
	int	bullets;
	int  	clip_n;
	int 	sound;
} Gun;


typedef struct Light_s {
	
	int 	id;
	int	active;
	int	spec; //

	char 	name[64];

	
//===========  Object Base ====================
	int	CellsInWOMB_n;
	Cell 	*CellsInWOMB[64];
	
	Shape 	*shape;
	
	int 	lifetime;
	int 	weight;
	float 	speed;	// m/s^2 
	int 	is_gravity;
	
	float 	move_speed;	// m/s^2 
	vector 	move_direction[4];
	
	vector 	center[4];
	vector 	position[4];
	vector 	direction[4];

	float	radius;
	float 	centerOLD[3];	

	float	relativeAlt; // 
	float	relativeHeight;
	float 	bottom[3];

	// pitch == x axis rotation
	// heading == y axis rotation 
	// roll  == z axis rotation
	float 	pitch,heading,roll;
	float 	view_pitch,view_heading,view_roll;

	float 	view_rotate[4]; // view_rotate[0]=pitch    ?
	vector	view_position[4];
	vector	view_direction[4];

	void 	(*WorkFunc)();
	void	(*InputFunc)();
	void	(*DrawFunc)();

    	Vertex	vertex[1024];  //  will be dynamic !! 
    	float	falling_speed;

} Light;
	
typedef struct Object_s {

	int 	id;
	int	active;
	int	spec; //
	char 	name[64];

//===========  Object Base ====================
	int	CellsInWOMB_n;
	Cell 	*CellsInWOMB[128];

	Shape 	*shape;			// ִϸ̼Ǿ model ϳ ???
	Shape 	*shape_arm;		// ƯѰ ؾ 

	int	isStatic; 		// ºor  not used 
	int 	lifetime;
	int 	weight;
	float 	speed;			// m/s^2 
	int 	is_gravity; 		// used :  DealObject(),
	
	float 	move_speed;		// m/s^2 
	vector 	move_direction[4];	// ̴¹
	
	
	vector 	center[4];		// body ġ (羲)
	vector 	position[4];		// body ġ ???
	vector 	up[4];			// body up *****

	// pitch  : x axis rotation
	// heading: y axis rotation 
	// roll   : z axis rotation
	// glRotate ұ ?
//	vector 	pitch,heading,roll;	// body ȸ 
	vector  rotate[4];		// body ȸ player_commonWork()
	vector 	direction[4];		// body  from rotate[4]
    	vector	translate[4];		// body ġ
	vector 	direction_draw[4];		// body   draw_Ҷ 

					
	vector 	view_rotate[4]; 	// view_rotate[0]=pitch  
	vector	view_position[4];	// local ? world ?
	vector	view_direction[4];
	vector  view_up[4];

   	float	view_matrix[4][4];	//DEL 



	float	radius; 		//bound_sphere_radius;	
	float	effective_radius; 	//for Cell
	float  	leg;			//üʿ => ٴڿ obj->center 
	float 	centerOLD[3];	

	float	relativeAlt; 		//  : ߹ٴں   
	float	relativeHeight; 	//ʿ.
	float 	bottom[3];


	void 	(*WorkFunc)();
	void	(*InputFunc)();
	void	(*DrawFunc)();

	Joint		joint[128];  	//  
    	Vertex		vertex[1024];  	// ӽ , will be dynamic !! 

	float		falling_speed;


	//============= BOY ==================
	
	int		net;	// ??? flagΰ ?
	int 		uid; 	// Ʈũ ̵ƴ !

	int		life_power;
	int		defence_power;

	Uint16		hited;
	int		hited_not_proved;  // *********
	int		hited_joint;
	int		hited_by_weapon;
	int		hited_by_uid;
	void		*hited_to_obj;

	int		bullet_n;
	int		clip_n;

	float 		bottom_normal[3];

	int		action;		// for other style body 
	int		action_upper;  // for human style body 
	int		action_lower;

	float 		side_move_speed;	// m/s^2 
	vector 		side_move_direction[4];
	
	Key 		frame[128];  //׳ static , .. 20byte *128 =

	// Object  ִϸ̼ ¼ 
	Animation 	animation;
	Animation 	animation_upper;
	Animation 	animation_lower;
	Animation 	ani_arm;


	void * 		think;
	Uint32		weapon;
	
	Uint16		action_test;

	// ================ test ================
	Uint32	flag;
	
	void 	*sock;
	void 	*Data;
	float	matrix[4][4];
	Vector 	V1; //DEL


	float 	v1[3];

	float	laser_distance;
//del
	Uint32	think_time;
	int	ai_action;
	Uint16	action_old;

	int 	net_flag;
//	int 	udp_send_flag;
	int 	udp_recv_flag;
	int 	shot;
	Uint32 	trigger_pressed_time;
	Uint32 	packet_time;
    //    ObjectList *list;
    //    
} Object; // New_Object();


typedef struct s_think {
	Object  *obj;
	Object  *target_object;
	Uint32 	shot_time;
	Uint32 	time1,time2,time3;
	Uint32  expired;
	
	float 	speed; 
	int	action; //del 
	int 	state;
	float   v1[3],v2[3],v3[3],normal[3];
	float   moveto[3];
} Think;


#define MAX_OBJECTS 128

#define OBJECT_MAN	320
#define OBJECT_GUN	321
#define OBJECT_LIGHT	322

#define OBJECT_LOCAL	0x00000001
#define OBJECT_REMOTE	0x00000002
#define OBJECT_NET	0x00000004
#define OBJECT_ALPHA	0x00000008  //??


void close_program();


#ifdef _MSC_VER
void ERROR(char *fmt,...);
void DEBUG(char *fmt,...);
void DEBUGB(char *fmt,...);
void OKARG(char *fmt,...);

#define OK()  			printf("")
#define START() 	 	printf("")

#else
void error(char *func,char *fmt,...);
#define OKARG(format,...)  	printok((char *)__FUNCTION__,format,##__VA_ARGS__)
#define OK()  			printok((char *)__FUNCTION__," ")
#define START() 	 	printstart((char *)__FUNCTION__," ")
//if get errors ,then exit program.
#define ERROR(format,...)  	error		((char *)__FUNCTION__,format,##__VA_ARGS__)
#define DEBUG(format,...)  	printDEBUG	((char *)__FUNCTION__,format,##__VA_ARGS__)
#define DEBUGB(format,...)  	printDEBUGB	((char *)__FUNCTION__,format,##__VA_ARGS__)


#endif 

#define CHECK_OBJ(obj)		if(obj==NULL) ERROR("Object NULL"); 


// ===========  main.c ==============
Object* new_net_player(char *name);
void Animation_JointTransform(Animation *ani,Joint *joints);
int Shape_VertexTransform(Shape *shape,Joint *joints,Vertex *vertex);
void Animation_JointSynthesis2(Animation *ani,Joint *joints,int j1,int j2,Key *);
void player_restart(Object *obj);

void FLAG_SET(Uint32 *flag,Uint32 val);
void FLAG_RESET(Uint32 *flag,Uint32 val);
int  FLAG_CHECK(Uint32 flag,Uint32 val);
#define IS_FLAG FLAG_CHECK
#define SET_FLAG FLAG_SET
#define RESET_FLAG FLAG_RESET

// ====================================

#define CHECK_OPENGL_ERROR( cmd )  cmd;\
{ GLenum error;  while ( (error = glGetError()) != GL_NO_ERROR) {  printf( "[%s:%d]  %s  failed with error %s\n", __FILE__,  __LINE__, #cmd, gluErrorString(error) );  }}

#endif
