#include "define.h"
#include "core.h"
#include "draw.h"
#include "load.h"
#include "math.h"
#include  <stdarg.h>

Triangle *zbuffer_triangle[1024*32];
int 	zbuffer_triangle_n=0;


int cursor_x=0,cursor_y=0,cursor_indent_x=0;

void SetCursorXY(int x,int y)
{
    cursor_x=x,cursor_y=y;
}

void SetCursorIndent(int x)
{
    cursor_x=cursor_indent_x=x;
}

// impossible ? should use GL ?
void Draw_Pixmap(int x, int y )
{
	//glRasterPos2i(ww,0);
//	glDrawPixels(100,500,GL_RGB,GL_UNSIGNED_BYTE,gimp_image.pixel_data);
}

void (*PanelFunc[16])();
int PanelFunc_n=0;
Panel *PanelList[64];
int Panel_n=0;
int PanelX,PanelY,PanelWidth,PanelHeight;

Panel *panelZbuffer=NULL;
Panel *panelDEBUG=NULL;
Panel *panelHelp=NULL;
Panel *panelInfo=NULL;
Panel *panelRadar=NULL;
Panel *panelScreen=NULL;
Panel *CurrentPanel=NULL;
Panel *panelNumMenu=NULL;
Panel *panelDebugLine=NULL;
Panel *panelConsole=NULL;
Panel *panel_ServerInfo=NULL;


Panel *New_Panel(int x,int y,int width,int height,void (*Do))
{
    Panel *p;
    p=xmalloc(sizeof(Panel));
    p->x=x;
    p->y=y;
    p->Width=width;
    p->Height=height;
    p->show=0;
    p->Do=Do;

    PanelList[Panel_n]=p;
    Panel_n++;
    return p;
}


Panel *StackPanel[8];
int StackPanelLevel=0;

void Panel_Current( Panel *p )
{

	CurrentPanel=p;
	PanelX=p->x;
	PanelY=p->y;
	PanelHeight= p->Height;
	PanelWidth = p->Width;

	cursor_x=cursor_indent_x=2,cursor_y=0;

	glViewport(PanelX,ScreenHeight - PanelY - PanelHeight, PanelWidth, PanelHeight);
	glScissor(PanelX,ScreenHeight - PanelY - PanelHeight, PanelWidth, PanelHeight);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glOrtho(0, PanelWidth, 0, PanelHeight, -50.0, 50.0);  
	//glTranslatef(0,ScreenHeight - PanelY -PanelHeight,0); 

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();    
}	                                                                                          
  /*                                                                                              
struct _GdkGLContextPrivate {                                                                   
  Display    *xdisplay;                                                                         
  GLXContext glxcontext;                                                                        
  guint ref_count;                                                                              
};                                                                                     

//nt glmakecurrent(GdkDrawable *drawable, GdkGLContext *context)                          
//{                                                                                               
 // GdkGLContextPrivate *private = (GdkGLContextPrivate*)context;                                 
//  glxcontext = glXCreateContext(dpy, vi, ((GdkGLContextPrivate*)sharelist)->glxcontext, direct
                                                                                                
//  return (glXMakeCurrent(private->xdisplay, GDK_WINDOW_XWINDOW(drawable), private->glxcontext) =
//} */                      
    

void PushPanel()
{
    if(StackPanelLevel==7) printf("warning...!! StakPanel : top!!\n");
    else{
	StackPanel[StackPanelLevel]=CurrentPanel;
	StackPanelLevel++;
    }
//    glPushMatrix(); 
}


void PopPanel()
{
    if(StackPanelLevel==0) {
	DEBUGB("warning...!! StakPanel : Top No pop!!\n");
	return;
    }
    StackPanelLevel--; 
    Panel_Current(StackPanel[StackPanelLevel]);
  //  glPopMatrix();
}


void Panel_Close(Panel *p){    p->show=0; }
void Panel_Hide(Panel *p){    p->show=0; }
void Panel_Open(Panel *p){     p->show=1; }

void Panel_Show(Panel *p){ 	if(p==NULL) return;    p->show=~p->show; }
void Panel_Toggle(Panel *p){ 	if(p==NULL) return;    p->show^=1; }

	
void Panel_Insert(void *func)
{
    Panel_n++;
}


Panel_Draw()
{
    int i;

    for(i=0 ;i<Panel_n;i++){
	    if(PanelList[i]==NULL)
	    {
		    ERROR("pane==NULL");
 	    }
	    if(PanelList[i]->show==0)continue; 
	    if(PanelList[i]->Do==NULL)continue; 
	
	    PushPanel();
	    Panel_Current(PanelList[i]);
	    //CurrentPanel->Do();
	    PanelList[i]->Do();
	    PopPanel();
    }
}



int *sliding_x;
int *sliding_y;
int sliding_ex;
int sliding_ey;

#define slots sliding_slots
struct {

    float fx,fy,fz;
    int state;
    int ix,iy;
    int *pX,*pY;
    int ex,ey;
    Panel *panel;
    Object *object;
    int deltaX,deltaY;

    float fAccountX,fAccountY;
} slots[64];


#define SLIDING_MOVING	2
#define SLIDING_DONE	3
#define SLIDING_NONE	0
#define SLIDING_READY	5
#define SLIDING_RETURN  6
#define SLIDING_START	7



int Sliding_N=0;

int New_Sliding_X(int x1,int x2,int *pX)
{
   return New_Sliding_Position2D(x1,x2,0,0,pX,NULL);
}


// x1  x2  ̵Ѵ. 
int New_Sliding_Position1D(int x1,int x2,int *px)
{
    sliding_slots[Sliding_N].pX=px;
    sliding_slots[Sliding_N].ix=x1;
    sliding_slots[Sliding_N].ex=x2;

    
    slots[Sliding_N].deltaX=slots[Sliding_N].ex - slots[Sliding_N].ix;
    slots[Sliding_N].fAccountX=0;
    Sliding_N++;
    return Sliding_N-1;
}



int New_Sliding_Y(int y1,int y2,int *pY)
{
    return New_Sliding_Position2D(0,0,y1,y2,NULL,pY);
}


int New_Sliding_Position2D(int x1,int x2,int y1,int y2,int *px,int *py)
{
}


New_Sliding_Panel(int x1,int x2,int *px)
{

	//    sliding_x=x1;
  //  sliding_y=y1;
//    sliding[sliding_window_n].
}


int Sliding_State(int key)
{
    
}

Sliding_Start(int key)
{
    slots[key].state=1;
}


Sliding_Return(int key)
{

    int i;
    slots[key].state=1;
//    slots[key].state=SLIDING_RETURN;
    i=slots[key].ix;
    slots[key].ix = slots[key].ex;
    slots[key].ex = i;
    slots[key].deltaX = slots[key].ex - slots[key].ix;
    slots[key].fAccountX=0;

}


Sliding_Insert2D(int *x1,int *y1,int x2,int y2)
{
//    New
    sliding_x=x1;
    sliding_y=y1;

    sliding_ex=x2;
    sliding_ey=y2;


}


Sliding_Insert3D(int *x1,int *y1,int x2,int y2)
{
    sliding_x=x1;
    sliding_y=y1;

    sliding_ex=x2;
    sliding_ey=y2;

}


#define SPEED 50
Sliding_Core()
{
    int i,tx;
    int *px;

    
#define Account  slots[i].fAccountX
    for(i=0 ; i< Sliding_N; i++){
	
	if(slots[i].state==SLIDING_DONE ) continue;
	px= slots[i].pX;

	   if( slots[i].deltaX >0 ){
		*px+=(int)Account;
		Account+=SPEED * fDeltaTime;
		if(*px > slots[i].ex) slots[i].state=SLIDING_DONE,*px=slots[i].ex;
	    }

	    else{ 
		*px+=(int)Account;
		Account-=SPEED * fDeltaTime;
//		printf("count(%d)account = %f \n ",count++,Account);
		if(*px < slots[i].ex) slots[i].state=SLIDING_DONE,*px=slots[i].ex;
	    }

#undef  Account 	    
    }

}

#undef slots

inline ColorRGB(char r,char g,char b){ glColor3ub(r,g,b); }


inline Color(int c)
{
	switch(c)
	{
		case WHITE  :
			glColor3ub(255,255,255);
			break;
		case RED  :
			glColor3ub(255,0,0);
			break;
		case BLUE :
			glColor3ub(0,0,255);
			break;
		case GREEN :
			glColor3ub(0,255,0);
			break;
		case LIGHTGREEN  :
			glColor3ub(120,255,120);
			break;
		default :
			break;
	}    	
}


void DrawPoint(int x,int y) //  ׸ 
{
	glBegin( GL_POINTS );
	glVertex2f( x, y );
	glEnd();
}

DrawPoint3D(int x,int y,int z) //  ׸ 
{
	glBegin( GL_POINTS );
	glVertex3f( x, y,z );
	glEnd();
}


void DrawLine(int x1,int y1,int x2,int y2)
{
	glBegin( GL_LINES );
	glVertex2f( x1, PanelHeight - y1 );
	glVertex2f( x2, PanelHeight - y2 );
	glEnd();
}



void DrawRectLineGL(int x1,int y1,int width,int height)
{
	glBegin( GL_LINE_LOOP );
	glVertex2f( x1,  y1 );
	glVertex2f( x1+width,  y1 );
	glVertex2f( x1+width,  y1 + height );
	glVertex2f( x1, y1+ height );
	glEnd();
}

void DrawRectLine(int x1,int y1,int width,int height)
{
	glBegin( GL_LINE_LOOP );
	glVertex2f( x1, PanelHeight - y1 );
	glVertex2f( x1+width, PanelHeight - y1 );
	glVertex2f( x1+width, PanelHeight - y1 -height );
	glVertex2f( x1, PanelHeight - y1 -height );
	glEnd();
}


inline DrawRect(int x1,int y1,int w,int h)
{
	glRecti(x1, PanelHeight - y1, x1+w, PanelHeight -y1 -h);
//     glRecti(x1, PanelHeight - y1, x1+w, PanelHeight -y1 -h);
}

void DrawRectTexture(int x1,int y1,int w,int h,GLuint tex_id)
{
	glBindTexture(GL_TEXTURE_2D, tex_id);
	glBegin( GL_QUADS );
	{
		glTexCoord2f(0,0);
		glVertex2i(0,0);   // ġ  ?
		glTexCoord2f(1,0);  // u,vƳ ?
		glVertex2f(x1+w,0);
		glTexCoord2f(1,1);
		glVertex2f(x1+w,y1+h);
		glTexCoord2f(0,1);
		glVertex2f(0,y1+h);
	}
	glEnd(); 
}


#define SLICE 16
DrawCircle3D(int x,int y,float r,Vector *n)
{
	int i;
	
	Position Circle[32];
	float theta1,theta2;
	float up[3]={0,1,0};

	
	float 	theta= 2*M_PI / SLICE;

	for(i=0; i<SLICE;i++)
	{
		Circle[i].x=1;
		Circle[i].y=0;
		Circle[i].z=0;
	}
	
	for(i=0;i< SLICE;i++)
		vectorRotate(VECTOR(&Circle[i]),up,theta);

		
	theta1=acos(n->y);
	theta2=acos(n->x);

	glBegin( GL_LINES );
   	for(i=0;i<SLICE; i++)
		glVertex3fv(&Circle[i].x);
   	glEnd();
}


//Blend  
//void glBlendFunc(GLenum sfactor,GLenum dfactor)
//		   ̹     ̹ 
//		
//sfactor
//    	Specifies how the red, green, blue and alpha source blending factors are computed. 
//    	Nine symbolic constants are accepted: GL_ZERO, GL_ONE, GL_DST_COLOR, 
//    	GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_COLOR, GL_DST_ALPHA, 
//    	GL_ONE_MINUS_DST_ALPHA, and GL_SRC_ALPHA_SATURATE.

//dfactor   
//	Specifies how the red, green, blue and alpha destination blending factors are computed. 
//	Eight symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SCR_COLOR, 
//	GL_ONE_MINUS_SRC_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_COLOR, GL_DST_ALPHA, 
//	and GL_ONE_MINUS_DST_ALPHA. 


Draw_RectBlendAlpha(int x,int y,int width,int height,float alpha)
{	
	//Why ??????
    glDisable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
 
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glColor4f(0.1, 0.12, 0.1, alpha);
    DrawRect(x,y, width, height); 
    glColor4f(1.0, 1.0, 1.0,1.0); 

    glDisable(GL_BLEND);                                                                 // Enabl
}
    

void DrawRectBlend(int x,int y,int width,int height)
{	
	//Why ??????
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(0.0, 0.1, 0.0, 0.18);
	DrawRect(x,y, width, height); 
	glColor4f(1.0, 1.0, 1.0,1.0); 

	glDisable(GL_BLEND);                                                                 // Enabl
}
    

//DEL int current_FontWidth=7;
#include "./graphics/libfont.c"

// Basis Sting Drawer
#define DrawStrXY Draw_StringXY
//int DrawStrXY(int x,int y,char *string)
int Draw_StringXY(int x,int y,char *string)
{
	int ret;
	//    cursor_x=cursor_indent_x;
	ret=__DrawStrXY(x,y,string);
	if(strchr(string,'\n')!=NULL){
		cursor_y=y+FontHeight[CurrentFontID];
		cursor_x=cursor_indent_x;
	}
	else cursor_x=x+ret;

	return ret;
}

int Draw_CharXY(int x,int y,char ch)
{
	int ret;
	//    cursor_x=cursor_indent_x;
	char string[2];
	string[0]=ch;
	string[1]=0;
	ret=__DrawStrXY(x,y,string);
	return ret;
}


int DrawStr(char *string)
{
	return Draw_StringXY(cursor_x,cursor_y,string);
}

//ʾδ. 
int DrawString(char *string)
{
///  use SDL  or GL  ?
	int len, i;
	if( string == NULL) return;

	glRasterPos2i(cursor_x,PanelHeight - cursor_y -12);

	len = (int) strlen(string);

	//     for (i = 0; i < len; i++)
	//    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, string[i]);

	//    if(string == '\n')
	cursor_y+=    14;
	//    return len*current_FontWidth;

}


Draw_MediumStringXY(int x,int y,char *string)
{
    	__DrawStrScaleXY(x,y,1.3,string);
}

Draw_LargeStringXY(int x,int y,char *string)
{	

	//glScalef(4,4,4);
    	__DrawStrScaleXY(x,y,2,string);
	
//    int len, i;
//     glRasterPos2i(x,PanelHeight - y -24);
//     len = (int) strlen(string);
//    FontSize(2);    
     //     for (i = 0; i < len; i++)
  //    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18,string[i]);
}

Draw_StringScaleXY(int x,int y,float s,char *string)
{	

    	__DrawStrScaleXY(x,y,s,string);

}


int DrawPrintfXY(int x,int y, const char *fmt, ... )
{
	char text[256]; /* Holds our string */
	va_list ap;     /* Pointer to our list of elements */

	/* If there's no text, do nothing */
	if ( fmt == NULL )
		return;

	/* Parses The String For Variables */
	va_start( ap, fmt );
	/* Converts Symbols To Actual Numbers */
	vsprintf( text, fmt, ap );
	va_end( ap );
	return DrawStrXY(x, y,text);
}

 
int DrawPrintf(const char *fmt, ... )
{
	char text[256]; /* Holds our string */
	va_list ap;     /* Pointer to our list of elements */

	/* If there's no text, do nothing */
	if ( fmt == NULL )
		return;
	/* Parses The String For Variables */
	va_start( ap, fmt );
	/* Converts Symbols To Actual Numbers */
	vsprintf( text, fmt, ap );

	va_end( ap );
	return DrawStr(text);
}

                                                                                                

    
DrawPromptCursor()
{

}

// arm϶ ׷ʳ ? 
// ...
//
DrawCrossHair()
{

	char buffer[64];
	


	glColor3ub(120,255,120);
	//   glColor4f(1.0, 1.0, 1.0,.5);
	DrawLine(HalfScreenWidth - 10, HalfScreenHeight,HalfScreenWidth + 10, HalfScreenHeight);
	DrawLine(HalfScreenWidth , HalfScreenHeight-10 ,HalfScreenWidth , HalfScreenHeight +10 );

	draw_crosshair_object_name();
}


#define MAXLINE  3
char PrintInfoLineStr[4][128]; // ִ 3θ 
char *PrintInfoLineStrP[3]; 
char PrintInfoLineStrC[3]; 

typedef struct {
	char string[64];
} infostr;

infostr queue_infoline[5];



int  PrintInfoLineN=0;

Panel_Draw_Info() // ȭ  ܿ , ġ
{
    int i;
    return;
    //for(i =0 ;i<3;i++)
    for(i =0 ;i<1;i++)
    {
//	  glColor4ub(0,0,0,255);
        //  Draw_StringXY(5,40-14*i,PrintInfoLineStr[2-i] );
    		
	  DrawRectBlend(0,0,PanelWidth,PanelHeight);
	//  DrawRectBlend(0,0,30,PanelHeight);
    		
	  // glEnable(GL_BLEND);
	  Color(PrintInfoLineStrC[2-i]);
	
 //         Draw_StringXY(5,40-14*i,PrintInfoLineStr[2-i] );
          Draw_StringXY(5,0,PrintInfoLineStr[2-i] );
//	  printf("%s\n",PrintInfoLineStr[3-i]);
    }
}

//
AddInfoLine(char *str,int c)
{
    if(PrintInfoLineN != 0)
    {
	strcpy(PrintInfoLineStr[2],PrintInfoLineStr[1]);
	strcpy(PrintInfoLineStr[1],PrintInfoLineStr[0]);
	PrintInfoLineStrC[2]=PrintInfoLineStrC[1];
	PrintInfoLineStrC[1]=PrintInfoLineStrC[0];
	PrintInfoLineN=0;
    }	  

    PrintInfoLineStrC[0]=c;
    
    strcpy(PrintInfoLineStr[0],str);
//    printf("%s\n",PrintInfoLineStr[3-i]);

    PrintInfoLineN++;
}


AddInfoLine2(char *str,int c)
{

	PrintInfoLineStrC[0]=c;

	strcpy(PrintInfoLineStr[0],str);
	//    printf("%s\n",PrintInfoLineStr[3-i]);

	PrintInfoLineN=1;
}



Inform(char *str)
{
    AddInfoLine(str,BLUE);
}


InformMessage(char *str)
{
   // AddInfoLine(str,BLUE);
}

InformMessageBLUE(char *str)
{
    AddInfoLine2(str,BLUE);
}


InformMessageRED(char *str)
{
    AddInfoLine2(str,RED);
}





Error(char *str)
{
    AddInfoLine2(str,RED);
}


extern int draw_cell_n,LeafCellsInFOV_n;
extern unsigned int zbuffer_hole_n;
extern int	ObjectsInFOV_n;

int  console_line_start=0;
int  console_line_end =0;
int  console_line_max =24;
GLuint  console_tex_id=0;
int  console_line_point=0;
char console_buffer[80][160];

char *console_line_list[160];

//  ܼ ׷ִԼ 
// DrawAll()Լ ȣǾ 
void Panel_Draw_Console()
{
	char buffer[128];
	int i,t,n;

    	Draw_RectBlendAlpha(0,0,PanelWidth,PanelHeight,0.4);

//	glEnable(GL_TEXTURE_2D);
//	DrawRectTexture(0,0,PanelWidth,PanelHeight,console_tex_id);

	if(console_line_start<console_line_end)
		for(i=console_line_start;i<console_line_end;i++)
			DrawPrintf("%s\n",console_buffer[i]);
//			DrawStr(console_buffer[i]);

	if(console_line_start>console_line_end)
	{
		for(i=console_line_start;i<console_line_max;i++)
			DrawPrintf("%s\n",console_buffer[i]);
		for(i=0;i<console_line_end;i++)
			DrawPrintf("%s\n",console_buffer[i]);
	}

//	if(console_line_start==console_line_end)
}


void Panel_Draw_Console2()
{
	char buffer[128];
	int i,t,n;
	
    	Draw_RectBlendAlpha(0,0,PanelWidth,PanelHeight,0.4);
	for(i=0;i<80;i++)
		DrawStr(console_line_list[i]);

}


//ӽ  
void Console_clear()
{
	console_line_start=0;
	console_line_end=0;
	console_line_point=0;
	console_line_max=panelConsole->Height /14;
}

void init_Console()
{
	console_tex_id=LoadTextureFile("intro.gpf");
	Console_clear();
	console_line_max=ScreenHeight/12;
}


int console_test_mode=0;
// ok
void Console_printf(const char *fmt, ... )
{
	char text[256]; /* Holds our string */
	va_list ap;     /* Pointer to our list of elements */

	if(arg_server) return;

	/* If there's no text, do nothing */
	if ( fmt == NULL )
		return;

	/* Parses The String For Variables */
	va_start( ap, fmt );
	/* Converts Symbols To Actual Numbers */
	vsprintf( text, fmt, ap );
	va_end( ap );
	
//	printf("Console:%s",text);

	strcpy(console_buffer[console_line_end],text);

	if(console_line_start>console_line_end) 
	{
		console_line_end++;
		console_line_start++;
	}else 
		console_line_end++;
	
		
	if(console_line_end==console_line_max)
	{
		console_line_end=0;
		console_line_start=1;
	}

	if(console_line_start==console_line_max)
		console_line_start=0;

	

	if(console_test_mode ) 
	// ̰ǽŰ澲 ڹڻ!  
	//    ִ Ʈ. 
	{
		if(arg_server>0) return;

		glClearColor (0.0, 0.0, 0.0, 0.0);
   		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   		Panel_Current(panelConsole);
   		//Panel_Current(panelScreen);
		
		glEnable(GL_TEXTURE_2D);
		DrawRectTexture(0,0,PanelWidth,PanelHeight,console_tex_id);
		Panel_Draw_Console();
	////	DealInput(); 
		SDL_GL_SwapBuffers();  
	}

}


char *get_emptyLine()
{


}


void Console_printf2(const char *fmt, ... )
{
	char text[256]; /* Holds our string */
	va_list ap;     /* Pointer to our list of elements */
	char *new_buffer;
	/* If there's no text, do nothing */
	if ( fmt == NULL )
		return;

	/* Parses The String For Variables */
	va_start( ap, fmt );
	/* Converts Symbols To Actual Numbers */
	vsprintf( text, fmt, ap );
	va_end( ap );

	new_buffer=get_emptyLine();
	strcpy(new_buffer,text);

}


// ϴ װ 
void Panel_Draw_debug()
{
	char buffer[128];
	int i,t,n;

    
    	DrawRectBlend(0,0,PanelWidth,PanelHeight);
	glColor4ub(255,255,255,255);

  /* for(i=0;i<200;i+=12){
       sprintf(buffer,"y=%d",i);
	DrawStr(0,i,buffer);
   } */
	if(player==NULL) ERROR("player null");
	if(Camera==NULL) ERROR("camera null");

//  DrawPrintf("Object=%d  Polygon=%d  fps=%d Dir:x=%f  y=%f   z=%f\n"
//	,Object_n,total_polygon(),fps ,player->direction[0],player->direction[1],player->direction[2]);
  
   	
   	DrawPrintf("fps=%d   " ,fps );
   	DrawPrintf("ObjectsInFOV_n=%d  player( CellsInWOMB_n=%d  falling_speed=%3.3f " ,
			ObjectsInFOV_n,player->CellsInWOMB_n,player->falling_speed);
   	DrawPrintf("relativeAlt=%3.3f) laser_d=%f\n" ,player->relativeAlt,player->laser_distance);

	//   	DrawPrintf("fps=%d   glTime=%dms   totalTime=%dms threadTime=%dms     testTime=%dms  \n"
//			,fps ,glTime,totalTime,threadTime,testTime);


    	n=total_OctreeTriangle();
    	if(n==0) n=1;
    // 	DrawPrintf("map->shape->polygon_n=%d\n",map->shape->polygon_n);
    	DrawPrintf("octree_total_triangle_n=%d  zbuffer_hole_n=%d ",n,zbuffer_hole_n);
    	DrawPrintf("draw_polygon =%d(%d\%)\n",draw_polygon_n,draw_polygon_n*100/n);

	DrawPrintf("CellsInFOV_n=%d  draw_cell_n=%d   LeafCellInFOV_n=%d   BlockCells_Hit_N=%d\n"
			,BlockCells_inFOV_N,draw_cell_n,LeafCellsInFOV_n,BlockCells_Hit_N);

	DrawPrintf("direction(%f %f %f) ",Camera->direction[0],Camera->direction[1],Camera->direction[2]);
	DrawPrintf("rotate(%f %f %f)\n",Camera->rotate[0],Camera->rotate[1],Camera->rotate[2]);
	DrawPrintf("center[%f %f %f]\n",
	Camera->center[0],Camera->center[1],Camera->center[2]);

	DrawPrintf("view_direction(%f %f %f) ",Camera->view_direction[0],Camera->view_direction[1],Camera->view_direction[2]);
	DrawPrintf("view_rotate(%f %f %f)\n",Camera->view_rotate[0],Camera->view_rotate[1],Camera->view_rotate[2]);
	Draw_Debug_network();
//    DrawPrintf("BlockCell_Hit_N=%d\n",BlockCells_Hit_N);
    //visiable_polygon_n=0;
}



int	print_help_show_time=3000;  //  ƴ... 
char	buffer[1024];

Panel_Draw_Help()
{
	char *help_str[]={   "ESC: Quit",
		"F1 : Help",
		"F5 : Render Mode" ,
		"W  : forward",
		"S  : backward",
		"Mouse : Direction",
		NULL};

	int i;


	/*if(print_help_show_time<0){
	  print_help_show=0;
	  print_help_show_time=6000;
	  return;
	  }
	  print_help_show_time-=iDeltaTime;   */
	DrawRectBlend(0,0,PanelWidth,PanelHeight);
	sprintf(buffer,"PanelY=%d PanelHeight=%d",PanelY,PanelHeight);
	DrawStrXY(10,200,buffer);


	ColorRGB(118,255,118);  //׸  
	Draw_LargeStringXY(10,30,"HELP SCREEN");
	for(i=0; help_str[i] ;    i++)	   DrawStrXY(10,(70+i*22),help_str[i]);

}


extern client_n;
Panel_Draw_ServerInfo()
{
	int i;

	Draw_RectBlendAlpha(0,0,PanelWidth,PanelHeight,0.3);
	ColorRGB(118,255,118);  //׸  
	
	
	cursor_y=80;
	cursor_x=cursor_indent_x=40;
	Draw_MediumStringXY(cursor_indent_x,50,"Server");
	print_client_info();

}



	    
//extern int GetNumMenuKey;

typedef struct {
    int show;
    int	ID;
    char *string;
    void *pointer;

} Item;

char *NumMenuItem[32];
NumMenu *NumMenus[32];
NumMenu *NumMenuS;
int	 NumMenu_N=0;

int GetNumMenuKey=0;

NumMenu *New_NumMenu(char *str[],void (*callback))
{
    int i;
    NumMenu *n;
    n=xmalloc(sizeof(NumMenu));
 
    for(i=0; str[i] ;i++)
	n->item[i]=str[i];
    n->item[i]=NULL;
        
    n->callback=callback;

    NumMenus[NumMenu_N++]=n;
    return n;
    
}


NumMenu_Close()
{
    NumMenuS=NULL;
    Panel_Close(panelNumMenu);
//DEL    NumMenuItem[0]=NULL;    
    GetNumMenuKey=FALSE;
}


NumMenu_Show(NumMenu *nm)
{
    if(NumMenuS!=nm){
	NumMenuS=nm;   
        Panel_Open(panelNumMenu);
        GetNumMenuKey=TRUE;
    }
    else{
	    NumMenu_Close();
    }
}


NumMenu_GetKey(int sym)
{  
    if(!GetNumMenuKey) return;

    //48 ~ 57
    if( 47<sym	&& sym < 58)
    {
	NumMenuS->callback(sym-48);

    }
//	printf("press %d\n",sym);
}



void NumMenu_Core()
{
    int i;
    
    if(ScreenWidth<600) return;
    if(NumMenuS==NULL) return;

    
    DrawRectBlend(0,0, PanelWidth,PanelHeight); 

//    SetCursorIndent(10);//cursor_indent_x=10;
    Color(WHITE);
    for(i=0; NumMenuS->item[i] ;i++)
	DrawPrintf("%d.%s\n",i+1,NumMenuS->item[i]);

}


Draw_ShowPlayers()
{
   char *help_str[]={   "Name",
			"ping",
 			"Ip"};
			
   int i,x_pos=100,y_pos=100;

   if(print_help_show_time<0){
   	print_help_show=0;
   	print_help_show_time=6000;
   	return;
   }

   print_help_show_time-=iDeltaTime;


   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   glColor4f(0.0, 0.0, 0.0, 0.2);
   
   DrawRect(60,60,ScreenWidth -60 ,ScreenHeight -60);
//   DrawRect(0,ScreenHeight-25,ScreenWidth,ScreenHeight);

//   glColor4f(0.0, 0.0, 0.0, 1);
   glColor4f(1.0, 1.0, 1.0,1.0); 
  

   ColorRGB(118,255,118); //׸  
//   DrawLargeStr(170,105,"HELP SCREEN");
   for(i=0; i< 6 ;    i++)
	   DrawStrXY(110,135+i*16,help_str[i]);

}


typedef struct {
    int x,y;
//    float r,g,b;
    char r,g,b;
    char str[128];
} ItemString;


ItemString *InitItemString(int x,int y, char *str)
{


}


InitTopMenu()
{


}


DrawTopMenu()
{

//   if(print_info_show!=1) return;
    char *TopMenuList[]=
    {"[" CTIME "]" ,
			"F1:Help",
			"F2:Debug" ,
			"F4:Octree" ,
			"F5:Model" ,
//			"F6:Camera",
			"F12:FullScreen",NULL };

    int i,n,x=0;

    DrawRectBlend(0,0,ScreenWidth,16);
          
   // Color(LIGHTGREEN);
  
    cursor_x=0;
    for(i=0; TopMenuList[i] ;i++)
    {
	//Draw_StringXY(x,0,TopMenuList[i]);
	DrawStr(TopMenuList[i]);
	cursor_x+=16;
    }
//   sprintf(buffer,"Xrot = %d Yrot= %d Camera_z=%f ",Xrot,Yrot,Camera_z);
//  printstring(GLUT_BITMAP_HELVETICA_12,buffer );
}




SDL_Surface *imagex;
SDL_Rect dest;

DrawSDL()
{
	DrawCockpit();
}


// not work .. impossble function..
DrawCockpit()
{

    /* Load the BMP file into a surface */

    dest.x = 0;
    dest.y = 0;
    dest.w = imagex->w;
    dest.h = imagex->h;
    SDL_BlitSurface(imagex, NULL,sdl_screen, &dest);

    /* Update the changed portion of the screen */
//    SDL_UpdateRects(sdl_screen, 1, &dest);
//    SDL_FreeSurface(image);

}



//interface functionms

Toggle_Help()
{
    Panel_Toggle(panelHelp);
}

Show_Help()
{
    Panel_Open(panelHelp);
}


Show_ServerInfo()
{
    Panel_Show(panel_ServerInfo);
}

Toggle_Show_Radar()
{
    Panel_Show(panelRadar);
}


Show_Laser()
{
     
}

int EnableMapTest=0;
int MapTest_BlcokCellBound=0;
int Flag_DrawJoint=0;
extern Object *dopplegang;

DealNumMenu_COMMAND(int k)
{
	switch(k)
	{
		case 1:
			if(dopplegang!=NULL)
				dopplegang->active^=1;	

			break;

		case 4:
			Toggle_Show_Radar();	
			break;

		case 5:
			//Panel_Show(panelZbuffer);
			//	octree_level++;
			//	octree_level--;
			// 	MakeOctreeMap(map->shape);	
			// 	MakeOctreeMap(map->shape);	
			break;
		case 2:
			Flag_DrawJoint^=1;	
			break;


		case 3:
			MapTest_BlcokCellBound^=1;	
			break;


		case 6:
			RenderMode=0;	

			break;
		case 7:
			RenderMode=3;	

			break;
		case 8:
			RenderMode=8;	

			break;

	}
}

Press_TAB()
{
     char *Menu[]={   
			"Toggle DopleGanger",//"Toggle Zbuffer",
			"Toggle Joint",//"Toggle Zbuffer",
			"Toggle BlockCellBound",
			"Toggle Radar",
			"none",//"Toggle Zbuffer",
			"Render Normal ",
			"Render WireFrame ",
			"Render WOMB ",
		NULL };
   


	static NumMenu *nm=NULL; 
	if(!nm) 	nm=New_NumMenu(Menu,DealNumMenu_COMMAND);
	NumMenu_Show(nm);
}


extern int NextKey;
extern int KeyState;

DealTABMenu_ModelTest(int k)
{
   switch(k)
   {
      case 1:
	KeyState^= 1; //XOR 
	break;
     case 2:
	NextKey++;
	break;
     case 3:
	NextKey--;
	break;
    case 4:
	break;

    case 5:
	break;

	  
   }
}
TABMenu_ModelTest()
{
     char *Menu[]={   
			"Play/Stop ",
			"inc -",
			"dec +",
			"	",
			" 	",
		NULL };
   
    static NumMenu *nm=NULL; 
 
    if(!nm) 	nm=New_NumMenu(Menu,DealTABMenu_ModelTest);
    NumMenu_Show(nm);
}


press_tild()
{
   	static int key=-1;

	if(key==-1) 
	{
		key=New_Sliding_Position1D(ScreenHeight,ScreenHeight/2, &panelConsole->y);
		Sliding_Start(key);
		Panel_Show(panelConsole);

	}
	else 

	Sliding_Return(key);

}



Press_F2()
{
	static int key=-1;

	if(key==-1) 
	{
		//	ʱȭ 
		key=New_Sliding_Position1D(panelDebugLine->y,ScreenHeight/2 + ScreenHeight/3 ,&panelDebugLine->y);
		Sliding_Start(key);
		//	printf("y=%d\n",panelDebugLine->y);
		//	Panel_Show(panelDebugLine);

	} 
	else
		Sliding_Return(key);

    /*    switch(Sliding_State(key))
    {
	case SLIDING_READY:
	    Sliding_Start(key);
	    break;
	case SLIDING_DONE:
	    Sliding_Return(key);
    }
     */
}


//float *zbuffer;
//unsigned short zbuffer[ZBUFFER_WIDTH][96];
//unsigned short *zbuffer;
unsigned short zbuffer[ZBUFFER_HEIGHT*ZBUFFER_WIDTH];
unsigned short *draw_zbuffer;
//unsigned short zbuffer1[ZBUFFER_HEIGHT][ZBUFFER_WIDTH];

//unsigned short *zbuffer;
//short zbuffer[1024*1024];
int zbufftexture;
int read_zbuff=0;
int size;


init_zbuffer1()
{
	/* Create a 32-bit surface with the bytes of each pixel in R,G,B,A order,
	   as expected by OpenGL for textures */
	SDL_Surface *surface;
	Uint32 rmask, gmask, bmask, amask;

	

	printf("sizeof(float)= %d\n",sizeof(float));
	/* SDL interprets each pixel as a 32-bit number, so our masks must depend
	   on the endianness (byte order) of the machine */
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
	rmask = 0xff000000;
	gmask = 0x00ff0000;
	bmask = 0x0000ff00;
	amask = 0x000000ff;
#else
	rmask = 0x000000ff;
	gmask = 0x0000ff00;
	bmask = 0x00ff0000;
	amask = 0xff000000;
#endif

	/*	size=2*ScreenHeight*ScreenWidth;
		zbuffer=(unsigned short *)glXAllocateMemoryNV(size,1.0,1.0,1.0);
		if(zbuffer==NULL) ERROR(" zbufftexture NULL");
		printf("zbufftexture=%x\n",zbuffer);

*/


	surface = SDL_CreateRGBSurface(SDL_HWSURFACE, ScreenWidth, ScreenHeight, 32,
			rmask, gmask, bmask, amask);
	if(surface == NULL) {
		fprintf(stderr, "CreateRGBSurface failed: %s\n", SDL_GetError());
		exit(1);
	}

	
	//    zbuffer=surface->pixels;
	glGenTextures( 1, &zbufftexture );
	glBindTexture( GL_TEXTURE_2D, zbufftexture); 


	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);                                                     
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);                                                     

	//    glTexImage2D( GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT,
	//			ScreenWidth, ScreenHeight, 0,GL_DEPTH_COMPONENT , GL_UNSIGNED_BYTE, zbuffer ); 
	//  glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA,ScreenWidth, ScreenHeight, 0,GL_RGBA , GL_UNSIGNED_BYTE, zbuffer ); 
	glTexImage2D( GL_TEXTURE_2D, 0,1 ,1024, 1024, 0,GL_DEPTH_COMPONENT, GL_UNSIGNED_SHORT, zbuffer ); 
    
}

init_zbuffer2()
{
//	zbuffer=zbuffer1[0];
}


inline void  zbuffer_draw_point(int x,int y)
{
	unsigned short color=0;
	
	if(x<0 || x>ZBUFFER_WIDTH ||y>ZBUFFER_HEIGHT || y<0) return;
	zbuffer[y*ZBUFFER_WIDTH+x]=color;
}

int watch_x1,watch_x2,watch_y1,watch_len;
//̰  ?
watchdog()
{
	DEBUG("x1=%d x2=%d y=%d len=%d",watch_x1,watch_x2,watch_y1,watch_len);
}




inline void  draw_hline(int x1,int x2,int y)
{

	int  i,len,tmp;
	unsigned short color=0;

	watch_x1=x1;
	watch_x2=x2;
	watch_y1=y;

	if(x2<x1){
		return;
	}
	
	if(x2<0 || x1>ZBUFFER_WIDTH ||y>ZBUFFER_HEIGHT || y<0) return;
	if(x1 < 0) x1=0;
	if(x2 > ZBUFFER_WIDTH) x2=ZBUFFER_WIDTH;

	len=x2-x1;
	watch_len=len;

	for(i=0;i<len;i++)	
		zbuffer[y*ZBUFFER_WIDTH+x1+i]=color;


}

inline void  draw_hlinev2(int x1,int x2,int y,unsigned short color)
{

	int  i,len,tmp;

	watch_x1=x1;
	watch_x2=x2;
	watch_y1=y;

	if(x2<x1){
		return;
	}
	
	if(x2<0 || x1>ZBUFFER_WIDTH ||y>ZBUFFER_HEIGHT || y<0) return;
	if(x1 < 0) x1=0;
	if(x2 > ZBUFFER_WIDTH) x2=ZBUFFER_WIDTH;

	len=x2-x1;
	watch_len=len;

	for(i=0;i<len;i++)	
		zbuffer[y*ZBUFFER_WIDTH+x1+i]=color;

}




// by hyun
inline void  draw_hlinef(float sx,float ex,int y)
{

	int  i,len,tmp,k;
	unsigned short color=0;
	int  x1,x2;

	unsigned short *ptr;
	float fx1,fx2;

//	return;
//	x1= (int)(sx+0.5);	
//	x2= (int)(ex+0.5);
	x1= (int)sx;
	x2= (int)ex;
	
	if(x2<x1){
//		ERROR(" small sx=%f ex=%f  x1=%d,x2=%d ",sx,ex,x1,x2);
		tmp=x1;	x1=x2;	x2=tmp;
		
	}

//	if( x2<0 || x1>ZBUFFER_WIDTH ) return;
	if( x2<0 || x1>ZBUFFER_WIDTH ||  y>ZBUFFER_HEIGHT || y<0 ) return;

	if(x1 < 0) x1=0;
	if(x2 > ZBUFFER_WIDTH) x2=ZBUFFER_WIDTH-1;


	len= x2-x1 +1 ;
//	len= (int) ( fx2 - fx1 +1 );

//	ptr=&zbuffer[0][0];
//	k=y*ZBUFFER_WIDTH;
	for(i=0;i<len;i++)	
		//ptr[k + x1 + i]=color;
		zbuffer[y*ZBUFFER_WIDTH+x1+i]=color;



}



inline void test_hline(int x[3],int y[3])
{

	draw_hline(0,64,96/2);
	draw_hline(0,64,96/4);
}


#define min(x,y)   x>y ?  y : x
#define max(x,y)   x>y ?  x : y

// original source 
// http://www.cs.helsinki.fi/group/goa/mallinnus/lines/bresenh.html
int low[200],high[200]; // One value for each scanline  


inline void draw_point2(int x , int y)
{
//	draw_point(x,y);
	if(y < 0 || y > ZBUFFER_HEIGHT) return;
	low[y]=min(low[y],x);
	high[y]=max(high[y],x);
}	

void linev6(int x1,int  y1,int  x2,int  y2)
{
	
	int dx  = x2 - x1, dy  = y2 - y1, y   = y1,   eps = 0;
	int x;
      
	for ( x = x1; x <= x2; x++ )  {
        	//s.Plot(x,y,colour); 
		if(y>0 && y< ZBUFFER_HEIGHT){
		//	low[y]=min(low[y],x);
  		//	high[y]=max(high[y],x);
			zbuffer_draw_point(x,y);
		}
        	eps += dy;
        	if ( (eps << 1) >= dx )  {
          		y++;  eps -= dx;
        	}
	}

}
/* uses y=mx+b to calculate y from x */

void linev3(int x1,int  y1,int  x2,int  y2)
{
	float dx,dy;
	float y,m,b;
	int   x,iy;

	

	dy = y2-y1;
	dx = x2-x1;
	m = dy/dx;
	b = y1-m*x1;
	for (x=x1; x<=x2; x++) {
	 	y=m*x+b;
		iy=y;
  		zbuffer_draw_point(x,iy);
	}
}


void linev4(int x1,int  y1,int  x2,int  y2)
{
	int  	dx,dy;
	int   	x,y;
	int 	steep=0;	

	float f;
	float incrE,incrNE;

	dy = y2-y1;
	dx = x2-x1;
	dx = abs(dx);
	dy = abs(dy);

	if( dy > dx) 
	{

		//if(y1
		SWAP(dx,dy);
		SWAP(x1,y1);
		SWAP(x2,y2);
		steep=1;
		/*	

			y = y1;
			f = -dx;
			incrE = 2*dy;                         
			incrNE = 2*(dy-dx);                   
			for (x=x1; x<=x2; x++) {
			draw_point(x,y);
			if (f>0) {
			y = y+1;
			f = f + incrNE;                 
			}
			else
			f = f + incrE;                     
			}

*/





	}

	{
		y = y1;
		f = -dx;
		incrE = 2*dy;                          /* &lt------------ */
		incrNE = 2*(dy-dx);                    /* &lt------------ */
		for (x=x1; x<=x2; x++) {

			if(steep) 
				zbuffer_draw_point(y,x);
			else zbuffer_draw_point(x,y);

			if (f>0) {
				y = y+1;
				f = f + incrNE;                    /* &lt------------ */
			}
			else
				f = f + incrE;                     /* &lt------------ */
		}


	}

}


// http://www.edepot.com/linee.html
// THE EXTREMELY FAST LINE ALGORITHM Variation E (Addition Fixed Point PreCalc)
inline void linev5( int x, int y, int x2, int y2) 
{
	int j;
   	int yLonger=0;
	int shortLen=y2-y;
	int longLen=x2-x;
	int swap;
	int decInc;

	if (abs(shortLen)>abs(longLen)) {
		swap=shortLen;
		shortLen=longLen;
		longLen=swap;				
		yLonger=1;
	}
	if (longLen==0) decInc=0;
	else decInc = (shortLen << 16) / longLen;

	if (yLonger) {
		if (longLen>0) {
			longLen+=y;
			for (j=0x8000+(x<<16);y<=longLen;++y) {
				draw_point2(j >> 16,y);	
				j+=decInc;
			}
			return;
		}
		longLen+=y;
		for (j=0x8000+(x<<16);y>=longLen;--y) {
			draw_point2(j >> 16,y);	
			j-=decInc;
		}
		return;	
	}

	if (longLen>0) {
		longLen+=x;
		for ( j=0x8000+(y<<16);x<=longLen;++x) {
			draw_point2(x,j >> 16);	
			j+=decInc;
		}
		return;
	}
	
	longLen+=x;
	for ( j=0x8000+(y<<16);x>=longLen;--x) {
		draw_point2(x,j >> 16);	
		j-=decInc;
	}
	

}
// Bresenham Line Algorithm
// always y2 > y1   , dy > 0 
inline void linev7( int x1, int y1, int x2, int y2) 
{
	int		x, y;
	int		dx, dy;
	int		incx, incy;
	int		balance;


	if (x2 >= x1)
	{
		dx = x2 - x1;
		incx = 1;
	}
	else
	{
		dx = x1 - x2;
		incx = -1;
	}

	dy = y2 - y1; 
	
	// incy = 1;


	
	x = x1;
	y = y1;



	if (dx >= dy)
	{
		//  slope  0 ~ 1 
		dy = dy << 1;
		balance = dy - dx;
		dx = dx << 1;

	
		if(incx>0) {

			//if(x2>ZBUFFER_WIDTH) x2=ZBUFFER_WIDTH;
			for(x=x1; x < x2; x++)
			{
				draw_point2(x, y);
				if (balance >= 0)
				{
					y++; 	//y += incy;
					balance -= dx;
				}
				balance += dy;
			} 
			draw_point2(x, y);
		}
		else 
		{
			for(x=x1; x > x2; x--)
			{
				draw_point2(x, y);
				if (balance >= 0)
				{
					y++; 	//y += incy;
					balance -= dx;
				}
				balance += dy;
			} 
			draw_point2(x, y);
		
		}

		
	}
	else
	{
		//  slope  1 ~ * 
		dx <<= 1;
		balance = dx - dy;
		dy <<= 1;

//		if(y1 < 0) 	y1=0;
		if(y2 > ZBUFFER_HEIGHT) y2=ZBUFFER_HEIGHT;


		//while (y != y2)
		for(y = y1  ; y<y2 ; y++ )
		{
			draw_point2(x, y);
			if (balance >= 0)
			{
				x += incx;
				balance -= dy;
			}
			balance += dx;
		} 
		draw_point2(x, y);
	}


}


// http://www.fact-index.com/b/br/bresenham_s_line_algorithm_c_code.html
void linev8(int x0, int y0, int x1, int y1)
//void linev8(int x0, int y0, int x1, int y1, int color)
{
       int i;
       int steep = 1;
       int sx, sy;  /* step positive or negative (1 or -1) */
       int dx, dy;  /* delta (difference in X and Y between points) */
       int e;

       /*
        * inline swap. On some architectures, the XOR trick may be faster
        */
       int tmpswap;
#define SWAP(a,b) tmpswap = a; a = b; b = tmpswap;



       /*
        * optimize for vertical and horizontal lines here
        */
      
       dx = abs(x1 - x0);
       sx = ((x1 - x0) > 0) ? 1 : -1;
       dy = abs(y1 - y0);
       sy = ((y1 - y0) > 0) ? 1 : -1;
       if (dy > dx) {
               steep = 0;
               SWAP(x0, y0);
               SWAP(dx, dy);
               SWAP(sx, sy);
       }
       e = (dy << 1) - dx;
       for (i = 0; i < dx; i++) {
               if (steep) {
                     //  plot(x0,y0,color);
			draw_point2(x0,y0);
               } else {
                     //  plot(y0,x0,color);
			draw_point2(y0, x0);
               }
               while (e >= 0) {
                       y0 += sy;
                       e -= (dx << 1);
               }
               x0 += sx;
               e += (dy << 1);
       }
}


inline void draw_triangle2(int x[3],int y[3])
{

	int i;
	float tmp0,tmp1;
	float dx1,dx2,dx3;

	float sx,ex; int sy;
//	if (B.y-A.y > 0) dx1=(B.x-A.x)/(B.y-A.y) else dx1=0;
//	if (C.y-A.y > 0) dx2=(C.x-A.x)/(C.y-A.y) else dx2=0;
//	if (C.y-B.y > 0) dx3=(C.x-B.x)/(C.y-B.y) else dx3=0;
	if (y[1]-y[0] > 0) dx1=(float)(x[1]-x[0])/(float)(y[1]-y[0]); 
		else 	dx1=0;
	if (y[2]-y[0] > 0) dx2=(float)(x[2]-x[0])/(float)(y[2]-y[0]); 
		else dx2=0;
	if (y[2]-y[1] > 0) dx3=(float)(x[2]-x[1])/(float)(y[2]-y[1]); 
		else dx3=0;

	
	if(y[2]<0 || y[0] > ZBUFFER_HEIGHT ) {
//		DEBUG("x[0]=%d,y[0]=%d x[1]=%d,y[1]=%d x[2]=%d,y[2]=%d",x[0],y[0],x[1],y[1],x[2],y[2]);
		return; 
	}

	//????????????????????
	if(y[1]>ZBUFFER_HEIGHT){
//		DEBUG("y[1]>96   x[0]=%d,y[0]=%d x[1]=%d,y[1]=%d x[2]=%d,y[2]=%d",x[0],y[0],x[1],y[1],x[2],y[2]);
		y[1]=ZBUFFER_HEIGHT-1;
		y[2]=ZBUFFER_HEIGHT-2;
	}

	if(y[2]>ZBUFFER_HEIGHT){
		y[2]=ZBUFFER_HEIGHT-1;
	}




	if(y[1]<0){
		tmp1=-y[1] -1;
		tmp0=-y[0] -1;
		y[1]=-1;
		y[0]=0;
			
		x[0] =tmp0*dx2  + x[0];
		x[1] =tmp1*dx3  + x[1];
		
			
	} 
	
//	S=E=A;
	sx=ex=x[0];
	sy=y[0];


	// below bottom 
	if(y[0]<0 && y[1]>0){
		tmp0=-y[0];
		sy=0;
		if(dx1>dx2){
			sx+=tmp0*dx2;
			ex+=tmp0*dx1;
		}
		else 
		{
			sx+=tmp0*dx1;
			ex+=tmp0*dx2;
		}
	
	} 


	if(dx1 > dx2)
	{
		for(;sy<=y[1];sy++,sx+=dx2,ex+=dx1)
			draw_hlinef(sx,ex,sy);
		ex=x[1]; //E=B; // ???
		//DEBUG(" ex=%f  x[1]=%d ",ex,x[1]);
		for(;sy<=y[2];sy++,sx+=dx2,ex+=dx3)
			draw_hlinef(sx,ex,sy);
	}

	
	else
	{
		for(;sy<=y[1];sy++,sx+=dx1,ex+=dx2)
			draw_hlinef(sx,ex,sy);
		sx=x[1];  //S=B; //??
		for(;sy<=y[2];sy++,sx+=dx3,ex+=dx2)
			draw_hlinef(sx,ex,sy);
	}
//	DEBUG("new Triangle dx1=%f  dx2=%f dx3=%f",dx1,dx2,dx3);


}

inline void draw_triangle3(int x[3], int y[3],unsigned short depth)
{
    	int t,y2;
	
	
	for ( t=0; t<ZBUFFER_HEIGHT; t++)
	{    low[t]=319,high[t]=0; 	}
	
	linev8(x[0],y[0],x[1],y[1]);
	linev8(x[1],y[1],x[2],y[2]);
	linev8(x[0],y[0],x[2],y[2]);


	if(y[0] >0) 	t=y[0];	else t=0;
	if(y[2] < ZBUFFER_HEIGHT) y2=y[2];else y2=ZBUFFER_HEIGHT;


	for ( ; t< y2; t++)
		draw_hlinev2(low[t],high[t],t,depth);

}


inline void draw_triangle4(int x[3], int y[3],unsigned short depth)
{
	//draw_hlinev2(low[t],high[t],t,depth);
}


inline void Zbuffer_clear()
{
	int i;
	unsigned short *addr;
	// addr=&zbuffer[0];
	
	for(i=0;i<ZBUFFER_HEIGHT*ZBUFFER_WIDTH;i++)
		//addr[i]=65535; // 
		zbuffer[i]=65535; // 
		
}



int 	wx[4],wy[4];
//inline void  Draw_TriangleZbuffer(Triangle *tri)
inline void  Zbuffer_DrawTriangle1(Triangle *tri)
{

	
	int 	i;
	//static 	int 	wx2[4],wy2[4];
	float 	x,y,z,farz;
	float 	tx,ty,tz;
	float 	tmpf;
	float 	ratio;
    	float 	cos,sin;
	

	unsigned short zdepth;
	int out;
	int tmpx,tmpy;
	int zflag;
	int smallx,largex;

	zflag=0;


	out=0;
	farz=0;
	smallx=ZBUFFER_WIDTH+1;
	largex=-1;

	for(i=0;i<3;i++)
	{
		
		x=tri->vertex[i].x;
		y=tri->vertex[i].y;
		z=tri->vertex[i].z;
	
//		vectorSubtract(v,&Camera->x);
///		x-=Camera->x;	y-=Camera->y;		z-=Camera->z;

//	    	Yrotation(&x,-Camera->heading);
    		cos= heading_cos;
    		sin= -heading_sin;
    		tx=  x*cos + z*sin;
    		z=  -x*sin + z*cos;


// 		Xrotation(&x,-Camera->pitch);
    		cos= pitch_cos;
    		sin= -pitch_sin;
    		ty=  y*cos - z*sin;
    		z=  y*sin + z*cos;

		x=tx; y=ty;

		if(farz > z) {
		
			farz=z;		
		}
	
	
		if(z> -10 ) {
			 zflag++; 
			 z=-10;
		}

		ratio=-(z/zbuffer_depth);
		x=x/ratio;
		y=y/ratio;

		
		wx[i]=(int)(x+(float)(ZBUFFER_WIDTH/2) +0.5);
		wy[i]=(int)(y+(float)(ZBUFFER_HEIGHT/2) + 0.5);

		if(wx[i] >largex )  largex=wx[i];
		if(wx[i] <smallx )  smallx=wx[i];
			

	}

	farz=farz/-Frustrum.far2;

	zdepth= (unsigned short)((float)farz*655350);
	//DEBUG("farz=%f zdepth=%d",farz,zdepth);

	if(zflag==3 ) return;
	//if(zflag == 3  ) return;

	//    wx[0]= 0; wy[0]=0;     wx[1]= 80; wy[1]=10;     wx[2]= 30; wy[2]=70; 

	// wy[2]  > wy[1] > wy[0] 
	if (wy[1] < wy[0])
	{
		tmpx = wx[1]; wx[1] = wx[0];  wx[0] = tmpx;
		tmpy = wy[1]; wy[1] = wy[0];  wy[0] = tmpy;
	}

	if (wy[2] < wy[0])
	{
		tmpx = wx[2]; wx[2] = wx[0];  wx[0] = tmpx;
		tmpy = wy[2]; wy[2] = wy[0];  wy[0] = tmpy;

	}

	if (wy[1] > wy[2])
	{
		tmpx = wx[1]; wx[1] = wx[2];  wx[2] = tmpx;
		tmpy = wy[1]; wy[1] = wy[2];  wy[2] = tmpy;
	}


	if(wy[2]<0 || wy[0]>ZBUFFER_HEIGHT || smallx > ZBUFFER_WIDTH || largex < 0 ) return ;


	// draw_triangle3(wx,wy,zdepth);    return;
	//draw_triangle5(wx,wy,zdepth);    return;
	// draw_triangle2(wx,wy);	return;


	//	draw_triangle2(wx[2],wy[2],wx[1],wy[1],wx[0],wy[0]);
	//    draw_triangle(wx,wy);	return;

}

//ӽ׽Ʈ 
void Zbuffer_addTriangle(Triangle *tri)
{
	zbuffer_triangle[zbuffer_triangle_n++]=tri;
}


inline void  Zbuffer_DrawTriangle(Triangle *tri)
{
	int 	i;
	float 	x,y,z,farz;
	float 	ratio;
	
	float 	matrix[4][4];
	
	//unsigned short zdepth_color;
	int zdepth_color;

	int out;
	int tmpx,tmpy;
	int zflag;
	zflag=0;


	out=0;
	farz=0;

	glGetFloatv( GL_PROJECTION_MATRIX , matrix[0] );

	//Matrix_transpose(matrix);

	for(i=0;i<3;i++)
	{
		float vt[3],v[3];	
		vt[0]=tri->vertex[i].x;
		vt[1]=tri->vertex[i].y;
		vt[2]=tri->vertex[i].z;
	
		//Matrix_vectorRotate(matrix,vt,v);
		Matrix_vectorTransform(matrix,vt,v);

		/*if(farz > v[2]) {
		
			farz=z;		
		}
	
		if(v[2]> -10 ) {
			 zflag++; 
			 v[2]=-10;
		}*/

		//ratio=-(v[2]/zbuffer_depth);
		//v[0]=v[0]/ratio;
		//v[1]=v[1]/ratio;
		
		wx[i]=(int)(v[0]+(float)(ZBUFFER_WIDTH/2) +0.5);
		wy[i]=(int)(v[1]+(float)(ZBUFFER_HEIGHT/2) + 0.5);

	}

	//farz=farz/-Frustrum.far2;
	farz=farz/Frustrum.far2;
	//zdepth_color= (unsigned short)((float)farz*655350);
	//DEBUGB("farz=%f zdepth=%d",farz,zdepth);
	//draw_triangle4(wx,wy,zdepth_color);    
	//glColor3i(zdepth_color,zdepth_color,zdepth_color); 
	glColor3f(farz,farz,farz); 

	glBegin(GL_TRIANGLES);	
	    {
		    glVertex2i(wx[0],wy[0]);
		    glVertex2i(wx[1],wy[1]);
		    glVertex2i(wx[2],wy[2]);
	    }
	glEnd(); 

		
	return;
	//	draw_triangle3(wx,wy,zdepth);    
	//	draw_triangle2(wx,wy);	return;
	//	draw_triangle2(wx[2],wy[2],wx[1],wy[1],wx[0],wy[0]);
	//    	draw_triangle(wx,wy);	return;
}




unsigned int  gllist;
unsigned int  draw_zbuffer_hole_n;
unsigned int  zbuffer_hole_n;
float    lazer[ZBUFFER_WIDTH*ZBUFFER_HEIGHT][3];

void draw_lazer()
{
	int i;

	glPointSize(4);

	
	glColor3ub(255,0,0);	

	glBegin(GL_POINTS);
	for(i=0;i<draw_zbuffer_hole_n;i++)
		glVertex3fv(lazer[i]);
	
	glEnd();

    	glPointSize(1);

//	news 
//	gllist=glGenLists(1);
//	glNewList(gllist, GL_COMPILE);	
//	glEndList();
}


Cell *HitedCell;

extern Line current_Laser;
extern Cell NullCell;
extern int     ViewableCells_N;

void Find_ViewableCells2()
{
	int i,j;
	unsigned short tmp;
	float v[3],z;
	line	l;
	Vector 	V1,V2;

	Zbuffer_clear();

	ViewableCells_N=0;
	i=8;

	/* Ģ) 1. ִ  Cell ׷ ּ hole  ֻ  .
	//	2. ¥ Ȯ ո鿡 ִ Cell ãϴϱ 켱 ã 
	//	      ã´. 
	
	) 1.  ãü Һ.
	*/
	//1. FOV   
	//´ Cell ׸¹.
	//
	//2.켱 Ÿ   Cell ٱ׸ 
	// hole ãƼ ¹.
	
	//3.
	
	vectorCopy(l.normal,Camera->view_direction);
	vectorCopy(l.onPoint,Camera->view_position);
	vectorAdd(l.onPoint,Camera->center);

	check_HitCellFOV(l);
/*	for(i=0;i<LeafCellsInFOV_n;i++)
	{
		List_ViewableCells[i]=List_LeafCellsInFOV[i];
	  	Shape_checkBackFace(List_ViewableCells[i]->shape);
	}
	ViewableCells_N=LeafCellsInFOV_n;	
	
	find_HitedCellsInFOV(); */
}



void Find_ViewableCells()
{
	int i,j,k,w,h,diff;
	unsigned short tmp;
	float v[3],z;
	Line 	line;
	Vector 	V1,V2;

		

	Zbuffer_clear();

	ViewableCells_N=0;
//	for(i=16;i>0;i/=2){
	i=8;

	zbuffer_hole_n=0;
	for(h=0;h<ZBUFFER_HEIGHT;h+=i)
		for(w=0;w<ZBUFFER_WIDTH;w+=i)
			if(zbuffer[h*ZBUFFER_WIDTH + w]==65535){
				v[0]=w - (ZBUFFER_WIDTH/2);
				v[1]=h - (ZBUFFER_HEIGHT/2);
				v[2]=  - zbuffer_depth ;

    				vectorUnProjectRotation(v);
				
				vector2Vector(&V1,v);
				VectorScale(&V1,30);
				// RE VectorAdd(&V1,&Camera->Position);
				VectorSetVector(&Camera->V1,&V1);
				
			
				//vectorCopy(lazer[zbuffer_hole_n],v);
				lazer[zbuffer_hole_n][0]=V1.x;
				lazer[zbuffer_hole_n][1]=V1.y;
				lazer[zbuffer_hole_n][2]=V1.z;
				zbuffer_hole_n++;

				//RE VectorSetVector(&V2,&Camera->Position);
				LineSetVector(&line,&V1,&V2);
				LineCopy(&current_Laser,&line);
				find_HitedCellsInFOV();
			}

	return;

	diff=2;
	zbuffer_hole_n=0;
	for(i=0; i< ZBUFFER_HEIGHT *ZBUFFER_WIDTH; i++)
			if(zbuffer[i]==65535){
				h=i/ZBUFFER_WIDTH;
				w=i%ZBUFFER_WIDTH;
				v[0]=w - (ZBUFFER_WIDTH/2);
				v[1]=h - (ZBUFFER_HEIGHT/2);
				v[2]=  - zbuffer_depth ;

    				vectorUnProjectRotation(v);
    			
//				vector2Vector(&Camera->V1,v);
//				VectorScale(&Camera->V1,30);
//				VectorAdd(&Camera->V1,&Camera->Position);

				//vertexUnProjectRotation(v);
				
				vector2Vector(&V1,v);
				VectorScale(&V1,30);
				//RE VectorAdd(&V1,&Camera->Position);
				VectorSetVector(&Camera->V1,&V1);
				
			
				//vectorCopy(lazer[zbuffer_hole_n],v);
				lazer[zbuffer_hole_n][0]=V1.x;
				lazer[zbuffer_hole_n][1]=V1.y;
				lazer[zbuffer_hole_n][2]=V1.z;
				zbuffer_hole_n++;

				// RE VectorSetVector(&V2,&Camera->Position);
				LineSetVector(&line,&V1,&V2);
				find_HitedCellsInFOV(&line);
			}

	return;
//	t0=SDL_GetTicks();  
//	??????????????????????????????????????????????????????????????????
	for(h=0;h<ZBUFFER_HEIGHT;h++)
		for(w=0;w<ZBUFFER_WIDTH;w++)
		{

			if(zbuffer[h*ZBUFFER_WIDTH + w]==65535){
				v[0]=w - (ZBUFFER_WIDTH/2);
				v[1]=h - (ZBUFFER_HEIGHT/2);
				v[2]=  - zbuffer_depth;

			///	vertexUnProjectRotation(v);
				vector2Vector(&V1,v);
				
				//vectorCopy(lazer[zbuffer_hole_n],v);
				lazer[zbuffer_hole_n][0]=V1.x;
				lazer[zbuffer_hole_n][1]=V1.y;
				lazer[zbuffer_hole_n][2]=V1.z;
				zbuffer_hole_n++;

				//RE VectorSetVector(&V2,&Camera->Position);
				LineSetVector(&line,&V1,&V2);
				find_HitedCellsInFOV(&line);
				w++;
				//w++;

			}
//			else	zbuffer[h*ZBUFFER_WIDTH+w]=0; 
		//zbuffer[w][h]=65535-tmp; 
		}


	return ;
	/*
	for(h=0;h<96;h++)
		for(w=0;w<128;w++)
		{
			tmp=zbuffer[h*128+w];

				
			if(tmp==65535){
				
				zbuffer[h*128+w]=65535;

				hole_n++;
				v[0]=w - 128/2;
				v[1]=h - 96/2;
				v[2]=z;

				vectorRotationView(v);

				
				
			}
			else 
				zbuffer[h*128+w]=65535-tmp; 
		}



	t0=SDL_GetTicks();  
	v[0]=3;v[1]=3;v[2]=3;
	for(i=0;i<128*128;i++)
	{
		vectorRotationView(v);
	} 
	return ;


 	for(i=0;i<1;i++)
	{
			tmp=zbuffer[i];
			if(tmp==65535){
				zbuffer[i]=65535;
				hole_n++;
				vectorRotationView(v);
			}
			else 
				zbuffer[i]=0;
	} 
	
	
	if(hole_n>1) {
	
	
	
	
	} */

}


Panel_Zbuffer_Draw()
{
	float scale;
	int i;
	
	for(i=0;i<zbuffer_triangle_n;i++)
		Zbuffer_DrawTriangle(zbuffer_triangle[i]);

	zbuffer_triangle_n=0;

	return;

	Zbuffer_clear();

	DrawRectLine(1,1, PanelWidth-2,PanelHeight-1); 
//	glFlush();
//	glFinish();
	glRasterPos2i(0,0);
	glDrawPixels(ZBUFFER_WIDTH,ZBUFFER_HEIGHT,GL_LUMINANCE,GL_UNSIGNED_SHORT,zbuffer);

}


// ̰  ?
float radar_scale;
Panel_DEBUG_Draw()
{ 

	float scale;
    	DrawRectBlend(0,0, PanelWidth,PanelHeight); 
	DrawRectLine(1,1, PanelWidth-2,PanelHeight-1); 


}

Draw_CellBoundWOMB(Object *obj)
{
	int i;

	glColor4f(1.0, 1.0, 1.0,1.0); // Blending !
	glColor3ub(255,255,0); // orange
	for(i=0;i<obj->CellsInWOMB_n;i++)	
		Draw_CellBound(obj->CellsInWOMB[i]);

}
 
Draw_CellWOMB(Object *obj)
{
	int i;

	glColor4f(1.0, 1.0, 1.0,1.0); // Blending !
	for(i=0;i<obj->CellsInWOMB_n;i++)	
		Shape_DrawWOMBtest(obj->CellsInWOMB[i]->shape);
	  	//Draw_BlockCell(obj->CellsInWOMB[i]);

}


// 
Panel_Draw_Radar()
{ 
	float scale;

	if(player==NULL) ERROR("player null");
	if(Camera==NULL) ERROR("camera null");
    	
	DrawRectBlend(0,0, PanelWidth,PanelHeight); 
	DrawRectLine(1,1, PanelWidth-2,PanelHeight-1); 
	
	// HOW ?? -> Ok
    	glMatrixMode(GL_PROJECTION);
    	glLoadIdentity();
    	glOrtho(-PanelWidth/2, PanelWidth/2,-PanelHeight/2, PanelHeight/2, -1000.0,1000.0);  
	scale=(float)3/(UNIT);
	///    glTranslatef(-player->x+PanelWidth/4,-20,-player->z-PanelHeight/4);
	glScalef(scale,scale,scale);
 	glRotatef(90,1,0,0); 
   	glTranslatef(-Camera->center[0],-UNIT*100,-Camera->center[2]);

	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity (); 		


    	// WHy ?????    
	//    PolygonModeOn();
    
    	glDisable(GL_DEPTH_TEST);
	// glDisable(GL_TEXTURE_2D); // Why ???
	
	//Draw_Map();
    	//Draw_BlockCellBound();
    	//if(MapTest_BlcokCellBound ) Draw_BlockCellBound();
    

	Object_DrawDirectionWorld(player);
    	Draw_Frustrum();  
//    	Draw_Laser();

//	Draw_CellBound(Camera->cell);
    	Draw_BlockCellBound();
	Draw_CellBoundWOMB(player);	

	glColor3ub(0,255,255);

//DEL     	Draw_HitBlockBound();
/*
    	Color(LIGHTGREEN);
    	glPointSize(2);
    	DrawPoint3D(Camera->x ,5,Camera->z );
    	glPointSize(1);
*/
}




extern Cell  	*List_LeafCellInFOV[1024];

extern int	LeafCellInFOV_n;

//test  
Object_Draw_LaserWORLD(Object *obj)
{

	//    vectorCopy(tempV,Camera->direction);
	//    vectorScale(tempV,(float)50*UNIT);
	//    vectorAdd(tempV,Camera->center);
	//    printf("tempV= %f %f %f  100*UNIT=%f\n",tempV[0],tempV[1],tempV[2],(float)100*UNIT);
	float v[3],v2[3];
	vectorCopy(v,obj->v1);
	vectorScale(v,40);
	vectorAdd(v,obj->center);
	vectorAdd(v,obj->view_position);

	vectorCopy(v2,obj->center);
//	vectorAdd(v2,obj->view_position);
	
	glColor3ub(0, 255, 0); //GREEN
	glPointSize(7);
	glBegin( GL_LINES );
	glVertex3fv( v2);
	glVertex3fv( v);
	glEnd();
}

// more general 
Object_DrawViewDirectionWorld(Object *obj)
{
	float  v1[3],v2[3];

	glColor3ub(255, 0, 0); //RED 

	vectorCopy(v1,obj->view_direction);
	vectorScale(v1,40);
	
	vectorAdd(v1,obj->view_position);
	
	vectorCopy(v2,obj->center);
	vectorAdd(v2,obj->view_position);
	vectorAdd(v1,v2);

	glBegin( GL_LINES );
	glVertex3fv( v2);
	glVertex3fv( v1);
	glEnd();
    	
	glPointSize(8);
	glBegin( GL_POINTS );
	glVertex3fv( v2);
	glEnd();
 
	//  glPointSize(1);
	
}

Object_DrawDirectionWorld(Object *obj)
{
	float  v1[3];

	glColor3ub(0, 0,255); //BLUE
	vectorCopy(v1,obj->direction);
	vectorScale(v1,60);
	vectorAdd(v1,obj->center);

	glBegin( GL_LINES );
	glVertex3fv( obj->center);
	glVertex3fv( v1);
	glEnd();
    	
	glPointSize(8);
	glBegin( GL_POINTS );
	glVertex3fv( obj->center);
	glEnd();
 
	//  glPointSize(1);
}



Object_DrawViewDirectionR(Object *shape)
{
	float  v1[3];

    	glDisable(GL_DEPTH_TEST);

	vectorCopy(v1,shape->direction);
	vectorScale(v1,100);

	//glColor4f(1.0, 0.0, 0.0,1.0); //RED 
	//glColor3f(1.0, 0.0, 0.0); //RED 
	glColor3ub(255, 0, 0); //RED 

	glBegin( GL_LINES );
	glVertex3f( 0,0,0);
	glVertex3fv( v1);
	glEnd();
    	
	glPointSize(8);
	glBegin( GL_POINTS );
	glVertex3f(0,0,0);
	
	glPointSize(10);
	
	glVertex3fv(v1);
	glEnd();
 

	glEnable(GL_DEPTH_TEST);
	//  glPointSize(1);
	
}




// ǥ  object ٴ ǥ  
Object_DrawBottom(Object *obj)
{
	float  v1[3];

	glColor4f(0.0, 1.0, 0.0,1.0); 

	glBegin( GL_LINES );
//	glVertex3f( obj->x,obj->y,obj->z);
	glVertex3fv( obj->center);
	glVertex3fv(obj->bottom);
	glEnd();
    	
	glPointSize(8);
	glBegin( GL_POINTS );
//	glVertex3f( obj->x,obj->y,obj->z);
	glVertex3fv( obj->center);
	
	glPointSize(10);
	glVertex3fv(obj->bottom);
	glEnd();
 

	//  glPointSize(1);
	
}






/* Rainbow of colors */                                                                         
static GLfloat colors[12][3] =                                                                  
{                                                                                               
        { 1.0f,  0.5f,  0.5f},                                                                  
        { 1.0f,  0.75f, 0.5f},                                                                  
        { 1.0f,  1.0f,  0.5f},                                                                  
        { 0.75f, 1.0f,  0.5f},                                                                  
        { 0.5f,  1.0f,  0.5f},                                                                  
        { 0.5f,  1.0f,  0.75f},                                                                 
        { 0.5f,  1.0f,  1.0f},                                                                  
        { 0.5f,  0.75f, 1.0f},                                                                  
        { 0.5f,  0.5f,  1.0f},                                                                  
        { 0.75f, 0.5f,  1.0f},                                                                  
        { 1.0f,  0.5f,  1.0f},                                                                  
        { 1.0f,  0.5f,  0.75f}                                                                  
};  

#define MAX_PARTICLES 512
typedef struct                                                                                  
{                                                                                               
    int   active; /* Active (Yes/No) */                                                         
    float fade;   /* Fade Speed      */                                                         
                                                                                                
    float r;      /* Red Value       */                                                         
    float g;      /* Green Value     */                                                         
    float b;      /* Blue Value      */                                                         
   	
    float x;      /* X Position      */                                                         
    float y;      /* Y Position      */                                                         
    float z;      /* Z Position      */                                                         
                                                                                                
    float xi;     /* X Direction     */                                                         
    float yi;     /* Y Direction     */                                                         
    float zi;     /* Z Direction     */                                                         
                                                                                                
    float xg;     /* X Gravity       */                                                         
    float yg;     /* Y Gravity       */                                                         
    float zg;     /* Z Gravity       */
    int	    TextureSize;
    float   Size;

    long 	life;   /* Particle Life   */                                                         
    char 	rgba[4];
    vector 	center[3];
    vector 	direction[3];
    int 	texture_id;
    
} particle;   

particle particles[MAX_PARTICLES];
int	Particeles_N=0;

int 	particle_n=0;


void ResetParticle( int num, int color, float xDir, float yDir, float zDir )                    
{                                                                                               
    particles[num].active = TRUE;                                                               
    particles[num].life = 1.0f;
    /* Random Fade Speed */                                                                     
    particles[num].fade =0.003;
	//( float )( rand( ) %100 ) / 1000.0f + 0.003f;                         
    /* Select Red Rainbow Color */                                                              
    particles[num].r = colors[color][0];                                                        
    /* Select Green Rainbow Color */
    particles[num].g = colors[color][1];                                                        
    /* Select Blue Rainbow Color */                                                             
    particles[num].b = colors[color][2];
    /* Set the position on the X axis */                                                        
    particles[num].x = 0.0f;
    particles[num].y = 5.0f;                                                                    
    particles[num].z = 0.0f;                                                                    
    particles[num].xi = xDir;                                                                   
    particles[num].yi = yDir;                                                                   
    particles[num].zi = zDir;                                                                   
    particles[num].xg = 0.0f;                                                                   
    particles[num].yg = -1.1f;                                                                  
    particles[num].zg = 0.0f;                                                                   
    particles[num].Size = 3.0;
    return;                                                                                     
}     

New_Particle()
{
    int loop;
    for ( loop = 0; loop < MAX_PARTICLES ; loop++ )                                            
        {                                                                                       
            int color = ( loop + 1 ) / ( MAX_PARTICLES / 12 );                                  
            float xi, yi, zi;                                                                   
            xi =  ( float )( ( rand( ) % 50 ) - 26.0f ) * 10.0f;                                
            yi  = ( float )( ( rand( ) % 50 ) - 25.0f ) * 10.0f;                            
            zi = ( float )( ( rand( ) % 50 ) - 25.0f ) * 10.0f;                            
                                                                                                
            ResetParticle( loop, color, xi, yi, zi );                                           
        }    
}

init_Particle()
{
	int i;
	for(i=0;i<MAX_PARTICLES;i++)
		particles[i].active=0;		
	particle_n=0;
}


// for test !!
// ǥ ޴´ !!!
New_BulletMark(float *v)
{
	int i;

	if(particle_n + 2 > MAX_PARTICLES) return;
	for(i=0;i<MAX_PARTICLES;i++)
		if(particles[i].active==0)
			break;		

	particles[i].active=1;
	particles[i].life=20000;
	vectorCopy(particles[i].center,v);
	particle_n++;
}

// ź縸 ׸. 
Particle_Draw()
{
	int 	i;
	
    	//glDisable(GL_DEPTH_TEST);
    	glDisable(GL_TEXTURE_2D);
	glLoadIdentity();  // ??
//	glEnable(GL_POINT_SMOOTH);
	glDisable( GL_BLEND );
	glDisable( GL_LIGHTING);
//	glColor3ub(255,255,255);
	glColor3f(1,1,1);  // white color
	glPointSize(4);

	glBegin( GL_POINTS );                                               
	
	for ( i = 0; i < MAX_PARTICLES; i++ )  
        {                                                                                       
            if ( particles[i].active )                                                       
                {                    
			if(particles[i].life<0 )
			{
				particles[i].active=0;
				particle_n--;
				continue; 
			}
			glVertex3fv(particles[i].center);                                   
			particles[i].life-=iDeltaTime;
		}
	}

	glEnd();
	glEnable(GL_DEPTH_TEST);

}


Decal_Rect(Position *ctr,float w,float h, Vector *n, Vector *H)
{



}


// 2D ? 3D ?
Draw_Map()
{
   glEnable(GL_DEPTH_TEST);
  // if(EnableMapTest){
	Draw_Cells();
    	if(MapTest_BlcokCellBound ) Draw_BlockCellBound();
    	//Draw_FOV();
//   }       else  	   Shape_Draw(map->shape);
   
}



Uint32 game_timer=0;

void Draw_Timer()
{
	char buffer[64];
	int minute,second;
// 	game_timer+=iDeltaTime;
	
	second=game_timer/1000;
	minute=second/60;
	sprintf(buffer,"TIME  %02d:%02d ",minute,second%60);
	//Draw_StringScaleXY(HalfScreenWidth-50,20,1.5,buffer);
	Draw_StringXY(HalfScreenWidth-50,15,buffer);
}

Uint32 game_score=0;

void Draw_misc()
{
	char buffer[64];
	if(player==NULL) return;

//	sprintf(buffer,"score  %2d ",game_score);
	//Draw_StringXY(10,130,buffer);

	sprintf(buffer,"SCORE %7d",game_score);
	Draw_StringXY(10,15,buffer);
	
	sprintf(buffer,"%3d ",player->life_power);
	Draw_LargeStringXY(10,ScreenHeight -50 ,buffer);

	// źâ 
	sprintf(buffer,"%2d/%2d ",player->bullet_n,player->clip_n);
	Draw_StringScaleXY(ScreenWidth-110,ScreenHeight -50,2.5,buffer);

}


//======================= Title ====================

#define MAX_TITLE 64
struct {                                                                                              
    int   active; /* Active (Yes/No) */                                                         
    float fade;   /* Fade Speed      */                                                         
                                                                                                
    float r;      /* Red Value       */                                                         
    float g;      /* Green Value     */                                                         
    float b;      /* Blue Value      */                                                         
    
    int 	life;   
    char 	rgba[4];
    vector 	center[3];
    vector 	direction[3];
    int 	texture_id;

    unsigned char 	buffer[128];

} titles[MAX_TITLE];   

int title_n=0;

init_Title()
{
	int i;
	for(i=0;i<MAX_TITLE;i++)
		titles[i].active=0;		
	title_n=0;
	OK();
}

New_item()
{
	int i;
	for(i=0;i<MAX_TITLE;i++)
		if(titles[i].active==0) break;		
	if(i==MAX_TITLE) ERROR("too many title!!");


	title_n++;
}


void New_Title_base(int x,int y,int time,char *str)
{
	int i;
	for(i=0;i<MAX_TITLE;i++)
		if(titles[i].active==0) break;		
	if(i==MAX_TITLE) ERROR("too many title!!");

	titles[i].active=1;
	titles[i].life=time;
	titles[i].center[0]=x;
	titles[i].center[1]=y;
	strcpy(titles[i].buffer,str);
		
	title_n++;
}

void New_Title_center(char *str)
{
	int n;
	int width;
	int x,y;
	n=strlen(str);
	width=Font_getWidth() * n;	

	y=HalfScreenHeight - 50;	
	x=HalfScreenWidth - (width/2);
	
	New_Title_base(x,y,3000,str);
}



void Do_Title(int index)
{
	float fade;
	fade=titles[index].life;
	fade=fade/2000;

//	glColor4f(1.0, 1.0, 1.0,fade);
	glColor4f(fade, fade, fade,1.0);
//	Draw_StringXY(titles[index].center[0],titles[index].center[1],titles[index].buffer);
   	__DrawStrScaleXY(titles[index].center[0],titles[index].center[1]
			,1.2,
			titles[index].buffer);
//    	__DrawStrScaleXY(x,y,1.3,string);
}
	
// base format
void Title_Draw()
{
	int i;
	int new_title_n;

	new_title_n=title_n;

	for ( i = 0; i < title_n; )  
	{
		if ( titles[i].active )                                                       
		{                 
			titles[i].life-=iDeltaTime;

			if(titles[i].life<0 )
			{
				titles[i].active=0;
				new_title_n--;
	//			continue; 
			}
			else{
				Do_Title(i);

			}
			i++;
		}
	}

	title_n=new_title_n;
}



void DrawAll2D()
{
   // 2D ׸ ʱȭ

//   glShadeModel(GL_SMOOTH);
//   glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
//   glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);
//   glEnable(GL_COLOR_MATERIAL);
	
    	
	glColor4f(1.0, 1.0, 1.0,1.0); // Blending  

	glDisable(GL_CULL_FACE);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);


	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, ScreenWidth, 0, ScreenHeight, -50.0, 50.0);  //   glOrtho(-0.5, 639.5, -0.5, 479.5, -1.0, 1.0);      
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();    



//	DrawTopMenu();


	glColor4f(1.0, 1.0, 1.0,1.0);
	
//	DrawCrossHair();
	Draw_Timer();
	Draw_misc();

	Title_Draw();
	Panel_Draw();
		
	//   glRasterPos2i(ScreenWidth-150,100);
	//   glDrawPixels(ZBUFFER_WIDTH,ZBUFFER_HEIGHT,GL_LUMINANCE,GL_UNSIGNED_SHORT,draw_zbuffer);



	//  Color(BLUE);
	//  DrawLine(10,10,500,300);

}



void DrawAll3D()
{
	int i;
	{
		// glDisable(GL_CULL_FACE);
		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);
		glEnable(GL_DEPTH_TEST);
	}
	draw_polygon_n=0;
	glColor4f(1.0, 1.0, 1.0,1.0); // Blending !

    	if(MapTest_BlcokCellBound ) Draw_BlockCellBound();

	LightingOn();
	
	Draw_Cells();  //ó 
	
  for(i=0;i<ObjectsInFOV_n;i++)	
	draw_object(List_ObjectsInFOV[i]);

	Particle_Draw();
	DrawLightSource();
	
	glDisable(GL_TEXTURE_2D);
	glDisable( GL_BLEND );
	glDisable( GL_LIGHTING );

	glColor4f(1.0, 1.0, 1.0,1.0); // Blending !

	//	draw_lazer();
	//	glClearDepth( 0.9f );  // Ÿ ?
	//	glDepthFunc( GL_LEQUAL ); 
	//	glDepthRange(0,0.99);
	//	glPolygonMode(GL_FRONT,GL_FILL);
	//	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	// 	glPolygonMode(GL_FRONT,GL_FILL);
	
	//    	FogOn();

	//   	draw_axes();
} 



void DrawAll(void)
{

	if(arg_server) return;
	
	glClearColor (0.0, 0.0, 0.0, 0.0);
   	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
//   	glClear(GL_DEPTH_BUFFER_BIT);
    
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
	glDepthFunc(GL_LEQUAL);

   	Sliding_Core();
	DrawAll3D();   // 3D  ׸
	DrawAll2D();   // 2D ׸

// 	Draw_Laser();
// 	glColor4f(1.0, 1.0, 1.0,1.0); // Blending  remove !
//	glCallList(gllist);
//	glDeleteLists(gllist,1); 
//   	t0=SDL_GetTicks();  
//    	t1=SDL_GetTicks(); 

	SDL_GL_SwapBuffers();  
}




int GetPX(int px)
{
    int x;
    if(px >0){
	x=(float)(ScreenWidth/100)*px;
	return x;
    }
    else return x;
}


Init_Panel()
{
	int key;
	init_zbuffer2();

	panelScreen=New_Panel(0,0,ScreenWidth,ScreenHeight,NULL);
	panelDebugLine=New_Panel(0,ScreenHeight-14,ScreenWidth,200,Panel_Draw_debug);
	panelNumMenu=New_Panel(0,110,170,200,NumMenu_Core);
	panelRadar=New_Panel(ScreenWidth-220,20,200,150,Panel_Draw_Radar);
	panelZbuffer=New_Panel(ScreenWidth-220,200,ZBUFFER_WIDTH,ZBUFFER_HEIGHT,Panel_Zbuffer_Draw);

	panelHelp=New_Panel(0,0,ScreenWidth,ScreenHeight,Panel_Draw_Help);
	panel_ServerInfo=New_Panel(0,0,ScreenWidth,ScreenHeight,Panel_Draw_ServerInfo);
	panelConsole=New_Panel(0,0,ScreenWidth,ScreenHeight,Panel_Draw_Console);


//===================================================================
	panelInfo=New_Panel(10,20,ScreenWidth/2,20,Panel_Draw_Info);
//===================================================================

	Panel_Show(panelConsole);
	PrintInfoLineStr[0][0]=0;
	PrintInfoLineStr[1][0]=0;
	PrintInfoLineStr[2][0]=0;
 	OK();
}

Init_Panel2()
{
	Panel_Show(panelDebugLine);
	Panel_Show(panelConsole);
	Panel_Show(panelRadar);
//	Panel_Show(panelZbuffer);

//	Panel_Show(panelInfo); /// ̰ ?
	Panel_Current(panelScreen);
	
	panelConsole->Height=ScreenHeight/2;
	Console_clear();
       	OK();
}



