#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>

#include <GL/gl.h>


#include "SDL.h"
#include "SDL_image.h"



/* Set up some booleans */
#define TRUE  1
#define FALSE 0

/* This is our SDL surface */

SDL_Surface *image;

//GLsizei width,height;
unsigned char *BitmapBits;
char filename[64];

remove_ext(char *fname)
{
    int i;
    for(i=0;0!=fname[i];i++)
	if(fname[i]=='.') fname[i]=0;
}

    
SDL_Surface * LoadImage()
{
    /* Set The Default GL Mode To RBGA (32 BPP) */
    GLuint type = GL_RGBA;
    /* This Will Hold Our RGB Pixel Data */
    GLubyte *RGB_image;
    int imageSize;
    int i;

    if ( !(image = IMG_Load( filename ) ) )
	{
	    fprintf( stderr, "Could not open image: %s: %s\n", filename,
		     SDL_GetError( ) );
	    return( FALSE );
	}

    /* Create A Copy Of The Pixel Data */
    imageSize = image->w * image->h * image->format->BytesPerPixel;
    RGB_image = image->pixels;
    /* Swap The 1st And 3rd Bytes */

    for ( i = 0; i < imageSize; i += image->format->BytesPerPixel )
	RGB_image[i] ^= RGB_image[i + 2] ^= RGB_image[i] ^= RGB_image[i + 2];

    return image;
}

int SaveC()
{
	int BPP=0;
	int lenth,linelenth;
	int row=0;
	char *source;

	int i;

	char filenameExt[64]
		;
	FILE *fd;

	strcpy(filenameExt,"");
	strcat(filenameExt,"image_");
	strcat(filenameExt,filename);
	strcat(filenameExt,".c");

	//    printf("filename=%s\n",filenameExt);
	if(!(fd=fopen(filenameExt,"w")))
	{
		printf("Error\n");
		exit(0);

	}


	if(image->format->BytesPerPixel==4)
	{
		//	printf("RGBA image...\n");
		BPP=4;
	}	
	else {
		//	printf("RGB image...\n");
		BPP=3;
	}	


	lenth=image->w * image->h * BPP;
	BitmapBits=malloc(lenth);

	// upside down
	linelenth=image->w*BPP;

	source=image->pixels + lenth - linelenth;

	for(row=0;row < image->h;row++)
		memcpy(BitmapBits + row*linelenth ,source - row*linelenth ,linelenth);



	fprintf(fd,"/* image to C    by hyun   */\n");
	fprintf(fd,"/* ver 0.01   for openGL   */\n");

	fprintf(fd,"char pixels_%s[ %d *%d *%d ]={\n",filename,image->w,image->h,BPP);

	//    printf("lenth=%d \n",lenth);
	for(i=0;i<lenth-1;)
	{	
		fprintf(fd,"%3d,",BitmapBits[i++]);
		if(!(i%32))
			fprintf(fd,"\n\t");
	}

	fprintf(fd,"%d ",BitmapBits[lenth -1]);
	fprintf(fd,"};\n");


	fprintf(fd,"struct s_gl_image image_%s= { %d, %d, %s,0, pixels_%s };\n"
			,filename,image->w,image->h,"GL_RGBA",filename);



	fclose(fd);

	printf("Saved \"%s\" !!\n",filename);
	return 1;
}


void Quit( int returnCode )
{
    SDL_Quit( );
    exit( returnCode );
}

int texture[3];

int main( int argc, char **argv )
{

    int videoFlags;
    int i;
    
    if ( argc == 1 ) {                                                                
	fprintf(stderr, "GPF convert  by hyun 0.80\n");
	fprintf(stderr, "Usage: %s <imagefile>\n\n", argv[0]);
	exit(1);                                                                        
    }                                                                                       
                
//    printf(" basename %s\n",basename(argv[1]));

    for(i=1;i< argc ;i++)
    {
	strcpy(filename,argv[i]);
	LoadImage();
	remove_ext(filename);
	SaveC();
    }

    return( 0 );
}
