/*
   GPF viewer  	by hyun
*/

#include <endian.h>
#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>

#include "../gpf.c"




/* screen width, height, and bit depth */
int ScreenWidth=256; 
int ScreenHeight=256;
#define SCREEN_BPP     16

/* Set up some booleans */
#define TRUE  1
#define FALSE 0

/* This is our SDL surface */
SDL_Surface *surface;
GPF *g;
GLint texture;

int draw_mode=1;
//  ׸  ʳ ?  2ǹũⰡƴϸ翬 ʳܾ 

GLuint format;
char filename[64];


void Quit( int returnCode )
{
    SDL_Quit( );
    exit( returnCode );
}



void LoadHeader()
{
    if ( g=GPF_fileload(filename) )/// "data/font_lucida_7x12.tga" ) ) )
        {
	    GLuint type;
	    if(g->format==GPF_RGBA) format= GL_RGBA;
	    if(g->format==GPF_RGB) format= GL_RGB;
	    if(g->format==GPF_INDEX) format= GL_COLOR_INDEX;
//	    printf("GL_RGBA=%d,GL_RGB=%d\n",GL_RGBA,GL_RGB);
	    printf("\n");
	    printf("version  = %d \n",g->version );
	    printf("format   = %d ",g->format);
	    if(g->format==GPF_RGB)
	 	   printf("(RGB)\n");
	    if(g->format==GPF_RGBA)
	 	   printf("(RGBA)\n");
	    if(g->format==GPF_INDEX)
	 	   printf("(INDEX)\n");
	    printf("width    = %d \n",g->width);
	    printf("height   = %d \n",g->height);

	    
	    ScreenHeight=g->height;
	    ScreenWidth =g->width;
	    printf("Ok..Headloaded\n");
	}
    else printf("error load..\n");
}

int LoadGLTextures()
{

	    GLuint comp;
	    if(g->format==GPF_RGBA){
		    format= GL_RGBA;
		    comp=4;
	    }
	    if(g->format==GPF_RGB)
	    {
		    format= GL_RGB;
		    comp=3;
	    }
	  
	    if(g->format==GPF_INDEX)
	    {
		    format= GL_COLOR_INDEX;
		    comp=1;
	    }
	   
	    glGenTextures( 1, &texture );
	    glBindTexture( GL_TEXTURE_2D, texture );
	   
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);                                                     
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);  
		
	    // ̰ž ʳ´. 
	    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) ;
            glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	    
            glTexImage2D( GL_TEXTURE_2D, 0, comp, g->width, g->height, 0, format, GL_UNSIGNED_BYTE, g->data );

	    printf("Ok..loaded\n");
    return 1;
}



int resizeWindow( int width, int height )
{
	glViewport( 0, 0, ( GLint )width, ( GLint )height );

	glMatrixMode(GL_PROJECTION);                                                                 
	glLoadIdentity();                                                                            
	glOrtho(0,width, 0, height, -5.0, 5.0);  
	//   glOrtho(-0.5, 639.5, -0.5, 479.5, -1.0, 1.0);      
	glMatrixMode(GL_MODELVIEW);                                                                  
	glLoadIdentity();                                                                            

	return( TRUE );
}

// glDrawPixels ̿ϴ¹ 
int drawGLScene1( GLvoid )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	//glRasterPos2i(0,ScreenHeight - g->height);                                          
	glRasterPos2i(0,0);
	glDrawPixels(g->width,g->height,format,GL_UNSIGNED_BYTE,g->data);          
	SDL_GL_SwapBuffers( );
	return( TRUE );
}


// 
//
int drawGLScene2( GLvoid )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	glEnable( GL_TEXTURE_2D );               
	glLoadIdentity( );

	//̰ ʳ.... ׷ ? :  ̹Ƿ -> ߸. 
	// glColor3f( 1.0f, 1.0f, 1.0f );
	glBindTexture( GL_TEXTURE_2D, texture );

	glBegin( GL_QUADS );
	// **** glVertex2i()  
	// ̹ Ʒ  ϴ°ǰ ?
	glTexCoord2f( 0, 0 );
	glVertex2i( 0, 0 );

	glTexCoord2f( 1, 0 );
	glVertex2i( ScreenWidth,0 );

	glTexCoord2f( 1, 1 );
	glVertex2i( ScreenWidth, ScreenHeight   );

	glTexCoord2f( 0, 1 ); 
	glVertex2i( 0, ScreenHeight );
	glEnd( );

	SDL_GL_SwapBuffers( );
	return( TRUE );
}


void handleKeyPress( SDL_keysym *keysym )
{
	switch ( keysym->sym )
	{
		case SDLK_SPACE:
			draw_mode^=1;
			break;

		case SDLK_ESCAPE:
			Quit( 0 );
			break;
		default:
			Quit( 0 );
			break;
	}

	return;
}



int main( int argc, char **argv )
{

	int videoFlags;
	int done = FALSE;    /* used to collect events */
	SDL_Event event;    /* this holds some info about our display */
	int isActive = TRUE;

	if ( argv[1] == NULL ){
		fprintf(stderr, "gpf viewer by hyun ver\n");
		fprintf(stderr, "Usage: %s <gpf_file>\n\n", argv[0]);
		exit(1);                                                                        

	}
	else strcpy(filename,argv[1]);

	if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
	{
		fprintf( stderr, "Video initialization failed: %s\n",
				SDL_GetError( ) );
		Quit( 1 );
	}

	videoFlags  = SDL_OPENGL;          /* Enable OpenGL in SDL */
	videoFlags |= SDL_GL_DOUBLEBUFFER; /* Enable double buffering */
	videoFlags |= SDL_HWPALETTE;       /* Store the palette in hardware */
	videoFlags |= SDL_RESIZABLE;       /* Enable window resizing */

	LoadHeader(); 	// ScreenHeight,ScreenWidth 

	surface = SDL_SetVideoMode( ScreenWidth, ScreenHeight, SCREEN_BPP,videoFlags );
	if ( !surface )
	{
		fprintf( stderr,  "Video mode set failed: %s\n", SDL_GetError( ) );
		Quit( 1 );
	}

	glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
	
	resizeWindow( ScreenWidth, ScreenHeight );
	LoadGLTextures();

	while ( !done )
	{
		while ( SDL_PollEvent( &event ) )
		{
			switch( event.type )
			{
				case SDL_KEYDOWN:
					handleKeyPress( &event.key.keysym );
					break;
				case SDL_QUIT:
					done = TRUE;
					break;
				default:
					break;
			}
		}

		if(draw_mode)
			drawGLScene1();
		else drawGLScene2();
	}

	Quit( 0 );
	return( 0 );
}
