#include <stdlib.h>
#ifndef _MSC_VER
#include <unistd.h>
#endif
#include "SDL.h"
#include "SDL_net.h"
#include "define.h"
#include "network.h"



struct sClient {
    char name[64];
    Uint32 ipaddr;
    Uint16 port;
} client_list[32];


typedef struct client_info_struct client;
struct client_info_struct {
    char name[64];
    Uint32 ipaddr;
    Uint16 port;
};


client client_slot[32];

// linked list


//sClient *client_list[32];

    
int client_n=0;


int main(int argc, char *argv[])
{
	client *clientinfo;
	IPaddress ip,*remoteip;
	TCPsocket server,client[32];
	char message[1024];
	char buffer[1024];
	int len;
	Uint32 ipaddr;
	Uint16 port;
	
	// check our commandline
	
	// initialize SDL
	if(SDL_Init(0)==-1)
	{
		printf("SDL_Init: %s\n",SDL_GetError());
		exit(1);
	}

	// initialize SDL_net
	if(SDLNet_Init()==-1)
	{
		printf("SDLNet_Init: %s\n",SDLNet_GetError());
		exit(2);
	}

	// get the port from the commandline
	port=TCP_PORT; //strtol(argv[1],NULL,0);
	
	// Resolve the argument into an IPaddress type
	if(SDLNet_ResolveHost(&ip,NULL,port)==-1)
	{
		printf("SDLNet_ResolveHost: %s\n",SDLNet_GetError());
		exit(3);
	}

	// open the server socket
	server=SDLNet_TCP_Open(&ip);
	printf("Listening Clients...\n");


	if(!server)
	{
		printf("SDLNet_TCP_Open: %s\n",SDLNet_GetError());
		exit(4);
	}

   while(1)
   {
		// try to accept a connection
           
	client[client_n]=SDLNet_TCP_Accept(server);
	if(client[client_n])
	{
		// get the clients IP and port number
		remoteip=SDLNet_TCP_GetPeerAddress(client[client_n]);
    		if(!remoteip)
		{
			printf("SDLNet_TCP_GetPeerAddress: %s\n",SDLNet_GetError());
			continue;
		}

		// print out the clients IP and port number
		ipaddr=SDL_SwapBE32(remoteip->host);
		printf("Accepted a connection from %d.%d.%d.%d port %hu\n",
			ipaddr>>24,
			(ipaddr>>16)&0xff,
			(ipaddr>>8)&0xff,
			ipaddr&0xff,
			remoteip->port);

		// read the buffer from client
		len=SDLNet_TCP_Recv(client[client_n],buffer,1024);

		if(!len)
		{
			printf("SDLNet_TCP_Recv: %s\n",SDLNet_GetError());
			continue;
		}

		clientinfo=(struct client_info_struct *)buffer;
		printf("Client[%d]: name=%s\n",client_n,clientinfo->name);
		client_n++;

	}
		else
		{ // no connection accepted
			//printf("SDLNet_TCP_Accept: %s\n",SDLNet_GetError());
			SDL_Delay(100); //sleep 1/10th of a second
			continue;
		}


	}
	
	// shutdown SDL_net
	SDLNet_Quit();

	// shutdown SDL
	SDL_Quit();

	return(0);
}


/*		if(message[0]=='Q')
		{
			printf("Quitting on a Q received\n");
			break;
		}

//		SDLNet_TCP_Close(client);

*/
