#include "define.h"

#ifndef __NETWORK_H
#define __NETWORK_H

#ifdef WIN32 

#else
	#include <netinet/in.h>
#endif

#define NET_PLAYERINFO		1
#define NET_NEW_PLAYER		2
#define NET_DEL_PLAYER		3
#define NET_SERVER_INFO		4		
#define NET_START_GAME		5
#define NET_TOO_MANY_PLAYER	6
#define NET_CLIENT_INFO		7
#define NET_PLAYER_UID		8
#define NET_YOUR_UID		8

#define NET_CONNECTION		30


#define NET_SERVER_UDP_PORT	20	
#define NET_SERVER_REPLY	21

#define NET_SERVER_NUMBER	22
#define NET_SERVER_LIST		23


#define MAXBUF	4096

#define ROOT_SERVER_IP		"168.188.129.194"
#define ROOT_SERVER_PORT	20003

#define CLIENT_TCP_PORT 	20000
#define CLIENT_UDP_PORT 	CLIENT_TCP_PORT
#define GAME_SERVER_PORT	20001

#pragma START_PACK_STRUCTS

typedef struct {
  //  unsigned char size;
    unsigned char id;
    unsigned char n;
    unsigned char data[256];
} PACK_STRUCT TCP_Packet ;


typedef struct {
	unsigned char id;
	unsigned char name[64];
	Uint16 		udp_port;
	int		uid;
	int		object_id;
} PACK_STRUCT Packet_Info ;

typedef struct {
    unsigned char id;
    int		client_n;
    Uint32	time;
    char	version_string[32];
} PACK_STRUCT Packet_Server_Info ;

typedef struct {
    unsigned char id;
} PACK_STRUCT Packet_START_GAME ;


typedef struct {
//   	unsigned char id;
//	Uint32	number;
	char	title[32];
	char 	address[32];
//	char	version[32];
	int	player_n;

}PACK_STRUCT Packet_SERVER_ITEM ;

typedef struct {
    	unsigned char 	id;
	Uint16		number;
	Packet_SERVER_ITEM  list[32];
}PACK_STRUCT Packet_SERVER_LIST ;


typedef struct {
    	unsigned char id;
}PACK_STRUCT Packet_TEMP ;


typedef struct {
//    unsigned char size;
	Uint8		n;
	Uint32		seq;
	int		uid;
	float 		position[3];
	float 		direction[3];
	float 		view_direction[3];
	float 		move_direction[3];
	float 		move_speed;
	float 		relativeAlt;
	float 		rotate[3];
	float		heading,pitch;
	Uint16		action_test;

	Uint8		hit;
	int		hit_uid;
	Sint16		hit_damage;
	Sint16		hit_joint;

} PACK_STRUCT Packet_UDP ;



typedef struct {
//    unsigned char size;
    unsigned char pointer;
    unsigned char data[32];
}PACK_STRUCT UDP_Packet ;

#pragma END_PACK_STRUCTS

typedef struct s_cli {
	int 	uid;
	int	seq;
	int	loss;
	int	misc;
	int	fps;
} Packet_Client_Info;


void init_Network(); // SERVER 
void check_protocol();
void Network_Connect();
void DealNetwork();

#endif
