// Model -> Shape 
//  Shape is better word than Model !! 
//
//
#define Polygon PolygonX
typedef struct {
    	int 	flag;
    	int 	vertex_n;
    	int 	isBack;
    	int 	texture_id;
    	Vector 	Normal; //DEL
		vector	normal[3];
    	Vertex 	vertex[16];
    	Position2D *TexCoord;
} Polygon;



typedef struct {
    int 	flag;  // attribute 
    int 	mode;  // attribute 

    int		FrameID;
    Vector 	normal;
    vector 	norm[3];
    int 	attribute;
    int 	vertex_id[3]; // this is better for Skeleton Animation!!!!!
    Vertex 	vertex[3];   // this is better for MAP .. static model !!!!
    int 	texture_id;
    Position2D 	TexCoord[3];
} SharedTriangle;




#define TRIANGLE_FLAG_MAP  	111
#define TRIANGLE_FLAG_MODEL  	222 

typedef struct {
	int 	flag;   // attribute
	int	isBack;

	float 	normal[3]; 
	int 	vertex_id[3]; 	// this is better for Skeleton Animation!!!!!
	Vertex 	vertex[3];   	// this is better for MAP .. static model !!!!
	int 	texture_id;

	// dont used but .... what ??
	Position2D 	TexCoord[3];   // for more flexiable but  not used for MilkShape Model
	int		joint;

} Triangle ;  // Static Size !!!!!!!!!!!!!!!!

#define Face Triangle

              
//DEL not used
typedef struct {
	int id;
	int linked_id;
	float x,y,z;
} Skeleton;

typedef struct sKey {
	float translate[3];
    	float rotate[3];
    	float orient[3]; // not used 

	Uint32  msec;
	int	event;
	int	event_seq; 
	// example  
	// if(event==SOUND) playsound(event_seq);
} Key;


typedef struct sAni {
	char name[64];    	
	int  id ;
	unsigned int time;
	unsigned int start;
	unsigned int end;
	unsigned int frame_n;
	int	joint_n;
	Key 	**frame;  //this will be  frame[joint_number ][ sequence_key ].translate[0] ;
//	AniCluster *frame;
} Ani;


// cluster
typedef struct sJoint {
  	int 	id; 
	char 	name[64];    	


	Key 	*frame;

    	int 	child_n;
    	int 	child_memory_n;
    	int 	vertex_n;
    	int 	vertex_memory_n;
	

	int 	*vertex_id; 	//  speed down ...  pointer better! 
	Vertex 	**vertex;	// this will be  *vertex[0]
	
	float   rotate[3]; 
	float   translate[3]; 

	int	parent_id; // this better 
	struct 	sJoint *parent;
    	struct 	sJoint *child[32];  //static better 

	int	child_id[32];
	

	float	mReference[4][4];  //used 
	float	mAbsolute[4][4];
	float  	mRelative[4][4];
	float  	mRelativeFinal[4][4];

} Joint;



typedef struct sShape 
{
	char 	name[32];

	unsigned long	FrameID;

	int	key; 
	int 	nextKey;
	int 	ani_state;


	int 	ani_n;		//   ִϸ̼  used
	int 	frame_n; 	// DEL 

	int 	vertex_n;
	int 	triangle_n;
	int 	joint_n; 
	int 	polygon_n;

	int 	triangle_memory_n;
	int 	polygon_memory_n;

	float 	x,y,z;		// ǹ -> tlansrate[3]  -> center[3];
	float   center[3];
 
	float 	min_x,min_y,min_z,max_x,max_y,max_z;
	float 	radius;

	//Bound		bound;
	Vertex 		*vertex;  	//vertex list 
	Vertex		*vertex0;
	Triangle 	*triangle;
	Joint		*joint;  	// joint list
	Ani		*ani;
	
	Triangle 	*share_triangle;  //ٸ shape ϴ triangle 
	
	int		*animation;  // animation ID list
	int		animationKey;
	
	Polygon		*polygon;  


	int		shape_n;
	struct sShape 	*parent;
	struct sShape 	*shape[32];


	//   
	float   	rotate[3]; 
	float   	translate[3]; 

	int 		id;
	int		level; // ??
	int 		flag;  // triangle mode 

} Shape; 


Joint * Joint_Init(Joint *j);
void Shape_MakeTriangleMemory(Shape *s,int n);


#define ANI_PLAYING   	1
#define ANI_STOP   	9
#define ANI_INIT   	99
#define ANI_END   	0

//??? 
#define ANI_GUN_DRAW   		 0
#define ANI_GUN_IDLE   		 1
#define ANI_GUN_RELOAD   	 2
#define ANI_GUN_SHOT	   	 3


#define ANI_GUN_GLOCK18_DRAW   		0
#define ANI_GUN_GLOCK18_RELOAD   	2
#define ANI_GUN_GLOCK18_SHOOT   	3

#define ANI_GUN_MP5_DRAW   		0
#define ANI_GUN_MP5_IDLE   		1
#define ANI_GUN_MP5_RELOAD   		2
#define ANI_GUN_MP5_SHOT1  		3
#define ANI_GUN_MP5_SHOT2  		4
#define ANI_GUN_MP5_SHOT3  		5

#define INTERUPT_ENABLE		1
#define INTERUPT_DISABLE		0



#define ANI_BOY_IDLE   		0
#define ANI_BOY_RUN   		1
#define ANI_BOY_JUMP   		2
#define ANI_BOY_LONGJUMP   	3
#define ANI_BOY_DEAD_1   	4
#define ANI_BOY_DEAD_2   	5
#define ANI_BOY_SHOT_KNIFE   	7
#define ANI_BOY_RELOAD_MP5	6
#define ANI_BOY_RELOAD_handgun	8
#define ANI_BOY_THREAD		9
#define ANI_BOY_CROUCH_IDLE	10
#define ANI_BOY_CROUCH_RUN	11
#define ANI_BOY_DEATH_HEAD   	12

// Ʈġ ȣ 
#define BODY_SPINE    2
#define BODY_SPINE2   4
#define BODY_SPINE3   5
#define BODY_HEAD     7
#define BODY_R_HAND	26
#define BODY_R_HAND_FINGER	30
#define BODY_L_TOE   43
#define BODY_R_TOE   49

// SET_ACTION  ȯ   upper,lower .
#define PLAYER_IDLE 	1000
#define PLAYER_RUN 	1
#define PLAYER_JUMP 	2
#define PLAYER_CROUCH 	3
#define PLAYER_SHOT 	4444
#define PLAYER_KNIFE 	55
#define PLAYER_DEAD_1 	5
#define PLAYER_DEAD_2 	6
#define PLAYER_RELOAD 	3333
#define PLAYER_RECLIP 	3333


// SET_ACTION    upper,lower .
#define IDLE		0x0001
#define CROUCH		0x0002
#define RUN		0x0004
#define FORWARD		0x0004
#define BACKWARD	0x0008
#define JUMP		0x0010
#define LEFTSIDE	0x0020
#define RIGHTSIDE	0x0040

//ACTION upper 
#define RELOAD	0x0100
#define SHOT	0x0200
#define DEAD	0x0400


// Object->weapon
#define KNIFE		1
#define MP5		2
#define GLOCK18		3
/* 
 *
 *  viewdirection[3];
 *  center[3];
 * 
 * 
 *
 */



