#include "define.h"
//#include "core.h"
#include "network.h"


#define MAX_CLIENT	64

Uint32 t,T0,iDeltaTime=0;
//Uint32 game_timer=0;
int game_timer=0;

struct s_client {
	int	using;	
	char 	name[256];
	char  	address[64];
	char 	version[32];
	
	int	server_flag;

	int	uid;		// unique player ID
	Uint32	ipaddr;
	Uint32	host;
	int	seq;

	char	os[128];
	char    gl_driver[128];
	int	fps;
	
	int	player_n;
	int 	last_packet_uid;
	
	UDPsocket udp_socket;
	TCPsocket tcp_socket;

} client[MAX_CLIENT];


int		client_n=0;
int 		server_n=0;

struct s_server {
	int	using;	
	char 	name[256];
	char  	address[64];
	char 	version[32];
	
	char	os[128];
	char    gl_driver[128];
	int	fps;
	int	player_n;
	
	UDPsocket udp_socket;
} server_list[MAX_CLIENT];

Packet_Client_Info client_info[MAX_CLIENT];


Uint16 		port;

IPaddress 	ip,*remoteip;
TCPsocket 	server_socket;
TCPsocket 	tcp_socket;
SDLNet_SocketSet  tcp_socket_set;
SDLNet_SocketSet  udp_socket_set;

UDPsocket 	udp_socket;

Packet_Info	*packet_info;
//del Packet_data	*packet_data;
Packet_Info	packet_info_out;

int		out_n=0;

char 		recv_buffer[MAXBUF];
char 		send_buffer[MAXBUF];
int 		numused;
//Server 


void reset_client(int index)
{
	client[index].using=0;
	client[index].server_flag=0;
	client[index].tcp_socket=NULL;
	client[index].udp_socket=NULL;
}

send_TCP(int id, void *buff, int len )
{
	int i,result;
	Uint16 size;
	
	size=len;
	SDLNet_TCP_Send(client[id].tcp_socket,&size,2); 
	result=SDLNet_TCP_Send(client[id].tcp_socket,buff,len); 

	if(result<len){
		printf("SDLNet_TCP_Send: %s\n",SDLNet_GetError());
		//printf("ERROR:SDLNet_TCP_Send: r=%d %s\n",result,SDLNet_GetError());
		exit(0);
	}
}


send_TCP2(TCPsocket tcp_socket, void *buff, int len )
{
	int i,result;
	Uint16 size;

	size=len;
	SDLNet_TCP_Send(tcp_socket,&size,2); 
	result=SDLNet_TCP_Send(tcp_socket,buff,len); 

	if(result<len){
		printf("SDLNet_TCP_Send: %s\n",SDLNet_GetError());
		//printf("ERROR:SDLNet_TCP_Send: r=%d %s\n",result,SDLNet_GetError());
		exit(0);
	}
}



void init_Network() // SERVER 
{
	int len,i;
	Uint32 ipaddr;
	Uint16 port;
	
	
	// initialize SDL
	if(SDL_Init(0)==-1)
	{
		printf("SDL_Init: %s\n",SDL_GetError());
		exit(1);
	}

	if(SDLNet_Init()==-1)
	{
		printf("SDLNet_Init: %s\n",SDLNet_GetError());
		exit(2);
	}

	
	// Resolve the argument into an IPaddress type
	if(SDLNet_ResolveHost(&ip,NULL,ROOT_SERVER_PORT)==-1)
	{
		printf("SDLNet_ResolveHost: %s\n",SDLNet_GetError());
		exit(3);
	}
	
	// open the server socket
	server_socket=SDLNet_TCP_Open(&ip);
	printf("Listening Clients... \n");
	if(!server_socket)
	{
		printf("SDLNet_TCP_Open: %s\n",SDLNet_GetError());
		exit(4);
	}
	
//del 	udp_socket=SDLNet_UDP_Open(UDP_PORT);
		

	for(i=0;i<MAX_CLIENT;i++)
	{
		reset_client(i);
	}


	tcp_socket_set=SDLNet_AllocSocketSet(MAX_CLIENT);
	if(!tcp_socket_set) {
		printf("SDLNet_AllocSocketSet: %s\n", SDLNet_GetError());
		exit(1); //most of the time this is a major error, but do what you want.
	}

	// server_socket tcp_socket_set ߰Ѵ 
	numused=SDLNet_TCP_AddSocket(tcp_socket_set,server_socket);
	if(numused==-1) {
    		printf("SDLNet_AddSocket: %s\n", SDLNet_GetError());
   		 // perhaps you need to restart the set and make it bigger...
	}
	
	udp_socket_set=SDLNet_AllocSocketSet(1);	
	if(!udp_socket_set) {
		printf("SDLNet_AllocSocketSet: %s\n", SDLNet_GetError());
		exit(1); //most of the time this is a major error, but do what you want.
	}

	// Ҵ 
	//UDP ̸ ٸְ ,Ҷ  bind,unbind  ϸǴ. 
/*	for(i=0;i<MAX_CLIENT;i++)
	{	
		UDPsocket udpsock;
		udpsock=SDLNet_UDP_Open(UDP_PORT);
		if(!udpsock) {
			printf("SDLNet_UDP_Open: %s [%d]\n", SDLNet_GetError(),i);
			exit(2);
		}
		client[i].udp_socket=udpsock;
	} */


}


show_static()
{
	int i;
	int server_n=0;
	int idx=0;
	
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(client[i].server_flag==1)
		{
			server_n++;
		}
	}

	printf("============================================\n");
	printf("server_n=%d\n",server_n);
	printf("index	address		title\n",server_n);

	for(i=0;i<MAX_CLIENT;i++)
	{
		if(client[i].server_flag==1)
		{
			printf("%2d  %13s   %s \n",idx++,client[i].address,client[i].name);
		}
	}

	printf("============================================\n");


}

// client server ش. 
void init_server(int n)
{
	int 	channel,len;
	int	result;
	unsigned char send_size;
	Packet_Info *packet_info;


	packet_info=(Packet_Info*)recv_buffer;
	strcpy(client[n].name,packet_info->name);

	client[n].server_flag=1;
	server_n++;

	show_static();
}



void del_server(int n)
{
	int 	channel,len;
	int	result;
	int 	uid;
	unsigned char send_size;
	
	printf("SDLNet_TCP_Recv: %s\n",SDLNet_GetError());
	printf("	maybe disconnect ? -> right \n");

	tcp_socket=client[n].tcp_socket;
	SDLNet_TCP_DelSocket(tcp_socket_set,tcp_socket);
	SDLNet_TCP_Close(tcp_socket);

	if(client[n].server_flag) server_n--;
	reset_client(n);
	client_n--;
}



// OK 
void del_client(int n)
{
	int 	channel,len;
	int	result;
	int 	uid;
	unsigned char send_size;
	
//	printf("SDLNet_TCP_Recv: %s\n",SDLNet_GetError());
//	printf("	maybe disconnect ? -> right \n");
	printf("disconnect !\n");

	tcp_socket=client[n].tcp_socket;
	SDLNet_TCP_DelSocket(tcp_socket_set,tcp_socket);
	SDLNet_TCP_Close(tcp_socket);

	if(client[n].server_flag) server_n--;
	reset_client(n);
	
	client_n--;

	show_static();
}


// templete
send_TEMP()
{
	int len;
	int i;
	Packet_TEMP server_temp;

	server_temp.id=NET_START_GAME;
	len=sizeof(Packet_TEMP);
	
	memcpy(send_buffer,&server_temp,len);
//	send_toAll_tcp(send_buffer,len);
}


send_NET_SERVER_LIST(int n)
{
	int len;
	int i;
	int idx;
	Packet_SERVER_LIST packet;


	
	idx=0;
	for(i=0;i<MAX_CLIENT;i++)
	{
		if(client[i].server_flag==1)
		{
			strcpy(packet.list[idx].title,client[i].name);
			strcpy(packet.list[idx].address,client[i].address);
			idx++;
		}
	}
	
	packet.id=NET_SERVER_LIST;
	packet.number=idx;
	
	//len=3 +  sizeof(Packet_SERVER_ITEM)*server_n;
	len=3 +  sizeof(Packet_SERVER_ITEM)*idx;
	send_TCP(n,&packet,len);
	
	printf("server_n=%d  !\n",idx);
	printf("send_NET_SERVER_LIST !\n");
}



UDP_send_SERVER_LIST()
{
	int len;
	int i;
	Packet_TEMP server_temp;

	server_temp.id=NET_START_GAME;
	len=sizeof(Packet_TEMP);

	memcpy(send_buffer,&server_temp,len);
	//send_TCP(n,send_buffer,len);
}


Uint32 server_info_time=0;


packet_parsing(int n)
{

	int 	channel,len;
	int	result;

	switch(recv_buffer[0]){
		case NET_SERVER_LIST:
			send_NET_SERVER_LIST(n);				
			break;
		case NET_CLIENT_INFO:
			init_server(n);
			break;
		default:
			//printf("TCP_Recv %d bytes  from [%d] ???????\n",len,i);
			printf("paralle ??? \n");
	}

}



void poll_TCP()
{
	TCPsocket tcp_socket;
	Uint32 	ipaddr;

	int 	len;
	int 	i;
	int 	channel;
	int 	n;

	Uint16 recv_size;

	n=SDLNet_CheckSockets(tcp_socket_set, 10);
	if(n==0) return;

// **** Լ  soecket_Set ִ°͸  üũѴ. 
// server_socket  ο Ŭ̾Ʈϰ ...
if(SDLNet_SocketReady(server_socket))
{
	// non-blocking mode 
	// get a new client-connected-socket 
	tcp_socket=SDLNet_TCP_Accept(server_socket);
	if(tcp_socket)
	{
		// get the clients IP and port number
		remoteip=SDLNet_TCP_GetPeerAddress(tcp_socket);
		if(!remoteip){
			printf("SDLNet_TCP_GetPeerAddress: %s\n",SDLNet_GetError());
			return;
		}

	
		//ִ ڸã 
		for(i=0;i<MAX_CLIENT;i++)	//if(client[i].using==0) 
			if(client[i].tcp_socket==NULL) 
				break;

		if(i>=MAX_CLIENT){
			printf("Too many client !!\n");
			return;
		}

		client[i].using=1;
//del 		client[i].host=remoteip->host;// network endian 
		client[i].tcp_socket=tcp_socket;
		client[i].udp_socket=NULL;  //TCP ⶧ ʿ.
		strcpy(client[i].name,"null");

		// print out the clients IP and port number
		ipaddr=SDL_SwapBE32(remoteip->host);
		sprintf(client[i].address,"%d.%d.%d.%d",
				ipaddr>>24,(ipaddr>>16)&0xff,(ipaddr>>8)&0xff,	ipaddr&0xff);
		
		// tcp_socket_set  οŬ̾Ʈ tcp_socket߰ 
		numused=SDLNet_TCP_AddSocket(tcp_socket_set,tcp_socket);
		if(numused==-1) {
			printf("SDLNet_AddSocket 1: %s\n", SDLNet_GetError());
			// perhaps you need to restart the set and make it bigger...
		}
		printf("new client !!\n");
	}

}


	for(i=0;i<MAX_CLIENT;i++)
	{
		
		//if(client[i].using==0)  continue;
		if(client[i].tcp_socket==NULL)  continue;
		tcp_socket=client[i].tcp_socket;
		if(!SDLNet_SocketReady(tcp_socket)) continue;
		
		// read the buffer from client
		SDLNet_TCP_Recv(tcp_socket,&recv_size,2);
		len=SDLNet_TCP_Recv(tcp_socket,recv_buffer,recv_size);
		if(len<=0)
		{
			//  ó 
			del_client(i);
			continue;
		} 
		///printf("recv  !!\n");
		//  ƴ϶ 
		packet_parsing(i);
	}

}


IPaddress ip;


int main()
{
	Uint32 ipaddr;
	TCPsocket tcp_socket;
	init_Network();
	srand(0); 

	while(1)
	{
		t = SDL_GetTicks();  //	return value is  mili seconds !!!!
    		iDeltaTime = t - T0; 	 //   seconds = mseconds / 1000;
    		T0 = t;     		
		poll_TCP(); // TCP ó 		
	}

	// shutdown SDL_net
	SDLNet_Quit();
	// shutdown SDL
	SDL_Quit();

	return(0);
}
