/* GPF file implementation by hyun 
   load,save

   support  RGBA

 */

#define  VERSION  0.1

#include <stdlib.h>
#include <stdio.h>
#include "define.h"
#include "core.h"



typedef struct s_gpf 
{
    char id[3]; // GPF
    int  version;
    int  type;
    int  width,height;
    long  length;
    char *data;
} PACK_STRUCT  GPF;
#define GPF_RGB	    3
#define GPF_RGBA    4

void GPF_RGB2RGBA(GPF *h)
{
    unsigned char r,g,b,a;
    int i,j;
    //unsigned 
    char *data,*dest;
    

    if(h->type==GPF_RGBA) return ;

    dest=malloc( h->width * h->height * 4 );

    data=h->data;

    j=0;
    for( i=0;i< h->length; )
    {
	r=data[i++];
	g=data[i++];
	b=data[i++];
	a=(r+g+b)/3;
//	printf("a=%d ",a);
	dest[j++]=r;
	dest[j++]=g;
	dest[j++]=b;
	dest[j++]=a;	
    }
    free(data);
    h->data=dest;
    h->type=GPF_RGBA;
    h->length=h->width * h->height * 4;
}

// GPF_New
#define New_GPF GPF_New
GPF *GPF_New(int width,int height,int type,char *data)
{
    GPF  *h;
    
    h = malloc(sizeof(GPF_HEADER)); 
    strcpy(h->id,"GPF");

    h->version=1;

    h->width=width;
    h->height=height;
    h->type=type;

    if( type==GPF_RGB)
        h->length=width*height*3;
    if( type==GPF_RGBA)
        h->length=width*height*4;

    h->data=data;    
    
    return h;
}


void GPF_Remove(GPF *g)
{
    free(g->data);
    free(g);
}



int GPF_filesave(GPF *h,char *filename)
{
    FILE *fd;
    if(!(fd=fopen(filename,"w"))) printf("GPF_filesave: file open Error!! ");

    fwrite(h,sizeof(GPF_HEADER),1,fd);
    fwrite(h->data,h->length,1,fd);
    fclose(fd); 
    return 1;
}


GPF *GPF_fileload(char *filename)
{
    FILE *fd;
    GPF  *h;
//    char *data;
#ifdef GPF
//DEL    if(!(fd=fopen(GetDirName(filename),"r")))
#else
    if(!(fd=fopen(filename,"r")))
#endif
    {	    
	    printf("Error...GPF_fileload: file \"%s\" open Error!! ",filename);
    	    exit(1);return NULL;
    }
    

    h = malloc(sizeof(GPF)); 
//    h = GPF_New(

    fread(h,sizeof(GPF_HEADER), 1, fd);

    h->data = malloc(h->length); 
    fread(h->data,h->length, 1, fd);
    fclose(fd);
    return h;
}

