// 2003.04.11 
// add
//
//

#include <GL/gl.h>
#include <time.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>


//#include "define.h"

#define WIDGET_CENTER 		0
#define WIDGET_LEFTCONNER	1

#define WIDGET_BUTTON	0
#define WIDGET_INPUT	1

#define WIDGET_ON_MOUSE		32

typedef struct {
	int x1;
	int y1;
	int x2;
	int y2;
	int what;
	void *where;
} widget_area;


int widget_n=0;
widget_area widgets[256];

int wmouse_x;
int wmouse_y;
int wmouse_state;

#define WIDGET_BUTTON_3D 	11
#define WIDGET_BUTTON_3IMG 	13

typedef struct {
	int x1;
	int y1;
	int x2;
	int y2;
	int state;
	char *buffer;
	gl_image *normal;
	void (*func)();
} widget_input;


typedef struct {
	int x1;
	int y1;
	int x2;
	int y2;
	int state;
	int mode;
	gl_image *normal;
	gl_image *on_mouse;
	gl_image *clicked;
	void (*func)();
} widget_button;







#define PanelHeight ScreenHeight

void DrawLine(int x1,int y1,int x2,int y2)
{
   glBegin( GL_LINES );
   glVertex2f( x1, PanelHeight - y1 );
   glVertex2f( x2, PanelHeight - y2 );
   glEnd();
}

                                                                                    
DrawRect(int x1,int y1,int w,int h)                                                             
{                                                                                               
     glRecti(x1, PanelHeight - y1, x1+w, PanelHeight -y1 -h);                                   
}            

int DrawCharXY(int x,int y,char ch)
{
  	glRasterPos2i(x,ScreenHeight - y);

  	glutBitmapCharacter(GLUT_BITMAP_9_BY_15, ch);
  /*glutStrokeCharacter(GLUT_STROKE_ROMAN,i); */
// GLUT_BITMAP_TIMES_ROMAN_24
	return glutBitmapWidth(GLUT_BITMAP_9_BY_15,ch);

}


DrawStrXY(int x,int y,char *str)
{
	while(*str)
		x+=DrawCharXY(x,y,*str++);
	
}

                                                                                      

widget_new(int x,int y,int w,int h,int what,void *p)
{
	widgets[widget_n].x1=x;	
	widgets[widget_n].y1=y;	
	widgets[widget_n].x2=x+w;	
	widgets[widget_n].y2=y+h;	
	widgets[widget_n].what=what;
	widgets[widget_n].where=p;	
	widget_n++;
}
	

widget_new_input(int x,int y,int width)
{
	widget_input *w;
	

	w=(widget_input *)malloc(sizeof(widget_input));


	widget_new(x,y,width,18,WIDGET_INPUT,w);
}

widget_new_button(int mode,int x,int y,gl_image *normal,gl_image *on_mouse,gl_image *clicked,void *f)
{
	int nx,ny;
	widget_button *b;
	b=(widget_button *)malloc(sizeof(widget_button));

	if(mode==WIDGET_CENTER){
		nx=x-(normal->width/2);
		ny=y-(normal->height/2);
	
	}
	
	printf("nx=%d x=%d, ny=%d y= %d\n",nx,x,ny,y);
	b->x1=nx;
	b->y1=ny;
	b->x2=nx+normal->width;
	b->y2=ny+normal->height;


	b->normal=normal;
	b->on_mouse=on_mouse;
	b->clicked=clicked;
	b->func=f;
	b->mode=WIDGET_BUTTON_3IMG;
		
	widget_new(nx,ny,normal->width,normal->height,WIDGET_BUTTON,b);

}

gl_image *MakeBlackImage(gl_image *img)
{
	gl_image *t;
	int i,j;
	int length;
	unsigned char r,g,b,a;
	
	t=(gl_image *)malloc(sizeof(gl_image));
	t->height=img->height;
	t->width=img->width;
	t->format=img->format;

	length=t->width * t->height * 4;
	t->pixels=(unsigned char*)malloc(length); 

	j=0;                                                                                        
   
	for( i=0;i< length; )
    {                                                                                           
        r=img->pixels[i++];                                                                            
        g=img->pixels[i++];
        b=img->pixels[i++];                                                                            
        a=img->pixels[i++];
//      printf("a=%d ",a);                                                                      
//	if(a>0){
	t->pixels[j++]=a/10;
        t->pixels[j++]=a/10;                                                                            
        t->pixels[j++]=a/10;                                                                            
        t->pixels[j++]=a;
//	}
    }    
	return t;
}



widget_new_button3D(int mode,int x,int y,gl_image *normal,void *f)
{
	int nx,ny;
	widget_button *b;

	b=(widget_button *)malloc(sizeof(widget_button));

	if(mode==WIDGET_CENTER){
		nx=x-(normal->width/2);
		ny=y-(normal->height/2);
	
	}

	if(mode==WIDGET_LEFTCONNER){
		nx=x;
		ny=y;
	}


//	printf("nx=%d x=%d, ny=%d y= %d\n",nx,x,ny,y);
	b->x1=nx;
	b->y1=ny;
	b->x2=nx+normal->width;
	b->y2=ny+normal->height;


	b->normal=normal;
	b->mode=WIDGET_BUTTON_3D;
	b->func=f;

    	b->on_mouse=MakeBlackImage(normal);


	widget_new(nx,ny,normal->width,normal->height,WIDGET_BUTTON,b);

}

/*
widget_new_button2(int mode,int x,int y,gl_image *normal,gl_image *on_mouse,gl_image *clicked,void *f)
{
	widget_button *b;
	b=(widget_button *)malloc(sizeof(widget_button));
	b->normal=normal;
	b->on_mouse=on_mouse;
	b->clicked=clicked;
	b->func=f;
} */


widget_draw_button(widget_button *b)
{


	//if(b->state!=WIDGET_ON_MOUSE)	
//    if(b->mode==WIDGET_BUTTON_3IMG)	
	
	if( (b->x1 < wmouse_x && wmouse_x < b->x2) &&
			( b->y1 < wmouse_y && wmouse_y < b->y2))
	{
//		printf("xxxx\n");
    		if(b->mode==WIDGET_BUTTON_3D)
		{
			
			if(wmouse_state==GLUT_DOWN) {
				Draw_image(b->x1,b->y1,b->normal);
			}
			else{
				Draw_image(b->x1,b->y1,b->on_mouse);
				Draw_image(b->x1-5,b->y1-5,b->normal);
			}
		}
		else			
			Draw_image(b->x1,b->y1,b->on_mouse);
	}

	else{
		Draw_image(b->x1,b->y1,b->normal);

	}
}


widget_draw()
{

	int i;
	
	for(i=0;i<widget_n;i++)
	{
		switch(widgets[i].what)
		{
			case WIDGET_BUTTON :
				widget_draw_button(widgets[i].where);
				break;
		}
	}
}



int input_state=0;

widget_inputx(int x,int y,char *str)
{
	int len;
	len=strlen(str);
	
}





/*
if ( state ) {                                                                                
  curr_cursor = GLUT_CURSOR_TEXT;                                                       
    glutSetCursor( GLUT_CURSOR_TEXT );                                                          
  }                                                                                             
  else {
    glutSetCursor( GLUT_CURSOR_LEFT_ARROW );
  }

*/


widget_draw_input()
{
//	if(input_state==0)
//		draw_cursor();

	
}

widget_event_keyboard(int k)
{

	


}


widget_mouse(int button,int state,int x,int y)
{
	int i;
	widget_area *w;
	widget_button *b;

	wmouse_x=x;
	wmouse_y=y;
	wmouse_state=state;

	for(i=0;i<widget_n;i++)
	{
		w=&widgets[i];
		if( ( widgets[i].x1 < x && x< widgets[i].x2 ) 
		&& (widgets[i].y1 < y && y< widgets[i].y2 ) )
		{
			switch( widgets[i].what){
				case WIDGET_BUTTON : 
					
//					b=(widget_button *)w->where;
//					b->state=WIDGET_ON_MOUSE;	
//					widget_draw_button((widget_button *)w->where,1);
					
					if(state==GLUT_DOWN) {
						b=(widget_button *)w->where;
						b->func();
					}
					break;
			}
			
		}
	 

	}
}
	

