#include "system.h"
#include "math.h"

// ̰ 𼭶 ? mesa ?sgi?
void glLookAt(float  eye[3], float forward_dir[3],float v_up[3] )
{
	int i,j;
	float  side[3],up[3] ;
	GLfloat m[4][4];
	
	//	vectorCopy(up,v_up);
	/* Side = forward x up */
	vectorCrossProduct(side,forward_dir, v_up);
	//vectorNormalize(forward_dir); 
	vectorNormalize(side);
	//vectorNormalize(v_up);
	
	/* Recompute up as: up = side x forward */
	vectorCrossProduct(up,side, forward_dir);  

	matrixZero(m);
	
	m[0][0] = side[0];
	m[1][0] = side[1];
	m[2][0] = side[2];

	m[0][1] = up[0];
	m[1][1] = up[1];
	m[2][1] = up[2];

	m[0][2] = -forward_dir[0];
	m[1][2] = -forward_dir[1];
	m[2][2] = -forward_dir[2];
	
	glMultMatrixf(&m[0][0]);
	glTranslatef(-eye[0], -eye[1], -eye[2]);
}


//  ǹ̴ glmatrix  ־ٶ 
// transposѴ.
//
void test_matrix()
{
	float m[4][4];
	float PM[4][4];
	float v[3]={10,20,35};
	glMatrixMode(GL_PROJECTION_MATRIX);
	glLoadIdentity();

//	glMultMatrixf(&m[0][0]);

	glTranslatef(10, 20, 30);
	glGetFloatv(GL_PROJECTION_MATRIX,PM[0]);
	PM[0][1]=12;
	PM[0][2]=13;
	PM[0][3]=14;
	PM[1][2]=23;
	PM[1][3]=24;
	PM[1][0]=21;
	PM[2][0]=31;
	PM[2][1]=32;
	PM[3][0]=41;
	PM[3][2]=42;
	PM[1][1]=22;
	matrixPrint(PM);
	matrixTranspose(PM);
	matrixPrint(PM);

	matrixZero(m);
	matrixTranslate(m,v);
	matrixPrint(m);
	
	glLoadMatrixf(m[0]);
	glGetFloatv(GL_PROJECTION_MATRIX,PM[0]);
	//matrixTranspose(PM);
	matrixPrint(PM);

//	matrixTranspose(PM);
	system_exit();
}

float rot_mat[4][4];  // depth buffer ?
float PM[4][4]; // projection matrix
float MM[4][4];

// DRAFT  , center=target position;
void glLookAt_(float  eye[3], float center[3],float up[3] )
//void glLookAt_(float  eye[3], float dir[3],float up[3] )
{
	float m[4][4];
	vector dir[3];
	vector left[3];
	vector up_[3];

	vectorCopyf(up_,up);	

	vectorCopyf(dir,eye);	
	vectorSubtractM(dir,center);
	vectorNormalize(dir);
	
	// left͸  up  
	vectorNormalize(up_);   // effect 
	vectorCrossProduct(left,up_,dir);
	vectorNormalize(left); // effect

	vectorCrossProduct(up_,dir,left);
	vectorNormalize(up_);

	matrixZero(m);
	m[0][0] = left[0];
	m[0][1] = left[1];
	m[0][2] = left[2];

	m[1][0] = up_[0];
	m[1][1] = up_[1];
	m[1][2] = up_[2];

	m[2][0] = dir[0];
	m[2][1] = dir[1];
	m[2][2] = dir[2];
	
	m[3][3] = 1;

	matrixTranspose(m); // to GL 
	matrixCopy(rot_mat,m);
	

	// Frustrum_matrix * GL_PROJECTION
	glMultMatrixf(&m[0][0]); 
	glTranslatef(-eye[0], -eye[1], -eye[2]);

	glGetFloatv(GL_PROJECTION_MATRIX,PM[0]);
	matrixTranspose(PM);
//	test_matrix();
}

extern int DWIDTH,DHEGIHT;

int glProject(float v[3],float w[3])
{
	float o[4],c[4],d[3];
	float f,n;
	o[0]=v[0];
	o[1]=v[1];
	o[2]=v[2];
	o[3]=1.0;
	
	matrixMultvector4f(PM,o,c); //result c[4]
	if (c[3] == 0.0) return 0;  //?
	
	//if(c[3]!=1.0) 	console_printf("c[3]=%f",c[3]);
//	if(PM[2][3]<0.0) 	console_printf("pm[2][3]=%f",PM[2][3]);
	d[0]=c[0]/c[3];
	d[1]=c[1]/c[3];
	d[2]=c[2]/c[3];

	// ??
	d[0]=d[0]*0.5 + 0.5;
	d[1]=d[1]*0.5 + 0.5;
//	d[2]=d[2]*0.5 + 0.5; // usless ?

	//f=500,n=5;
	w[0]=d[0] * DWIDTH + 0;
	w[1]=d[1] * DHEGIHT+ 0;
	w[2]=d[2];
//	w[2]=(d[2] + 1)*0.5;
//	if(w[2]>1 or w[2]<0) return 0;
	if(w[2]<0) return 0;
	return 1;
}

int glProjecti(float o[4],int w[3])
{
	float c[4],d[3];
	float f,n;
	o[3]=1.0;
	
	matrixMultvector4f(PM,o,c); //result c[4]
	if (c[3] == 0.0) return 0;  //?
	
	d[0]=c[0]/c[3];
	d[1]=c[1]/c[3];
	d[2]=c[2]/c[3];

	if(d[2]>=1 or d[2]<0) return 0;
	// ??
	d[0]=d[0]*0.5 + 0.5;
	d[1]=d[1]*0.5 + 0.5;
//	d[2]=d[2]*0.5 + 0.5; // usless ?

	//f=500,n=5;
	w[0]=FAST_ROUND(d[0] * DWIDTH + 0);
	w[1]=FAST_ROUND(d[1] * DHEGIHT+ 0);
	w[2]=FAST_ROUND((d[2]) * 255); // 0~4.0
//	w[2]=(d[2] + 1)*0.5;
//	if(w[2]<0) return 0;
	if(w[2]<0) w[2]=0;
	return 1;
}

/*
Here is the equation I came up with when I was playing around with it:

        winz = 1.0 - (m_z_near * m_z_far / m_eye_off - m_z_near) / (m_z_far -
m_z_near);

m_eye_off was the offset in -ve Z from the target point.

Jeff Holt
Intergraph Corp 
*/
