#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>

#ifndef LIST_H
#define LIST_H

template <class ListItem> class List2
{
public:
    List2() 
        :m_numelements(0)
    {
        m_head = new Link;
        m_tail = new Link;
        m_head->next = m_tail;
        m_tail->next = m_tail;
    };
    ~List2()
    {    
        Link* before = m_head;
        Link* after;

        while (before->next != m_tail)
        {
            after = before->next->next;
            delete before->next;
            before->next = after;
        }

        delete m_head;
        delete m_tail;
    };

    void Insert(int index, const ListItem& data)
    {
        Link* before = m_head;
        Link* newnode;

        for (int i=0;i<index;i++)
            before = before->next;
        newnode = new Link(data);
        newnode->next = before->next;
        before->next = newnode;
        m_numelements++;
    }

    void remove(int index)
    {
        Link* before = m_head;
        Link* after;

        for (int i=0;i<index;i++)
            before = before->next;

        after = before->next->next;
        delete before->next;
        before->next = after;
        m_numelements--;
    }

    ListItem operator[](int index)
    {
        Link* element = m_head->next;
        for (int i=0;i<index;i++)
            element = element->next;
        return element->data;
    }

    int size()      // number of elements in the list
    {
        return m_numelements;
    }

private:

    // node in our list
    struct Link
    {
        Link()
            :next(NULL) {};
        Link(const ListItem& datain)
            :data(datain),
            next(NULL) {};
        Link*   next;   // next node in list    
        ListItem    data;   // data stored in this node
    };

    // head and tail
    Link*   m_head;
    Link*   m_tail;
    int     m_numelements;
};

// ver 0.1
// 1. int_key Dictionary  support
// 2. 
template <class T> class List
{
public:
	struct Node 
	{
		public:
		Node(const T& x, Node* n=NULL) :data(x),next(n){ }
		Node* before;
		Node* next;
		int	 index;
		T data;
	};

public:
	Node	*head;
	Node	*end;
	Node	*cur_node;
	int	node_n;

	List() : head(0),end(0),node_n(0),cur_node(0) { 	}
	~List() {
		//printf("List: destroy!\n");
		clear(); 
	}

	//ok works, hash code 
	T operator[](const int idx)
	{	
		Node *node;
		node=get_node(idx);
		if(node==NULL)
			return NULL;
			//printf("List: node no exist !!! over index \n");
		return node->data;
	}
	
	int  	size()  { return node_n; }
	void 	begin() { cur_node=head; }
	void 	next()  { if(cur_node) cur_node=cur_node->next;  }  
	int	find(T x){
		for ( Node *n = head; n!= NULL ; n=n->next )
			if(n->data==x) {
				cur_node=n;
				return 1;
			}
		return 0;
	}
	
	int	find_reverse(T x){
		for ( Node *n = end; n!= NULL ; n=n->before )
				if(n->data==x) {
					cur_node=n;
					return 1;
				}
		return 0;
	}

	T current() 
	{ 
		if(cur_node)
			return cur_node->data; 
		else 
			return NULL;
	}

	//void clear() { while (head) remove_node(end); }
	void clear() { while (head) pop_front(); }
	T pop_front() 
	{	 
		T x=head->data;	
		remove_node(head);  
		return x;
	}

	void push_front(const T& x) {
		Node* tmp = new Node(x,head); head = tmp;
	}
	
	// draft
	void addcopy(const T x) {
		T n=new T();
		memcpy(n,x,sizeof(T));
	}
	// append to the last , return idx
	int add(const T x) {
		Node	*node;
		//ex: first , end node 
		node = new Node(x,0);
		if(head==0)
		{
			head=node;		
			node->before=0;
		}
		else
		{
			end->next=node;
			node->before=end;
		}
		node->index=node_n;	//	printf("node_n=%d\n",node_n);
		end=node;
		node_n++;
		return node_n-1;
	}
	// work?
	void append(int idx,const T x) {
		Node	*node;		
		//ex: first , end node 
		node = new Node(x);
		if(head==0)
			head=node;
		else
			end->next=node;
		
		node->before=end;
		node->next=0; 	//last
		end=node;

		if(idx>=0)
			node->index=idx;
		else
			node->index=node_n;
		node_n++;
	}

	//return old data
	T replace(int idx,const T x) 
	{
		Node	*node;
		T		old_data;
		node=get_node(idx);
		if(node==NULL)
		{
			append(idx,x);
			old_data=NULL;
		}
		else
		{
			old_data=node->data;
			node->data=x;
		}
		return old_data;
	}

	//ok works
	Node* get_node(int idx)
	{	
		for ( Node *n = head; n!= NULL ; n=n->next )
			if(n->index==idx) return n;
		return NULL;
	}

	void reindex(){
		int i=0;
		for ( Node *n = head; n!= NULL ; n=n->next )
			n->index=i++;
	}

	void remove_current()	{	
		Node *tmp=cur_node;
		if(tmp==NULL) 
		{
			printf("List:remove_current():  node 0 ? \n");
			exit(0);
			return ;
		}
		cur_node=tmp->next;
		remove_node(tmp);

	}
	//ok works , NO DATA !!
	void remove_node(Node *node)
	{
		Node *before,*next;
	
		if(node==0)
		{	
			printf("List:  node 0 ? \n");
			exit(0);
			return ;
		}

		// 1. if fist node remove   head==node,before=0
		// 2. if last node remove	end== node, next=0;
		// 3. only one remove	head ==end== node, before==next==0
		before=node->before;  
		next=node->next;    
		// basis
		if (before)
			before->next=next;
		else
			head=next;
		
		if (next)
			next->before=before;
		else
			end=before;

		//delete node->data;// VALGRIND !
		//delete node;
		node_n--;
	}

	//ok works
	void remove(int idx) 
	{ 
		Node *node;
		node=get_node(idx);
		if(node!=0)
			remove_node(node);
		else
		{
			printf("List : wrong index [%d] size = %d\n",idx,node_n);
			for ( Node *n = head; n!= NULL ; n=n->next )
				printf("	index [%d] \n",n->index);
			exit(0);
		}
	}

};


// ...
class List_string : public List <char *>
{
	public:
	List_string() :List<char*>()
	{
	}
	/*
	void remove_node(Node *node)
	{
		Node *before,*next;
		if(node==0)
		{	
			printf("List:  node 0 ? \n");
			return ;
		}
		before=node->before;  
		next=node->next;    
		
		// basis
		if (before!=0)
			before->next=next;
		else
			head=next;
		
		if (next!=0)
			next->before=before;
		else
			end=before;
		
		free( node->data );	// ***
		delete node;
		node_n--;
	}*/

	int add_str(const char *str)
	{
		//char *buff=(char *)malloc(strlen(str)+1);
		char *buff= strdup (str);
		return List<char*>::add(buff);
		//List<char*>::add(str);
	}
};

/*
class String
{
public:
	String(){data=NULL;};
	String(char *str)
	{
		data=NULL;
	//	data="xxx";
		set(str);
	};
	~String()
	{
	//	printf(" Destruct !!\n");
		free(data);
	};

	void set(char *str)
	{
		free(data);
		data=(char *)malloc(strlen(str)+1);
		strcpy(data,str);
	}
	void set(const char *str)
	{
		free(data);
		data=(char *)malloc(strlen(str)+1);
		strcpy(data,str);
	}
	String& operator=(char *str)
	{
		printf("String *\n");
		set(str);
	}

	String& operator=(String &str)
	{
		printf("String &\n");
		set(str.get());
	//	set(str);
	}
	
	String operator=(String &str)
	{
		set(str.get());
	//	set(str);
	}

	void operator+(String str)
	{
		set(str.get());
	//	set(str);
	}

	char * get()
	{
		return data;
	}
	private:

	char *data;


};
*/
extern "C"
{
    typedef int (*compare_func)(const void *, const void *);
}

#define DEBUG 
template<class T> class Index
{
	public:
	T *index;
	int allocated_size;
	int used;

    Index(int max = 16)
	{
		index=(T *)malloc(sizeof(T)*max);
		allocated_size=max;
		used=0;	
	}
	
    ~Index()
	{
		free(index);
	}
	
	T operator[](int i)
	{
		#ifdef DEBUG
		/*if(i>=used)
		{
			printf("INDEX: over ?\n");
			exit(0);
		}*/
		#endif
		if(i>=used) return 0;

	    return index[i];
	}

	int size() { return used; }
	void add(T x){
		if(++used >= allocated_size)
			grow();
		index[used-1] = x;
	}

	void add(Index<T> *I){
		for(int i=0;i<I->used;i++)
			add(I->index[i]);
	}

	T front_pop()
	{
		return 0;
	}
	T top()
	{
		if(used==0) 
			return 0;
		return index[used-1];
	}

	T pop()
	{
		if(used==0) 
			return 0;
		used--;
		return index[used];
	}
	void insert(int idx,T val)
	{
		add(index[idx]);
		index[idx]=val;
	}     
	void remove(int idx)
	{
		#ifdef DEBUG
		if ( idx >= used ) 
		{ 
			std::cerr << "INDEX attempt to remove object " << idx << " from array with only " << used << " objects\n"; 
			exit(0); 
		} 
		#endif		
			
		used--;
		index[idx]=index[used];
	}

	/*
	void remove(T x)
	{
		int idx=-1;
		for(int j = 0; j < used ; j++)
			if(index[j]==x)	idx=j;
		if(idx>=0) Index::remove(idx);

	}*/

	void remove_order(int idx)
	{
		#ifdef DEBUG
		if ( idx >= used ) 
		{ 
			std::cerr << "INDEX attempt to remove object " << idx << " from array with only " << used << " objects\n"; 
			exit(0); 
		} 
		#endif		
		
		for(int j = idx; j < used - 1; j++)
			index[j] = index[j + 1];
		used--;
	}
	void clear(){ used=0;	}
	void grow()
	{
		allocated_size*= 2;
		index = (T *)realloc(index, allocated_size * sizeof(T));
	}
	void sort(int (*compare)(T a, T b))
	{
		qsort(index, used, sizeof(T),(compare_func) compare);
	}

};

class IndexInt : public Index<int>
{	
	void remove(int idx)
	{
		for(int j = idx; j < used - 1; j++)
			index[j] = index[j + 1];
		used--;
	}

};

//http://www.oroboro.com/rafael/docserv.php?index=algorithms&article=vector
#include <iostream>
#ifndef DBLARRAY_SIZE 
#define DBLARRAY_SIZE 16 
#endif 

template <class T> class DBLARRAY 
{ 
	public: 
		DBLARRAY() { _num = 0; _size = 0; _list = 0; next_idx=0; } 
		DBLARRAY( int size ) { _num = 0; _size = size; _list = new T[_size]; next_idx=0; } 
		~DBLARRAY(){ delete _list; } 
		int Add( T& obj ) 
		{ 
			if ( !_size ) { _size = DBLARRAY_SIZE; _list = new T[_size]; } 
			if ( _size == _num ) 
			{ 
				_size <<= 1; 
				T* tmp = new T[_size]; 
				memcpy( tmp, _list, ( _num * sizeof( T ))); 
				delete (void*)_list; 
				_list = tmp; 
			} 
			_list[ _num ] = (T&)obj; memset( &obj, sizeof(T), 0 ); 
			return _num++; 
		} 
		T Remove() 
		{ 
			if ( !_num ){ 
				std::cerr << "DBLARRAY Underflow (@" << (void*)this << ")\n"; 
				exit(0); 
			} 
			return _list[ --_num ]; 
		} 
		T Remove( int i ) { 
			if ( i > _num ) 
			{ 
				std::cerr << "DBLARRAY attempt to remove object " << i << " from array with only " << _num << " objects\n"; 
				exit(0); 
			} 
			T t = _list[i]; 
			memmove( _list+i, _list+i+1, (( _num - i )*sizeof(T))); _num--; return t; 
		} 
		void Clear(){ _num = 0; } 
		T& operator[]( int i ){ return _list[i]; } 
		T operator[]( int i ) const { return _list[i]; } 
		int IsEmpty(){ return ( _num == 0 ); } 
		int Size() const { return _size; } 
		int Num() const { return _num; } 
		
		// Que
		T Next() { 
			if ( next_idx == _num ) next_idx = 0; 
			return _list[ next_idx++ ]; 
		} 
		// Stack
		void Push( T& obj ){ Add( obj ); } 
		T Pop(){ 
			if ( !_num ) { std::cerr << "DBLSTACK underflow (@" << (void*)this << ")\n"; exit(0);} 
			return _list[ --_num ]; 
		}

	protected: 
		T* _list; 
		int _size; 
		int _num; 
		int next_idx; 
}; 


#endif
