#include <math.h>
#include "math.h"
#include "object/shape.h"

/* __CRT_INLINE float __cdecl rintf (float x)
{
  float retval;
  __asm__ ("frndint;" : "=t" (retval) : "0" (x) );
  return retval;
} */

// 5% error ?


float vectorDistance( float a[3],float b[3])
{
	float v[3];
	vectorSubtract(v,b,a);
	return vectorLength(v);
}

float lineVectorDistance(Line *l, float v[3])
{

	float a[3],b[3],d;
	vectorSubtract(a,v,l->onPoint);
	d=vectorDotProduct3f(a,l->normal);

	vectorCopy3f(b,l->normal);
	vectorScale(b,d);
	vectorAdd(b,l->onPoint);

	return vectorDistance(v,b);
}

//
//  openGL 은 반시계방향 회전임 : glRotatef
//

void vertexCopy(Vertex *vo,Vertex *vin)
{
	vo->x=vin->x;
	vo->y=vin->y;
	vo->z=vin->z;
	vo->u=vin->u;
	vo->v=vin->v;
}

// 
void vertexCopy(Vertex *vr,vector v[3])
{
	v[0]=vr->x;	v[1]=vr->y;	v[2]=vr->z;
}


void vectorPrint(vector v[3])
{
	printf("(%f %f %f)\n",v[0],v[1],v[2]);
}

void vectorSetZero  (vector *v)
{ 
	v[0] = 0; 
	v[1] = 0; 
	v[2] = 0; 
}

void vectorSet  (vector *v, float x,float y, float z)
{ 
	v[0] = x; 
	v[1] = y; 
	v[2] = z; 
} 


void vectorCopy(int out[3],float in[3]) { 
	out[0]=FAST_ROUND(in[0]*1024);
	out[1]=FAST_ROUND(in[1]*1024);
	out[2]=FAST_ROUND(in[2]*1024);
}



void vectorCopy (float out[3],Vertex *v) 
{
	out[0]=v->x ; 
	out[1]=v->y ; 
	out[2]=v->z ; 
}


void vectorCopy (Vertex *v,vector in[3]) 
{
	v->x = in[0]; 
	v->y = in[1]; 
	v->z = in[2]; 
}

//두 벡터 사이의 각을 구한다 
//return : radian > 0 ? 
float vectorAngle(float v1[3],float v2[3])
{
	/*  
	 *   cos(angle)|v1||v2| = v1 dot v2 이용 
	 */
	float dot,angle;
	float len_v1,len_v2;

	len_v1=vectorLength(v1);
	len_v2=vectorLength(v2);
	//  두벡터사의의 각없음 
	if(len_v2==0 || len_v1==0)
	{ 
		len_v2=1024;
		return 0;
	}
//	if(len_v1==0) len_v1=1024;
	dot=vectorDotProduct3f(v1,v2);
	dot=dot/(len_v1*len_v2);
	angle=acos(dot); // always > 0 
//	DEBUG("angle=%f,dot=%f,len_v1=%f,len_v2=%f",angle,dot,len_v1,len_v2);	
	return angle;
}


#ifndef MATH_MACRO
void vectorSubtract (vector3f *va, vector3f *vb) 
{ 
	va[0] = va[0]-vb[0]; 
	va[1] = va[1]-vb[1]; 
	va[2] = va[2]-vb[2]; 
} 

void vectorSubtract (vector3f out[3],vector3f *va, vector3f *vb) 
{ 
	out[0] = va[0]-vb[0]; 
	out[1] = va[1]-vb[1]; 
	out[2] = va[2]-vb[2]; 
} 
 

void vectorCopy (vector out[3],vector *in) 
{
	out[0] = in[0]; 
	out[1] = in[1]; 
	out[2] = in[2]; 
}


void matrixMultvector4f(float mat[4][4], float v[4],  float out[4])
{
	out[0] = vectorDotProduct4f(mat[0],v);
	out[1] = vectorDotProduct4f(mat[1],v);
	out[2] = vectorDotProduct4f(mat[2],v);
	out[3] = vectorDotProduct4f(mat[3],v);
}

float vectorDotProduct4f(float v1[4], float v2[4])
{
	return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2] + v1[3]*v2[3];
}

float vectorDotProduct3f(float v1[3], float v2[3])
{
	return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2];
}
#endif



//"xorps  %%xmm1,%%xmm1" // xmm1 to zero  : XOR 1^1=0
//"movhlps %%xmm0,%%xmm1;"   //  hight 2 float  to xmm1 low
//"movhps %%xmm0,%%xmm1;"   //  cross copy to xmm1
//"addps %%xmm0,%%xmm1;"   //  add 
//	"movlps %1,%%xmm0;"	  // move two float  to xmm0's low
//		"movss  %1,%%xmm0;"  // move float(32bit) to xmm0's low 
//		"xorps  %%xmm0,%%xmm0" // xmm0 to zero  : XOR 1^1=0

//	r=v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2];
//	__asm__("movl %1,%0;":"=r"(result):"r"(r));

	
float vectorDotProduct3fx(float v1[4], float v2[4])
{
	float vr[4];
//	v1[3]=0,v2[3]=0;
	//__asm__ __volatile__ (
	asm (
			"movups %1,%%xmm0;"   // move four float(128bit) to xmm0
			"mulps %2,%%xmm0;"   //  multifly four float(128bit) to xmm0
			"movups %%xmm0,%0;"
			:"=m"(vr):"m"(v1[0]),"m"(v2[0]));
	
	vr[0]+=vr[1];
	vr[0]+=vr[2]; // cached 
//	static int xcount=0;
//	if(v3[3]!=0) console_printf("false=%d",xcount++);
//	console_printf("[%f %f %f ]",v4[0],v4[1],v4[2]);
	return vr[0];
}

// TEST
float  vectorLength_TEST(float v[3])
{
	int		i;
	float	length;
	
   	length = (v[0]*v[0]+v[1]*v[1]+v[2]*v[2]); 
	/*if (length < EPSILON) {
	//	DEBUGB("length is Zero = %f",length);
		return 0; 
	}*/
//	v2sf __builtin_ia32_pfrsqrt (v2sf);
	length = sqrt (length);		// FIXME
	return length;
}

//proved !!
void vectorCrossProduct (float out[3],float v1[3], float  v2[3])
{
	out[0] = v1[1]*v2[2] - v1[2]*v2[1];
	out[1] = v1[2]*v2[0] - v1[0]*v2[2];
	out[2] = v1[0]*v2[1] - v1[1]*v2[0];
}
 
void vectorScale (vector3f v[3], float scale) 
{ 
	v[0] = v[0] * scale; 
	v[1] = v[1] * scale; 
	v[2] = v[2] * scale; 
} 


typedef struct {
      float f[4]; } v4sf;
//typedef float v4sf __attribute__ ((__vector_size__ (16)));
//typedef float v4sf __attribute__  ((vector_size (16)));
v4sf aa;
 
//proved!!
int vectorNormalizeN(float v[3]) 
{    
	float length= vectorLength(v); 	// sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]); 
	//	if (length == 0.0) {	
	//	if ( length >-EPSILON && length < EPSILON) {
	if ( length < EPSILON) {
		// printf("normarlize:""zero length vector\n");    
		v[0]=0,v[1]=0,v[2]=0;
		return 0;
	}
	v[0] /= length; 
	v[1] /= length; 
	v[2] /= length;
	return 1;
}

// 세계의 꼬지점으로부터 법선구하기 
void vectors2normal(float v1[3], float v2[3],float v3[3], float out[3]) 
{ 
		float v4[3],v5[3];
    	v4[0]=v2[0]-v1[0];
    	v4[1]=v2[1]-v1[1];
    	v4[2]=v2[2]-v1[2];
    	v5[0]=v3[0]-v1[0];
    	v5[1]=v3[1]-v1[1];
    	v5[2]=v3[2]-v1[2];
    	vectorCrossProduct(out,v5,v4); // CW -> CCW
    	vectorNormalize(out);
}


void vectorAdd (vector3f out[3], vector3f vb[3]) 
{ 
	out[0] = out[0]+vb[0]; 
	out[1] = out[1]+vb[1]; 
	out[2] = out[2]+vb[2]; 
} 

void vectorAdd (vector3f out[3], vector3f a[3], vector3f vb[3]) 
{ 
	out[0] = a[0]+vb[0]; 
	out[1] = a[1]+vb[1]; 
	out[2] = a[2]+vb[2]; 
} 

//DRAFT 
/*
   glRotate3f(angle,

   http://astronomy.swin.edu.au/~pbourke/geometry/rotate/

   Assume right hand coordinate system.
   Positive angles are anticlockwise looking down the axis
   towards the origin.
*/

void vectorRotate(float v[3],float rad_angle,float  axis[3])
{
	float q[3];
	float costheta,sintheta;
	float theta;

	//theta=RADIAN(angle);
	theta=rad_angle;

	vectorSet(q,0,0,0);
	vectorNormalize(axis);
	costheta = cos(theta);
	sintheta = sin(theta);

	q[0] += (costheta + (1 - costheta) * axis[0] * axis[0]) * v[0];
	q[0] += ((1 - costheta) * axis[0] * axis[1] - axis[2] * sintheta) * v[1];
	q[0] += ((1 - costheta) * axis[0] * axis[2] + axis[1] * sintheta) * v[2];

	q[1] += ((1 - costheta) * axis[0] * axis[1] + axis[2] * sintheta) * v[0];
	q[1] += (costheta + (1 - costheta) * axis[1] * axis[1]) * v[1];
	q[1] += ((1 - costheta) * axis[1] * axis[2] - axis[0] * sintheta) * v[2];

	q[2] += ((1 - costheta) * axis[0] * axis[2] - axis[1] * sintheta) * v[0];
	q[2] += ((1 - costheta) * axis[1] * axis[2] + axis[0] * sintheta) * v[1];
	q[2] += (costheta + (1 - costheta) * axis[2] * axis[2]) * v[2];

	vectorCopy3f(v,q);
}

void matrixCopy(float out[4][4],float in[4][4])
{
	int r,c;
	for(r=0;r<4;r++)
		for(c=0;c<4;c++)
			out[r][c]=in[r][c];

}

void matrixPrint(float mat[4][4])
{
		int r,c;
		for(r=0;r<4;r++)
		{
			printf("|");
			for(c=0;c<4;c++)
				printf(" %5.1f ",mat[r][c]);

			printf("|\n");
		}	
		printf("\n");
}

void matrixZero(float mat[4][4])
{
	int r,c;

	for(r=0;r<4;r++)
	{
		mat[r][0]=0;
		mat[r][1]=0;
		mat[r][2]=0;
		mat[r][3]=0;
	}
	return;
}

// proved 
void matrixTranspose(float mat[4][4])
{
	int r,c;
	float f;

	for(r=0;r<4;r++)
	{
		for(c=r+1;c<4;c++)
		{
			f=mat[r][c];
			mat[r][c]=mat[c][r];
			mat[c][r]=f;
		}
	}
}
/*
	matrixZero(m);
	m[0][0] = 1;
	m[0][1] = 2;
	m[0][2] = 3;
	m[0][3] = 4;
	m[1][0] = 5;
	m[1][1] = 6;
	m[1][2] = 7;
	m[1][3] = 8;

	m[2][0] = 9;
	m[2][1] = 10;
	m[2][2] = 11;
	m[2][3] = 12;
	m[3][0] = 13;
	m[3][1] = 14;
	m[3][2] = 15;
	m[3][3] = 16;

	matrixTranspose(m);
	matrixPrint(m);
	system_exit();
*/	


// Description :  matrix * vector
// 3행 버린다. if v[3]==1 일때 
void matrixMultvector(float mat[4][4], float v[3],  float out[3])
{
	out[0] = vectorDotProduct3f(v, mat[0]) + mat[0][3];
	out[1] = vectorDotProduct3f(v, mat[1]) + mat[1][3];
	out[2] = vectorDotProduct3f(v, mat[2]) + mat[2][3];
}



void matrixTranslate(float mat[4][4],float v[3])
{
	mat[0][3]=v[0];
	mat[1][3]=v[1];
	mat[2][3]=v[2];
}

// rotate by the inverse of the matrix
// 회전행렬의 transepose는 역변환(역행열)임.
void matrixIMultvector( float m[4][4],float in1[3], float out[3])
{
	out[0] = in1[0]*m[0][0] + in1[1]*m[1][0] + in1[2]*m[2][0];
	out[1] = in1[0]*m[0][1] + in1[1]*m[1][1] + in1[2]*m[2][1];
	out[2] = in1[0]*m[0][2] + in1[1]*m[1][2] + in1[2]*m[2][2];
}


//  입력각 angles[3]에 따른  회전 매트리스 M 생성 
//
//  반시계방향(CCW)생성한다  angle은 라디안값
//  (Z*Y)*X then transpose = ? same ?
//   보류,
//
//   m_rotX * m_rotY * m_rotZ 
void matrixAngles (float angles[3], float mat[4][4] )
{
	float		angle;
	float		sr, sp, sy, cr, cp, cy;
	if(1)
	{
	//????????????????????????????????????????
	// NOT  m_rotX * m_rotY * m_rotZ  
	//  shoud be radian !
	angle = angles[2]; 	// * (M_PI*2 / 360);
	sy = sin(angle);
	cy = cos(angle);
	angle = angles[1];	// * (M_PI*2 / 360);
	sp = sin(angle);
	cp = cos(angle);
	angle = angles[0];	// * (M_PI*2 / 360);
	sr = sin(angle);
	cr = cos(angle);

	// matrix = (Z * Y) * X
	mat[0][0] = cp*cy;
	mat[1][0] = cp*sy;
	mat[2][0] = -sp;
	mat[3][0] = 0;
	mat[0][1] = sr*sp*cy+cr*-sy;
	mat[1][1] = sr*sp*sy+cr*cy;
	mat[2][1] = sr*cp;
	mat[3][1] = 0;
	mat[0][2] = (cr*sp*cy+-sr*-sy);
	mat[1][2] = (cr*sp*sy+-sr*cy);
	mat[2][2] = cr*cp;
	mat[3][2] = 0;

	mat[0][3] = 0.0;
	mat[1][3] = 0.0;
	mat[2][3] = 0.0;
	mat[3][3] = 1.0;
	}
	else
	{
		float A,B,C,D,E,F,AD,BD;
		float angle_x,angle_y,angle_z;
		angle_x=angles[0];
		angle_y=angles[1];
		angle_z=angles[2];

		A       = cos(angle_x);
		B       = sin(angle_x);
		C       = cos(angle_y);
		D       = sin(angle_y);
		E       = cos(angle_z);
		F       = sin(angle_z);
		AD      =   A * D;
		BD      =   B * D;

		mat[0][0]  =   C * E;
		mat[0][1]  =  -C * F;
		mat[0][2]  =   D;
		mat[1][0]  =  BD * E + A * F;
		mat[1][1]  = -BD * F + A * E;
		mat[1][2]  =  -B * C;
		mat[2][0]  = -AD * E + B * F;
		mat[2][1]  =  AD * F + B * E;
		mat[2][2]  =   A * C;
		mat[0][3]  =  mat[1][3] = mat[2][3] = 0;
		mat[3][0]  =  mat[3][1] = mat[3][2] = 0;
		mat[3][3] =  1;
	}
}

//  기능: A와 B의 곱 
//
//  나중에 mmx나 3dnow로 변경해봐야.
//  (in1) x (in2) = (out)
//  
//  matrix 곱은 계속 누적가능함.
void matrixMult(float in1[4][4],  float in2[4][4], float out[4][4])
{
	if(0)
	{
	out[0][0] = in1[0][0] * in2[0][0] + in1[0][1] * in2[1][0] + in1[0][2] * in2[2][0];
	out[0][1] = in1[0][0] * in2[0][1] + in1[0][1] * in2[1][1] + in1[0][2] * in2[2][1];
	out[0][2] = in1[0][0] * in2[0][2] + in1[0][1] * in2[1][2] + in1[0][2] * in2[2][2];
	out[0][3] = in1[0][0] * in2[0][3] + in1[0][1] * in2[1][3] + in1[0][2] * in2[2][3] + in1[0][3];
	out[1][0] = in1[1][0] * in2[0][0] + in1[1][1] * in2[1][0] + in1[1][2] * in2[2][0];
	out[1][1] = in1[1][0] * in2[0][1] + in1[1][1] * in2[1][1] + in1[1][2] * in2[2][1];
	out[1][2] = in1[1][0] * in2[0][2] + in1[1][1] * in2[1][2] + in1[1][2] * in2[2][2];
	out[1][3] = in1[1][0] * in2[0][3] + in1[1][1] * in2[1][3] + in1[1][2] * in2[2][3] + in1[1][3];
	out[2][0] = in1[2][0] * in2[0][0] + in1[2][1] * in2[1][0] + in1[2][2] * in2[2][0];
	out[2][1] = in1[2][0] * in2[0][1] + in1[2][1] * in2[1][1] + in1[2][2] * in2[2][1];
	out[2][2] = in1[2][0] * in2[0][2] + in1[2][1] * in2[1][2] + in1[2][2] * in2[2][2];
	out[2][3] = in1[2][0] * in2[0][3] + in1[2][1] * in2[1][3] + in1[2][2] * in2[2][3] + in1[2][3];
	}
	else
	{
		// proved
		int r,c;
		for(r=0;r<4;r++)
			for(c=0;c<4;c++)
				out[r][c]=in1[r][0]*in2[0][c] + in1[r][1]*in2[1][c] 
					+ in1[r][2]*in2[2][c] + in1[r][3]*in2[3][c];
	}
}

void make_XrotateMatrix(float theta,float mat[4][4])
{
	mat[0][0]=1;	mat[0][1]=0;	mat[0][2]=0;	mat[0][3]=0;
	mat[1][0]=0;	mat[1][3]=0;
	mat[2][0]=0;	mat[2][3]=0;
	mat[3][0]=0;	mat[3][1]=0;	mat[3][2]=0;	mat[3][3]=1;

	mat[1][1]=cos(theta);	mat[1][2]=-sin(theta);
	mat[2][1]=sin(theta);	mat[2][2]=cos(theta);
}


// example.
//	make_rotateMatrix(90, (1,0,0), matrix) : rotate matrix by X axis
//	
void make_rotateMatrix(float theta,float norm[3],float mat[4][4])
{


}

int test_intersect_triangle_line(Triangle *t,Line *line1,float *distance);
int test_intersect_triangle_triangle(Triangle *src_tr,Triangle *dst_t)
{
	float distance;
	Line line;
	for(int i=0; i<2;i++)
{
	vectorCopyf(line.onPoint,dst_t->vertice[i]);
	vectorCopyf(line.normal,dst_t->vertice[i+1]);
	vectorSubtract2f(line.normal,dst_t->vertice[i]);
	float edge_len=vectorLength(line.normal);
	vectorNormalize(line.normal);
 	
	int result= test_intersect_triangle_line(src_tr,&line,&distance);

	if (result)
	{	
		// if(distance >= edge_len) 
		if(distance<0)
		printf("distance=%f\n",distance);
			return 1;
	}
}

	return 0;
}

int test_intersect_triangle_triangle(float *s_verts[3],float *d_verts[3],float *distance)
{
		

}

//return distance 
int test_intersect_triangle_edge(float *verts[3],float *edge[2],float *distance)
{
	Line line;
	vectorCopyf(line.onPoint,edge[0]);
	vectorCopyf(line.normal,edge[1]);
	vectorSubtract2f(line.normal,edge[0]);

	float edge_len=vectorLength(line.normal);
	vectorNormalize(line.normal);
 	
	int result= test_intersect_triangle_line4(verts,&line,distance);

	if (result)
	{	
		if(*distance >= edge_len) 
			return 1;
	}
	return 0;	
}

// *CULL MODE : normal 방향 충돌만 검사, 반대방향 충돌무시 

// -> NO CULL ?
int test_intersect_triangle_line(Triangle *tr,Line *line1,float *distance)
{
	const float *vert0,*vert1,*vert2;
	float *dir,*orig;
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;
	float t,u,v;

	dir=line1->normal;
	orig=line1->onPoint;

	vert0=tr->vertice[0];
	vert1=tr->vertice[1];
	vert2=tr->vertice[2];

	/* find vectors for two edges sharing vert0 */
	vectorSubtract(edge1,vert1,vert0);
	vectorSubtract(edge2,vert2,vert0);

	vectorCrossProduct(pvec,dir,edge2); // 삼각형의 한 모서리와 직선방향 벡터곱 
	det = vectorDotProduct3f(edge1, pvec);  // 직선과 삼각형이 평행한가 검사 

	if (det < EPSILON)		return 0;
	vectorSubtract(tvec, orig, vert0);
	
	u = vectorDotProduct3f(tvec, pvec);
	if (u < 0.0 || u > det)		return 0;
	
	vectorCrossProduct(qvec, tvec, edge1);
	
	v = vectorDotProduct3f(dir, qvec);
	if (v < 0.0 || u + v > det)	return 0;

	t = vectorDotProduct3f(edge2, qvec);
	inv_det = 1.0 / det;
	t *= inv_det;
	
	*distance=t;
	//console_printf("d=%f",t);
	return 1;
}

int test_intersect_triangle_line4(float *verts[3],Line *line1,float *distance)
{
	const float *vert0,*vert1,*vert2;
	float *dir,*orig;
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;
	float t,u,v;

	dir=line1->normal;
	orig=line1->onPoint;

	vert0=verts[0];
	vert1=verts[1];
	vert2=verts[2];

	/* find vectors for two edges sharing vert0 */
	vectorSubtract(edge1,vert1,vert0);
	vectorSubtract(edge2,vert2,vert0);

	vectorCrossProduct(pvec,dir,edge2); // 삼각형의 한 모서리와 직선방향 벡터곱 
	det = vectorDotProduct3f(edge1, pvec);  // 직선과 삼각형이 평행한가 검사 

	if (det < EPSILON)		return 0;
	vectorSubtract(tvec, orig, vert0);
	
	u = vectorDotProduct3f(tvec, pvec);
	if (u < 0.0 || u > det)		return 0;
	
	vectorCrossProduct(qvec, tvec, edge1);
	
	v = vectorDotProduct3f(dir, qvec);
	if (v < 0.0 || u + v > det)	return 0;

	t = vectorDotProduct3f(edge2, qvec);
	inv_det = 1.0 / det;
	t *= inv_det;
	
	*distance=t;
	//console_printf("d=%f",t);
	return 1;
}

int test_intersect_square_line(float *verts[4],Line *line,float *distance)
{
	test_intersect_triangle_line4(verts,line,distance);
	test_intersect_triangle_line4(&verts[1],line,distance);
}

// work?
int test_intersect_quad_line_1(float *verts[4],Line *line1,float *distance)
{
	float *vert0,*vert1,*vert2;
	float *dir,*orig;
	float edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
	float det,inv_det;
	float t,u,v;

	dir=line1->normal;
	orig=line1->onPoint;

	vert0=verts[0];
	vert1=verts[1];
	vert2=verts[2];

	/* find vectors for two edges sharing vert0 */
	vectorSubtract(edge1,vert1,vert0);
	vectorSubtract(edge2,vert2,vert0);

	vectorCrossProduct(pvec,dir,edge2); // 삼각형의 한 모서리와 직선방향 벡터곱 
	det = vectorDotProduct3f(edge1, pvec);  // 직선과 삼각형이 평행한가 검사 

	if (det < EPSILON)		return 0;

	vectorSubtract(tvec, orig, vert0);	
	u = vectorDotProduct3f(tvec, pvec);
	if (u < 0.0 || u > det)		return 0;
	
	vectorCrossProduct(qvec, tvec, edge1);
	v = vectorDotProduct3f(dir, qvec);
	if (v < 0.0 || u + v > det)	return 0;

	t = vectorDotProduct3f(edge2, qvec);
	inv_det = 1.0 / det;
	t *= inv_det;
	
	*distance=t;
	//console_printf("d=%f",t);
	return 1;
}


