#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include "list.h"
#include "system.h"

char buff[2048];
void system_exit();
void system_error(const char *fmt,...)
{                                                                                               
    va_list arg_ptr;
    static char buffer[128];   
                                                                                                
    va_start(arg_ptr, fmt); 
    vsprintf(buffer, fmt, arg_ptr);
    printf("ERROR:  %s \n",buffer);
    system_exit();
}

#include <sys/time.h>
// return mili seconds 
long current_time(void)
{
   struct timeval tv;
   struct timezone tz;
   (void) gettimeofday(&tv, &tz);
   //return (long) tv.tv_sec * 1000000 + (long) tv.tv_usec;
   return (long) tv.tv_sec * 1000000 + (long) tv.tv_usec;
}

// 파일패스네임에서 파일이름만 추출  
// WIN32에 없는 함수
char *basename(const char *filename)
{
	char *p = strrchr (filename, '/');
	return p ? p + 1 : (char *) filename;
}


//기능:파일이름에서 확장자만 제거 
void remove_ext(char *fname)
{
	int i;
	for(i=0;0!=fname[i];i++)
		if(fname[i]=='.') fname[i]=0;
}

char null_ext[]="null_ext";
char *get_ext(char *path)
{
	char *p;
	p=strrchr(path,'.');
	if(p)
		p++;
	if(p) 
		return p;
	else
		return null_ext;
}

void get_basename_without_ext(char *dst, char *path)
{
	strcpy(dst,basename(path));
	remove_ext(dst);	
}
//ok
//Description: 
//		1.remove newline(0x0A) or return(0x0D)
//		2.return count if found "newline"
int strip_ctrlchar(char *str)
{
	char *str_o;
	int i=0;
	int count=0;
	
	str_o=str;

	while(*str)
	{
		if(*str==0x0d)
			;
		else if(*str==0x0a)
			count++;
		else
			buff[i++]=*str;
		str++;
	}
	buff[i]=0;
	strcpy(str_o,buff);
	return count;
}


// 대문자 소문자로바꾸기 
// str2lowercase function()
void strlowcase(char *s)
{

	//while ( *s != '\0' )
	while ( *s != 0x00 )  //this is better  ㅋ ㅋ ㅋ 
	{
		if ( *s >= 'A' && *s <= 'Z' )
		{
			*s += 32; 
		}
		s++;
	}
}


class File_List
{
	public:
	File_List(char *fn,char *fp)
	{
		filename=strdup(fn);
		filepath=strdup(fp);
	}
	~File_List()
	{
		free(filepath);
		free(filename);
	}
	//private:
	char *filename;
	char *filepath;
};

List<File_List*> Filelist;
#include <dirent.h>
void dump_dir(const char *dir_path)
{	
	char	path[64];	
	DIR 	*d;	
	struct dirent *e;

	d = opendir(dir_path);
	if(!d)
	{
		//printf("init_filelist(): can't open %s\n",dir_path);
		return;		
	}
	while((e = readdir(d)) != 0) 
	{
		if(e->d_name[0]=='.') continue;
	
		strcpy(path,dir_path);		
		strcat(path,"/");
		strcat(path,e->d_name);
	
		if(strchr(e->d_name,'.')==0)
		//if(e->d_type==DT_DIR)  // dosen't work
		{
			dump_dir(path);
		}
		else
		{
			//printf("fname=%s , path=%s , type %d\n",e->d_name,path,e->d_type);
			Filelist.add(new File_List(e->d_name,path));
		}
	}
	closedir(d);
}



void init_filelist(const char *fdir_path)
{

	FILE 	*fd;
	int		i,j,k,n=0;
	char 	filename[128];
	char 	pathname[128];
	int		len;
	DIR 	*d;	
	struct dirent *e;
	
	d = opendir(fdir_path);
	if(!d)
		system_error("init_filelist(): can't open %s",fdir_path);
	closedir(d);
	dump_dir(fdir_path);

	printf("FileList size=%d\n",Filelist.size());
//	system_exit();
}


//get pathname from FilelistDB
char *get_pathname(const char *name)
{
   	int	 i,size;
	char *fname;
	
	fname=basename(name);
	size=Filelist.size();
	for(i=0;i<size;i++)
	{
		if(!strcmp(Filelist[i]->filename,fname))
			return Filelist[i]->filepath;
		if(!strncmp(Filelist[i]->filename,fname,strlen(fname)))
			return Filelist[i]->filepath;
	}
	printf("get_pathname(): Error! can't find [%s]\n",name);
	return NULL;
}

int vsscanf3(const char *s,const char *fmt, va_list va)
{
    // A simplified vsscanf implementation, 
    // solely for cStatistic::freadvarsf.
    // Only recognizes %s %f,%d, %u, %ld, %lu, %lg and 
    // whitespace. '#' terminates scanning.

	int k=0;
	while (1)
	{
		if (*fmt=='%')
		{
			int n;
			if (fmt[1]=='s')
			{
				k+=sscanf(s,"%s%n",va_arg(va,char *),&n);
				s+=n; fmt+=2;
			}
			else if (fmt[1]=='f')
			{
				k+=sscanf(s,"%f%n",va_arg(va,float*),&n);
				s+=n; fmt+=2;
			}
			else if (fmt[1]=='d')
			{
				k+=sscanf(s,"%d%n",va_arg(va,int*),&n);
				s+=n; fmt+=2;
			}
			else if (fmt[1]=='u')
			{
				k+=sscanf(s,"%u%n",va_arg(va,int*),&n);
				s+=n; fmt+=2;
			}
			else if (fmt[1]=='l' && fmt[2]=='d')
			{
				k+=sscanf(s,"%ld%n",va_arg(va,long*),&n);
				s+=n; fmt+=3;
			}
			else if (fmt[1]=='l' && fmt[2]=='u')
			{
				k+=sscanf(s,"%lu%n",va_arg(va,long*),&n);
				s+=n; fmt+=3;
			}
			else if (fmt[1]=='l' && fmt[2]=='g')
			{
				k+=sscanf(s,"%lg%n",va_arg(va,double*),&n);
				s+=n; fmt+=3;
			}
			else
			{
				system_error("opp_vsscanf: unsupported"" format '%s'",fmt);
				return k;
			}
		}
		else if (isspace(*fmt))
		{
			while (isspace(*s)) s++;
			fmt++;
		}
		else if (*fmt=='\0' || *fmt=='#')
		{
			return k;
		}
		else
		{ 
			system_error("opp_vsscanf: unexpected "
					"char in format '%s'",fmt);
			return k;
		}
	}
}

// screen pixels and size vars
//int DWIDTH=(1<<DWIDTHBIT),DHEGIHT=(1<<(DWIDTHBIT-1));
int DWIDTH=300,DHEGIHT=256;
int  flag_depth_draw=0;
#define DEPTHINT unsigned char
DEPTHINT data[640*600]; //16bit
DEPTHINT plot_color;
DEPTHINT qplot_color;
int  flag_depth_test=0;
int  flag_test=0;


// MMX code : SLOW 
void depth_clear1()
{
	//int count=(DWIDTH*DHEGIHT)/2;
	int count=(DWIDTH*DHEGIHT)/(4*8);
	// ATNT mov src,dst
	if(0)asm(
	 	"movl %0 ,%%edi \n" 
	 	"movl %0 ,%%ebx \n" 
		"movl %1 ,%%ecx \n"
		"pcmpeqd %%mm0 ,%%mm0 \n "
	"L99: \n"	
    		//"jecxz EXIT0 \n"
		//"dec %%ecx;"
    		"movq %%mm0,0(%%edi)\n"
    		//"addl $8,%%edi\n"
    		"movq %%mm0,8(%%ebx)\n "
    		"movq %%mm0,16(%%edi)\n"
    		"movq %%mm0,24(%%ebx)\n"
    		"movq %%mm0,32(%%edi)\n"
    		"movq %%mm0,40(%%ebx)\n"
   		"movq %%mm0,48(%%edi)\n"
    		"movq %%mm0,56(%%ebx)\n"
    		"movq %%mm0,64(%%edi);"
    		/* "movq %%mm0,72(%%edi);"
    		"movq %%mm0,80(%%edi);"
    		"movq %%mm0,88(%%edi);"
    		"movq %%mm0,96(%%edi);"
    		"movq %%mm0,104(%%edi);"
    		"movq %%mm0,112(%%edi);"
    		"movq %%mm0,120(%%edi);" */
    		"addl $64,%%edi \n" // add 64 each loop
    		"addl $64,%%ebx \n" // add 64 each loop
    		"loop L99 \n"
    		//"jmp L64 \n"
	"EXIT0: \n"	
		//"emms" 
		: :"r" (data),"r" (count): "%mm0","%edi","%ecx","ebx");
}

void depth_clear()
{
	int count=(DWIDTH*DHEGIHT)>>2;
	// AT&T mov src,dst
	asm(
		"movl %0 ,%%edi \n" 
		"movl %1 ,%%ecx \n"
		//"movl $0xFFFFFFFF ,%%eax \n "
		"movl $0xFFFFFFFF ,%%eax \n "
		"rep  stosl \n"  : :"r" (data),"r" (count): "%edi","%ecx","%eax");
}

void depth_clear2()
{
	int count=(DWIDTH*DHEGIHT)/2;
		int *p;
		p=(int*)data;
		//for(i=0;i< DWIDTH*DHEGIHT/2;)	data[i++]=0xFFFFF; // 2 byte
		for(int i=0;i< count ;)
		{
			p[i++]=0xFFFFFFFF; // 4 byte
		}
}

void draw_depth()
{
	if(flag_depth_draw==0) return;
	
	if(1)
	{
		glMatrixMode(GL_PROJECTION);
	//	glPushMatrix();
		glLoadIdentity();
		extern int screen_height,screen_width;
		glOrtho( 0, screen_width,0, screen_height, -1, 1 );		
		glViewport(0,0,screen_width,screen_height);
		glMatrixMode(GL_MODELVIEW);
	//	glPushMatrix();
		glLoadIdentity();

		glDisable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);// #!!!
		//glEnable(GL_SCISSOR_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	else
	{
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
	}

	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	glRasterPos2i(0,0);
	glColor4f(1.0,1.0,1.0,1.0);
	//glDrawPixels(DWIDTH, DHEGIHT,/* GLenum format */ GL_LUMINANCE,GL_UNSIGNED_SHORT, data);	
	//glDrawPixels(DWIDTH, DHEGIHT,/* GLenum format */ GL_LUMINANCE,GL_SHORT, data);	
	glDrawPixels(DWIDTH, DHEGIHT,/* GLenum format */ GL_LUMINANCE,GL_UNSIGNED_BYTE, data);	

}


extern int depth_passed_pixels;
typedef struct
{
	int x,y;
	int col;
} point;
#include <string.h>
// 1. 
void hline3_clip(float sx,float ex,int y,int dontdraw=0) 
{ 
	
	int s,e;
	if(y<0 or y>=DHEGIHT) return;

	s=FAST_ROUND(sx);	
	e=FAST_ROUND(ex);
	if(s> DWIDTH) return;
	if(s<0) s=0;
	if(e<0 ) return;
	if(e>=DWIDTH) e=DWIDTH;		
	DEPTHINT *p=&data[(y*DWIDTH) + s]; // 
	DEPTHINT col=qplot_color; // 

	int len=e-s;
	
	if(0)
	{
		*p = col;
		p[len] = col;
		depth_passed_pixels++;
		return ;
	}
	else
	
	if(dontdraw)
	for(int i=0; i <= len; i++)		
	{	if(col< *p)
		{
			depth_passed_pixels++;
			return ;
		}
		p++;
	}
	else
	for(int i=0; i <= len; i++)		
	{	if(col< *p)
		{
			depth_passed_pixels++;
			*p = col;
		}
		p++;
	}
		//if(*p>col){ depth_passed_pixels++;	return 1; 	}
}

int shline_asm(int sx,int sc,int ex,int ec,int y) 
{

	//int s,e,len,col;
	//s=sx>>8,e=ex>>8;
	//if(len==0) return 0;
	//col=sc;
	//int k=len/4;
//	int s,e,k; // %eax,%ebx,%ecx,%edx,
//	int dc=(ec-sc)/y;
//	s=sx>>;
//	*p++=e;
//	*p=e;
//	k=dc;
	if(0)
	asm(
		//"movl	20(%%ebp), %%edx \n\t" 	 // ec
		//"movl	24(%%ebp), %%ecx \n\t"  // %ecx =y	 
		
		// %dx= sx >> 8;
		"movl	%0, %%edx \n\t"   	// sx
		"sarl 	$8,%%edx \n\t"  	// 
		
		// %edi= _DWIDTH*y + s;
		"movl	%4, %%ecx \n\t"  	// %ecx =y	 
	       	"movl 	_DWIDTH,%%eax \n\t"		
	       	"imul 	%%eax,%%ecx \n\t"
		"addl	%%edx,%%ecx \n\t"
		"leal	_data(%%ecx,%%ecx),%%edi \n\t"

		//%ecx =e-s; %ecx++;
		"movl	%2, %%eax \n\t" 	 // ex
		"subl	%0 ,%%eax \n\t"		// ex-sx
		"sarl 	$8,%%eax \n\t"  	//  %eax =(ex-sx)>>8
		"movl 	%%eax,%%ecx \n\t"  	// 
		"incl	%%ecx \n\t"		// len++;

		"cmp	$0,%%ecx \n\t"
		"jle	EXIT_LOOP%= \n\t"		// less equel 
	

		"movl	%3, %%eax \n\t" 	 // ec
		"movl	%1, %%ebx \n\t"  	// sc
		"subl	%1,%%eax \n\t"	

		"cltd 	\n\t"  			// *******************
		"idivl	%%ecx \n\t"		// dc= %eax = (e-s) / len
	
	/*	
		"xorl	%%edx, %%edx \n\t"  
		"pinsrw $0,%%edx,%%mm3 \n\t"
		"add  	%%eax,%%edx \n\t"
		"pinsrw $1,%%edx,%%mm3 \n\t"
		"add  	%%eax,%%edx \n\t"
		"pinsrw $2,%%edx,%%mm3 \n\t"
		"add  	%%eax,%%edx \n\t"
		"pinsrw $3,%%edx,%%mm3\n\t"
	
		"pinsrw $0,%%ebx,%%mm0\n\t"
		"pinsrw $1,%%ebx,%%mm0\n\t"
		"pinsrw $2,%%ebx,%%mm0\n\t"
		"pinsrw $3,%%ebx,%%mm0\n\t"
		
		"movd	%%ecx, %%mm5\n\t"
		"sarl	$2,%%ecx \n\t"
	"LOOPX: \n\t"
		"paddw %%mm3,%%mm0\n\t"
		"movq %%mm0,%%mm2\n\t"
    		"psrlw $8,%%mm2\n\t"
    		
		"pminsw 0(%%edi),%%mm2\n\t"
		"movq %%mm2,0(%%edi)\n\t"
		"add	$8,%%edi \n\t"
		"loop 	LOOPX\n"
		
	
		"movd 	%%mm5,%%ecx \n\t"	
		"and	$0x00000003,%%ecx \n\t"
		
		"cmp	$0,%%ecx \n\t"
		"jle	EXIT_LOOP%= \n\t"		// less equel 
	*/
		
		//"pextrw $3,%%mm0,%%ebx\n\t"
		"movl	%%ebx, %%edx \n\t"  	// 
		"sarl	$8,%%edx \n\t"		//  sc
		
	"LOOP%=: \n\t"
		//"cmpw	0(%%edi),%%dx \n\t"
		"cmpb	0(%%edi),%%dl \n\t"
		"ja	NEXT%= \n\t"
		"mov	%%dl,0(%%edi) \n\t"
		"incl	_depth_passed_pixels \n\t"
		"NEXT%=: \n\t"
		"add	%%eax,%%ebx \n\t"
		//"add	$2,%%edi \n\t"
		"incl	%%edi \n\t"
		"movl	%%ebx,%%edx \n\t"
		"sarl	$8,%%edx \n\t"

		"loop 	LOOP%=\n"

	"EXIT_LOOP%=:	\n\t"		// 
	
		::"m"(sx),"m"(sc),"m"(ex),"m"(ec),"m"(y):"eax","edx","ecx","ebx","edi");

	return 0;
		//	return s+e+k;

	
//	*p=0; 
/*
	asm(
		"mov   %4,%%eax \n" 
		
	"LOOPX: \n\t"
		
		"paddw %%mm3,%%mm0\n\t"
		"pextrw $3,%%mm0,%%eax\n\t"

    		"movq (%1),%%mm2\n\t"
    		"psrlw $8,%%mm0\n\t"
    		"movq %%mm0,%%mm1\n\t"
    		"pminsw %%mm2,%%mm0\n\t"
		"pcmpeqw %%mm0,%%mm1\n\t"  // if(S==D) then D=FF;
		"pmovmskb %%mm1,%%edx\n\t"
		"cmpl 	$0,%%edx \n\t"
		"jz	NOWRITE\n\t"
		"movq	%%mm0,(%1)\n\t"
		"inc	%0\n"
		
	"NOWRITE: \n\t"
		"add  $1,%1 \n\t"
		"loop LOOPX\n"
		
		::"g" (a),"g" (p),"c"(k),"g"(dc),"g"(sc): "%mm0","%mm1","%mm2","%eax","%edx");
	//	: :"g" (s),"g" (p),"c"(k): "%mm0","%mm1","%mm2");
		
		depth_passed_pixels+=a;
	k=len%4; 

	*///	for(int i=0; i < k; i++)		
	{
	/*	DEPTHINT cl=col >> 8;
		if(cl< *p)
		{
			depth_passed_pixels++;
			*p = cl;
		}
		col+=dc;
		p++;
	*/}
 	return 0;

}

int shline(int sx,int sc,int ex,int ec,int y) 
{
	int s,e,len;
	s=sx>>8,e=ex>>8;
	DEPTHINT *p=&data[(y*DWIDTH) + s]; // 
	len=e-s; len++;
	if(len==0) return 0;
	register int dc=(ec-sc)/len;
	int col;
	col=sc;
	for(int i=0; i < len; i++)		
	{
		DEPTHINT c=col >> 8;
		if(c<= *p)
		{
			depth_passed_pixels++;
			*p = c;
		}
		col+=dc;
		p++;
	}
	return 0;
}

int shlineCheck(int sx,int sc,int ex,int ec,int y) 
{
	int s,e,len;
	s=sx>>8,e=ex>>8;
	DEPTHINT *p=&data[(y*DWIDTH) + s]; // 
	len=e-s; len++;
	if(len==0) return 0;
	int dc=(ec-sc)/len;
	int col;
	col=sc;


	for(int i=0; i < len; i++,p++)		
	{
		DEPTHINT c=col >> 8;
		col+=dc;
		if(c<= *p)
		{
			depth_passed_pixels++;
			return 1 ;
		}
	}
	return 0;
}



/** fill triangle **/
#define SWAP(a,b) { dt=a[0]; a[0]=b[0]; b[0]=dt;  dt=a[1]; a[1]=b[1]; b[1]=dt; 	dt=a[2]; a[2]=b[2]; b[2]=dt; }
#define SWAPP(a,b) {  p=a; a=b; b=p; } 


void fill_triangle4_noclip(int p0[3],int p1[3], int p2[3], int dontdraw) 
{

	//int *p0,*p1,*p2,*pt;
	float d0, d1, d2;
	float dx0,dx1,dx2;
	float dy0,dy1,dy2;
	float dc0,dc1,dc2;
	int *p;

	if(p1[1] < p0[1]) SWAPP(p1,p0); //	if(y1 < y0)  
	if(p2[1] < p1[1]) SWAPP(p2,p1); //	if(y2 < y1)
	if(p2[1] < p0[1]) SWAPP(p2,p0); //	if(y2 < y0) 
	if(p1[1] < p0[1]) SWAPP(p1,p0); //	if(y1 < y0) 

	dx0 = (p1[0] - p0[0]);  // B-A 
	dy0 = (p1[1] - p0[1]);

	dx1 = (p2[0] - p0[0]);  // C-A
	dy1 = (p2[1] - p0[1]);

	dx2 = (p2[0] - p1[0]);  // C-B
	dy2 = (p2[1] - p1[1]);

	if(dy0 > 0) d0 = dx0 / dy0, dc0=((p1[2]-p0[2]))/dy0; 
	else         d0 =dx0, dc0=p1[2]-p0[2]; 		// y0==y1
	if(dy1 > 0) d1 = dx1 / dy1, dc1=((p2[2]-p0[2]))/dy1;
	else         d1 = dc1=0;
	if(dy2 > 0) d2 = dx2 / dy2, dc2=((p2[2]-p1[2]))/dy2;
	else         d2 = dc2=0;

	int y,y1,y2;
	float sx,ex,sc,ec;
	y=p0[1];
	y1=p1[1];
	y2=p2[1];
	
	sx=p0[0],ex=p0[0];sc=p0[2];ec=p0[2];
	if(d0>d1)
	{
		// 우 볼록 삼각형
		for(;y<y1;y++,sx+=d1,sc+=dc1,ex+=d0,ec+=dc0)	
	;//		if(shline_clip(sx,sc,ex,ec,y,dontdraw)) return; 
		ex=p1[0]; ec=p1[2];   
		for(;y<y2;y++,sx+=d1,sc+=dc1,ex+=d2,ec+=dc2) 	
	;//		if(shline_clip(sx,sc,ex,ec,y,dontdraw)) return; 
	}
	else
	{
		// 좌볼록 삼각형
		for(;y<y1;y++,sx+=d0,sc+=dc0,ex+=d1,ec+=dc1) 
	;//		if(shline_clip(sx,sc,ex,ec,y,dontdraw)) return; 
		sx=p1[0]; sc=p1[2];
		for(;y<y2;y++,sx+=d2,sc+=dc2,ex+=d1,ec+=dc1) 
	;//		if(shline_clip(sx,sc,ex,ec,y,dontdraw)) return; 
	}

}
// using
void fill_triangle5_noclip(int *p0,int *p1, int *p2, int dontdraw) 
{

	//int *p0,*p1,*p2,*pt;
	int d0, d1, d2;
	int dx0,dx1,dx2;
	int dy0,dy1,dy2;
	int dc0,dc1,dc2;
	int *p;

	if(p2[1] < p0[1]) SWAPP(p2,p0); //	if(y2 < y0) 
	if(p2[1] < p1[1]) SWAPP(p2,p1); //	if(y2 < y1)
	if(p1[1] < p0[1]) SWAPP(p1,p0); //	if(y1 < y0)  

	dx0 = (p1[0] - p0[0])<<8;  // B-A 
	dy0 = (p1[1] - p0[1]);

	dx1 = (p2[0] - p0[0])<<8;  // C-A
	dy1 = (p2[1] - p0[1]);

	dx2 = (p2[0] - p1[0])<<8;  // C-B
	dy2 = (p2[1] - p1[1]);

	if(dy0 > 0) d0 = dx0 / dy0, dc0=((p1[2]-p0[2])<<8)/dy0; 
	else         d0 =dx0, dc0=p1[2]-p0[2]; 		// y0==y1
	if(dy1 > 0) d1 = dx1 / dy1, dc1=((p2[2]-p0[2])<<8)/dy1;
	else         d1 = dc1=0;
	if(dy2 > 0) d2 = dx2 / dy2, dc2=((p2[2]-p1[2])<<8)/dy2;
	else         d2 = dc2=0;

	int y,y1,y2;
	int sx,ex,sc,ec;
	y=p0[1];
	y1=p1[1];
	y2=p2[1];
	
	sx=p0[0]<<8,ex=p0[0]<<8;
	sc=p0[2]<<8;ec=p0[2]<<8;

	if(dontdraw)
	{
	if(d0>d1)
	{
		// 우 볼록 삼각형
		for(;y<y1;y++,sx+=d1,sc+=dc1,ex+=d0,ec+=dc0)	
			if(shlineCheck(sx,sc,ex,ec,y)) return; 
		ex=p1[0]<<8; ec=p1[2]<<8;   
		for(;y<y2;y++,sx+=d1,sc+=dc1,ex+=d2,ec+=dc2) 	
			if(shlineCheck(sx,sc,ex,ec,y)) return; 
	}
	else
	{
		// 좌볼록 삼각형
		for(;y<y1;y++,sx+=d0,sc+=dc0,ex+=d1,ec+=dc1) 
			if(shlineCheck(sx,sc,ex,ec,y)) return; 
		sx=p1[0]<<8; sc=p1[2]<<8;
		for(;y<y2;y++,sx+=d2,sc+=dc2,ex+=d1,ec+=dc1) 
			if(shlineCheck(sx,sc,ex,ec,y)) return; 
	}

	}
	else
	{

		if(d0>d1)
		{
		// 우 볼록 삼각형
		for(;y<y1;y++,sx+=d1,sc+=dc1,ex+=d0,ec+=dc0)	
			shline(sx,sc,ex,ec,y); 
		ex=p1[0]<<8; ec=p1[2]<<8;   
		for(;y<y2;y++,sx+=d1,sc+=dc1,ex+=d2,ec+=dc2) 	
			shline(sx,sc,ex,ec,y); 
		}
		else
		{
		// 좌볼록 삼각형
		for(;y<y1;y++,sx+=d0,sc+=dc0,ex+=d1,ec+=dc1) 
			shline(sx,sc,ex,ec,y); 
		sx=p1[0]<<8; sc=p1[2]<<8;
		for(;y<y2;y++,sx+=d2,sc+=dc2,ex+=d1,ec+=dc1) 
			shline(sx,sc,ex,ec,y); 
		}
	}

}

/*
  WGT Graphics Tutorial #1
  Topic: Filled Polygons
			 By Chris Egerter
			 October 7, 1994
*/

short startx[800];
int startcol[800];



inline int shadedline3 (const int x, int len,const int firstcolor,const int lastcolor,const int y,const int check=0)
{
	int colorvalue;
	int step;
	int i;

	if (len <= 0){	 return 0; }
	
	len++;
	step = ( lastcolor - firstcolor) / len;
	colorvalue = firstcolor ;   // ???? why slow ?? // colorvalue = firstcolor << 8;

	DEPTHINT *p=data +(y*DWIDTH) + x; // width=256
	DEPTHINT col;

	if(check)
	{
		for (i=0; i<len; i++)
		{
			col=colorvalue>>8;
			if(*p>col){ depth_passed_pixels++;	return 1; 	}
			p++;
			colorvalue += step;
		}
	}
	else
	{
		for (i=0; i<len; i++)
		{	
			col=colorvalue>>8;
			if(*p>col){ depth_passed_pixels++; *p=col; }
			p++;
			colorvalue += step;
		}
	}
	return 0;
}



//32bit
inline int gpolyline (int x1, int y1, int col1, int x2, int y2, int col2,int check)
{
	int tmp,y;
	int x,m;
	int col, colstep; /* First color, and the step value */

	if (y2 != y1)      /* This isn't a horizontal line */
	{
		if (y2 < y1)     /* Make sure y2 is greater than y1 */
		{
			tmp = y1;       /* Swap the y coordinate */
			y1 = y2;
			y2 = tmp;

			tmp = x1;       /* Swap the corresponding x coordinates */
			x1 = x2;
			x2 = tmp;

			tmp = col1;     /* Swap the corresponding color values */
			col1 = col2;
			col2 = tmp;
		}
	
		m = ((x2 - x1)<<8) / (y2 - y1);	
		colstep = ((col2 - col1) << 8) / (y2 - y1);
		
		x = x1<<8;   /* Multiply be 256 */
		col = col1 << 8;	 /* Initial color in 8.8 fixed point format */

		/* m is the fractional amount to add to the x coordinate every row.
		   m is equal to (delta x) / (delta y).  In other words, the x coordinate
		   has to change by (x2 - x1) columns in (y2 - y1) rows. */

		/* Calculate the color step value similar to the method in the
		   shadedline routine, only we're dividing by the delta y value. */


		//x += m; /* We ALWAYS skip the first point in every line. This is done */
		y1++; 
		/* because we do not want to store the point where two lines
				 meet, twice.  This would result in a single point being drawn. */
		
		for (y = y1; y <= y2; y++) /* Go through each row */
		{
			int px1=startx[y];

			if (px1 == -1) /* Store the first coordinate */
			{
				startx[y] = x>>8;
				startcol[y] = col;	/* store the color */
			}
			else
			{
				int px2=x>>8;
				int r;
				
				if(px2>px1)
					r=shadedline3(px1,px2-px1, startcol[y], col, y,check);
				else
					r=shadedline3(px2,px1-px2, col,startcol[y],y,check);

				if(r==1) return 1;
			}
			x += m;		     /* Add our constant to x */
			col += colstep;
		}
	}

	return 0;
}

/* Draws a shaded polygon given an array of vertices. */
int shadedtriangle (point *vertexlist,int check,int miny,int maxy)
{
	int i,y;
	point *curpt,*nextpt;

	for (y = miny; y <= maxy; y++)
		startx[y] = -16000;

	curpt = vertexlist;      /* Set to the first vertex in the array */
	nextpt = vertexlist + 1; /* and to the second vertex */
	gpolyline (curpt->x,  curpt->y,  curpt->col, nextpt->x, nextpt->y, nextpt->col,check);
	curpt += 1; nextpt += 1;
	gpolyline (curpt->x,  curpt->y,  curpt->col, nextpt->x, nextpt->y, nextpt->col,check);
	curpt += 1; nextpt += 1;
	nextpt = vertexlist;  /* Now close the polygon by doing a line between  the first and last vertex. */
	gpolyline (curpt->x,  curpt->y,  curpt->col, nextpt->x, nextpt->y, nextpt->col,check);

	return 1;
}


int shadedpoly (point *vertexlist, int numvertex,int dontdraw,int min_y,int max_y)
{
	int i,y;
	
	point *curpt,*nextpt;

	/*
	for (i = 0; i < numvertex; i++)
	{
		int ty=vertexlist[i].y;
		if(ty>max_y)	max_y=ty; // HP 20% 
		if(ty<min_y)	min_y=ty;
	}
	
	if(min_y==DHEGIHT and max_y==0)
	{
		console_printf("y ==== !! [%d] [%d]",min_y,max_y);
		//for (i = 0; i < numvertex; i++)
		//	console_printf("y = kkk !! [%d] ",vertexlist[i].y);
	}

	if (min_y < 0 or max_y > DHEGIHT)	
	{	
		//console_printf("ERROR : min_y=%d max_y=%d",min_y,max_y);
		return 0;
	} */
	
	curpt = vertexlist;      /* Set to the first vertex in the array */
	nextpt = vertexlist + 1; /* and to the second vertex */
	
	if(0)
	for (y = min_y; y <= max_y; y++) //for (y = 0; y <= DHEGIHT; y++)
		startx[y] = 0xFFFF;
	
	else
	{	
		// movsd : 4 bytes move to EDI from ESI 
		// stosd(stosl? ) : 4 bytes store to EDI , for ECX length 
		int len=(max_y-min_y)>>1;
		short *p=&startx[min_y];
		
		//asm("cld"); // EDI++
		asm("movl %0 ,%%edi " ::"m" (p): "%edi"  );
		asm("movl %0 ,%%ecx " ::"r" (len): "%ecx" );
		asm("inc  %%ecx " :: : "%ecx" );
		asm("movl $0xFFFFFFFF ,%%eax ":::"%eax");
		asm("rep stosl");
		
	}	
	
	for (i = 1; i < numvertex; i++)
	{
		gpolyline (curpt->x,  curpt->y,  curpt->col, nextpt->x, nextpt->y, nextpt->col,dontdraw);
		curpt += 1;  nextpt += 1;
	}

	nextpt = vertexlist;  /* Now close the polygon by doing a line between  the first and last vertex. */
	gpolyline (curpt->x,  curpt->y,  curpt->col, nextpt->x, nextpt->y, nextpt->col,dontdraw);

	return 1; 
}





