/* 
 * GPF file implementation by hyun 
   load,save
   support  RGBA
 */

//#define  VERSION  31
#define  VERSION  040


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gpf.h"

//  ϴ°ǰ ?
void GPF_RGB2RGBA(GPF *h)
{
	unsigned char r,g,b,a;
	int i,j;
	//unsigned 
	unsigned char *data,*dest;

	if(h->format==GPF_RGBA) return ;
	dest=(unsigned char *)malloc( h->width * h->height * 4 );

	data=h->data;

	j=0;
	for( i=0;i< h->length; )
	{
		r=data[i++];
		g=data[i++];
		b=data[i++];
		a=(r+g+b)/3;
		//	printf("a=%d ",a);
		dest[j++]=r;
		dest[j++]=g;
		dest[j++]=b;
		dest[j++]=a;	
	}
	free(data);
	h->data=dest;
	h->format=GPF_RGBA;
	h->length=h->width * h->height * 4;
}

void GPF_upsidedown(GPF *gpf)
{
	// upside-down ֱ  hyun 
	unsigned char *data_new;
	unsigned char *data;
	unsigned char *source;

	int  	BPP;
	int lenth,scanline_length;
	int h,width,height;


	data=gpf->data; 
	width=gpf->width;
	height=gpf->height;
	BPP=gpf->format;

	lenth=width * height * BPP;
	data_new=(unsigned char *)malloc(lenth);
	scanline_length=width*BPP;

	source=data + lenth - scanline_length;
	for(h=0;h < height ; h++)
		memcpy(data_new + h*scanline_length ,source - h*scanline_length ,scanline_length);

	free(gpf->data);
	gpf->data=data_new;
}


// GPF_New
#define New_GPF GPF_New
GPF *GPF_New(int width,int height,int format,char *data)
{
	GPF  *h;

	h =(GPF*) malloc(sizeof(GPF_HEADER)); 

	strcpy(h->id,"GPF");
	h->version=VERSION;

	h->width=width;
	h->height=height;
	h->format=format;

	if( format==GPF_RGB)
		h->length=width*height*3;
	if( format==GPF_RGBA)
		h->length=width*height*4;

	h->data=(unsigned char *)data;    

	return h;
}


void GPF_Remove(GPF *g)
{
	free(g->data);
	free(g);
}



int GPF_filesave(GPF *h,char *filename)
{
	FILE *fd;
	if(!(fd=fopen(filename,"wb"))) printf("GPF_filesave: file open Error!! \n");

	fwrite(h,sizeof(GPF_HEADER),1,fd);
	fwrite(h->data,h->length,1,fd);
	fclose(fd); 
	return 1;
}

// ⹮ΰ ? ִٸ ...
void GPF_loadV3(char *filename,GPF *gpfh)
{
	FILE *fd;
	GPF3  h;
	// printf("sizeof(GPF_HEADER)=%d \n",sizeof(GPF_HEADER)); 
	if(!(fd=fopen(filename,"rb")))
	{	    
		printf("Error : GPF_fileload: file \"%s\" open Error!!\n ",filename);
		exit(1);
	}

	fread(&h,sizeof(GPF_HEADER), 1, fd);
	h.data =(unsigned char *) malloc(h.length+100); 
	//h.data =(unsigned char *) malloc(h.length);  //cause a gluBuild2DMipmaps bugs
	if(h.length < 32 ){
		printf(" file size too low !! h->length=%d  %s !!",h.length,filename);
		exit(0);
	}
	int size=fread(h.data,h.length, 1, fd);
	//printf("gpf: w=%d h=%d length =%d \n",h.width,h.height,h.length);
	//printf("gpf: w*h*format=%d \n",h.width*h.height*h.format);

	fclose(fd);


	gpfh->width=h.width;
	gpfh->height=h.height;
	gpfh->format=h.format;
	gpfh->data=h.data;
}



GPF *GPF_fileloadV4(char *filename)
{
	FILE *fd;
	GPF  *h;

	// printf("sizeof(GPF_HEADER)=%d \n",sizeof(GPF_HEADER)); 

	if(!(fd=fopen(filename,"rb")))
	{	    
		printf("Error : GPF_fileload: file \"%s\" open Error!!\n ",filename);
		exit(1);
	}


	h = (GPF *)malloc(sizeof(GPF)); 
	//    h = GPF_New(

	fread(h,sizeof(GPF_HEADER), 1, fd);

	//    if(    	return NULL;
	h->data =(unsigned char *) malloc(h->length); 
	if(h->length < 32 ){
		printf(" file size too low !! h->length=%d  %s !!",h->length,filename);
		exit(0);
	}

	fread(h->data,h->length, 1, fd);
	fclose(fd);
	return h;
}

typedef struct s_gpfcommon
{
	char 	id[3]; // GPF
	char 	version[8];
} GPF_common;

GPF *GPF_fileload(char *filename)
{

	FILE *fd;
	GPF_common gpfh;
	GPF  *gpf;

	gpf = (GPF *)malloc(sizeof(GPF)); 

	if(!(fd=fopen(filename,"rb")))
	{	    
		printf("Error : GPF_fileload() \"%s\" open Error!!\n ",filename);
		exit(1);
	}

	fread(&gpfh,sizeof(GPF_common), 1, fd);
	fclose(fd);

	if(!strcmp(gpfh.version,"040"))
	{
		printf("gpf: 040\n");
		return GPF_fileloadV4(filename);
	}
	else
	{	
		GPF_loadV3(filename,gpf); 
		return gpf;
	}
}
