//#include "define.h"

/*#ifdef _MSVC_
#else
#define PACK_STRUCT 	__attribute__((packed))
#endif
*/

#ifdef _MSC_VER
	#define inline
	#define START_PACK_STRUCTS 	pack(push, 1)
	#define END_PACK_STRUCTS	pack(pop)
	#define PACK_STRUCT
#else 
	#define START_PACK_STRUCTS 	
	#define END_PACK_STRUCTS     	
	#define PACK_STRUCT 		__attribute__((packed))
#endif


#pragma START_PACK_STRUCTS

typedef struct s_gpf3 
{
	char 	id[3]; // GPF
	int  	version;
	int  	format;   // RGB,RGBA
	int  	width,height;
	long  	length;
	unsigned char 	*data;
} PACK_STRUCT  GPF3;

typedef struct s_gpf
{
	char 	id[3]; // GPF
	int  	version;
	int  	format;   // RGB,RGBA
	int  	width,height;
	long  	length;
	unsigned char 	*data;
} PACK_STRUCT  GPF;


typedef struct s_gpf4 
{
	char 	id[3]; // GPF
	char 	version[4];
	char 	str_type[8];  //RGB,RGBA, BGR, etc
    	char 	str_width[8],str_height[8];
    	char 	str_length[16];
	unsigned char 	*data;
} PACK_STRUCT  GPF4;


// 3+ 4*3 + 4 =19byte
typedef struct s_header 
{
    char id[3]; // GPF
    int  version;
    int  format;
    int  width,height;
    long length;
} PACK_STRUCT GPF_HEADER;


// gpf->format 
#define GPF_RGB	    	3
#define GPF_RGBA    	4
#define GPF_INDEX    	1
//#define RGB		GPF_RGB
//#define RGBA		GPF_RGBA

typedef struct sgf_header 
{
    char id[4]; // SGF
    char str_version[8];
    char str_type[8];  //RGB,RGBA, BGR, etc
    char str_width[8],str_height[8];
    char str_length[16];
    char EOT; //end of text
} PACK_STRUCT  SGF_HEADER;

#pragma END_PACK_STRUCTS

GPF *GPF_fileload(char *filename);
int GPF_filesave(GPF *h,char *filename);
void GPF_Remove(GPF *g);
GPF *GPF_New(int width,int height,int format,char *data);

