#include <stdarg.h>

#include "object.h"
#include "shape.h"
#include "texture.h"
#include "octree.h"

#include "../math.h"
#include "../system.h"

#define HAMMER_FACTOR 0.2
#define EPSILON_MAP 0.001 // ******

PlaneViewer 	*viewer;
Object		*map_shape;

int	block_num=0;
char 	buffer[1024];
char 	Word[1024];

// convert quake angles -> direction  
void angle2direction(float angles[3],float v[3])
{

}

char * stripQuto(char *str)
{
	static char buff[128];

	int n=strlen(str)+1;
	int j=0;
	if(n>sizeof(buff))	system_error("stripQuto(): over size !!");

	for(int i=0;i<n;i++)
	{
		if(str[i]!='\"')
			buff[j++]=str[i];
	}
	return buff;
}
// DRAFT 
// dont go over {  } 
char * getWrapWord(FILE *fd)
{
	char ch;
	int  i=0;
	int quat=0,comment=0;

	while(!feof(fd))
	{
		ch=fgetc(fd);
		switch(ch)
		{	
			case 0x0d:  //for dos 
				fgetc(fd); // 0x0A 

			case ' ': 
				if(quat) {
			   		Word[i++]=' ';
					break;
				}
			case '\n':
			case '\t':
			case '[':
			case ']':
			case ')':
			case '(':
			case '=':
				if(i>0){
					Word[i]=0;
					return Word;
				}

				break;
			
			case '\'' :
			case '\"' :
				if(quat!=1){
					quat=1;
					break;
				}	
				else {
					Word[i]=0;
					return Word;
				}
		
			default :
			   Word[i++]=ch;
			 break;
			
		}

	}
	return Word;
}	

// new methode 
char * MAP_get_item(FILE *fd,const char *name)
{
	static char buff[512];

	while(!feof(fd))
	{
		getWrapWord(fd);
		if(Word[0]=='}')
		{
			system_error("cant find %s !\n",name);
			break;
		}

		if(strcasecmp(Word,name)==0)
		{
			getWrapWord(fd);
			strcpy(buff,Word);
//			printf("%s = %s \n",name,buff);
			return buff;
		}
	}
}

// dont use this 
int MAP_scanf(FILE *fd,const char *name,const char *fmt,...)
{
		
	va_list arg_ptr;
	long int fpos;

	fpos= ftell (fd);
	va_start(arg_ptr, fmt); 

	while(!feof(fd))
	{
		getWrapWord(fd);
		if(Word[0]=='}')
		{
			printf("cant find %s !",name);
			if(fseek(fd,fpos,SEEK_SET)!=0) system_error("error fseek2");
			break;
		}

		if(strcasecmp(Word,name)==0)
		{
			getWrapWord(fd);
			//printf("word=%s \n",Word);
#ifdef LINUX
			vsscanf(Word,fmt,arg_ptr);
#endif
			va_end(arg_ptr);
			return 1;
		}
	}

	system_error("cant find %s !",name);
	return 0;
}

int  MAP_GET_targetname(FILE *fd,char *str)
{
	return MAP_scanf(fd,"targetname","%s",str);
}


// x,y,z ?
void MAP_angles(FILE *fd,float angles[3])
{
	getWrapWord(fd);
	if(!strcmp(Word,"angles"))
	{
		getWrapWord(fd);
//		printf("angles= %s \n",Word);	
		sscanf(Word,"%f %f %f",&angles[0],&angles[1],&angles[2]);
//		system_error("for test");
	}
	else system_error("not angle!!");
}


void MAP_pitch(FILE *fd,float *angles)
{
	getWrapWord(fd);
	if(!strcmp(Word,"pitch"))
	{
		getWrapWord(fd);
//		printf("angles= %s \n",Word);	
		sscanf(Word,"%f ",angles);
//		system_error("for test");
	}
	else system_error("not angle!!");
}

//DEL
void MAP_origin(FILE *fd,float value[3])
{
	getWrapWord(fd);
	if(!strcmp(Word,"origin"))
	{
		getWrapWord(fd);
//		printf("angles= %s \n",Word);	
		sscanf(Word,"%f %f %f",&value[0],&value[2],&value[1]);
		value[2]=-value[2];
//		system_error("for test");
	}
	else system_error("not origin");
}

// set spawn positions
int MAP_info_player_deathmatch(FILE *fd)
{
	float angle[3];
	float origin[3];
	Object *obj;
	obj = new Object("deathmatch");
	sscanf(MAP_get_item(fd,"angles"),"%f %f %f",&angle[0],&angle[2],&angle[1]);
	//MAP_scanf(fd,"origin","%f %f %f",&origin[0],&origin[1],&origin[2]);
	//MAP_origin(fd,origin);
	sscanf(MAP_get_item(fd,"origin"),"%f %f %f",&origin[0],&origin[2],&origin[1]); 
	origin[2]=-origin[2];
///	vectorPrint(origin);
	obj->setPosition(origin);

	system_add(obj);
}

int MAP_info_null(FILE *fd)
{
	int n;
	char name[128];
	float v[4];

	if(MAP_GET_targetname(fd,name))
	{
	//	if(!strcmp(name,"player"))
	//		MAP_origin(fd,info_holocaust.player_origin);
	//	else MAP_origin(fd,info_holocaust.enemy_origin);
	}
}


int MAP_light(FILE *fd)
{
	float origin[3];
	float angle[3];
	Object *obj;
	return 0;
	obj=new Object("light");
	MAP_get_item(fd,"_light");
	sscanf(MAP_get_item(fd,"angles"),"%f %f %f",&angle[0],&angle[2],&angle[1]);
	sscanf(MAP_get_item(fd,"origin"),"%f %f %f",&origin[0],&origin[2],&origin[1]); 
	origin[2]=-origin[2];
	obj->setPosition(origin);	
	system_add(obj);
	return 0;
//	obj->effective_radius=5*METER;
//	MAP_scanf(fd,"_light","%f %f %f %f",&v[0],&v[1],&v[2],&v[3]);
}

// play sound 
int MAP_ambient_generic(FILE *fd)
{
	int n;
	int sound_id;
	char buffer[128];
	char name[128];
	char *filename;
	Object *obj;

	obj=new Object("sound");
	MAP_scanf(fd,"targetname","%s",name); // "targetname" is Object name
///	if(MAP_message(fd,buffer))// "message" is  wave filename 
	{
//		filename=basename(buffer);
		//sound_id=LoadWave2(filename);
		//Object_soundPlayLoop(obj,sound_id);
	}

///	MAP_origin(fd,obj->center);
	
	//Object_InsertList(obj); 
}
                                                                             
struct planetex_strcut 
{
	int texture_id;
	float uoff,voff;
	float uscale,vscale;
	float nu[3],nv[3];
	float uoffwidth;
	float voffheight;
	float widthuscale;
	float heightvscale;
} planetex[32];

Plane plane[32];
int plane_n=0;

// define normal vector to a plane ??
void PlaneSetNormalVertex(Plane *P,float normal[4],float v1[4],float v2[4],float v3[4])
{
	// need change !!!
//	VectorSetVector(&P->normal,N);
//	VectorSetVector(&P->onPoint,v);
	vectorCopyf(P->normal,normal);
	vectorCopyf(P->onPoint,v1);
	vectorCopyf(P->onPoint2,v2);
	vectorCopyf(P->onPoint3,v3);
	P->distance=vectorDotProduct3f(normal,v1);  // distance from origin(0,0,0)
}



//   ̷ ϱ 
// 1. EPSILON  簡ɼ .
//  http://astronomy.swin.edu.au/~pbourke/geometry/3planes/
int vectorIntersction3Plane(vector *out,Plane *p1,Plane *p2,Plane *p3)
{
	float d;

	vector vtemp[3];
	vectorSet(out,0,0,0);
	
	vectorCrossProduct(vtemp,p2->normal,p3->normal);
	d=vectorDotProduct3f(vtemp,p1->normal);

	
	//  two of p1,p2,p3  are  parallel  
	if(d > -EPSILON_MAP && d< EPSILON_MAP){
		//printf("zero= %f" ,d);
		return 0;
	}
	
	vectorScale(vtemp,p1->distance);
	vectorAdd(out,vtemp);

	vectorCrossProduct(vtemp,p3->normal,p1->normal);
	vectorScale(vtemp,p2->distance);
	vectorAdd(out,vtemp);
	
	vectorCrossProduct(vtemp,p1->normal,p2->normal);
	vectorScale(vtemp,p3->distance);
	vectorAdd(out,vtemp);

	vectorScale(out,1.0/d);	
	return 1;
	
}

// very danger  -> malloc()
int sets[128][3];
int sets_n=0;
inline int math_sets_add(int set[3])
{
	int i,j;
	int s1,s2,s3;
	int dup=0;
	
	for(i=0;i<sets_n;i++)
	{
		s1=sets[i][0];
		s2=sets[i][1];
		s3=sets[i][2];
		
		dup=0;
		for(j=0;j<3;j++)
		{
			if(s1==set[j]) dup++;
			if(s2==set[j]) dup++;
			if(s3==set[j]) dup++;

			if(dup==3)
				return sets_n;
		}
	}

	sets[sets_n][0]=set[0];
	sets[sets_n][1]=set[1];
	sets[sets_n][2]=set[2];
	sets_n++;
	return sets_n;
}

// n  3 ̴  
int make_combination(int n,int sel)
{	
	int a[32];
	int i,j,m;
	int set[3];

	int total=0,c_total=0;

	sets_n=0;	
	for(i=0;i<n;i++)
		a[i]=i;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			for(m=0;m<n;m++)
			{
				if(i!=j && j!=m && m!=i)
				{
					set[0]=a[i];
					set[1]=a[j];
					set[2]=a[m];
					if(set[0]==sel or set[1]==sel or set[2]==sel)
						math_sets_add(set);
					else 
						;

					total++;
				}
			}

	int fail=0;
	
	for(i=0;i<sets_n;i++)
		if(sel==sets[i][0] or sel==sets[i][1] or  sel==sets[i][2])
			;
		else
		{
			printf("[%d] sel %d ( %d %d %d ) \n",i,sel,sets[i][0],sets[i][1],sets[i][2]);
			fail=1;
		}
	return sets_n;
}


// works ok.
void remove_duplicatedpoint(SDX_Polygon *p)
{
	int i,j;
	int x,y,z;
	int tx,ty,tz;
	IndexInt list;

	//printf("list.size =%d \n",list.size());
	//printf("vertex.size =%d \n",p->vertexs.size());
	Vertex *v;
	for(i=0;i<p->vertexs.size()-1;i++)
	{
		p->vertexs.begin();
		for(j=0;j<i;j++)
			p->vertexs.next();
		v=p->vertexs.current();
		if(v==0) break;
	
		x=(int) v->x;
		y=(int) v->y;
		z=(int) v->z;

		p->vertexs.next();
		for(;p->vertexs.current()!=NULL;)
		{
			v=p->vertexs.current();
			tx=(int) v->x;
			ty=(int) v->y;
			tz=(int) v->z;
			if (x==tx and y==ty and z==tz)
			{
				p->vertexs.remove_current();
			
			}
			else
				p->vertexs.next();
		}
	}

	p->vertexs.reindex(); //prevent index hole 

	return;
/*
	for(i=0;i<p->vertexs.size()-1;i++)
	{
		x=(int) p->vertexs[i]->x;
		y=(int) p->vertexs[i]->y;
		z=(int) p->vertexs[i]->z;
		
		for(j=i+1;j<p->vertexs.size();j++)
		{
			if(i!=j)
			{
				tx=(int) p->vertexs[j]->x;
				ty=(int) p->vertexs[j]->y;
				tz=(int) p->vertexs[j]->z;
				if (x==tx and y==ty and z==tz)
					list.add(j);		
			}
		}
	}
	
	for(i=0;i<list.size();i++)
	{
		p->vertexs.remove(list[i]);
	}

	p->vertexs.reindex(); //prevent index hole 
*/
}


void vertexSwap(Vertex *v1,Vertex *v2)
{
	float f[3];
	f[0]=v1->x;
	f[1]=v1->y;
	f[2]=v1->z;
	
	v1->x=v2->x;
	v1->y=v2->y;
	v1->z=v2->z;

	v2->x=f[0];
	v2->y=f[1];
	v2->z=f[2];
}

// works 
int sort_vertexs(SDX_Polygon *p)
{
	int i,j;
	vector v1[3],v2[3],v3[3],norm[3],center[3];
	float angle,angle_max;
	int idx_max;

	// set center of polygon 
	vectorSet(center,0,0,0);
	for(i=0;i<p->vertexs.size();i++)
	{
		vertexCopy(p->vertexs[i],v1);
		vectorAdd(center,v1);
	}
	vectorScale(center,1.0/(float)p->vertexs.size());


	for(i=0;i<p->vertexs.size()-2;i++)
	{
		vertexCopy(p->vertexs[i],v1);
		vectorSubtractM(v1,center);
		if(vectorNormalizeN(v1)==0)
			system_error("vectorNormalize");
		
		idx_max=-1;
		angle=0;
		angle_max=-2;
		
		for(j=i+1;j<p->vertexs.size();j++)
		{
			vertexCopy(p->vertexs[j],v2);
			vectorSubtractM(v2,center);
			if(vectorNormalizeN(v2)==0)
				system_error("vectorNormalize");
		
			vectorCrossProduct(v3,v1,v2); // |v1||v2|sin(th)
			// should be 1 
			//		 or -1 
			//		 or  0 : if sin(180) v1,v2  
			if(vectorDotProduct3f(p->normal,v3)>0) 
			{
				//̰  cos ũ
				angle=vectorDotProduct3f(v1,v2);  
				if(angle<-2.0) 
				{
					printf("angle=%f\n",angle);
					vectorPrint(v1);
					vectorPrint(v2);

					Line *line=new Line();
					vectorScale(v1,100);
					vectorScale(v2,100);
					vectorAdd(v1,center);
					vectorAdd(v2,center);
					vectorCopyf(line->normal,v1);
					vectorCopyf(line->onPoint,v2);
					viewer->addLine(line);
					return 0;
				}
			
				if(angle>=angle_max)
				{
					idx_max=j;
					angle_max=angle;
				}
			}

			/*
			if(f==0) 
			{
				printf("dot=%f\n",f);
				vectorPrint(v1);
				vectorPrint(v2);

				Line *line=new Line();
				vectorScale(v1,100);
				vectorScale(v2,100);
				vectorAdd(v1,center);
				vectorAdd(v2,center);
				vectorCopy(line->v1,v1);
				vectorCopy(line->v2,v2);
				viewer->addLine(line);
				return 0;
			} */

		}

		if(idx_max<0)
		{
			//system_error("???");
			return 0;
		}
		else
			vertexSwap(p->vertexs[i+1],p->vertexs[idx_max]);
	
	}

	return 1;
}


// TODO: add basic object (light,...)
// : plane   Ѱ polygon  
//  polygonFromPlanes() 
//  planes2polon()
int polygonFromPlanes(Polygon *p,int idx)
{

	int		i,j,k,m,n,r,t=0,x;
	int		legal;	
	float	f;
	float	nv[3],v1[3],v2[3];
	float	u,v;
	int		count;

	vectorCopyf(p->normal,plane[idx].normal);  // ** normal vector set !
	
	count=make_combination(plane_n,idx);
	for (x=0;x<count;x++)
	{
		i=sets[x][0];
		j=sets[x][1];
		k=sets[x][2];
		//  n ̷ Ʈ(귯)   ϱ 
		// 7 -> 6 
		// 5 -> 4 
		r=vectorIntersction3Plane(v1,&plane[i],&plane[j],&plane[k]);
		// 
		if(r==0) continue;			

		legal=true;
		// chek in or out 
		for(m=0;m<plane_n;m++){
			f=vectorDotProduct3f(v1,plane[m].normal);
			f-=plane[m].distance;		//ok
			if(f>0.001)  //if(f>0)
				legal=false;
		}
		if(legal)
		{
			Vertex *V=new Vertex();
			V->x=v1[0];
			V->y=v1[1];
			V->z=v1[2];
			p->vertexs.add(V);
		}
	}

	//  ̻.װ  °쵵 . 
	// memory leak
	remove_duplicatedpoint(p);

	int flag_error=0;
	
	if(sort_vertexs(p)==0)
	{
		printf("Error: sort_vertexs \n");
		flag_error=1;
	}

	if(p->vertexs.size() >11 or p->vertexs.size() <3){
		printf("  11< vertex_n <3 total_plane_n=%d vertex_n =  %d\n",plane_n, p->vertexs.size());
		printf("  idx =%d \n",idx);

		flag_error=1;
	}
	

	if(p->vertexs.size() >= plane_n )
	{
		
		//if(p->vertexs.size()==8 and plane_n==6)
		//	;
	//	else
		{
			printf("error:  plane_n=%d   vertex_n=%d",plane_n,p->vertexs.size());		
			flag_error=1;
		}
	}
	
	if(flag_error)
	{
		for (x=0;x<count;x++)
		{
			i=sets[x][0];
			j=sets[x][1];
			k=sets[x][2];
			printf(" [%d] (%d %d %d) \n",x,i,j,k);
		}
		for(i=0;i<plane_n;i++)
			viewer->addPlane(&plane[i],idx);

		for(i=0;i<p->vertexs.size();i++)
		{
			viewer->addVertex(p->vertexs[i]);
			//printf("[%d] x=%f y=%f z=%f\n",i,p->vertexs[i]->x,p->vertexs[i]->y,	p->vertexs[i]->z);
		}

		system_add(viewer);
		system_loop();	
		system_exit();
	}

	// u,v mapping 
	for(j=0;j<p->vertexs.size();j++)
	{
		float u,v;
		v2[0]=p->vertexs[j]->x;
		v2[1]=p->vertexs[j]->y;
		v2[2]=p->vertexs[j]->z;

		// need normailize 
		u=vectorDotProduct3f(v2,planetex[idx].nu)/planetex[idx].widthuscale + planetex[idx].uoff;
		v=-vectorDotProduct3f(v2,planetex[idx].nv)/planetex[idx].heightvscale - planetex[idx].voff;
		
		p->vertexs[j]->u=u;
		p->vertexs[j]->v=v;
		//printf("u=%f v=%f \n",u,v);
		//printf("uoff=%f voff=%f \n",planetex[idx].uoff,planetex[idx].voff);
	}

	p->texture_id=planetex[idx].texture_id;
	
	if(planetex[idx].texture_id==0) 
		return 0;
	
	return 1;
}


int getBrushLine(char *sbuff)
{
	int		width,height;
	int		texture_id;
	float	uoff,voff;
	float	uscale,vscale;
	float	normal[3];
    float	v1[3],v2[3],v3[3],f;
	float	nu[3],nv[3];	
	float   tex_rot;
	float	factor=1;
	char    texture_name[64];
/* 
  ( -1184 1424 64 ) ( -1376 1424 64 ) ( -1376 1424 224 )
  SANDWLLDOOR [ 1 0 0 32 ] [ 0 0 -1 64 ]  0 			1 		1
				tex_U		tex_V	   tex_rotation		U_scale		V_scale

			  [ 0 1 0 -284 ] [ 0 0 -1 423 ] 0			1.13	 0.72

	
	 [ 1 0 0 32 ] 	 
	first 3 are texture axis' normal 
	last  1 is offset or shift 
*/

	// x => x , z => y , y => -z  
	sscanf(sbuff,"( %f %f %f ) ( %f %f %f ) ( %f %f %f ) %s [ %f %f %f %f ] [ %f %f %f %f ] %f %f %f ",
			&v1[0],&v1[2],&v1[1],
			&v2[0],&v2[2],&v2[1],
			&v3[0],&v3[2],&v3[1],
			texture_name,
			&nu[0],&nu[2],&nu[1],&uoff,
			&nv[0],&nv[2],&nv[1],&voff,
			&tex_rot,&uscale,&vscale);  //tex_rot: obsolete reading ?

/*
	printf(" %0.2f %0.2f %0.2f , %0.2f %0.2f %0.2f , %f %f %f , %s , %f %0.1f %0.1f %0.1f \n",
			v1[0],v1[2],v1[1],
			v2[0],v2[2],v2[1],
			v3[0],v3[2],v3[1],
			texture_name,
			nu[0],nu[2],nu[1],uoff,
			nv[0],nv[2],nv[1],voff); 
	printf(" %f %f \n" ,uscale,vscale);
	printf("%f %f %f \n" ,nu[0],nu[1],nu[2]);
	printf("%f %f %f \n" ,nv[0],nv[1],nv[2]);
*/	
	v1[2]*=-1;
	v2[2]*=-1;
	v3[2]*=-1;
	nu[2]*=-1;
	nv[2]*=-1;
	
	// almost uscale==vscale==1.0
	uscale*=1;//HAMMER_FACTOR;
	vscale*=1;//HAMMER_FACTOR;

	//CW -> CCW
	vectors2normal(v1,v2,v3,normal);	
	PlaneSetNormalVertex(&plane[plane_n],normal,v1,v2,v3);
	
	//texture name
	//if(strcasecmp(Word,"sky")==0 || strcasecmp(Word,"aaatrigger")==0 ||
	if( strcasecmp(texture_name,"aaatrigger")==0 || 
			strcasecmp(texture_name,"clip")==0 ||
			strcasecmp(texture_name,"generic011")==0 || 
			strcasecmp(texture_name,"+0~fifties_lgt2")==0)
	{
		planetex[plane_n].texture_id=0;
		width=64;
		height=64;
	}
	else {
		texture_id=LoadTextureFile(texture_name,&width,&height);
		planetex[plane_n].texture_id=texture_id;
		//Texture_getBasis(texture_id,&width,&height);
	}
	
	vectorCopyf(planetex[plane_n].nu,nu);
	vectorCopyf(planetex[plane_n].nv,nv);

	planetex[plane_n].widthuscale=width*uscale;
	planetex[plane_n].heightvscale=height*vscale;
	planetex[plane_n].uscale=uscale;
	planetex[plane_n].vscale=vscale;
	
	// normalize to 1(maximum)  eg)  width=255,uoff=128
	planetex[plane_n].uoff=uoff/width; 
	planetex[plane_n].voff=voff/height;
//	printf("widthuscale %f  width = %d \n",planetex[plane_n].widthuscale ,width);
	return 1;
}

//
void verticeCopy(float vo[5],Vertex *vin)
{
	vo[0]=vin->x;
	vo[1]=vin->y;
	vo[2]=vin->z;
	vo[3]=vin->u;
	vo[4]=vin->v;
}

void verticeCopy(Triangle *t,int idx,Vertex *vin)
{
	t->vertice[idx][0]=vin->x;
	t->vertice[idx][1]=vin->y;
	t->vertice[idx][2]=vin->z;
	t->tex[idx][0]=vin->u;
	t->tex[idx][1]=vin->v;
}
// No Quad system. only triangles with polygons.
//ok. system_polygon2triangles
void Polygon2Triangles(Object *obj,Polygon *p)
{
	int i,size;
	size=p->vertexs.size();

	/*
	if(size==4)
	{
		Quad *q;
		q=new Quad();
		verticeCopy(q->vertice[0],p->vertexs[0]);
		verticeCopy(q->vertice[1],p->vertexs[1]);
		verticeCopy(q->vertice[2],p->vertexs[2]);
		verticeCopy(q->vertice[3],p->vertexs[3]);

		vectorCopyf(q->normal,p->normal);	//ok
		q->texture_id=p->texture_id;
		q->flag=TRIANGLE_MODE_STATIC;
		obj->quads.add(q);
	}
	else  */
		for(i=0;i<size-2;i++)
		{
			Triangle *tri;
			tri=new Triangle();
			//verticeCopy(tri->vertice[0],p->vertexs[0]);
			//verticeCopy(tri->vertice[1],p->vertexs[i+1]);
			//verticeCopy(tri->vertice[2],p->vertexs[i+2]);
			verticeCopy(tri,0,p->vertexs[0]);
			verticeCopy(tri,1,p->vertexs[i+1]);
			verticeCopy(tri,2,p->vertexs[i+2]);
			vectorCopyf(tri->normal,p->normal);	//ok
			tri->texture_id=p->texture_id;
			tri->flag=MODE_STATIC_MULTEX;
			obj->triangles.add(tri);
		}
		
		for(i=0;i<size;i++)
		{
			delete p->vertexs[i];
		}
}



//  귯 ϴ  ... 
//
// Define: Brush is a set of triangles  -> can be a object
// 
// brush κ polygon ̾Ƴ.
//
int map_obj_id=0;
int MAP_brush(FILE *fd)
{
	int		i;
	int		poly_n=0;
	char 	sbuff[512];
	
	plane_n=0;
	while(!feof(fd))
	{	
		fgets(sbuff,sizeof(sbuff),fd);
		strip_ctrlchar(sbuff);
		if(sbuff[0]=='}') break;
		
		getBrushLine(sbuff);
		plane_n++;
	}

	Object *obj;
	obj=new Object();
	obj->id=map_obj_id++; // unique MAP Object ID
	obj->flag_triangle=MODE_STATIC_MULTEX; // for map
	
	int tid=-1,one_texture=1;

	for(i=0;i<plane_n;i++)
	{
		Polygon  *poly=new Polygon();

		if(polygonFromPlanes(poly,i))
		{
			Polygon2Triangles(obj,poly);
		}
	
		// check using same texture_id : for optimization
		if(tid<0)
			tid=poly->texture_id;
		if(tid!=poly->texture_id)
			one_texture=0;
		
		//poly->vertexes.purge();
		delete poly;
	}
	
	if(one_texture)
	{
		obj->flag_triangle=MODE_STATIC_ONETEX; // for map
		obj->texid=tid;
	}
	else obj->texid=-1;

	obj->boundbox.update();
	// add to map_obj
	map_shape->add(obj);

	return plane_n;
}


void MAP_class(FILE *fd)
{
	int done=0;
	int brush_n=0;
	int max_plane_n=0;

	while(!done){
		getWrapWord(fd);
		if(!strcmp(Word,"classname"))
		{
			char name[64],key[64];
			strcpy(name,Word);
			strcpy(key,getWrapWord(fd));
			//printf("record=%s   \tkey=%s\n",name,key);
			if(!strcmp(Word,"worldspawn"))
			{
				//printf("worldspawn\n");
				block_num=0;
			}else 
			if(!strcasecmp(Word,"info_player_deathmatch"))
			{
				//printf("MAP_info_player_deathmatch\n");
				MAP_info_player_deathmatch(fd);
			}else 
			if(!strcmp(Word,"ambient_generic"))
			{
			//	MAP_ambient_generic(fd);
			}else 
			if(!strcmp(Word,"light_environment"))
			{
				MAP_light(fd);
			}else 
			if(!strcmp(Word,"info_null"))
			{
				MAP_info_null(fd);
			}
		}else
			if(!strcmp(Word,"{"))  // Brush
			{
				int n;
				n=MAP_brush(fd);
				//if(n>max_plane_n)	max_plane_n=n;
				block_num++;
				brush_n++;
			}else
				if(!strcmp(Word,"}"))
					done=1;
	}

	if(brush_n>1)
		printf(" brush_n=%d\n",brush_n);
}

/*
"classname" "worldspawn"
"classname" "worldspawn"
"skyname" "des"
"MaxRange" "10000"
"mapversion" "220"
"mapversion" "220"
"wad" "\main\hyun.wad"
*/
// Hammer MAP file loader 
// version 0.81 
// TODO: 
//	1.random texture (remove pattern texture)
//
int  Load_MAP_Hammer(Object *obj,const char *filename)
{
	FILE *fd;

	map_shape=	obj;
	viewer = new PlaneViewer();  // bug tracker viewer !!
	
	// *****  "rb" for Windows !!!
	if(!(fd=fopen(get_pathname(filename),"rb"))) 
		system_error(" can't %s file open !! ",filename);
	
	// map version check!
	//
	while(!feof(fd))
	{
		getWrapWord(fd);
		if(Word[0]=='{')  // class start
		{
			MAP_class(fd);
		}
	}

	obj->boundbox.update();
	fclose(fd);
	//printf("MAP: face_n=%d \n",map_shape->triangle_num);
	//printf("MAP: total_plane_n=%d",total_plane_n);    
	delete viewer;
}

