#include "model_cs.h"
#include "model.h"

// DRAFT MODEL
void Model_CS::action(int s)
{
	if(s==RUN)
	{
		vectorCopyf(force,direction);
		vectorScale(force,0.1);
		force[1]+=0.004;
	}
}

// ver 0.1
Model_CS::Model_CS(const char *fname): Object(fname)
{
	flag_drawdefault=0;
	flag_physics=1;
	weight=1;
	flag_triangle=MODE_INDEX_ONETEX;

	Load_MODEL(this,fname);
	setPosition(0,0,0);
	// model initial 
	int i,j,size;
	Joint *joint;
	points.add(new Vertex);
	
	//triangles.clear();

	for(i=0;i<joints.size();i++)
	{			
		joint=joints[i];
		joint->prev_position[0]=0;	
		joint->prev_position[1]=0;	
		joint->prev_position[2]=0;	
		//vectorPrint(joint->rotate);
		//vectorPrint(joint->translate);
	}

	// make mAbsolute,mReference
	for(i=0;i<joints.size();i++)
	{			
		joint=joints[i];	
		//if(!joint->parent)
		matrixAngles(joint->rotate, joint->mReference);	
		/* if(i==0)
		{
			joint->mReference[0][3]=0;
			joint->mReference[1][3]=0;
			joint->mReference[2][3]=0;
		}*/
		//else 
		{
			joint->mReference[0][3]=joint->translate[0];
			joint->mReference[1][3]=joint->translate[1];
			joint->mReference[2][3]=joint->translate[2];	
		}

		if(joint->parent)
		{
			matrixMult(joint->parent->mAbsolute, joint->mReference, joint->mAbsolute);
		}	
		else {
			memcpy (joint->mAbsolute,joint->mReference,sizeof (float [4][4]));
		}

	}

	for(i=0;i<vertexs.size();i++)
		vertexs_origin.add(new Vertex());

	for(i=0;i<vertexs.size();i++)
	{			
		vertexCopy(vertexs_origin[i],vertexs[i]);
	}


	vector	v1[3],v2[3];
	for(i=0;i<joints.size();i++)
	{
		joint=joints[i];	
		size=joint->vertexs_id.size();
		for(j=0; j < size;j++)
		{
			Vertex *vert;
			id=joint->vertexs_id[j];
			vert=vertexs[id];
			vertexCopy(vert,v1);

			v1[0]-=joint->mAbsolute[0][3];
			v1[1]-=joint->mAbsolute[1][3];
			v1[2]-=joint->mAbsolute[2][3];

			matrixIMultvector(joint->mAbsolute,v1,v2);
			vertexs_origin[id]->x=v2[0];
			vertexs_origin[id]->y=v2[1];
			vertexs_origin[id]->z=v2[2]; 
//			vertex[id].u=v->u;  //̰׻žƴѰ ?
//			vertex[id].v=v->v;
		}
	}
		
//	joints[0]->mAbsolute[0][3];
//	position[1]-=joints[0]->mAbsolute[1][3];
//	joints[0]->mAbsolute[2][3];
	return;
}
// RADIOAN
void Direction2Angle(float v[3],float *th,float *zeta)
{
//	*th=1/tan(v[2]/v[0]);
	*th=atan(v[0]/v[2]);// - M_PI/4;
}

void TEST_v1(Object *obj,float *th)
{
	float  idir[3]={0,0,1};
	float  side_r[3],v1[3];
	
	vectorCopyf(v1,obj->direction);
	v1[1]=0;
	vectorCrossProduct(side_r,idir,obj->up);
	*th=vectorAngle(idir,v1);
	if(vectorDotProduct3f(side_r,obj->direction)>=0) *th=-*th;
		
	//*th=vectorAngle(idir,v1);
	//vectorCrossProduct(side_r,obj->direction,obj->up);
}

// ******* final result will be stored  mAbsolute[4][4];
void Model_CS::joints_transform(Key *frame)
{
	int i,j,size;

	float th=0,zeta;

	//if(vectorLength(direction)==1.0) 
	TEST_v1(this,&th);		
	
	//Animate 
	size=joints.size();
	for( i=0;i< size ; i++)
	{		
		float 	matrix[4][4];
		Joint 	*joint;
		Key	*key;

		joint=joints[i];
		
		key=frame->joints[i];
		if(i==0) 
		{
			float ang[3];
			vectorCopyf(ang,key->rotate);
			ang[2]+=th;//3.14/2; 
			matrixAngles(ang, matrix);	
		}
		else
			matrixAngles(key->rotate, matrix);	
		if(i==0)
		{
			//matrix[0][3]=0;
			//matrix[1][3]=0;//key->translate[1];
			//matrix[2][3]=key->translate[2]; 	// correct the pivot 
			matrix[2][3]=position[1];
			matrix[0][3]=position[2];	
			matrix[1][3]=position[0];
		//	matrix[0][3]=position[0];
		//	matrix[1][3]=position[1];
		//	matrix[2][3]=position[2];
		} 
		else 
		{
			matrix[0][3]=key->translate[0];
			matrix[1][3]=key->translate[1];
			matrix[2][3]=key->translate[2];	
		}

		matrixMult(joint->mReference,matrix, joint->mRelativeFinal);

		if(joint->parent)
		{
			matrixMult(joint->parent->mAbsolute, joint->mRelativeFinal, joint->mAbsolute);
		}	
		else {
			memcpy (joint->mAbsolute,joint->mRelativeFinal,sizeof (float [4][4]));
		}
	}

}

// 1. joint transform -> local transform -> gloabl transform
void Model_CS::vertexs_transform()
{
	int i,j,size,vsize;
	Joint *joint;
	Vertex *vtx;

	size=joints.size();
	for( i=0;i< size ; i++)
	{		
		joint=joints[i];
	
		vsize=joint->vertexs_id.size();
		for( j=0;j< vsize ;j++)
		{
			int vid;
			float v[3];
			float out[3];

			vid=joint->vertexs_id[j];
			v[0]=vertexs_origin[vid]->x;
			v[1]=vertexs_origin[vid]->y;
			v[2]=vertexs_origin[vid]->z;
		
			matrixMultvector(joint->mAbsolute,v,out);
			vertexs[vid]->x=out[0];
			vertexs[vid]->y=out[1];
			vertexs[vid]->z=out[2];
			//vertexs[vid]->x+=position[0];
			//vertexs[vid]->y+=position[1];
			//vertexs[vid]->z+=position[2];
		}
		joint->prev_position[0]=joint->mAbsolute[0][3]; // x 
		joint->prev_position[1]=joint->mAbsolute[1][3]; // y 
		joint->prev_position[2]=joint->mAbsolute[2][3]; // z 
	}
}


void DrawPoint(float v[3]);
void DrawLine(float v1[3],float v2[3]);
// 1.joint_transform
// 2.vertex_transform 
int Model_CS::Update(Uint32 msec)
{ 
	static int ani_idx=1;
	static int ktime=0;
	static int fidx=0;
	int i,j;
	int size;
	Joint *joint;
	int nextKey;
	int time;
	
	ktime+=msec;
	if(ktime<20) return msec;
	
	ktime=0;
	//time=animates[ani_idx]->time;
	
	fidx++;
	if(fidx>=animates[ani_idx]->frames.size())
		fidx=0;
	joints_transform(animates[ani_idx]->frames[fidx]);
	
	if(1)
	{
		Joint *joint;
		float v1[3],v2[3];
		joint=joints[0];
		v1[0] = joint->mAbsolute[0][3]; 
		v1[1] = joint->mAbsolute[1][3]; // Y 
		v1[2] = joint->mAbsolute[2][3];
		
		vectorCopyf(v2,v1);
		v2[1]-=1000;
		test_collision_edge(v1,v2);	
		
		if(collisions.size()>0)
		{
			float d=collisions[0]->distance;
			if(points.size()>0)
			{
				//DrawLine(v1,v2);	
				vectorCopyf(v2,v1);
				v2[1]-=d;
				points[0]->x=v2[0];
				points[0]->y=v2[1];
				points[0]->z=v2[2];
			}

			float h;
			float l1 =fabs(v1[1]-joints[43]->mAbsolute[1][3]);
			float l2 =fabs(v1[1]-joints[49]->mAbsolute[1][3]);
			if(l1>l2) h=l1;
			else h=l2;
			h+=5;
			if(d<h)
			{
				//position[1]=v1[1] + fabs(h-d);
				position[1]+= fabs(h-d) ;
				//position[1]=;
				force[1]=0;
			//	joints_transform(animates[ani_idx]->frames[fidx]);
			} 
			//v1[1] = joints[45]->mAbsolute[2][3];
			//v1[0] = joint->mAbsolute[1][3];
		}	
	}
	size=joints.size();

	if(1)
	{
	}
	else
	for(int i=0;i< size ; i++)
	{		
		Joint *joint;
		joint=joints[i];
		//joint=joints[i];
		if(joint->prev_position[0]==0 and  joint->prev_position[1]==0) continue;	
		float v1[3];
		v1[0]=joint->mAbsolute[0][3];
		v1[1]=joint->mAbsolute[1][3];
		v1[2]=joint->mAbsolute[2][3];
		test_collision_edge(joint->prev_position,v1);	
		if (collisions.size()>0)
		{
			vectorCopyf(position,position_prev);

			break;
			if(0) for(int i=0;i< size ; i++)
			{
				Joint *joint;
				joint=joints[i];
				// to global 
				joint->mAbsolute[0][3]=joint->prev_position[0];
				joint->mAbsolute[1][3]=joint->prev_position[1];
				joint->mAbsolute[2][3]=joint->prev_position[2];
			}
		}
	}
	vertexs_transform();
	boundbox.update();

//	position[1]= position[1]- joints[0]->mAbsolute[1][3];
///	console_printf("xx= %f \n",joints[0]->mAbsolute[1][3]);
}


