#include "object.h"
#include "octree.h"
#include "../math.h"
#include "../gl.h"

/*
 *
 *   make_cube()
 *   
 *   volume_size() -> boundbox 
 *   space_Size()  
 *
 */

void verticeCopy(float vo[5],float vin[5])
{
	vo[0]=vin[0];
	vo[1]=vin[1];
	vo[2]=vin[2];
	vo[3]=vin[3];
	vo[4]=vin[4];
}

// return space volume
float size_space(float v[3])
{

}

void make_cube(Object *obj)
{
	if(obj->triangles.size()!=0 or obj->quads.size()!=0)
		console_printf("not a null");

	Quad	*q;
	/*
	//top
	q=new Quad();
	q->flag=MODE_POINTER;
	q->pvertex[0]=vertexs[0];
	q->pvertex[1]=vertexs[2];
	q->pvertex[2]=vertexs[3];
	q->pvertex[3]=vertexs[1];
	vectorSet(q->normal,0,1,0);
	quads.add(q);
	//bottom
	q=new Quad();
	q->flag=MODE_POINTER;
	q->pvertex[0]=vertexs[4];
	q->pvertex[1]=vertexs[5];
	q->pvertex[2]=vertexs[7];
	q->pvertex[3]=vertexs[6];
	vectorSet(q->normal,0,-1,0);
	quads.add(q);

	//front
	q=new Quad();
	q->flag=MODE_POINTER;
	q->pvertex[0]=vertexs[0];
	q->pvertex[1]=vertexs[1];
	q->pvertex[2]=vertexs[5];
	q->pvertex[3]=vertexs[4];
	vectorSet(q->normal,0,0,1);
	quads.add(q);

	//back
	q=new Quad();
	q->flag=MODE_POINTER;
	q->pvertex[0]=vertexs[2];
	q->pvertex[1]=vertexs[6];
	q->pvertex[2]=vertexs[7];
	q->pvertex[3]=vertexs[3];
	vectorSet(q->normal,0,0,-1);
	quads.add(q);

	//right
	q=new Quad();
	q->flag=MODE_POINTER;
	q->pvertex[0]=vertexs[0];
	q->pvertex[1]=vertexs[4];
	q->pvertex[2]=vertexs[6];
	q->pvertex[3]=vertexs[2];
	vectorSet(q->normal,1,0,0);
	quads.add(q);

	//left
	q=new Quad();
	q->flag=MODE_POINTER;
	q->pvertex[0]=vertexs[1];
	q->pvertex[1]=vertexs[3];
	q->pvertex[2]=vertexs[7];
	q->pvertex[3]=vertexs[5];
	vectorSet(q->normal,-1,0,0);
	quads.add(q);
*/
}


extern Object	*map_object;
// DRAFT 
void triangleCopy(Triangle *to,Triangle *tin,Object *o=0)
{
	memcpy(to,tin,sizeof(Triangle));
	/*
	to->flag=tin->flag;
	to->texture_id=tin->texture_id;

	to->vertex_id[0]=tin->vertex_id[0];
	to->vertex_id[1]=tin->vertex_id[1];
	to->vertex_id[2]=tin->vertex_id[2];

	to->pvertex[0]=tin->pvertex[0];
	to->pvertex[1]=tin->pvertex[1];
	to->pvertex[2]=tin->pvertex[2];

	to->color[0]=tin->color[0];
	to->color[1]=tin->color[1];
	to->color[2]=tin->color[2];
	to->color[3]=tin->color[3];
	
	verticeCopy(to->vertice[0],tin->vertice[0]);
	verticeCopy(to->vertice[1],tin->vertice[1]);
	verticeCopy(to->vertice[2],tin->vertice[2]);
	*/
	if(o)
	{
		vectorAdd(to->vertice[0],o->position);
		vectorAdd(to->vertice[1],o->position);
		vectorAdd(to->vertice[2],o->position);
	}
}

// DRAFT
bool triangleIntersection(Triangle *tri,Line *line,float *distance,Object *obj)
{
	float *vs[3];

	if(tri->flag==MODE_POINTER)
	{
		vs[0]=tri->pvertex[0];	
		vs[1]=tri->pvertex[1];	
		vs[2]=tri->pvertex[2];	
	}
	else
	if(tri->flag & MODE_STATIC)  // for MODE_STATIC_MULTEX, MODE_STATIC_MULTEX
 	{
		vs[0]=tri->vertice[0];
		vs[1]=tri->vertice[1];
		vs[2]=tri->vertice[2];
	}
	else 
	if(tri->flag == TRIANGLE_MODE_INDEX)  // for MODEL?
 	{
	//	obj->vertexs;
		vs[0]=&obj->vertexs[tri->vertex_id[0]]->x;
		vs[1]=&obj->vertexs[tri->vertex_id[1]]->x;
		vs[2]=&obj->vertexs[tri->vertex_id[2]]->x;
	}
	else	console_printf("triangleIntersection() flag=%x obj=%s \n",tri->flag,obj->name);
		
	return test_intersect_triangle_line4(vs,line,distance);
	
}



void Object::init()
{
	setPosition(0,0,0);		// default position
	vectorSet(up,0,1.0,0);	// default up_vector
	vectorSet(rotate,0,0,0);	
	vectorSet(direction,0,0,1.0);	
	vectorSet(force,0,0,0);	// default up_vector

	setSpeed(0.0);		//DEL
	
	flag_inFOV=0;		
	flag_physics=1;
	flag_visiable=1;
	flag_drawdefault=1;
	flag_triangle=-1;			// 
	flag_active=0;
	flag_bbox=0;
	weight=0;
	elastic=0.5;

	level=-1;
	boundbox.setObject(this);
	boundbox.radius=5.0;
	stamp_draw=0;
	stamp_FOV=0;
	gllistid=-1;

	next=0;
	parent=0;
	addmsec=0;
}

Object::Object()
{ 
	// Object("null object"); // ERROR ? why ?
	strcpy(name,"null object"); 
	init();
}

Object::~Object()
{
	children.clear();
}


void Object::setName(const char *name_)
{ 
	strcpy(name,name_); 
}


Object::Object(const char *name_)
{ 
		strcpy(name,name_); 
		init();
}

void Object::add(Object *child)
{
	if(child->parent)
	{
		//child->parent->remove(child);
		//printf("??????????\n");
	}
	child->parent=this;
	children.add(child);
}

void Object::remove(Object *child)
{
	if(children.find_reverse(child))
	{
		children.remove_current();
		child->parent=0;
	}
}


/*
void Object::add_box(Object *child)
{ 
	set_bound_box(child);
	children.add(child);
	set_bound_box(this);
}
*/

int Object::Update()
{ 

}


int Object::Update(Uint32 msec)
{ 

}

// Triangle *makeCube(Object *o);
// draw Cube box
void Object::drawDefault() // go to Viewr better?
{
	//if(FOV_distance<2) return;		
	glLoadIdentity();
	glTranslatef(position[0],position[1],position[2]);

	if(flag_drawdefault==0) return;
	//glEnable(GL_TEXTURE_2D);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	float len=5.0;
	
	glColor4f(0.0,1.0,0,1.0);
	glScalef(len,len,len);
	// CUBE 
	glBegin(GL_QUADS);
	/* Front Face */
	/* Normal Pointing Towards Viewer */
	glNormal3f( 0.0f, 0.0f, 1.0f );
	glVertex3f( -1.0f, -1.0f,  1.0f );		
	glVertex3f(  1.0f, -1.0f,  1.0f );
	glVertex3f(  1.0f,  1.0f,  1.0f );
	glVertex3f( -1.0f,  1.0f,  1.0f );

	/* Back Face */
	/* Normal Pointing Away From Viewer */
	glNormal3f( 0.0f, 0.0f, -1.0f);
	glVertex3f( -1.0f, -1.0f, -1.0f );
	glVertex3f( -1.0f,  1.0f, -1.0f );
	glVertex3f(  1.0f,  1.0f, -1.0f );
	glVertex3f(  1.0f, -1.0f, -1.0f );

	/* Top Face */
	glNormal3f( 0.0f, 1.0f, 0.0f );
	glVertex3f( -1.0f,  1.0f, -1.0f );
	glVertex3f( -1.0f,  1.0f,  1.0f );
	glVertex3f(  1.0f,  1.0f,  1.0f );
	glVertex3f(  1.0f,  1.0f, -1.0f );

	/* Bottom Face */
	/* Normal Pointing Down */
	glNormal3f( 0.0f, -1.0f, 0.0f );
	glVertex3f( -1.0f, -1.0f, -1.0f );
	glVertex3f(  1.0f, -1.0f, -1.0f );
	glVertex3f(  1.0f, -1.0f,  1.0f );
	glVertex3f( -1.0f, -1.0f,  1.0f );

	/* Right face */
	/* Normal Pointing Right */
	glNormal3f( 1.0f, 0.0f, 0.0f);
	glVertex3f( 1.0f, -1.0f, -1.0f );
	glVertex3f( 1.0f,  1.0f, -1.0f );
	glVertex3f( 1.0f,  1.0f,  1.0f );
	glVertex3f( 1.0f, -1.0f,  1.0f );

	/* Left Face*/
	glNormal3f( -1.0f, 0.0f, 0.0f );
	glVertex3f( -1.0f, -1.0f, -1.0f );
	glVertex3f( -1.0f, -1.0f,  1.0f );
	glVertex3f( -1.0f,  1.0f,  1.0f );
	glVertex3f( -1.0f,  1.0f, -1.0f );

	glEnd();

	//draw direction vector
	glColor4f(0.0,0.0,1,1);

	float v1[3];
	vectorCopy3f(v1,direction);
	vectorScale(v1,3);
	//glLineWidth(2);
	glBegin( GL_LINES );
	glVertex3f(0,0,0);
	glVertex3fv(v1);
	glEnd();


}

extern Object *camera;

void BoundBox::draw_wire()
{	
	int i,j;
	float v1[3];
	int size;

	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glColor4f(0.0,1.0,0.0,1.0);

	//size=triangles.size();
	size=quads.size();
	for(i=0;i<size;i++)
	{			
		Quad *q;
		q=quads[i];
		//if(vectorDotProduct(v1,tri->normal)>=0)	continue;  // HP 
		glBegin(GL_LINE_LOOP);	
		for(j=0;j<4;j++)
			glVertex3fv(q->pvertex[j]);
		glEnd(); 
	}
	return ;
	for(i=0;i<size;i++)
	{			
		Triangle *tri;
		Quad *q;
		tri=triangles[i];
		//if(vectorDotProduct(v1,tri->normal)>=0)	continue;  // HP 
		if(tri->flag==TRIANGLE_MODE_POINTER)
		{
			//glColor4f(0,0.5,0,0.5); // green
			glBegin(GL_LINE_LOOP);	
			for(j=0;j<3;j++)
				glVertex3fv(tri->pvertex[j]);
			glEnd(); 
		}
	}
}

extern struct sFrustrum {
	float left,right,bottom,top;
	float Near,Far;
	float width,height;
	vector LB[4],LT[4],RB[4],RT[4];
	vector BL[4],BR[4],TL[4],TR[4];
	vector nL[4],nT[4],nB[4],nR[4];
	plane_t	sides[5];
} Frustrum;


float p[10][4];
// dirty DRAFT CODE!!
int clip3d_t(float *vp[3])
{
	float 	np[10][3];
	int	nvp=3, nv=0;

	
	for(int i=0;i<3;i++)
	{
	//	p[i][0]=vp[i][0], p[i][1]=vp[i][1], p[i][2]=vp[i][2];
		float *P=p[i],*V=vp[i];*P++=*V++; *P++=*V++; *P++=*V++;
	}
	// j=5
	for(int j=0;j<4;j++)
	{
		float d=Frustrum.sides[j].distance;
		float *norm=Frustrum.sides[j].normal;
		int out=0;

		for(int i=0;i<nvp;i++)
		{
			p[i][3]= M_vectorDotProduct3f(p[i],norm) - d;
			if(p[i][3] >0) out++;
		}
		
		if(out==nvp) return 0; // all points out of frustrum ! 	
		if(out==0) continue; // if all inside then pass
		
		nv=0;
		for(int i=0;i<nvp ;i++)
		{
			float *v1,*v2;
			v1=p[i];	

			if(i<nvp-1)  // 0,1,2
				v2=p[i+1];
			else
				v2=p[0];

			float da,db;   // distance plane -> point a

			da = v1[3];
			db = v2[3];

			if(da<=0) // inside of frustrum
			{
				np[nv][0]=v1[0];	
				np[nv][1]=v1[1];	
				np[nv][2]=v1[2]; 
				nv++;

				if(db>0) // outside
				{
					//new point
					float s = da/(da-db);   // intersection factor (between 0 and 1)
					np[nv][0] = v1[0] + s*(v2[0]-v1[0]);
					np[nv][1] = v1[1] + s*(v2[1]-v1[1]);
					np[nv][2] = v1[2] + s*(v2[2]-v1[2]);
					nv++;
				}
			}
			else  
			{
				// outside of F
				// no added
				if(db<=0) // inside
				{
					//new point
					float s = da/(da-db);   // intersection factor (between 0 and 1)
					np[nv][0] = v1[0] + s*(v2[0]-v1[0]);
					np[nv][1] = v1[1] + s*(v2[1]-v1[1]);
					np[nv][2] = v1[2] + s*(v2[2]-v1[2]);
					nv++;
				}
			}
		}
		nvp=nv;
		for(int i=0;i<nv;i++)
			p[i][0]=np[i][0],p[i][1]=np[i][1],p[i][2]=np[i][2];
	}

	return nvp; //return point_n
}

int clip2d_t(float *vp[3])
{
	float 	np[10][3];
	int	nvp=3, nv=0;

	
	for(int i=0;i<3;i++)
		p[i][0]=vp[i][0], 
		p[i][1]=vp[i][1],
		p[i][2]=vp[i][2];


	for(int j=0;j<3;j++)
	{
		float d=Frustrum.sides[j].distance;
		float *norm=Frustrum.sides[j].normal;
		int out=0;

		for(int i=0;i<nvp;i++)
		{
			p[i][3]= M_vectorDotProduct3f(p[i],norm) - d;
			if(p[i][3]>0) out++;
		}
		
		if(out==0) continue; // if all inside then pass

		nv=0;
		for(int i=0;i<nvp ;i++)
		{
			float *v1,*v2;
			v1=p[i];	

			if(i<nvp-1)  // 0,1,2
				v2=p[i+1];
			else
				v2=p[0];

			float da,db;   // distance plane -> point a

			da = v1[3];
			db = v2[3];

			if(da<=0) // inside of frustrum
			{
				np[nv][0]=v1[0];	
				np[nv][1]=v1[1];	
				np[nv][2]=v1[2]; 
				nv++;

				if(db>0) // outside
				{
					//new point
					float s = da/(da-db);   // intersection factor (between 0 and 1)
					np[nv][0] = v1[0] + s*(v2[0]-v1[0]);
					np[nv][1] = v1[1] + s*(v2[1]-v1[1]);
					np[nv][2] = v1[2] + s*(v2[2]-v1[2]);
					nv++;
				}
			}
			else  
			{
				// outside of F
				// no added

				if(db<=0) // inside
				{
					//new point
					float s = da/(da-db);   // intersection factor (between 0 and 1)
					np[nv][0] = v1[0] + s*(v2[0]-v1[0]);
					np[nv][1] = v1[1] + s*(v2[1]-v1[1]);
					np[nv][2] = v1[2] + s*(v2[2]-v1[2]);
					nv++;
				}
			}
		}
		nvp=nv;
		for(int i=0;i<nv;i++)
			p[i][0]=np[i][0],p[i][1]=np[i][1],p[i][2]=np[i][2];
	}

	return nvp; //return point_n
}


// cohen-shudeland's algorithm
// return : 
// 0. in : no clip need
// 1. out 
// 2. need clip
extern int DWIDTH,DHEGIHT;
int check_outside(float p[3][3])
{
	int bit[3],result,sum=0;
	for(int i=0;i<3 ;i++)
	{
		int b=0;
		int x,y;
		x=FAST_ROUND(p[i][0]);
		y=FAST_ROUND(p[i][1]);
	
		if(y>=DHEGIHT) b=b|0x08;
		if(y<0) b=b|0x04;
		if(x>=DWIDTH) b=b|0x02;
		if(x<0)	b=b|0x01;

		bit[i]=b;
		sum+=b;
	}
	result= bit[0] & bit[1] & bit[2];
	
	if(result > 0) return 1; // all points out
	if(sum==0) return 0;  // all points in
	else return 2;  // 

	// need clipping  
	{
		int i,n=3;
		for(i=0;i<n;i++)
		{

		}

		if(bit[0]==0x01) // y <  0
		{

		}
		if(bit[0]!=bit[1]) 
		{
		}

	}
//	if(bit[0]==0 and bit
}


typedef struct
{
	int x,y;
	int col;
} point;
point points[8];

int shadedpoly (point *vertexlist, int numvertex,int check,int miy,int mxy);
int shadedtriangle (point *vertexlist,int check,int miny,int maxy);
int dcount=0;
int depth_passed_pixels=0;
void fill_triangle3_clip(float fp0[2],float fp1[2], float fp2[2], int color,int dox) ;
void fill_triangle3_noclip(float fp0[3],float fp1[3], float fp2[3], int dontdraw); 
void fill_triangle4_noclip(int p0[3],int p1[3], int p2[3], int dontdraw); 
void fill_triangle5_noclip(int p0[3],int p1[3], int p2[3], int dontdraw); 
int depth_triangle(float *v[3],int dontdraw=0)
{
	
	extern int DHEGIHT;
	int out=0;
	int n;
	int ip[10][3];
	int min_y=DHEGIHT,max_y=0;
	static float min=1;
	n=clip3d_t(v);
	if(n>8 or n < 3)
	{
		//console_printf("DEBUG: maybe out of bound. check code clip n=%d",n);
		return 0;
	}
	if(1) 
	{
		int r;
		for(int i=0;i<n;i++)
		{
			if(glProjecti(p[i],ip[i])==0) out++;
		}
		//r=check_outside(fp); if(r==1) return 0;
		if(out >0 ) return 0;
		//float max=-3; // near = 0,far  = 1.0
		float depth=-2;
		//if(fp[0][2]>max) max=fp[0][2]; if(fp[1][2]>max) max=fp[1][2];	if(fp[2][2]>max) max=fp[2][2];
		//for(int i=0;i<n;i++)
		{
		//	if(fp[i][2]>depth) depth=fp[i][2]; 
		//	fp[i][2]=(fp[i][2])*65500;
		}
		// max==1 is out of bound 
		// if(depth>=1.0) return 0; // too far
		//max=max-0.9;
		//if(max<0) return 0;
		//console_printf("max=%.8f col=%u min=%.8f",depth,col,min);
		//int col=(int)(depth*65530);
		for(int i=0;i<n-2;i++) 	
			//fill_triangle3_noclip(fp[0],fp[i+1],fp[i+2],dontdraw);
			fill_triangle5_noclip(ip[0],ip[i+1],ip[i+2],dontdraw);
			//fill_triangle3_clip(fp[0],fp[i+1],fp[i+2],col,dontdraw);
	}
	else
	{
		// precache
		for(int i=0;i<n;i++)
		{
			int ty;
			if(glProjecti(p[i],ip[i])==0) out++;
			//console_printf("(%.0f,%.0f) (%.0f,%.0f) (%.0f,%.0f) ",p1[0],p1[1],p2[0],p2[1],p3[0],p3[1]);
			//console_printf("z=%.8f ",ip[i][2]);
			points[i].x=ip[i][0];
			ty=points[i].y=ip[i][1];
			if(ty>max_y)	max_y=ty; // HP 20% 
			if(ty<min_y)	min_y=ty;
			points[i].col=ip[i][2];
		}

		if(out>0)
		{
			static int fail_clip=0;	
			out=0;
			for(int i=0;i<3;i++)
				if(glProjecti(v[i],ip[i])==0) out++;
			if(out==0) 
				console_printf("DEBUG: clip fail !! but orignal OK !!!!!",fail_clip++);
			else console_printf("DEBUG: clip fail !! %d",fail_clip++);
			return 0;
		}
		else
		{
		//	if(n==3) shadedtriangle(points,dontdraw,min_y,max_y);
		//	else	
			shadedpoly(points,n,dontdraw,min_y,max_y);
		}

	
	}

	asm( "emms \t\n" );
}

// software render 
void BoundBox::draw2()
{	
}

inline void BoundBox::draw()
{	
	int i;
	int size;
	float v1[3];
	vectorCopyf(v1,center);  //vectorCopy(v1,position); zerom
	vectorSubtractM(v1,camera->position);
	vectorNormalize(v1);
	
	if(1)
	{
		// HP 9%
		//size=quads.size();
		glBegin(GL_QUADS);
		for(i=0;i<6;i++)
		{			
			Quad *q;
			q=quads[i];	
			if(vectorDotProduct3f(v1,q->normal)>=0)	continue;  // HP 
			//if(tri->flag==TRIANGLE_MODE_POINTER)
			glVertex3fv(q->pvertex[0]);
			glVertex3fv(q->pvertex[1]);
			glVertex3fv(q->pvertex[2]);
			glVertex3fv(q->pvertex[3]);
		}
		glEnd(); 
	}
	else
	{
		size=triangles.size();
		glBegin(GL_TRIANGLES);
		for(i=0;i<size;i++)
		{			
			Triangle *tri;
			tri=triangles[i];	
			if(vectorDotProduct3f(v1,tri->normal)>=0)	continue;  // HP 
			//if(tri->flag==TRIANGLE_MODE_POINTER)
			glVertex3fv(tri->pvertex[0]);
			glVertex3fv(tri->pvertex[1]);
			glVertex3fv(tri->pvertex[2]);
		}
		glEnd(); 

		if(size!=12) console_printf("kkk =%d",size);	
	}
}

#define CHECKIN(v) 	min[0] <= v[0]	and v[0] <=  max[0] \
		and	min[1] <= v[1] and v[1] <=  max[1] \
		and	min[2] <= v[2] and v[2] <=  max[2]

extern Uint32 	stamp;
// SOFTWARE DEPTH_BUFFER
int BoundBox::check_occlusion2()
{
	if(CHECKIN(camera->position))  // speed up
	{
		flag_occlusion=1; 
		depth_passed_pixels=1;
		return VISIABLE;
	}
	
	int i,j;
	float v1[3];
	vectorSubtract(v1,center,camera->position);
	vectorNormalize(v1);
	int size;
	
	depth_passed_pixels=0;
	if(robj->level>0)
	{
		// level >0 
		size=triangles.size();
		for(i=0;i<size;i++)
		{			
			Triangle *tri;
			tri=triangles[i];
			if(vectorDotProduct4f(v1,tri->normal)>=0)	continue;  // HP
			depth_triangle(tri->pvertex,1); // dont draw ! just check 
			if(depth_passed_pixels>0) break;
		}
		if(size!=12)	console_printf("Error:bound box size = %d ",size);
	}
	else 
	{
		
		size=robj->triangles.size();
		for(i=0;i<size;i++)
		{			
			Triangle *tri;
			tri=robj->triangles[i];
			//if(tri->flag!=MODE_STATIC) break;
			if(vectorDotProduct4f(v1,tri->normal)>=0)	continue;  // HP
			
			float *v[3];
			v[0]=tri->vertice[0];
			v[1]=tri->vertice[1];
			v[2]=tri->vertice[2];
			depth_triangle(v,0);
		} 
	}

	if(depth_passed_pixels>0)
	{
		// draw object in depth_buffer
		flag_occlusion=1;
		return VISIABLE;
	}
	flag_occlusion=0; 
	return HIDDEN;
}


int child_query(Object *obj);
int BoundBox::occlusion_query()
{
	GLuint	sampleCount;
    	GLint	available;

	if(robj->flag_visiable==stamp)  // speed up
	{
		//console_printf ( "skip %x",robj);
		return 1;
	}
 
	if(CHECKIN(camera->position))  // speed up
	{
		flag_occlusion=1; 
		return 1;
	}

	if(query_stamp==stamp) // already quering !
	{
		// check result avail 
	///	glGetQueryObjectivARB(query,GL_QUERY_RESULT_AVAILABLE_ARB,	&available);
		if(available)
		{
			///glGetQueryObjectuivARB(query, GL_QUERY_RESULT_ARB, &sampleCount); // blocking function
			if (sampleCount > 0) {
				flag_occlusion=1;
				return 1;
			}
			flag_occlusion=0;
			return 0;
		}
		else
			return 2; //pending...
	}

	if(query_stamp!=stamp)
	{
		glDisable(GL_LIGHTING); glDisable(GL_COLOR_MATERIAL);  glDisable(GL_NORMALIZE);
		
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE); glDepthMask(GL_FALSE);
		///glBeginQuery(GL_SAMPLES_PASSED_ARB, query);
		draw();
		///glEndQuery(GL_SAMPLES_PASSED_ARB);
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);glDepthMask(GL_TRUE);
		query_stamp=stamp;
		return 2;
	}
}

extern Object *dam_obj;
// GL_ARB_occlusion_query
int BoundBox::check_occlusion3(int query_flag=0)
{
	if(robj->flag_visiable==stamp)  // speed up
	{
		//console_printf ( "skip %x",robj);
		flag_occlusion=1; 
		return VISIABLE;
	}
    
	if(CHECKIN(camera->position))  // speed up
	{
		flag_occlusion=1; 
		return VISIABLE;
	}
    
	GLuint	sampleCount;
	GLint	available;
	
	if(query_stamp!=stamp)
	{
		glDisable(GL_LIGHTING); glDisable(GL_COLOR_MATERIAL);  glDisable(GL_NORMALIZE);
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE); glDepthMask(GL_FALSE);
		///glBeginQuery(GL_SAMPLES_PASSED_ARB, query);
		draw();
		///glEndQuery(GL_SAMPLES_PASSED_ARB);
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);glDepthMask(GL_TRUE);
		query_stamp=stamp;
	}

	int count=0;
	///glGetQueryObjectivARB(query,GL_QUERY_RESULT_AVAILABLE_ARB,	&available);
    	while (!available)
	{
	//	extern Index<Object*> stack_drawnp;
	//	if(dam_obj=stack_drawnp.pop())
		{
	//		if(dam_obj->boundbox.occlusion_query()==0) return 0;
		}
	////	glGetQueryObjectivARB(query,GL_QUERY_RESULT_AVAILABLE_ARB,	&available);
		count++;
	}
	//if(count>500) console_printf("count %d  leve=%d obj=%x",count,robj->level,robj); // 300more !!

	////glGetQueryObjectuivARB(query, GL_QUERY_RESULT_ARB, &sampleCount); // blocking function

	if (sampleCount > 0) {
		flag_occlusion=1;
		return VISIABLE;
    }
	
	flag_occlusion=0;
	return HIDDEN;
}


int BoundBox::check_occlusion(int query_flag=0)
{
	
	if(CHECKIN(camera->position))  // speed up
	{
		flag_occlusion=1; 
		return 1;
	}
    
	GLuint	sampleCount;
    GLint	available;

	//glDisable(GL_LIGHTING); glDisable(GL_BLEND); glDisable(GL_TEXTURE_2D);
	
	//slow
/*	if(robj->level < 0)
	{
		glBeginQuery(GL_SAMPLES_PASSED_ARB, query);
		robj->draw_raw();
		glEndQuery(GL_SAMPLES_PASSED_ARB);
		glGetQueryObjectuivARB(query, GL_QUERY_RESULT_ARB, &sampleCount); // blocking function
		if (sampleCount > 0) {
			flag_occlusion=1;
			return 1;
		}
		robj->stamp_draw=-1;
		flag_occlusion=0;
		return 0;
	}
	else	*/

	{
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE); glDepthMask(GL_FALSE);
		///glBeginQuery(GL_SAMPLES_PASSED_ARB, query);
		draw();
		///glEndQuery(GL_SAMPLES_PASSED_ARB);
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);glDepthMask(GL_TRUE);
//		glFlush(); // slow
	}

	///glGetQueryObjectuivARB(query, GL_QUERY_RESULT_ARB, &sampleCount); // blocking function

	if (sampleCount > 0) {
		flag_occlusion=1;
		return 1;
    }

	flag_occlusion=0;
	return 0;
   	/*
	int count=0;
	do{
		//DoSomeStuff();
		glGetQueryObjectivARB(query,GL_QUERY_RESULT_AVAILABLE_ARB,	&available);
		//count++;
    } while (!available);
	if(count>300) console_printf("count %d",count); // 300more !!
	*/
 }
// always pass pixel zero
//  1. if out of Frustrum 

// if 

// return 1 : visiable
// return 0 : hidden
//
int Object::draw_occluder(int no_query=0)
{
	int i,j,size;
	//int n_child=children.size();
	//int num_triangle=triangles.size();
	//if(num_triangle==0)	return 0;

	if(level>0) return 0;
	if(stamp_draw==stamp or flag_inFOV==0 ) return 0;

	stamp_draw=stamp; // *** 

//	if(no_query==0) 
//		if(boundbox.occlusion_query()==0)
//			return 0;

	draw_basis();

	if(no_query==0)
		return boundbox.check_occlusion2();

	return 0;
} 



//Shape_DrawCenter(Shape *shape)
void drawUpDirection(Object *obj)
{
	int   	i,j;  
	float	matrix[4][4];
	float 	xpoint[3];	
	float 	ypoint[3];	
	float 	zpoint[3];	
	float 	opoint[3];
	
	float	translate[3];
	float	rotate[3];
	
	int 	key;
	

	// center
	glPointSize(8);
	glColor4f(1.0, 0.0, 0.0,1.0); 
	glBegin(GL_POINTS);
	glVertex3fv(obj->position);
	
	glVertex3f(0,0,0);
	glEnd();
	
	// direction(BLUE)
	float v1[3],v2[3];
	vectorCopyf(v1,obj->direction);
	vectorScale(v1,20);
	vectorAdd(v1,obj->position);
	glColor4f(0.0,0.0,1.0,1.0); 
	glBegin(GL_LINES);
	glVertex3fv(obj->position);
	glVertex3fv(v1);
	glEnd();
	
	// Up(GREEN)
	vectorCopyf(v1,obj->up);
	vectorScale(v1,20);
	vectorAdd(v1,obj->position);
	glColor4f(0.0,1.0,0.0,1.0); 
	glBegin(GL_LINES);
	glVertex3fv(obj->position);
	glVertex3fv(v1);
	glEnd();


    	glEnable(GL_DEPTH_TEST);
	return ;
	vectorAdd(xpoint,translate);
	vectorAdd(ypoint,translate);
	vectorAdd(zpoint,translate);
	vectorCopyf(opoint,translate);
	glColor4f(1.0, 1.0, 1.0,1.0); 
	
	glPointSize(1);
	glBegin(GL_LINES);
	
	glVertex3fv(opoint);
	glVertex3fv(xpoint);
	glVertex3fv(opoint);
	glVertex3fv(ypoint);
	glVertex3fv(opoint);
	glVertex3fv(zpoint);
	
	glEnd(); 

	glPointSize(7);
	glColor4f(1.0, 0.0, 0.0,1.0); 
	glBegin(GL_POINTS);
	glVertex3fv(xpoint);
	
	glColor4f(0.0, 1.0, 0.0,1.0); 
	glVertex3fv(ypoint);
	
	glColor4f(0.0, 0.0, 1.0,1.0); 
	glVertex3fv(zpoint);
	glEnd(); 
			
	glPointSize(1);
}

void Joint_DrawAxis(Joint  *joint)
{
	Joint	*jc,*jp;
	Key	*frame,*jp_frame;
	int   	i,j;  
	float	matrix[4][4];
	float 	xpoint[3];	
	float 	ypoint[3];	
	float 	zpoint[3];	
	float 	opoint[3];
	
	float	translate[3];
	float	rotate[3];
	
	int 	key;
	
	//key=NextKey;
	key=0;
    	glDisable(GL_DEPTH_TEST);
	
//	printf("*joint=%x \n",joint);
	///frame=joint->frame;

// 	AngleMatrix(joint->frame[key].mRe, matrix);
/*
	printf("rotate= %f %f %f \n",frame[key].rotate[0],
					frame[key].rotate[1],
					frame[key].rotate[2]);
	printf("translate= %f %f %f \n",frame[key].translate[0],
					frame[key].translate[1],
					frame[key].translate[2]);
*/

//	Matrix_vectorRotate(matrix,xaxis,xpoint);
	
	///Matrix_vectorRotate(joint->mRelativeFinal,xaxis,xpoint);

	///Matrix_vectorRotate(joint->mRelativeFinal,yaxis,ypoint);
	///Matrix_vectorRotate(joint->mRelativeFinal,zaxis,zpoint);

//	Matrix_vectorRotate(matrix,xaxis,xpoint);
//	Matrix_vectorRotate(matrix,yaxis,ypoint);
//	Matrix_vectorRotate(matrix,zaxis,zpoint);
	translate[0]=joint->mAbsolute[0][3];
	translate[1]=joint->mAbsolute[1][3];
	translate[2]=joint->mAbsolute[2][3];
	
	vectorAdd(xpoint,translate);
	vectorAdd(ypoint,translate);
	vectorAdd(zpoint,translate);
	vectorCopyf(opoint,translate);

/*	printf("translate= %f %f %f \n",frame[key].translate[0],
					frame[key].translate[1],
					frame[key].translate[2]);
	printf("translateX= %f %f %f \n",joint->frame[key].translate[0],
					joint->frame[key].translate[1],
					joint->frame[key].translate[2]);
*/

	glColor4f(1.0, 1.0, 1.0,1.0); 
	
	glPointSize(1);
	glBegin(GL_LINES);
	
	glVertex3fv(opoint);
	glVertex3fv(xpoint);
	glVertex3fv(opoint);
	glVertex3fv(ypoint);
	glVertex3fv(opoint);
	glVertex3fv(zpoint);
	
	glEnd(); 

	glPointSize(7);
	glColor4f(1.0, 0.0, 0.0,1.0); 
	glBegin(GL_POINTS);
	glVertex3fv(xpoint);

	
	glColor4f(0.0, 1.0, 0.0,1.0); 
	glVertex3fv(ypoint);
	
	glColor4f(0.0, 0.0, 1.0,1.0); 
	glVertex3fv(zpoint);
	glEnd(); 
			

//	vectorAdd(

	glPointSize(1);
//	glPopMatrix();

    	glEnable(GL_DEPTH_TEST);
}

int Object::draw_joints()
{
	// Joint draw 
	int i,j;
	Joint *joint;
	Joint *p;
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	glColor4f(1.0,1.0,1.0,1.0);

	for(i=0;i<joints.size();i++)
	{			
		joint=joints[i];	
		
		if(joint->parent)
		{
			p=joint->parent;
			glBegin(GL_LINES);

			glVertex3f(
					p->mAbsolute[0][3],
					p->mAbsolute[1][3],
					p->mAbsolute[2][3]					
					);

			glVertex3f(
					joint->mAbsolute[0][3],
					joint->mAbsolute[1][3],
					joint->mAbsolute[2][3]					
					);
			glEnd(); 
		}
	}

	//draw joints Center !!
	glColor4f(1.0,0.0,0.0,1.0);
	glPointSize(6);
	glBegin(GL_POINTS);
		//glVertex3f(position[0],position[1],position[2]);
		glVertex3f(	joints[0]->mAbsolute[0][3],
				joints[0]->mAbsolute[1][3],
				joints[0]->mAbsolute[2][3]);
		
	glEnd(); 

	drawUpDirection(this);

	for(i=0;i<points.size();i++)
	{
		Vertex *v=points[i];
		glBegin(GL_POINTS);
		glVertex3f(v->x,v->y,v->z);
		glEnd(); 
	}

	
	glPointSize(1);
	glEnable(GL_DEPTH_TEST);
}

void DrawPoint(float v[3])
{
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	
	glColor4f(1.0,0.0,0.0,1.0);
	glPointSize(6);
	glBegin(GL_POINTS);
	glVertex3fv(v);
	glEnd(); 
	glPointSize(1);
	glEnable(GL_DEPTH_TEST);
}
void DrawLine(float v1[3],float v2[3])
{
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor4f(1.0,0.0,0.0,1.0);
	glPointSize(1);
	glBegin(GL_LINES);
	glVertex3fv(v1);
	glVertex3fv(v2);
	glEnd(); 
	glPointSize(1);
	glEnable(GL_DEPTH_TEST);
}	

// move to Viewer
int Object::draw_basis()
{ 
	int i,j,size;
	int n_child=children.size();
	int num_triangle=triangles.size();
	
	if(level>0) return 1;
	if(n_child==0 and num_triangle==0){	drawDefault();	return 1; }
	if(num_triangle==0)	return 0;

	glLoadIdentity();
	extern int flag_opacity;
	if(!flag_opacity) boundbox.draw_wire();

	if(flag_active==2)// or level==2)
	{
		glColor4f(1.0,0.7,0.7,1.0);
		glDisable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
		boundbox.draw_wire2();
		glEnable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		//glColor4f(0.7,1.0,0.7,1.0);
		//glColor4f(1.0,1.0,1.0,1.0);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}

	if(flag_opacity)
	{
		glDisable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		glColor4f(1.0,1.0,1.0,1.0);
	}
	else
	{
		glEnable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
		glColor4f(0.4,1.0,0.75,0.15);
	//	glBlendFunc(GL_ONE, GL_ONE); 
	//	GL_ONE_MINUS_SRC_ALPHA = ۿִ ȼ  ش. ?
	//
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		//glBlendFunc(GL_ONE_MINUS_DST_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		//glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
	}

	if(flag_active==1)// or level==2)
	{
	//	glDisable(GL_DEPTH_TEST);
		glColor4f(0.0,1.0,0.3,1.0);
		glDisable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
		boundbox.draw_wire2();
		glEnable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		glColor4f(0.9,1.0,1.0,0.5);
		//glColor4f(1.0,1.0,1.0,1.0);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		//glBlendFunc(GL_ONE_MINUS_DST_ALPHA, GL_ONE);
		//glBlendFunc(GL_ONE_MINUS_DST_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	//elss	glEnable(GL_DEPTH_TEST);
	
	//glRotatef(-t_rotY,v3[0],v3[1],v3[2]);
	//glRotatef(t_rot,up[0],up[1],up[2]);
	//glTranslatef(position[0],position[1],position[2]);
	
	float v1[4];
	vectorCopyf(v1,boundbox.center);
	vectorSubtractM(v1,camera->position);

	// using same texture , MAP OBJ
	if(flag_triangle==MODE_STATIC_MULTEX or flag_triangle==MODE_STATIC_ONETEX){
		for(i=0;i<num_triangle;i++)
		{		
			float vc[3];

			Triangle *tri;
			tri=triangles[i];
			// sqrt(0.5)  90dgree
			//glNormal3fv(tri->normal);
			//glColor4f(1,1,1,1);
			if(vectorDotProduct3f(v1,tri->normal)>0) continue;  // HP 30%
			
			extern int flag_depth_test;
			if(0)
			if(flag_depth_test)
			{
				float *v[3];
				v[0]=tri->vertice[0];
				v[1]=tri->vertice[1];
				v[2]=tri->vertice[2];
				int pass=depth_passed_pixels;
				depth_triangle(v,0);
				if(pass==depth_passed_pixels) continue;	
			}	
		

			if(tri->texture_id!=0)
				glBindTexture(GL_TEXTURE_2D, tri->texture_id);	
			else {	
				glDisable(GL_TEXTURE_2D); 
				glColor4fv(tri->color);	
			} 
			glBegin(GL_TRIANGLES);
			for(j=0;j<3;j++) { 			// 20% 
				//glTexCoord2fv(&tri->vertice[j][3]); 
				glTexCoord2fv(tri->tex[j]); // maybe blocking
				glVertex3fv(tri->vertice[j]);  // HP!
			}
			glEnd(); 

					
			dcount++;
			//draw normal vector
			if(0)
			{
				vectorSet(vc,0,0,0);
				vectorScale(vc,1.0/3);
				float v1[3];
				glColor4f(0.2,0.2,1,1);
				vectorCopy3f(v1,tri->normal);
				vectorScale(v1,10);
				vectorAdd(v1,vc);
				glLineWidth(2);
				glBegin( GL_LINES );
				glVertex3fv(vc);
				glVertex3fv(v1);
				glEnd();
				glLineWidth(1);
			}		
		}

	
		/*
			size=quads.size();
			for(i=0;i<size;i++)
			{			
				Quad *q;
				q=quads[i];
				if(vectorDotProduct3f(v1,q->normal)>0) continue;  // HP 30%
				glBindTexture(GL_TEXTURE_2D, q->texture_id);	
				glBegin(GL_QUADS);
				for(j=0;j<4;j++) { 
					glTexCoord2fv(&q->vertice[j][3]); 
					glVertex3fv(q->vertice[j]);  // HP!
				} 
				glEnd(); 
				dcount++;
			}
			*/
	}
	else
		if(flag_triangle==MODE_INDEX_ONETEX){
			glBindTexture(GL_TEXTURE_2D, texid);
			for(i=0;i<num_triangle;i++)
			{			
				Triangle *tri;
				tri=triangles[i];
				//	 if(tri->flag==TRIANGLE_MODE_INDEX)
				Vertex *vert;
				int  v_id;
				//	 glNormal3fv(tri->normal);
				glBegin(GL_TRIANGLES);
				for(j=0;j<3;j++)
				{
					v_id=tri->vertex_id[j];	
					vert=vertexs[v_id];				
					glTexCoord2f(vert->u,vert->v);
					glVertex3f(vert->x, vert->y, vert->z );
				}
				glEnd(); 
			}
		}
	return VISIABLE;
}

//DRAFT
int child_query(Object *obj)
{ 
	int i,j,size;

	for(obj->children.begin();obj->children.current()!=NULL;obj->children.next())
	{
		Object *objx=obj->children.current();
		if(objx->flag_inFOV==0 or objx->stamp_draw==stamp) continue;//??????????????
		objx->boundbox.occlusion_query(); // level3 ?
	}
}

//  1. draw GLOBAL triangle...
int sort_distance(Object *a,Object *b);
int check_isInFOV(Object *cell); 
extern Object *camera;
extern Index<Object*> occluder;
extern int flag_depth_test;
//int Object::draw(int flag, Index<Object*> *stack)
int Object::draw(int flag)
{ 
	int i,j,size;
	int n_child=children.size();
	int num_triangle=triangles.size();

	//if(flag_visiable==0 or Object::stamp_draw==stamp )	return 0; 
	if(Object::stamp_draw==stamp )	return 0; 
	stamp_draw=stamp;
	depth_passed=0;

	/* if(parent==0)
			flag_inFOV=check_isInFOV(this);
	else
		// 1. parent FOV_FULLIN -> all child FUILIN
		// 2. parent NOT IN -> all child NOTIN 
		if(parent->flag_inFOV==FOV_FULLIN)
			flag_inFOV=FOV_FULLIN;
		else  
			flag_inFOV=check_isInFOV(this);
        */


	if(flag_depth_test)
	//if(flag_depth_test and  num_triangle==0)
	{
		// **** may be redraw !! ???
		//if(boundbox.check_occlusion3()==HIDDEN)
		//if(level > 0 and boundbox.check_occlusion2()==HIDDEN)
		if(boundbox.check_occlusion2()==HIDDEN)
			return 0;
		if(level<0) 
			occluder.add(this);
	}

	// pre_query 
	///child_query(this);

	for(children.begin();children.current()!=NULL;children.next())
	{
		Object *obj=children.current();
		if(obj->stamp_draw==stamp ) continue;
		//if(!flag_depth_test)
		{ if(flag_inFOV==FOV_FULLIN) 
			obj->flag_inFOV=FOV_FULLIN;
		else obj->flag_inFOV=check_isInFOV(obj);  
		if(obj->flag_inFOV==0) continue;
		}
		obj->draw(flag);
	}


	{
		extern int depth_passed_pixels;
		depth_passed_pixels=0;
		draw_basis();
		if(depth_passed_pixels>0)
		{
			depth_passed=1;
			if(level<0)	occluder.add(this);
		}
		depth_passed=1;
		//if(flag_depth_test==0) depth_passed=1;
		
		if(joints.size()>0)		draw_joints();  // POST !!
	}	
	return 1;

//	if(stamp_draw==stamp) return 1; stamp_draw=stamp;

	//draw *
	glLoadIdentity();
	extern int flag_opacity;
	if(flag_opacity)
	{
		glDisable(GL_BLEND);
		//glEnable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		glColor4f(1.0,1.0,1.0,1.0);
	}
	else
	{
	//	glEnable(GL_BLEND);
	//	glDisable(GL_TEXTURE_2D);
	//	glColor4f(0.4,1.0,0.75,0.25);
	//	glBlendFunc(GL_ONE, GL_ONE);
	//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}


	//glFlush();   // Low Performance !!  blocking ?
	stamp_draw=stamp;
	return 1;
}

int Object::draw_tr()
{
	int i,j,size;
	int num_triangle=triangles.size();
	
	glLoadIdentity();	
	///glRotatef(-t_rotY,v3[0],v3[1],v3[2]);
	//glRotatef(t_rot,up[0],up[1],up[2]);
	//glTranslatef(position[0],position[1],position[2]);
	glDisable(GL_LIGHTING);
	glDisable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
	glColor4f(1.0,1.0,1.0,1.0);
	
//	if(direct_query)	glBeginQuery(GL_SAMPLES_PASSED_ARB, boundbox.query);
	float v1[4];
	vectorCopyf(v1,boundbox.center);  //vectorCopy(v1,position); zerom
	vectorSubtractM(v1,camera->position);
	vectorNormalize(v1);

	for(i=0;i<num_triangle;i++)
	{			
		Triangle *tri;
		tri=triangles[i];

		if(vectorDotProduct3f(v1,tri->normal)>0) continue;
		
		//glColor4f(1.0,1.0,1.0,1.0);
		if(tri->flag==MODE_STATIC_MULTEX)
		{
			glNormal3fv(tri->normal);
			if(tri->texture_id!=0)
				glBindTexture(GL_TEXTURE_2D, tri->texture_id);
			else 
			{
				glDisable(GL_TEXTURE_2D);
				glColor4fv(tri->color);
			}

			//glBegin(GL_LINE_LOOP);	
			glBegin(GL_TRIANGLES);
			for(j=0;j<3;j++)
			{
				//glTexCoord2f(tri->vertex[j].u,tri->vertex[j].v);
				//glVertex3f(
				//		tri->vertex[j].x,
				//		tri->vertex[j].y,
				//		tri->vertex[j].z );

			}
			glEnd(); 
		
		/*	
			float v1[3],v2[3];
			v1[0]=0;
			v1[1]=0;
			v1[2]=0;
			for(j=0;j<3;j++)
			{
				v1[0]+=tri->vertex[j].x;
				v1[1]+=tri->vertex[j].y;
				v1[2]+=tri->vertex[j].z;
			}

			//camera.direction
			glColor3ub(0,0,255);

		//	glEnable(GL_TEXTURE_2D);
			glLineWidth(5);
			glBegin( GL_LINES );
			vectorScale(v1,1.0/3);
			glVertex3fv(v1);
			vectorCopy(v2,tri->normal);
			vectorScale(v2,20);
			vectorAdd(v2,v1);
			glVertex3fv(v2);
			glEnd();

			glEnable(GL_TEXTURE_2D);
			glColor3ub(255,255,255);
			*/
		}
		else 
		if(tri->flag==TRIANGLE_MODE_INDEX)
		{
			Vertex *vert;
			int  v_id;
			glNormal3fv(tri->normal);
			glBindTexture(GL_TEXTURE_2D, tri->texture_id);

			glBegin(GL_TRIANGLES);
			for(j=0;j<3;j++)
			{
				v_id=tri->vertex_id[j];	
				vert=vertexs[v_id];				
				glTexCoord2f(vert->u,vert->v);
				glVertex3f(
						vert->x,
						vert->y,
						vert->z );
			}
			glEnd(); 
		}
	}
}


// BoundBox collision test
int Object::test_collision_edge(float *edge0, float *edge1,Object *obj)
{	
	Line line;

	vectorCopyf(line.onPoint,edge0);
	vectorCopyf(line.normal,edge1);
	vectorSubtract2f(line.normal,edge0);
	line.length=vectorLength(line.normal);
	vectorNormalize(line.normal);
	collisions.clear();
	if(line.length<0.0001) return 0;	
	boundbox.test_collision2(&line,obj);
}

int Object::test_collision_line(Line *line,Object *obj)
{	
	collisions.clear();
	boundbox.test_collision2(line,obj);
	
}


//1. inside ?
//2. test edge & plane 
int Object::static_collision(Object *obj)
{
	int n;
	n=obj->triangles.size();
	
	n=triangles.size();
	for(int i=0;i<n;i++)
	{
		//test_coliision_triangle
		Triangle *tri;
		tri=triangles[i];
		float a[3];	
		vectorCopyf(a,tri->vertice[0]);
		vectorCopyf(a,tri->vertice[1]);
	}
}


int test_intersect_triangle_triangle(Triangle *src_tr,Triangle *dst_t);
// DRAFT 
// Methode: full triangles test  , very slow 
int Object::collisionTest(Object *target)
{
	int i,j,n;

if(0)
{
	if(target->speed==0 )
		;//static_collision();
	else 
		;//dynamic collision();


	return 0;
}

			//	triangleIntersection
//	if((obj->flag_triangle&MODE_STATIC) and (flag_triangle&MODE_STATIC))
	{
		float c[4];
		int size=triangles.size();
			n=target->triangles.size();
		for(i=0;i<size;i++)
		{
			Triangle *st;
			float a[4],b[4];
			st=triangles[i];
			for(j=0;j<n;j++)
			{
				Triangle *tt;
				tt=target->triangles[j];
				if(test_intersect_triangle_triangle(st,tt)) 
					return true;
			}

		}
	}

	return false;
}

extern Object space;

void Object::deal_collision_v1()
{
		// normal collision test
		//BoundBox::test_collision()
		Object *womb=0;
		//womb=boundbox.find_womb(&space);
		extern Index<Object*> list_collision;
		list_collision.clear();
		
		boundbox.test_collision(&space); // this will be upgraded !!
		
		int n=list_collision.size(); // global
		if(n>0)
		{
			//console_printf("n=%d",n);
			int r=0;
			for(int i=0;i<n;i++)
			{
				Object *ot=list_collision[i];
				if(collisionTest(ot)) 
				{
					r=1;
					break;
				}

			}
			if(r)
			{
				// speed,weight,texture -> collision force -> force direction 
				// 
				//position[0]=position_prev[0];position[1]=position_prev[1];	position[2]=position_prev[2];
				vectorScale(force,-0.2); // reverse direction 
					
			}

		}

		if(womb)
		//if(hit_obj=boundbox.test_collision(womb)) 
		//if(hit_obj=boundbox.test_collision(map_object)) 
		{		
		//new_position[0]=position[0];new_position[1]=position[1];	new_position[2]=position[2];
		//temporaly 
			/*if(test_collision(hit_obj))
			{
				position[0]=position_prev[0];position[1]=position_prev[1];	position[2]=position_prev[2];
				vectorScale(force,0);
			} */
		}
		//else
		{

		}

}

// 0.find WOMB
// 1.object.moving( include gravity)
// 3.object.collision
int Object::common_update(Uint32 msec)
{ 
	int i;
	int size;
	float angles[3],mat[4][4];
	// 9.8 Ns = 0.0098 Nms
	float v1[3],v2[3],v[3];
	float new_position[3];
//	float position_prev[3];
	float new_center[3];

	int col_test=0;


	if(triangles_virtual.size()!=(size=triangles.size()))
	{
		for(int i=0;i<size;i++)
			triangles_virtual.add(new Triangle());
	}
	//if( msec <20) return msec;

	// 1. moving , gravity  by force[F]
	//if(flag_physics and vectorLength(force)>0)
	if(flag_physics)
	{
		float gravity[3]={0,-0.016,0};
		
		// 1. Gravity & Moving Force  
		vectorCopyf(position_prev,position);

		if(weight>0){
			if(weight < 1) // if very light object, will be down slowly
			{	
				vectorCopy3f(v1,gravity);
				vectorScale(v1,weight*50);  
				vectorAdd(force,v1);
			}
			 else 
				 vectorAdd(force,gravity);
		}
	
		vectorCopyf(v1,force);
		vectorScale(v1,msec);
		vectorAdd(position,v1);
	
		{	
			//size=triangles_local.size();
			size=triangles.size();
			for(i=0;i<size;i++)
			{
				Triangle *t=triangles[i];
				vectorAdd(t->vertice[0],t->vertice_orig[0],position);
				vectorAdd(t->vertice[1],t->vertice_orig[1],position);
				vectorAdd(t->vertice[2],t->vertice_orig[2],position);
				//triangleCopy(triangles[i],triangles_local[i],this);
			}
		}
		
		if(0 and flag==WORLD) // WORLD MODEL 
		{
			size=triangles.size();
			for(i=0;i<size;i++)
			{
				//triangleCopy(triangles[i],triangles_virtual[i],this);
				vectorAdd(triangles[i]->vertice[0],v1);
				vectorAdd(triangles[i]->vertice[1],v1);
				vectorAdd(triangles[i]->vertice[2],v1);
			}
		}
	
		flag_bbox=1;
		col_test=1;
		
		// 2. Rotate Force
		angles[0]=0;
		angles[1]=0;
		angles[2]=0;
		matrixAngles(angles,mat);
		//1. GL transform  
		//2. user transform 
	
	
	}

	if(flag_bbox)
	{
		boundbox.update();
		flag_bbox=0;
	}
	
	//if(col_test and joints.size()==0)
	if(col_test)
	{
		deal_collision_v1();
	}
	else
	{
		//	vectorCopy(v,direction);
		//	vectorScale(v,speed*msec);
		//	vectorAdd(new_position,v);
	}


	//womb=find_octree_node(this);		
	//size=womb->children.size();
	//for(int i=0;i<size;i++)
	{

	}


		// find cell of MAP hierachy
		
		
	// joint collision test.
	if(0)//	if(flag_physics)
	{
		float	ms=msec*0.001;
		int	size=joints.size();

		float max_lenth=0;
		for(int i=0;i<size;i++)
		{
			float lenth;
			float vtx[3];
			Joint *j=joints[i];
			vtx[0]=j->mAbsolute[0][3];
			vtx[1]=j->mAbsolute[1][3];
			vtx[2]=j->mAbsolute[2][3];
			lenth=vectorLength(vtx);
			if(max_lenth<lenth)
				max_lenth=lenth;
		}

		Object *womb;
		//womb=find_octree_node(this);			
		//size=womb->triangles.size();
		//for(int i=0;i<size;i++)
		{

		}
		//if collision ,then move to fit the lenth...

	}
				
		/*
		if(shape)
		{
			if(shape->triangles.size()!=0)
				shape->draw();
			else shape->drawDefault();
		}		
		else
		*/

	return 0;
	//	vectorCopy(position,new_position);
}

void Object::setDirection(float v[3])
{

}
//obj_position
void Object::setDirection2Target(vector target_position[3])
{
	vector v[3];
	vectorCopyf(v,target_position);
	vectorSubtractM(v,position);
	vectorNormalize(v);
	vectorCopyf(direction,v);
}

void Object::setPosition(vector x,vector y, vector z)
{
	position[0]=x;
	position[1]=y;
	position[2]=z;
}
void Object::setPosition(vector v[3])
{
	position[0]=v[0];
	position[1]=v[1];
	position[2]=v[2];
}

// speed -> force
void Object::setSpeed(float speed_)
{
//	speed=speed_;
	// if gravity exists, then 
//	vectorNo
//	vectorScale(force,speed_);
}

void Object::moveForward()
{
}

void Write(Object *o)
{
	//file name o->name;
	// triangle
	//
	//
	// octree
	// obj:2
	//    -> parent =1 
	// obj:123
	//    -> parent = 2
	// 
}
/*`
		 
	for(i=0;i<polygons.size();i++)
	{			
		SDX_Polygon *p;
		p=polygons[i];	

		glNormal3fv(p->normal);
		glBindTexture(GL_TEXTURE_2D, p->texture_id);
		glBegin(GL_POLYGON);
		//glBegin(GL_LINE_LOOP);	
		for(j=0;j<p->vertexs.size();j++)
		{
			glTexCoord2f(p->vertex[j].u,p->vertex[j].v);
			glVertex3f(
					p->vertex[j].x,
					p->vertex[j].y,
					p->vertex[j].z );

		}
		glEnd(); 
	}

			//draw_normal 
			float v1[3],v2[3];
			v1[0]=0;
			v1[1]=0;
			v1[2]=0;
			for(j=0;j<3;j++)
			{
				v1[0]+=tri->vertex[j].x;
				v1[1]+=tri->vertex[j].y;
				v1[2]+=tri->vertex[j].z;
			}

			glColor3ub(0,0,255);

			glLineWidth(5);
			glBegin( GL_LINES );
			vectorScale(v1,1.0/3);
			glVertex3fv(v1);
			vectorCopy(v2,tri->normal);
			vectorScale(v2,20);
			vectorAdd(v2,v1);
			glVertex3fv(v2);
			glEnd();

			glEnable(GL_TEXTURE_2D);
			glColor3ub(255,255,255);
			*/


