#include "../system.h"
#include "../math.h"
#include "shape.h"

#ifndef OBJECT_H
#define OBJECT_H

#define VISIABLE	1
#define HIDDEN		0
#define QUERING		2

#define WORLD		1
#define	LOCAL		2

#define EVENT_FORWARD  	0x0001
#define EVENT_BACKWARD  0x0002
#define EVENT_TURNLEFT  0x0003
#define EVENT_TURNRIGHT  0x0004
#define EVENT_RUN	

class Atom {
	public:
	virtual int Update(){}
	virtual int Update(Uint32 msec){ };
};

class Object;
// LOCAL or GLOBAL ? hmmm what ?
class BoundBox
{
	private:
		float vertexs[8][3];
	public:
		BoundBox();
		void setObject(Object *o){ robj=o;};
		void update();
		void update_vertex();
		void update_null();
		void draw();
		void draw2();
		void draw_wire();
		void draw_wire2();

		float volumeSize();  //used
		int	check_occlusion(int );
		int	check_occlusion1();
		int	check_occlusion2();
		int	check_occlusion3(int );
		int	occlusion_query();

		int checkIn(Object *o);  //DEL
		int checkIn(float v[3]);
		Object* check_collision(Object *o);
		Object* check_collision2(Object *o);

		Object* test_collision(Object *obj);
		Object* test_collision2(Line *line,Object *o);
		Object* find_collision_leaf(Object *o);
		Object* find_womb(Object *o);
		Object* find_womb_objects(Object *o);
		Object* find_octree_leafs(Object *o);

		float radius;
		float center[3];
		float center_prev[3];
		float min[3],max[3];
		int	flag_occlusion;
		int query_stamp;
		
		Index<Triangle*>	triangles;
		Index<Quad*>		quads;
		GLuint query;
		Object *robj;
		Index<Object*> 		collisions;
};

extern Object space;
class Object  {
	public:
	int 	id;
	char 	name[64];
	void	init();
	Object();
	Object(const char *name);
	~Object();
	
	void setName(const char *str);
	void add(Object *child);
	void remove(Object *child);
	void setSpeed(float speed_);  // del ? -> force ?
	void moveForward(); //???
	void setPosition(vector x,vector y, vector z);
	void setPosition(vector v[3]);
	void setDirection(vector v[3]); //
	void setDirection2Target(vector target_position[3]);
	void setLookAt(float v[3]); //


	void 	deal_collision_v1();
	int  	collisionTest(Object *obj);
	int 	static_collision(Object *obj);
	int 	test_collision_edge(float *edge0, float *edge1,Object *obj=&space);
	int 	test_collision_line(Line *line,Object *obj=&space);

	//virtual int Work();
	int common_update(Uint32 msec);
	virtual int Update(); 
	virtual int Update(Uint32 msec);

//	int draw(int flag=0, Index<Object*> *stack=NULL);
	int draw(int flag=0);
	int draw_tr();
	int draw_basis();
	int draw_joints();
	int draw_occluder(int );

	void	drawDefault();


	int 	life_time;		// mili sec
	int 	life;			// mili sec
	float 	weight;
	float 	speed;			// DEL !! m/s^2?  -> force
	Object	*next;			// linked list
	Object	*parent;			
	int	flag;		// WORLD,LoCAL
	int		flag_active;
	int		flag_drawdefault;
	int		flag_static; 		// ºor  
	bool		flag_physics; 		//
	int		flag_inFOV;		// used
	int		flag_triangle;		// TRIANGLE_MODE
	int		flag_axis;		// AXIS_LOCAL,AXIS_GLOBAL? // not used
	int		flag_occlusion;		// 
	int		flag_visiable;		// stamp
	int		flag_bbox;		// stamp
	int		gllistid;		// test
	int		texid;			// test
	long	addmsec;

	float	elastic;
	float	force[3];			// used
	float	distance;			
	float	FOV_distance;		//
	//========================================
	
	vector 	center[4];			//  ߽?
	vector 	center_prev[3];	
	vector 	position[4];		// body ġ 
	vector 	position_prev[4];	// body ġ 
	vector 	up[4];			// body  up *****	

	// pitch  : x axis rotation
	// heading: y axis rotation 
	// roll   : z axis rotation
	// glRotate ұ ?
	//vector 	pitch,heading,roll; 
	float	rotate[4];		// body ȸ 
	float 	direction[4];		// body  from rotate[4]
   	float	translate[4];		// body ġ  from Object.center
	float 	direction_draw[4];	// body   draw_Ҷ
					
	float 	view_rotate[4]; 	// view_rotate[0]=pitch  
	float	view_position[4];	// local ? world  from Objec.center
	float	view_direction[4];	// 
	float	view_up[4];

	BoundBox	boundbox;

	List<Object*>	children;
//	float	max_x,max_y,max_z;
//	float	min_x,min_y,min_z;
	int		level;
	int		stamp_draw;
	int		stamp_FOV;
	int		depth_passed;
	// TEST======================================
//	Shape					*shape;		// ִϸ̼Ǿ model ϳ ???
	Index<Vertex *>			vertexs;
	Index<Vertex *>			vertexs_local;
	Index<Triangle*>		triangles;
	Index<Triangle*>		triangles_local;  // orignal  ȸ   ϴ°   
	Index<Quad*>			quads;

	Index<Joint*>			joints;  	// joint list
	Index<SDX_Polygon*>		polygons;
	Index<Animate*>			animates;
	Index<Object*> 			collisions;
	
	Index<Triangle*>		triangles_virtual;

	
	Index<Vertex *>			points;
	Index<Line *>			lines;
} ;

// WHAT?
class Block : public Object 
{
	List<Triangle*> triangles; // global position.
	List<Triangle*> local_triangles; // local position.
};

#endif 
