#include "object.h"


extern Object space;
extern Object	*camera;
extern struct fr {
	float left,right,bottom,top;
	float Near,Far;
	float width,height;
	vector LB[4],LT[4],RB[4],RT[4];
	vector BL[4],BR[4],TL[4],TR[4];
	vector nL[4],nT[4],nB[4],nR[4];
	plane_t	sides[5];
} Frustrum;

typedef int v4sf __attribute__ ((vector_size (16)));
union f4vector 
{
  v4sf v;
  float f[4];
};

int count_checkisFov=0;
// need change !!! 2003/07/21
// BoundBox center,radius !! 
//inline int check_isInFOV(Object *cell) ;
int check_isInFOV(Object *obj) 
{
	float	r;
	float	minus_r;
	//float	distance;
	float	dpR,dpL,dpT,dpB;
  	float  tv[4];
	//  Cell߽ɱ  tv
	/*
   	if(cell->triangles.size()==0 and cell->children.size()==0)
	{
		//vectorCopy(tv,cell->center);
		vectorCopy(tv,cell->position);
		r=5.0;
	}
	else  */
	{
		vectorCopyf(tv,obj->boundbox.center);
		r=obj->boundbox.radius;
	}
	vectorSubtract(tv,tv,camera->position);
///	obj->FOV_distance=vectorLength(tv);
		
	// 2.second
	// is This cell outside ? 
	if(0)
	{
		float tmp[4];
		vectorDotProduct3fx2(tv,Frustrum.nL,tmp,dpL); if(dpL >= r) return 0;
		vectorDotProduct3fx2(tv,Frustrum.nR,tmp,dpR); if(dpR >= r) return 0;
		vectorDotProduct3fx2(tv,Frustrum.nT,tmp,dpT); if(dpT >= r) return 0;
		vectorDotProduct3fx2(tv,Frustrum.nB,tmp,dpB); if(dpB >= r) return 0;
	}
	else
	{
		dpL=vectorDotProduct3f(tv,Frustrum.nL); 
		if(dpL >= r) return 0;
		dpR=vectorDotProduct3f(tv,Frustrum.nR); 
		if(dpR >= r) return 0;
		dpT=vectorDotProduct3f(tv,Frustrum.nT); 
		if(dpT >= r) return 0;
		dpB=vectorDotProduct3f(tv,Frustrum.nB); 
		if(dpB >= r) return 0;
	}

	minus_r=-r;
	int		in=0;
	// 3.third
	// The rest are FULL or PARTIAL 
	if(dpR < minus_r) in++;  
	if(dpL < minus_r) in++;
	if(dpT < minus_r) in++;
	if(dpB < minus_r) in++;

//	console_printf("count check_isInFOV=%d",count_checkisFov++);
	//if(in==4 || cell->level==TREE_LEAF ) 	return FOV_FULLIN;
	if(in==4) 	return FOV_FULLIN;

	// The rest are PARTIAL
	return FOV_PARTIALIN;
/*
	// 1.first 
	// does camera in cell object ?
	//cell->distance=distance; // get the distance from camera , then insert it to the Cell
	if( distance < r )
		return FOV_PARTIALIN;
*/
}

#define MAX_DISTANCE	2000*ONEMETER
// UNIT * 1000 = 1km
// 20*UNIT * 50 = 1km^3
// totol= 50^3 cells


#define TOP_FRONT_LEFT		(int)0
#define TOP_FRONT_RIGHT 	(int)1
#define TOP_BACK_LEFT		(int)2
#define TOP_BACK_RIGHT		(int)3

#define BOTTOM_FRONT_LEFT  (int)4
#define BOTTOM_FRONT_RIGHT (int)5 
#define BOTTOM_BACK_LEFT   (int)6
#define BOTTOM_BACK_RIGHT  (int)7


BoundBox::BoundBox()
{
		int i;
		radius=0;
		flag_occlusion=0;
		query_stamp=0;
		for(i=0;i<8;i++)
		{
			vertexs[i][0]=0;
			vertexs[i][1]=0;
			vertexs[i][2]=0;
		}

		for(i=0;i<3;i++)
		{
			center[i]=0;
			center_prev[i]=0;
			min[i]=0;
			max[i]=0;
		}
		
		////glGenQueries(1, &query);
		
		Triangle *tri;
		Quad	*q;
		//top
		q=new Quad();
		q->flag=MODE_POINTER;
		q->pvertex[0]=vertexs[0];
		q->pvertex[1]=vertexs[2];
		q->pvertex[2]=vertexs[3];
		q->pvertex[3]=vertexs[1];
		vectorSet(q->normal,0,1,0);
		quads.add(q);
		//bottom
		q=new Quad();
		q->flag=MODE_POINTER;
		q->pvertex[0]=vertexs[4];
		q->pvertex[1]=vertexs[5];
		q->pvertex[2]=vertexs[7];
		q->pvertex[3]=vertexs[6];
		vectorSet(q->normal,0,-1,0);
		quads.add(q);

		//front
		q=new Quad();
		q->flag=MODE_POINTER;
		q->pvertex[0]=vertexs[0];
		q->pvertex[1]=vertexs[1];
		q->pvertex[2]=vertexs[5];
		q->pvertex[3]=vertexs[4];
		vectorSet(q->normal,0,0,1);
		quads.add(q);

		//back
		q=new Quad();
		q->flag=MODE_POINTER;
		q->pvertex[0]=vertexs[2];
		q->pvertex[1]=vertexs[6];
		q->pvertex[2]=vertexs[7];
		q->pvertex[3]=vertexs[3];
		vectorSet(q->normal,0,0,-1);
		quads.add(q);

		//right
		q=new Quad();
		q->flag=MODE_POINTER;
		q->pvertex[0]=vertexs[0];
		q->pvertex[1]=vertexs[4];
		q->pvertex[2]=vertexs[6];
		q->pvertex[3]=vertexs[2];
		vectorSet(q->normal,1,0,0);
		quads.add(q);
	
		//left
		q=new Quad();
		q->flag=MODE_POINTER;
		q->pvertex[0]=vertexs[1];
		q->pvertex[1]=vertexs[3];
		q->pvertex[2]=vertexs[7];
		q->pvertex[3]=vertexs[5];
		vectorSet(q->normal,-1,0,0);
		quads.add(q);

	
		//top
		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[0];
		tri->pvertex[1]=vertexs[3];
		tri->pvertex[2]=vertexs[1];
		vectorSet(tri->normal,0,1,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[0];
		tri->pvertex[1]=vertexs[2];
		tri->pvertex[2]=vertexs[3];
		vectorSet(tri->normal,0,1,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[0];
		tri->pvertex[1]=vertexs[1];
		tri->pvertex[2]=vertexs[5];
		vectorSet(tri->normal,0,0,1);
		triangles.add(tri);
	
		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[0];
		tri->pvertex[1]=vertexs[5];
		tri->pvertex[2]=vertexs[4];
		vectorSet(tri->normal,0,0,1);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[0];
		tri->pvertex[1]=vertexs[6];
		tri->pvertex[2]=vertexs[2];
		vectorSet(tri->normal,1,0,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[0];
		tri->pvertex[1]=vertexs[4];
		tri->pvertex[2]=vertexs[6];
		vectorSet(tri->normal,1,0,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[1];
		tri->pvertex[1]=vertexs[3];
		tri->pvertex[2]=vertexs[7];
		vectorSet(tri->normal,-1,0,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[1];
		tri->pvertex[1]=vertexs[7];
		tri->pvertex[2]=vertexs[5];
		vectorSet(tri->normal,-1,0,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[3];
		tri->pvertex[1]=vertexs[2];
		tri->pvertex[2]=vertexs[6];
		vectorSet(tri->normal,0,0,-1);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[3];
		tri->pvertex[1]=vertexs[6];
		tri->pvertex[2]=vertexs[7];
		vectorSet(tri->normal,0,0,-1);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[5];
		tri->pvertex[1]=vertexs[7];
		tri->pvertex[2]=vertexs[6];
		vectorSet(tri->normal,0,-1,0);
		triangles.add(tri);

		tri=new Triangle();
		tri->flag=TRIANGLE_MODE_POINTER;
		tri->pvertex[0]=vertexs[5];
		tri->pvertex[1]=vertexs[6];
		tri->pvertex[2]=vertexs[4];
		vectorSet(tri->normal,0,-1,0);
		triangles.add(tri);
}


float BoundBox::volumeSize()
{
	float h;
	float area;
	float vol;
	area=(max[0]-min[0])*(max[1]-min[1]);
	
	vol=area*(max[2]-min[2]);
	return vol;
}

#define CHECKIN(b,v) 	(b->min[0] <= v[0] and v[0] <=  b->max[0] \
		and	b->min[1] <= v[1] and v[1] <=  b->max[1] \
		and	b->min[2] <= v[2] and v[2] <=  b->max[2])
/* Quickest way of checking collision of 2 AABB is check they haven't collided.
xyz1 is bottom, left, near corner of AABB
xyz2 is top, right, far corner
bool CheckCollision(const AABB *pBox1, const AABB *pBox2)
{

    if(pBox1->xyz1.x > pBox2->xyz2.x) return false;
    if(pBox1->xyz1.y > pBox2->xyz2.y) return false;
    if(pBox1->xyz1.z > pBox2->xyz2.z) return false;
    if(pBox1->xyz2.x < pBox2->xyz1.x) return false;
    if(pBox1->xyz2.y < pBox2->xyz1.y) return false;
    if(pBox1->xyz2.z < pBox2->xyz1.z) return false;

    return true;
}
*/

Object* BoundBox::check_collision2(Object *o)
{
	BoundBox *b;
	b=&o->boundbox;
//	if(o->level==1) return o;
	if( o==robj )	return 0;
	if( min[0]>b->max[0]) return 0;
	if( min[1]>b->max[1]) return 0;
	if( min[2]>b->max[2]) return 0;
	if( max[0]<b->min[0]) return 0;
	if( max[1]<b->min[1]) return 0;
	if( max[2]<b->min[2]) return 0;
	return o;
}

Object* BoundBox::check_collision(Object *o)
{
	bool 	kiss = false;
	bool 	inside= false;
	int	i,j;
	int	count;
	
	BoundBox *b;
	b=&o->boundbox;

//	if(o->level==1) return o;
	
	if( o==robj )	return 0;

	// if(CHECKIN(box,center))
	// better !!
	count=0;
	if(( b->min[0]<=min[0] and min[0]<=b->max[0] )or(b->min[0]<=max[0] and max[0]<= b->max[0] ))
		count++;
	if(( b->min[1]<=min[1] and min[1]<=b->max[1] )or(b->min[1]<=max[1] and max[1]<= b->max[1] ))
		count++;
	if(( b->min[2]<=min[2] and min[2]<=b->max[2] )or(b->min[2]<=max[2] and max[2]<= b->max[2] ))
		count++;

	if (0)
	// *** a better methode is ..... only 3 points test  -> 2 points test avail !
	for(int i=0,count=0;i<8;i++)
	{
		// a means Axis
		if(		b->min[0] <= vertexs[i][0]	and vertexs[i][0] <=  b->max[0] 
			and	b->min[1] <= vertexs[i][1]	and vertexs[i][1] <=  b->max[1] 
			and	b->min[2] <= vertexs[i][2]	and vertexs[i][2] <=  b->max[2] )
		{
			count++;
		}
	}

	if(count == 3) 
		return o;
	return 0;
}

Index<Object*> list_collision;
DBLARRAY<Object*> nest_list;
// if speed==0 then
// return : the kissed LEAF objects (only Boundbox test)   work? 
Object* BoundBox::test_collision(Object *o)
{
	if(check_collision(o))
	{
		if( o->level<0 )
		{
			list_collision.add(o);
			robj->collisions.add(o);		
			return o;
		}
		
		int size=o->children.size();
		for(int i=0;i<size;i++)
		{
			Object *c;
			c=o->children[i];
			test_collision(c);
		}
	} 	
	return 0;
}

Object* BoundBox::find_collision_leaf(Object *o)
{
	bool 	kiss = false;
	bool 	inside= false;
	int	i,j;
	int	count;
	
	BoundBox *b;
	b=&o->boundbox;
	
	if( o==robj )	return 0;

	// if(CHECKIN(box,center))
	// better !!
	count=0;
	if(( b->min[0]<=min[0] and min[0]<=b->max[0] ) or (b->min[0]<=max[0] and max[0]<= b->max[0] ))
		count++;
	if(( b->min[1]<=min[1] and min[1]<=b->max[1] )or(b->min[1]<=max[1] and max[1]<= b->max[1] ))
		count++;
	if(( b->min[2]<=min[2] and min[2]<=b->max[2] )or(b->min[2]<=max[2] and max[2]<= b->max[2] ))
		count++;
	
	if(count==3)
	{
		int size=o->children.size();
		if( size== 0 )
		{
			list_collision.add(o);
			robj->collisions.add(o);		
			return o;
		}
		
		for(int i=0;i<size;i++)
		{
			Object *c;
			c=o->children[i];
			test_collision(c);
		}
	} 	
	return 0;
}



bool triangleIntersection(Triangle *tri,Line *line,float *distance,Object *obj);
// CORE !!
Object* BoundBox::test_collision2(Line *line,Object *obj)
{
	bool 	collide=false;
	
	BoundBox *box;
	box=&obj->boundbox;

	if(obj->level>0 and  CHECKIN(box,line->onPoint) ) 
	//if(CHECKIN(box,line->onPoint) ) // need repair !!
		collide=true;  // for leve=1
	else
	{
		Index<Triangle*> *tris;
		int tsize;
		
		//if(0) 
		if(obj->level<0)
		{
			tsize=obj->triangles.size();
			tris=&obj->triangles;
		}
		else 
		{ 
			//tsize=12;
			tsize=box->triangles.size();
			tris=&box->triangles;
		} 

		for(int i=0;i<tsize;i++)
		{
			float distance=0;
			Triangle *tri=(*tris)[i];
			if(vectorDotProduct3f(line->normal,tri->normal)>0) continue; // HP! 2%
			if(triangleIntersection(tri,line,&distance,obj) 
					and distance>0 
					and line->length >= distance   )
			{
				collide=true;
				if(obj->level>0) // HP
					break;
				
				obj->distance=distance;
				if(robj->collisions[0])
				{	
					if(robj->collisions[0]->distance>distance)
						robj->collisions.insert(0,obj);
				}
				else 
					robj->collisions.add(obj);
				return obj; 
			}
		}
	}
	
	if(!collide) return NULL; //!!!

	List<Object*> *lc=&obj->children;
	for(lc->begin();lc->current()!=NULL;lc->next())
	{
		Object *c;
		c=lc->current();
		if(robj==c) continue;
		test_collision2(line,c);
	}
	return NULL;
}


// find collision obj
Object* BoundBox::find_womb_objects(Object *o)
{
	bool kiss=false;
	bool inside=false;
	int	i,j,a;
	int	count;

	// 1. radius test 
	
	// 2. box test
	BoundBox *b;
	b=&o->boundbox;

	// *** a better methode is ..... only 3 points test  -> 2 points test avail !
	for(i=0,count=0;i<8;i++)
	{
		// a means Axis
		if(		    b->min[0] <= vertexs[i][0]	and vertexs[i][0] <=  b->max[0] 
				and	b->min[1] <= vertexs[i][1]	and vertexs[i][1] <=  b->max[1] 
				and	b->min[2] <= vertexs[i][2]	and vertexs[i][2] <=  b->max[2] )
		{
			count++;
		}
	}

	// should recurisve !
	if(count == 8)
	{
		//if(o->level==3)		return o;
		int size=o->children.size();
		for(i=0;i<size;i++)
		{
			Object *c;
			Object *r;
			c=o->children[i];
			if(r=find_womb(c))
				return r;
		}
		return o;
	}
	return NULL;

}

//DEL
int BoundBox::checkIn(Object *o)
{
	if(			min[0] <= o->position[0]	and o->position[0] <=  max[0] 
			and	min[1] <= o->position[1]	and o->position[1] <=  max[1] 
			and	min[2] <= o->position[2]	and o->position[2] <=  max[2] )
		return 1;
	else return 0;
}

int BoundBox::checkIn(float v[3])
{
	if(			min[0] <= v[0]	and v[0] <=  max[0] 
			and	min[1] <= v[1]	and v[1] <=  max[1] 
			and	min[2] <= v[2]	and v[2] <=  max[2] )
		return 1;
	else

	{

		
		
	}
	return 0;
	
}	

// find parent object , boundbox test only and FULLIN only !
// used only for space octree 
Object* BoundBox::find_womb(Object *o)
{
	int	count;
	
	BoundBox *b;
	b=&o->boundbox;

	//printf("level: %s\n",size);
	// ok !
	count=0;
	if( b->min[0] <= min[0]	and max[0] <=  b->max[0] ) count++;
	if( b->min[1] <= min[1]	and max[1] <=  b->max[1] ) count++;
	if( b->min[2] <= min[2]	and max[2] <=  b->max[2] ) count++;
	
	int 	size=o->children.size();
	if( size>8) 
		size=8;
	//if(o->level>0 ) 
	//printf("ch.size: %d  level: %d \n",size,o->level);
	
	if(count == 3)
	{
		List<Object*> *lc=&o->children;
		//if(lc->size()==0)	return 0;
		for(lc->begin();lc->current()!=NULL;lc->next())
		{

			Object *c,*r;
			c=lc->current();
			if(c->level>0 )
			if(r=find_womb(c))
				return r;
		}
		/*	
		int	i;
		for(i=0;i<size;i++)
		{
			Object *c;
			Object *r;
			c=o->children[i];
			if(c->level>0 )
			{
				if(r=find_womb(c))
					return r;
		
			}
		}*/
		return o;
	}
	return NULL;
}

Object* BoundBox::find_octree_leafs(Object *o)
{
	
	if(o->level<0) return NULL;

	if(check_collision2(o))
	{
		if(o->level==TREE_LEAF)
		{
			collisions.add(o);
			return o;
		}

		List<Object*> *lc=&o->children;
		for(lc->begin();lc->current()!=NULL;lc->next())
		{
			Object *c;
			c=lc->current();
			find_octree_leafs(c);
		}
		//if(r=find_womb(c))
	}
	return NULL;
}


// for Radar 
void BoundBox::draw_wire2()
{
	glBegin( GL_LINES );

	// top
	glVertex3fv(vertexs[0]);
	glVertex3fv(vertexs[1]);
	glVertex3fv(vertexs[2]);
	glVertex3fv(vertexs[3]);
	glVertex3fv(vertexs[0]);
	glVertex3fv(vertexs[2]);
	glVertex3fv(vertexs[1]);
	glVertex3fv(vertexs[3]);
	
	//vertical
	glVertex3fv(vertexs[0]);
	glVertex3fv(vertexs[4]);
	glVertex3fv(vertexs[1]);
	glVertex3fv(vertexs[5]);
	glVertex3fv(vertexs[2]);
	glVertex3fv(vertexs[6]);
	glVertex3fv(vertexs[3]);
	glVertex3fv(vertexs[7]);
	
	//bottom
	glVertex3fv(vertexs[4]);
	glVertex3fv(vertexs[5]);
	glVertex3fv(vertexs[6]);
	glVertex3fv(vertexs[7]);
	glVertex3fv(vertexs[4]);
	glVertex3fv(vertexs[6]);
	glVertex3fv(vertexs[5]);
	glVertex3fv(vertexs[7]);

	glEnd();
}

void BoundBox::update_null()
{
	int i;
		for(i=0;i<3;i++)
		{
			max[i]=robj->position[i];
			min[i]=robj->position[i];
			//make global center	
			center[i]=robj->position[i];
		}

	update_vertex();
}

//update radius,min[3],max[3],center[3],
void BoundBox::update()
{
	int i,j,size;
	int num_child,num_triangle,num_quad;
	num_child=robj->children.size();
	
	//????
	for(i=0;i<3;i++) {min[i]=999999;max[i]=-999999;}
	
	// 1. object's triangle loop find max,min value
	for(i=0;i<num_child;i++)
	{
		Object *c;
		c=robj->children[i];
		c->boundbox.update();
		
		for(j=0;j<3;j++)
		{
			if(max[j]<c->boundbox.max[j])
				max[j]=c->boundbox.max[j];
			
			if(min[j]>c->boundbox.min[j])
				min[j]=c->boundbox.min[j];
		}
	}	

	// 2. obj->triangles  get Max,Min value 
	// LOCAL or GLOBAL
	num_triangle=robj->triangles.size();
	for(i=0;i<num_triangle;i++)
	{
		Triangle *t;
		t=robj->triangles[i];
		float x,y,z;
		// TRIANGLE_MODE_INDEX
		if (t->flag==TRIANGLE_MODE_INDEX)
		{
			int idx;
			for(j=0;j<3;j++)
			{
				idx=t->vertex_id[j];
				x=robj->vertexs[idx]->x;
				if(x > max[0])	max[0]=x;
				if(x < min[0])	min[0]=x;
			
				y=robj->vertexs[idx]->y;
				if(y > max[1])	max[1]=y;
				if(y < min[1])	min[1]=y;

				z=robj->vertexs[idx]->z;
				if(z > max[2])	max[2]=z;
				if(z < min[2])	min[2]=z;			
			}
		}
		else
		if (t->flag==TRIANGLE_MODE_POINTER)
		{
			for(j=0;j<3;j++)
			{
				x=t->pvertex[j][0];
				if(x > max[0])	max[0]=x;
				if(x < min[0])	min[0]=x;
			
				y=t->pvertex[j][1];
				if(y > max[1])	max[1]=y;
				if(y < min[1])	min[1]=y;

				z=t->pvertex[j][2];
				if(z > max[2])	max[2]=z;
				if(z < min[2])	min[2]=z;			
			}
		}
		else
		if (t->flag & MODE_STATIC)
			for(j=0;j<3;j++)
			{
				x=t->vertice[j][0] ;	// + 	obj->position[0];
				if(x > max[0])	max[0]=x;
				if(x < min[0])	min[0]=x;

				y=t->vertice[j][1] ;//+ 	obj->position[1];
				if(y > max[1])	max[1]=y;
				if(y < min[1])	min[1]=y;

				z=t->vertice[j][2] ;//+ 	obj->position[2];
				if(z > max[2])	max[2]=z;
				if(z < min[2])	min[2]=z;			
			}
	}

	/*
	num_quad=robj->quads.size();
	for(i=0;i<num_quad;i++)
	{
		Quad *t;
		t=robj->quads[i];
		float x,y,z;
		if (t->flag==TRIANGLE_MODE_POINTER)
		{
			for(j=0;j<4;j++)
			{
				x=t->pvertex[j][0];
				if(x > max[0])	max[0]=x;
				if(x < min[0])	min[0]=x;
			
				y=t->pvertex[j][1];
				if(y > max[1])	max[1]=y;
				if(y < min[1])	min[1]=y;

				z=t->pvertex[j][2];
				if(z > max[2])	max[2]=z;
				if(z < min[2])	min[2]=z;			
			}
		}
		else
		if (t->flag==TRIANGLE_MODE_STATIC)
			for(j=0;j<4;j++)
			{
				x=t->vertice[j][0] ;	// + 	obj->position[0];
				if(x > max[0])	max[0]=x;
				if(x < min[0])	min[0]=x;

				y=t->vertice[j][1] ;//+ 	obj->position[1];
				if(y > max[1])	max[1]=y;
				if(y < min[1])	min[1]=y;

				z=t->vertice[j][2] ;//+ 	obj->position[2];
				if(z > max[2])	max[2]=z;
				if(z < min[2])	min[2]=z;			
			}
	} */

	// trick
	if(num_triangle==0 and num_quad==0 and num_child==0)
	{
		vectorCopy3f(center,robj->position);
	}
	else
	{
		for(i=0;i<3;i++)	//make global center
			center[i]=(max[i]+min[i])/2;		
	}
	// ?
	/*
	float v[3];
	vectorCopyf(v,center);
	vectorSubtractM(v,center_prev);
	if(vectorLength(v)>10)
		for(i=0;i<3;i++)
			center_prev[i]=center[i];
	*/
	update_vertex();

	if(robj->parent!=0)
	{
	//	robj->parent->remove(robj);
	}

//	Object *o=find_womb(&space);
//	if(o){
//		printf("o level=%d\n",o->level);
//		o->add(robj);	}
}

void BoundBox::update_vertex()
{
	float v[3];
	// make radius of BoundBox	
	v[0]=max[0];
	v[1]=max[1];
	v[2]=max[2];
	vectorSubtractM(v,center);
	radius=vectorLength(v);

	// make triangles of boundobx  from Max,Min 	
	// TOP_FRONT_RIGHT
	vertexs[0][0]=max[0]; vertexs[0][1]=max[1];	vertexs[0][2]=max[2];
	// TOP_FRONT_LEFT
	vertexs[1][0]=min[0]; vertexs[1][1]=max[1];	vertexs[1][2]=max[2];
	// TOP_BACK_RIGHT
	vertexs[2][0]=max[0]; vertexs[2][1]=max[1];	vertexs[2][2]=min[2];
	// TOP_BACK_LEFT
	vertexs[3][0]=min[0]; vertexs[3][1]=max[1];	vertexs[3][2]=min[2];
	// BOTTOM_FRONT_RIGHT
	vertexs[4][0]=max[0]; vertexs[4][1]=min[1];	vertexs[4][2]=max[2];
	// BOTTOM_FRONT_LEFT
	vertexs[5][0]=min[0]; vertexs[5][1]=min[1];	vertexs[5][2]=max[2];
	// BOTTOM_BACK_RIGHT
	vertexs[6][0]=max[0]; vertexs[6][1]=min[1];	vertexs[6][2]=min[2];
	// BOTTOM_BACK_LEFT
	vertexs[7][0]=min[0]; vertexs[7][1]=min[1];	vertexs[7][2]=min[2];
}


extern Uint32 	stamp;
// ־ top_cell  FOVȿ ִ Cell ãƳ   
// Ʈ ̿ ˻  ӵ ̵ճ  ? -> .
//  Don't Make Leaf !!!  -> for speed 
void fullinFOV(Object *obj)
{
	int i,size;
	size=obj->children.size();

	if(size==0)
	{
		obj->flag_inFOV=FOV_FULLIN;
		return;
	}

	List<Object*> *c=&obj->children;
	for(c->begin();c->current()!=NULL;c->next())
	{
		fullinFOV(c->current());
	}
}

// in ϰ : child 
// out :  child flag offѴ ?
void check_inFOV(Object *cell)
{
	Object *obj=cell;
	int ret;

	/*	if(cell==NULL){
		system_error("check_inFOV(): cell=NULL !!"); //for robust
		return ;
	}
	
	// recheck ?
	if(cell->stamp_FOV==stamp) 
	{
		console_printf("check_inFOV(): ???????");
		return;
	}
	else 
		cell->stamp_FOV=stamp;
	*/
		

	ret=check_isInFOV(obj);
	if(ret==0)
	{
		cell->flag_inFOV=0;
		return;
	}
	
	if(ret==FOV_FULLIN)
	{
		fullinFOV(obj);
		return ; 
	}

	obj->flag_inFOV=FOV_PARTIALIN;

	List<Object*> *c=&obj->children;
	for(c->begin();c->current()!=NULL;c->next())
		check_inFOV(c->current());
}

//faster ? 
void check_inFOV2(Object *cell)
{
	Object *obj=cell;
	int ret;

	List<Object*> *c=&obj->children;
	for(c->begin();c->current()!=NULL;c->next())
	{
		Object *o=c->current();
		ret=check_isInFOV(o);
		if(ret==0)
		{
			o->flag_inFOV=0;
			continue;
		}
		if(ret==FOV_FULLIN)
		{
			fullinFOV(o);
			continue; 
		}
		int size;
		size=o->children.size();
		if(size==0)
		{
			o->flag_inFOV=FOV_FULLIN;
			continue;
		}
		o->flag_inFOV=FOV_PARTIALIN;
		check_inFOV(o);
	}
}

#include "../ui/ui.h"
// work
void Draw_Frustrum()
{
	float v[3]={0,0,0};
	float tv[3];
    
	// camera.direction
	glColor3ub(0,0,255);
	glBegin( GL_LINES );
	glVertex3fv(camera->position);
	vectorCopyf(tv,camera->direction);
	vectorScale(tv,4000);
	vectorAdd(tv,camera->position);
	glVertex3fv( tv);
	glEnd();

	// frustrum 
	glColor4ub(255,255,255,255);
	glBegin( GL_LINES );
	glVertex3fv(camera->position);
	vectorCopyf(tv,Frustrum.LT);
	glVertex3fv( tv);
	glEnd();

	glBegin( GL_LINES );
	glVertex3fv( camera->position);
	vectorCopyf(tv,Frustrum.LB);
	glVertex3fv( tv);
	glEnd();

	glBegin( GL_LINES );
	glVertex3fv( camera->position);
	vectorCopyf(tv,Frustrum.RT);
	glVertex3fv( tv);
	glEnd();

	glBegin( GL_LINES );
	glVertex3fv( camera->position);
	vectorCopyf(tv,Frustrum.RB);
	glVertex3fv( tv);
	glEnd();

}

extern Uint32 	stamp;
// name : draw boundbox !! 
void draw_octree(Object *cell)
{
	int i,ret;
	int size;

	if(cell==NULL){
		system_error("cell=NULL !!"); //for robust
		return ;
	}

	//if(cell->flag_inFOV==0)	return ;
	//if(cell->boundbox.flag_occlusion==0)	return;
	//if(cell->stamp_draw!=stamp) return;
	size=cell->children.size();

	List<Object*> *c=&cell->children;
	for(c->begin();c->current()!=NULL;c->next())
	{
		draw_octree(c->current());
	}

	if(cell->level < 0 and cell->stamp_draw==stamp and (cell->depth_passed) )
	//if(cell->level < 0 and cell->stamp_draw==stamp and (cell->depth_passed) )	
	{
//		if(cell->level<0)
		glColor4ub(0,255,0,255);
//		else if(cell->level<0)	glColor4ub(0,0,255,255);
//		else if(cell->level>0)
	}
	else
	{
	//	if(cell->flag_occlusion==4)	glColor4ub(0,0,255,255); else	
			glColor4ub(255,64,0,255);
	}

	if(cell->parent)
	{
	//	if(cell->parent->level==3)	glColor4ub(0,255,0,255);
	//	if(cell->parent->level==2)	glColor4ub(255,0,0,255);
	//	if(cell->parent->level==1) 	glColor4ub(255,255,0,255);
	}

	cell->boundbox.draw_wire2();

}

int flag_radar=0; //DEL
float max_edge=0;
float radar_zoom=15;
void Draw_Radar()
{
	int i;
	float scale;
	int pw=200,ph=200;
//	if(flag_radar==0) return;
	if(camera==NULL) system_error("camera null");

	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	setColor(32,64,32,64);
//	glColor4ub(32,64,32,64);
//	drawRect(0,0,pw,ph);
//	setColor(255,0,0,128);
	glLineWidth(1);
	glRecti(0,0,pw,ph);
//	setColor(64,215,64,255);
	// HOW ?? -> Ok
   	glMatrixMode(GL_PROJECTION);
   	glLoadIdentity();

	glOrtho(-pw/2, pw/2,-ph/2, ph/2, -1000.0,1000.0);  
	scale=1.0*radar_zoom*10/(max_edge);
	glScalef(scale,scale,scale);
 	glRotatef(90,1,0,0); 
   	glTranslatef(-camera->position[0],-camera->position[1],-camera->position[2]);

	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity (); 		

	glDisable(GL_TEXTURE_2D); // Why -> for glLine,glColor
	
	glColor4ub(0,255,0,255);
	draw_octree(&space);
	
	extern List<Object*>	objects;
	for(i=0;i<objects.size();i++)
	{
		Object *obj;
		obj=objects[i];
		draw_octree(obj);
	}
	Draw_Frustrum();  
	
	glColor4ub(255,0,0,255);
	glPointSize(3);
	drawPoint(camera->position[0],5,camera->position[2] );
	glPointSize(1);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity (); 		
	scale=0.2;
	glScalef(scale,scale,scale);
	glRotatef(90,1,0,0); 
    	glTranslatef(-3.5,0,-3.5);
	draw_axes();

	glEnable(GL_TEXTURE_2D); 
}

	void setup2Dt()
	{
		glMatrixMode(GL_PROJECTION);
	//	glPushMatrix();
		glLoadIdentity();
		extern int screen_height,screen_width;
		glOrtho( 0, screen_width,0, screen_height, -1, 1 );		
		glViewport(0,0,screen_width,screen_height);
		glMatrixMode(GL_MODELVIEW);
	//	glPushMatrix();
		glLoadIdentity();

		glDisable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);// #!!!
		//glEnable(GL_SCISSOR_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}

void set_octree_node(Object *o,float c[3],float d)
{
	char buff[32];
	sprintf(buff,"octree node level=%d",o->level);
	o->setName(buff);
	vectorCopyf(o->boundbox.center,c);

	int i;
	for(i=0;i<3;i++)
	{
		o->boundbox.min[i]=c[i]-d;
		o->boundbox.max[i]=c[i]+d;
	}
	
	o->boundbox.update_vertex();
}


// make null node
void make_octree_node(Object *p)
{
	if(p->level>=TREE_LEAF)
		return;

	BoundBox *box;
	float d;

	box=&p->boundbox;
	d=box->max[0]- box->min[0]; 
	d=d/4;
	
		
		Object *obj;
		float center[3];	

		// 0.TOP_FRONT_RIGHT
		obj=new Object();		
		p->add(obj);
		center[0]=box->center[0]+ d;//x
		center[1]=box->center[1]+ d;//y
		center[2]=box->center[2]+ d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		make_octree_node(obj);

		// 1.TOP_FRONT_LEFT
		obj=new Object();		
		p->add(obj);
		center[0]=box->center[0]- d;//x
		center[1]=box->center[1]+ d;//y
		center[2]=box->center[2]+ d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		make_octree_node(obj);


		// 2.TOP_BACK_RIGHT
		obj=new Object();		
		center[0]=box->center[0]+ d;//x
		center[1]=box->center[1]+ d;//y
		center[2]=box->center[2]- d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		p->add(obj);
		make_octree_node(obj);


		// 3.TOP_BACK_LEFT
		obj=new Object();		
		center[0]=box->center[0]- d;//x
		center[1]=box->center[1]+ d;//y
		center[2]=box->center[2]- d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		p->add(obj);
		make_octree_node(obj);


		// 4.BOTTOM_FRONT_RIGHT
		obj=new Object();		
		center[0]=box->center[0]+ d;//x
		center[1]=box->center[1]- d;//y
		center[2]=box->center[2]+ d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		p->add(obj);
		make_octree_node(obj);

	
		// 5.BOTTOM_FRONT_LEFT
		obj=new Object();		
		center[0]=box->center[0]- d;//x
		center[1]=box->center[1]- d;//y
		center[2]=box->center[2]+ d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		p->add(obj);
		make_octree_node(obj);

		// 6.BOTTOM_BACK_RIGHT
		obj=new Object();		
		center[0]=box->center[0]+ d;//x
		center[1]=box->center[1]- d;//y
		center[2]=box->center[2]- d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		p->add(obj);
		make_octree_node(obj);

		// 7.BOTTOM_BACK_LEFT
		obj=new Object();		
		center[0]=box->center[0]- d;//x
		center[1]=box->center[1]- d;//y
		center[2]=box->center[2]- d;//z
		obj->level=p->level+1;
		set_octree_node(obj,center,d);
		p->add(obj);
		make_octree_node(obj);

}

void remove_null_node(Object *obj)
{
	int i,size;
	Object *child;
	List<Object*> *c;
	c=&obj->children;

	for(c->begin();c->current()!=NULL;c->next())
	{
		child=c->current();
		if(child->children.size()!=0)	
			remove_null_node(child);

		if(child->level > 0 and child->children.size()==0) 
			c->remove_current();
	//	else	console_printf("ttt size=%d",child->triangles.size());
	}
	
	c->reindex();
}
//draft
float diff_float(float a,float b)
{
	float p,d,s;
	d=fabs(b-a);
	s=b+a;
	p=100*d/s;
	return p;	
}

int   checkSameTriange(Triangle *t1,Triangle *t2)
{
	int i;
	float v1[3],v2[3];
	
	if((t1->flag & t2->flag & MODE_STATIC)==0) return 0;
			
	vectorZero(v1);
	vectorZero(v2);
	for(i=0;i<3;i++)
	{
		vectorAdd(v1,t1->vertice[i]);	
		vectorAdd(v2,t2->vertice[i]);	
	}

	vectorSubtract(v1,v1,v2);
	if(vectorLength(v1)<EPSILON*1) return 1;
	return 0;
}

//work?
int   checkTriangleSamePlane(Triangle *t1,Triangle *t2)
{
	if(t1->flag & t2->flag & MODE_STATIC)
	{
		float d,v[3];
		vectorSubtract(v,t1->vertice[0],t2->vertice[0])
		vectorNormalize(v);
		d=vectorDotProduct3f(v,t1->normal);
		if (d<EPSILON)
			return 1;
		else return 0;
	}
	return 0;
}
//work?
int   checkTriangleInclude(Triangle *dt,Triangle *st)
{
	if(dt->flag & st->flag & MODE_STATIC)
	{
		float d,v[3];
	//	vectorSubtract(v,t1->vertice[0],t2->vertice[0])
	//	vectorNormalize(v);
	//	d=vectorDotProduct3f(v,t1->normal);
		if (d<EPSILON)
			return 1;
		else return 0;
	}
	return 0;
}
//draft
int check_ffaceOfObject(Triangle *t1,Object *obj)
{
	if(!(obj->flag_triangle & MODE_STATIC))  return 0;
	int size;

	// ,
	for(int i=0; i< obj->triangles.size() ;)
	{
		float d;
		Triangle *t2 = obj->triangles[i];
		
		//if(0)
		if(checkSameTriange(t1,t2))
		{
		
			obj->triangles.remove(i);
			return 1;
		}
		else i++;
		/*
		if(checkTriangleSamePlane(t1,t2)==0) continue;
		d=vectorDotProduct3f(t1->normal,t2->normal);
		if(d<-0.99) // each face to face 
		{
			// area ?
			float a1,a2;
			a1=triangleArea(t1);
			a2=triangleArea(t2);
			if(diff_float(a1,a2)<3)
			{
				return 1;
			}
		}*/
	}

	return 0;
}

//int check_surfaceOfObject
int check_insideOfObject(float v[3][3],Object *obj)
{
	if(!(obj->flag_triangle & MODE_STATIC))  return 0;
	int size = obj->triangles.size();
	if(size==0)
		return 0;
	
	for(int i=0;i<size;i++)
	{
		float vk[3],d;
		Triangle *tri = obj->triangles[i];
		
		for(int j=0;j<3;j++)
		{
			vectorSubtract(vk,v[j],tri->vertice[0]);
			vectorNormalize(vk);
			d=vectorDotProduct3f(vk,tri->normal);
			if(d>0.0) // outside 
				return 0;
		}
	}

	for(int i=0;i<3;i++)
	{
		if(obj->boundbox.checkIn(v[i])==0)
		       return 0;	
	}

	return 1;
}
//
#define FLOAT_MAX 99999
float distancePlane(float n1[3],float p1[3],float n2[3],float p2[3])
{
	float 	v1[3],v2[3];
	float 	d,len;
	//vectorCopy3f(v1,p1);
	d=vectorDotProduct3f(n1,n2);
	if(d> -0.98 ) return FLOAT_MAX;

	vectorSubtract(v1,p1,p2);
	d=vectorDotProduct3f(v1,n1);

	//len=vectorLength(v1);
	//if(len<0.001) return 900;
	if(d<EPSILON) return 0;
	else 
		return d;
}

//work?
float triangleArea(Triangle *t)
{
	float s,a,b,c,area;
	
	if(t->flag & MODE_STATIC)
	{
		a=vectorDistance(t->vertice[0],t->vertice[1]);
		b=vectorDistance(t->vertice[1],t->vertice[2]);
		c=vectorDistance(t->vertice[2],t->vertice[0]);
		s=(a+b+c)/2;
		area=sqrt(s*(s-a)*(s-b)*(s-c));
		return area;
	}
	else return 0;
}

extern Index<Object*> list_collision;
// remove redundant triangles
//
// 1.ִ obj, ֺ, 鿡ְ( ġ),  ų  Ϲ ۾Ƽ ʴ°
// 2.
void CSG(Object *obj)
{
	Object *adj_o=0;
	BoundBox *box=&obj->boundbox;
	
	//1.find kissed objects(using boundbox)
	list_collision.clear();	
	
//<<<<<<< octree.cpp
	//console_printf("space boundbox. robj=%x",space.boundbox.robj);
//	adj_o=box->test_collision(&space); //find adjacent objects
//	if(adj_o==0) 
//=======
	box->test_collision(&space); //find adjacent objects
	if(list_collision.size()==0) 
//>>>>>>> 1.20
		return;

	if(obj->flag_triangle & MODE_STATIC)
	{
		// 1. remove triangles inside other object 
		int size=list_collision.size();
		int j;
		for(j=0;j<size;j++)
		{
			adj_o=list_collision[j];	
		
			for(int i=0;i<obj->triangles.size();)
			{
				// 1. tri->vertice is inside of Target_boundbox
				// 2. tri->vertice are in Target_plane(triange)
				Triangle *tri = obj->triangles[i];
				//int check_ffaceOfObject(float v[3][5],Object *obj)
				if(tri->flag & MODE_STATIC)
				{
					//if(check_ffaceOfObject(tri,adj_o) or
					if(check_insideOfObject(tri->vertice,adj_o))
					{
						obj->triangles.remove(i);
					}
					else	i++;
				}
				else 
					console_printf("Wrong ???");
			
			
				// distance of other obj's triangles 
			}
		}	
	}
	else { 
		console_printf("alpha");
		return ;
	}
	
	// 2. find adjcent objects in map objects
	// check kissed ? (not bound test) need EPSILON
	// which triangles ?
	// remove both triangles or only one triangle
	//
	
}

// void make_octree_node
// get_max_level(Cell *top)
// DRAFT
void init_octree(Object *map)
{
	float center[3]={0,0,0};
	int i;
	BoundBox *box;
		
	box=&map->boundbox;
	//find center and max_edge_length
	for(i=0;i<3;i++)
	{	
		float line;
		line=box->max[i]- box->min[i];
		center[i]=(box->max[i]+box->min[i])/2;		
		if(line>max_edge)
			max_edge=line;
	}

	//printf("max_edge=%f\n",max_edge);
	space.level=1;
	set_octree_node(&space,center,max_edge/2);
	make_octree_node(&space);
		
	int size;
	size=map->children.size(); 
	for(i=0;i<size;i++)
	{
		Object *c,*node;
		c=map->children[i];
		//console_printf("box radius=%f",c->boundbox.radius);
		//node=c->boundbox.find_womb(&space);
		//if(node) node->add(c);	
		c->collisions.clear();
		node=c->boundbox.find_octree_leafs(&space);
		int sizek=c->boundbox.collisions.size();
		if(sizek)
		{
			for(int j=0; j<sizek;j++)
			{
				Object *n=c->boundbox.collisions[j];
				if(n->level==3)
					n->add(c);
			}
			//console_printf("level=%d",node->level);
		}
		else 
			console_printf("find_womb fail !");
	}
	//printf("1.size=%d\n",map->children.size());
	// VALGRIND invalid
	// remove_null_node(&space);
	/* for(i=0;i<size;i++)
	{
		Object *c;
	//	c=map->children[i];
	//	CSG(c);
		//console_printf("box radius=%f",c->boundbox.radius);
	} */

	
	//console_printf("objn=%d",size);
	console_printf("level 1 size=%d",space.children.size());
	//system_add(&space); // never do this
}

float test_main()
{
//	Object *obj = new Object();
	float v1[4]={1,1,1,1},v2[4]={2,2,2,2};
	float f;
	int i;

	for(i=0;i<1024*1024*1024/8;i++)
	{
//		v1[0]=rand()/8;
		f=vectorDotProduct4f(v1,v2);	
		f=vectorDotProduct4f(v1,v2);	
		f=vectorDotProduct4f(v1,v2);	
		f=vectorDotProduct4f(v1,v2);	
		
		f=vectorDotProduct4f(v1,v2);	
		f=vectorDotProduct4f(v1,v2);	
		f=vectorDotProduct4f(v1,v2);	
		f=vectorDotProduct4f(v1,v2);	
		//f=vectorDotProduct4f(v1,Frustrum.nT);	
		//v2[1]=v1[0]=f;
	}
	return f;
}

void test()
{
	printf("result=%f\n",test_main());
//	for(int i=0;i<1024*1024*1024;i++)
//		check_isInFOV(obj);
}
// **********************************************************
//   OCCULUSION : 
//
Object *rooms;
Object MAP2;
// PORTAL SYSTEM
void init_portal()
{
	
}

void find_room()
{
}

void find_gate()
{

}


