#include "shape.h"
Shape::Shape()
{
}

void Shape::add(Triangle *t)
{
	triangles.add(t);		
}

void Shape::add(SDX_Polygon *p)
{
	polygons.add(p);		
}

void Shape::drawDefault()
{
	//glEnable(GL_TEXTURE_2D);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	float len=5.0;
	glColor4f(0.0,1.0,0,0.5);
	glScalef(len,len,len);
	// CUBE 
	glBegin(GL_QUADS);
	//front
	  /* Front Face */
      /* Normal Pointing Towards Viewer */
      glNormal3f( 0.0f, 0.0f, 1.0f );
      glVertex3f( -1.0f, -1.0f,  1.0f );		
	  glVertex3f(  1.0f, -1.0f,  1.0f );
		glVertex3f(  1.0f,  1.0f,  1.0f );
      glVertex3f( -1.0f,  1.0f,  1.0f );

      /* Back Face */
      /* Normal Pointing Away From Viewer */
      glNormal3f( 0.0f, 0.0f, -1.0f);
      glVertex3f( -1.0f, -1.0f, -1.0f );
      glVertex3f( -1.0f,  1.0f, -1.0f );
      glVertex3f(  1.0f,  1.0f, -1.0f );
      glVertex3f(  1.0f, -1.0f, -1.0f );

      /* Top Face */
      glNormal3f( 0.0f, 1.0f, 0.0f );
      glVertex3f( -1.0f,  1.0f, -1.0f );
      glVertex3f( -1.0f,  1.0f,  1.0f );
      glVertex3f(  1.0f,  1.0f,  1.0f );
      glVertex3f(  1.0f,  1.0f, -1.0f );

      /* Bottom Face */
      /* Normal Pointing Down */
      glNormal3f( 0.0f, -1.0f, 0.0f );
      glVertex3f( -1.0f, -1.0f, -1.0f );
      glVertex3f(  1.0f, -1.0f, -1.0f );
      glVertex3f(  1.0f, -1.0f,  1.0f );
      glVertex3f( -1.0f, -1.0f,  1.0f );

      /* Right face */
      /* Normal Pointing Right */
      glNormal3f( 1.0f, 0.0f, 0.0f);
      glVertex3f( 1.0f, -1.0f, -1.0f );
      glVertex3f( 1.0f,  1.0f, -1.0f );
      glVertex3f( 1.0f,  1.0f,  1.0f );
      glVertex3f( 1.0f, -1.0f,  1.0f );

      /* Left Face*/
      glNormal3f( -1.0f, 0.0f, 0.0f );
      glVertex3f( -1.0f, -1.0f, -1.0f );
      glVertex3f( -1.0f, -1.0f,  1.0f );
      glVertex3f( -1.0f,  1.0f,  1.0f );
      glVertex3f( -1.0f,  1.0f, -1.0f );

	glEnd();
}


void Shape::drawJoints()
{
	int i,j;
	Joint *joint;
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);

	for(i=0;i<joints.size();i++)
	{			
		joint=joints[i];	
		
		if(!joint->parent)
		{	
			glBegin(GL_LINES);
			//glVertex3f(joint->);
			glEnd(); 
		}
		// joint
	}

	glColor4f(1.0,0.0,0.0,1.0);
	glPointSize(8);
	glBegin(GL_POINTS);
		glVertex3f(0,0,0);
	glEnd(); 
	glPointSize(1);

	glEnable(GL_DEPTH_TEST);
}

void Shape::draw()
{
	Triangle *tri;
	int i;
	int j;
	//console_printf("triangles.size=%d",triangles.size());
	//printf("triangles.size=%d\n",5);//triangles.size());
	//printf("triangles.size=%d\n",triangles.size());
	//console_printf("triangles.size=%d \n",5);
	//system_exit();
	//return;
	glDisable( GL_LIGHTING );
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor4f(1.0,1.0,1.0,1.0);
	

	for(i=0;i<triangles.size();i++)
	{			
		tri=triangles[i];	

		if(tri->flag==TRIANGLE_MODE_STATIC)
		{
			glNormal3fv(tri->normal);
			glBindTexture(GL_TEXTURE_2D, tri->texture_id);

			//glBegin(GL_LINE_LOOP);	
			glBegin(GL_TRIANGLES);
			for(j=0;j<3;j++)
			{
				glTexCoord2f(tri->vertex[j].u,tri->vertex[j].v);
				glVertex3f(
						tri->vertex[j].x,
						tri->vertex[j].y,
						tri->vertex[j].z );
			}
			glEnd(); 
		}
		else 
		if(tri->flag==TRIANGLE_MODE_INDEX)
		{
			Vertex *vert;
			int  v_id;
			glNormal3fv(tri->normal);
			glBindTexture(GL_TEXTURE_2D, tri->texture_id);

			glBegin(GL_TRIANGLES);
			for(j=0;j<3;j++)
			{
				v_id=tri->vertex_id[j];	
				vert=vertexs[v_id];				
				glTexCoord2f(vert->u,vert->v);
				glVertex3f(
						vert->x,
						vert->y,
						vert->z );
			}
			glEnd(); 
		}
	}

	for(i=0;i<polygons.size();i++)
	{			
		SDX_Polygon *p;
		p=polygons[i];	

		glNormal3fv(p->normal);
		glBindTexture(GL_TEXTURE_2D, p->texture_id);
		glBegin(GL_POLYGON);
		//glBegin(GL_LINE_LOOP);	
		for(j=0;j<p->vertexs.size();j++)
		{
			glTexCoord2f(p->vertex[j].u,p->vertex[j].v);
			glVertex3f(
					tri->vertex[j].x,
					tri->vertex[j].y,
					tri->vertex[j].z );

		}
		glEnd(); 
	}


	drawJoints();
}

