#include "../list.h"

#ifndef SHAPE_H
#define SHAPE_H
#define vector float

void console_printf(char *fmt,...);
//typedef float vector; 

// Vertex Ÿ  uvؽ  ִ. 
typedef struct {
	float x,y,z;
	float u,v;
} Vertex;


struct plane_t
{
  float	normal[4];		   // normalized Normal-Vector of the plane
  float	distance;		// shortest distance from plane to Origin
};

typedef struct sEdge
{	
	float	v1[3];
		float	v2[3];
} Edge;

typedef struct sLine
{	
	float	normal[4];
		float	onPoint[3];
		float	length;
} Line;

typedef struct {
	float x,y,z;
} Vector;

typedef struct
{
	vector	 normal[4];
	vector	 origin[4];  // ???
	vector	 onPoint[3];
	vector	 onPoint2[3];
	vector	 onPoint3[3];
	vector	 distance;	//	normal_vect dot onPoint  
   //	κ Ÿ 
} Plane;

#define MODE_POINTER				0x1000	// share vertex (BoundBox) for Object,Triangle
#define MODE_STATIC_ONETEX			0x0101	// for MAP object one texture
#define MODE_STATIC_MULTEX			0x0100	// for MAP object 
#define MODE_STATIC					0x0100	// for MAP object 
#define MODE_INDEX_ONETEX			0x1001	// one texture

// NEW
#define TRIANGLE_MODE_INDEX			0x1005
#define TRIANGLE_MODE_DYNAMIC		0x1006	//
#define TRIANGLE_MODE_POINTER		0x1000	// used for BoundBox

class Object;
struct Triangle {
	int		flag;			// attribute
	int		isBack;			// ??
	float	normal[4]; 
	int		vertex_id[3];	// TRIANGLE_MODE_INDEX ! for Skeleton Animation
	float	*pvertex[3];	// TRIANGLE_MODE_POINTER! for BoundBox 
	float	vertice[3][3];	// for World , calc
							// TRIANGLE_MODE_STATIC (new) GLOBAL for map ?  and TexCoord
	float 	vertice_orig[3][3];
	int		texture_id;
	float	color[4];		// RGBA color
	float   tex[3][2];		// TEMP for Test
	int	joint;
	Object	*obj;
	//Position2D	TexCoord[3];   // for more flexiable but  not used for MilkShape Model
}; 

struct Quad {
	int		flag;			// attribute
	float	normal[4]; 
	int		vertex_id[4];	// TRIANGLE_MODE_INDEX ! this is better for Skeleton Animation!!!!!
	float	*pvertex[4];	// TRIANGLE_MODE_POINTER! BoundBox
	float	vertice[4][5];	// TRIANGLE_MODE_STATIC (new) GLOBAL  for map ?
	int		texture_id;
	float	color[4];		// color for triangle 
}; 

//#define SDX_Polygon Polygon
#define Polygon  SDX_Polygon
// wingdi.h #define _WINGDI_H
typedef struct s_polygon {
		int		flag;
		int		isBack;
		int		texture_id;
		float	normal[4];
		Vertex	vertex[16];	//DEL
	List<Vertex *> vertexs;
} SDX_Polygon;
									   
class tmp_key{
	float translate[3];
	float rotate[3];
	float orient[3]; // not used
};

typedef struct sKey {
	float translate[3];
	float rotate[3];
	float orient[3]; // not used
	Index<sKey*>	joints;
	unsigned int  msec;
	int	event;
	int	event_seq; 
	// example	
	// if(event==SOUND) playsound(event_seq);
} Key;

typedef struct sAni {
	int		id ;
	char	name[64];		
	unsigned int time;
	unsigned int start;
	unsigned int end;
	unsigned int frame_n;
	Index<Key*>		frames;  
	int			joint_n;
	//this will be	frame[joint_number ][ sequence_key ].translate[0] ;
} Animate;

typedef struct sJoint {
	int		id; 
	char	name[64];		
//	Index<Key*>		frames;  
//	Index<Vertex*> vertexs;
	IndexInt	vertexs_id;

	float	rotate[3];	//initial value 
	float	translate[3]; 

	int		parent_id;		// this better ? why?
	sJoint		*parent;		// faster
	Index<sJoint*>	children;		 

	float	mReference[4][4];  // ʱⰪ  
	float	mAbsolute[4][4];
	float	mRelative[4][4];
	float	mRelativeFinal[4][4];
	float	prev_position[4];
} Joint;


#endif 
