#include "../system.h"
#include <string.h>
#include "texture.h"
#include "gpf.c"
#include "../misc.h"
#include "../list.h"
//#include <SDL/SDL_image.h>
#define MAX_LOAD_TEX	512

class Texture {
	public:
    	int		is_active;		//??
    	char		*filename;
    	unsigned int	texture_id;
    	int		width,height;
	Texture(char *fn,int id,int w,int h)
	{
		filename=strdup(fn);
//		printf("Texture:filename %s \n",filename);
		texture_id=id;
		width=w;
		height=h;
	};
}; 

Index<Texture*> Textures; // texture list

//DRAFT
int LoadBMP(char *filename)
{
	Uint8 *rowhi, *rowlo;
	Uint8 *tmpbuf, tmpch;
	SDL_Surface *image;
	int i, j;
	GLuint	format,comps;
	GLuint texture;

	image=SDL_LoadBMP(filename);
	// 
	format= GL_RGB; 
	comps = GL_RGB;

	// GL surfaces are upsidedown 
	tmpbuf = (Uint8 *)malloc(image->pitch);
	if ( tmpbuf == NULL ) {
		system_error("Out of memory\n");
	}

	rowhi = (Uint8 *)image->pixels;
	rowlo = rowhi + (image->h * image->pitch) - image->pitch;
	for ( i=0; i<image->h/2; ++i ) {
		memcpy(tmpbuf, rowhi, image->pitch);
		memcpy(rowhi, rowlo, image->pitch);
		memcpy(rowlo, tmpbuf, image->pitch);
		rowhi += image->pitch;
		rowlo -= image->pitch;
	}

	glGenTextures( 1, &texture );
	glBindTexture( GL_TEXTURE_2D, texture); 

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);                                                     
	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) ;
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST ) ;
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

	if(gluBuild2DMipmaps(GL_TEXTURE_2D,comps,image->w,image->h,format,GL_UNSIGNED_BYTE,image->pixels)!=0)
			system_error("gluBuild2DMipmaps!");
	
	free(tmpbuf);
}


unsigned int LoadGPF(char *filename,int *id, int *w,int *h)
{
	GLuint texture;
	GLuint	format,comps;
	GPF		*g;

	if ( g=GPF_fileload(filename) )
	{
		GLuint type;
		switch(g->format)
		{
			case GPF_RGBA:
				format= GL_RGBA; comps=GL_RGBA;
				break;
			case GPF_RGB: 
				format= GL_RGB; comps=GL_RGB;
				break;
			default:
				system_error("LoadGPF: error");
		}

		{ // ʿ.
			//printf("type=%d,width=%d,height=%d\n",g->format,g->width,g->height);
			glGenTextures( 1, &texture );
			glBindTexture( GL_TEXTURE_2D, texture); 

			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);                                                     
			//BADimage why ?? -> ok 
			//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) ;
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST ) ;
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );                                               
			//DONT_DEL   
			//glTexImage2D( GL_TEXTURE_2D, 0, comps, g->width, g->height, 0, format, GL_UNSIGNED_BYTE, g->data );

			// GLU BUG !! read more data !!
			if(gluBuild2DMipmaps(GL_TEXTURE_2D,comps,g->width,g->height,format,GL_UNSIGNED_BYTE,g->data)!=0)  
				system_error("gluBuild2DMipmaps!");	    
		}

		*id=texture;
		*w=g->width;
		*h=g->height;

		if(texture==0)
			system_error("texture_id=%d  ",texture);

		GPF_Remove(g);
		return texture;
	}
	else 
	{	
		system_error( "Could not open image: %s: %s\n", filename,SDL_GetError( ) );
	}

	return 0;
}


//DEL: id   εȣ ˾Ƴ. 
int Texture_getBasis(int id,int *width,int *height)
{
	int i;
/* 	for(i=0;i<Texture_n;i++)
		if(loadedtexture[i].texture_id ==id )
		{ 
			if(width) *width=loadedtexture[i].width;
			if(height) *height=loadedtexture[i].height;
	    	return i;
		}
*/	return 0;
}

/*
// DRAFT
int LoadImageSDL(char *filename)
{
	Uint8 *rowhi, *rowlo;
	Uint8 *tmpbuf, tmpch;
	SDL_Surface *image;
	int i, j;
	GLuint	format,comps;

	GLuint texture;

	//SDL_Surface *surface;
	image=IMG_Load(filename);

	// check BGR or RGB ? 
	format= GL_RGB; 
	comps = GL_RGB;

	// GL surfaces are upsidedown 
	tmpbuf = (Uint8 *)malloc(image->pitch);
	if ( tmpbuf == NULL ) {
		system_error("Out of memory\n");
	}

	rowhi = (Uint8 *)image->pixels;
	rowlo = rowhi + (image->h * image->pitch) - image->pitch;
	for ( i=0; i<image->h/2; ++i ) {
		memcpy(tmpbuf, rowhi, image->pitch);
		memcpy(rowhi, rowlo, image->pitch);
		memcpy(rowlo, tmpbuf, image->pitch);
		rowhi += image->pitch;
		rowlo -= image->pitch;
	}

	glGenTextures( 1, &texture );
	glBindTexture( GL_TEXTURE_2D, texture); 

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);                                                     
	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) ;
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST ) ;
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

	if(gluBuild2DMipmaps(GL_TEXTURE_2D,comps,image->w,image->h,format,GL_UNSIGNED_BYTE,image->pixels)!=0)
			system_error("gluBuild2DMipmaps!");
	
}
*/

// DRAFT
//	
//	1.remove ext (gpf,bmp)
//
// load *.gpf  *.bmp
// return : 
//		texture_id
//		or ERROR
int LoadTextureFile(char *filename,int *w,int *h)
{
	int i;
	int tex_id,width,height;
	char *pathname;
	char name[64];
	
	get_basename_without_ext(name,filename);
	strlowcase(name);

//	̹ εǾ ̶ Ʈ ִ ãƺ...
	for(i=0;i<Textures.size();i++)
	{
		if(!strcasecmp(Textures[i]->filename,name)) // ignore case
		{ 
	//		printf("found %s texture name \n",bn);
			if(w and h)
			{
				*w=Textures[i]->width;
				*h=Textures[i]->height;
			//	printf("width=%d,height=%d\n",*w,*h);
			}
			//printf("found %d \n",Textures[i]->texture_id);
		//	printf("LoadTextureFile end\n");
			return Textures[i]->texture_id;
		}
	}

	if(pathname=get_pathname(name))
	{
		char *ext=get_ext(pathname);
		if(strcmp(ext,"bmp")==0)
			printf("DEBUG: BMP !! %s\n",name);//load bmp
		else
		if(strcmp(ext,"gpf")==0)
		{
			if(LoadGPF(pathname,&tex_id,&width,&height)==0)
			system_error("error LoadGPF ");
		}
		else 
		{
			printf("ERROR:  %s\n",name);
			return -1;
		}
	}
	
	Textures.add(new Texture(name,tex_id,width,height));

	//printf("loaded  %s \n",bn);
	if(w and h)
	{
		*w=width;
		*h=height;
	}
	//printf("LoadTextureFile end\n");
	return tex_id;
}


