// object viewer
#include "../math.h"
#include "viewer.h"

Viewer::Viewer():Object("viewer")
{
	Object *obj;
	vector v1[3];
	done=0;
	t_rotY=0;
	t_rotX=0;
	flag_drawdefault=0;
	flag_physics=1;

	obj=system_find_object("death");
	if(obj)
		setPosition(obj->position);
	else
		setPosition(20,20,20);

	vectorSet(v1,0,0,0);
	setDirection(v1);
	obj=this;	
	dtoken1=debug_token();
}

void Viewer::setObject(Object *o)
{
	obj=o;
}

Index<Object*> stack_drawn;
Index<Object*> occluder;

extern void setView();
extern Object	space;
extern List<Object *> lastDraws;
extern List<Object *> postDraws;
extern int stamp;

void check_inFOV(Object *cell);
int check_isInFOV(Object *cell); 

void depth_clear();
void draw_depth();

int Viewer::Update(Uint32 msec){ 
	
	system_input_disable();
	
	input_event();
	if(done)	system_exit();

	static float p[3]={-1,-1,-999},d[3]={-999,-99,-9};
	extern int  flag_depth_test;

	setView();
	glClearColor(0,0,0,0); 
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	//glClear(GL_DEPTH_BUFFER_BIT); // HP max=15% 
	//CHECK_OPENGL();
	//glDisable(GL_ALPHA_TEST);
	glDisable(GL_STENCIL_TEST);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST); // HP ?
	glEnable(GL_DEPTH_TEST);
	//glDisable(GL_DEPTH_TEST);
	//glDisable(GL_LIGHTING);
	//glDisable(GL_DITHER);
	glCullFace(GL_BACK); glEnable(GL_CULL_FACE); // HP MAX=3%
	glShadeModel(GL_FLAT);
	//glDisable(GL_ALPHA_TEST);

	extern int dcount;
	dcount=0;
	space.flag_inFOV=FOV_PARTIALIN;
	if(flag_depth_test==0) 
	{
		//NON OCCLUTION
		//check_inFOV(&space);
		space.draw(FOV_PARTIALIN); // draw the map 
		
		for(postDraws.begin();postDraws.current()!=NULL;postDraws.next())
		{
			Object *obj=postDraws.current();
			obj->draw(0);
		}
		postDraws.clear();

	}
	else // OCCLUTION Methode
	{
		depth_clear();
		//console_printf("stack_drawn0.size=%d",stack_drawn0.size());
		Object *o0;
	
		while(o0=stack_drawn.pop())	
			o0->draw(); 

		if(vectorCompare(p,position) and vectorCompare(d,direction))
		{
			//Cached Draw
			//int size=stack_drawn.size();
			//for(int i=0;i<size;i++) stack_drawn[i]->draw_occluder(0);
		} 
		else  
		{
			//check_inFOV(&space);
			//stack_drawn.sort(sort_distance);
			while(o0=stack_drawn.pop())
			{
			//	if( o0->draw()) ; // add to occluder
				//if( check_isInFOV(o0) and o0->draw(0)) ; // add to occluder
				//if( check_isInFOV(o0) and o0->draw_occluder(0)==VISIABLE)
				{
					/* Object *p=o0->parent;
					p->flag_visiable=stamp;
					if(p->level==3)
					{
					//	if(p->parent==0) console_printf("null parent");
						p->parent->flag_visiable=stamp;
					}	*/
				//	occluder.add(o0);
				} 
			}
			space.draw(); //occluder !!
		}

		extern Object	*camera;
		vectorCopyf(p,camera->position);
		vectorCopyf(d,camera->direction);
	
		stack_drawn.add(&occluder);
		occluder.clear();
	
		draw_depth();
	}

	extern int  flag_test;
	debug_printf(dtoken1,"triangles =%d  MODE=%d",dcount, flag_depth_test,flag_test);

}

int Viewer2::Update(Uint32 msec){ 
}

class Foobar: public Object 
{
	public:
	Foobar();

	int Update(Uint32 msec);
};

Foobar::Foobar(): Object()
{
	setName("foobar");
	flag_drawdefault=0;
	flag_physics=1;
	weight=1;
}

int Foobar::Update(Uint32 msec)
{
	//2. user transform 
		/*
		size=triangles_local.size();
		if(size==triangles.size())
		{
			for(i=0;i<size;i++)
			{
		//		triangleCopy(triangles[i],triangles_local[i],this);
				console_printf("%s",name);
			}
		} */
}



void triangleCopy(Triangle *to,Triangle *tin,Object *o=0);
//  |
//   
// random
void Viewer::launch_experiment()
{
	float spawn_pos[3];
	float v1[3],v2[3],v3[3];

	vectorCopyf(spawn_pos,position);

	int len=50;	
	v1[0]=random()%len;
	v1[1]=random()%len;
	v1[2]=random()%len;
	
	v2[0]=random()%len;
	v2[1]=random()%len;
	v2[2]=random()%len;

	v3[0]=random()%len;
	v3[1]=random()%len;
	v3[2]=random()%len;

//	printf(" (%f %f %f)\n",v1[0],v1[1],v1[2]);
//	printf(" (%f %f %f)\n",v2[0],v2[1],v2[2]);
//	printf(" (%f %f %f)\n",v3[0],v3[1],v3[2]);
//	v1[0]=0;	v1[1]=0;	v1[2]=0;
//	v2[0]=0;	v2[1]=0;	v2[2]=0;
//	v3[0]=0;	v3[1]=0;	v3[2]=0;

	Object *obj;
	obj=new Foobar();
	obj->flag= WORLD;
	obj->flag_triangle=MODE_STATIC;
	obj->flag_physics=true;
	obj->setPosition(spawn_pos);
	obj->weight=0.005; // 5g
	
	// shooting object with force=3 
	vectorCopyf(obj->force,direction);
	vectorScale(obj->force,1.7);

	Triangle *tri;
	tri=new Triangle();
	tri->flag=MODE_STATIC;
	tri->texture_id=0;
	tri->color[0]=(random()%255)/255.0;
	tri->color[1]=(random()%255)/255.0;
	tri->color[2]=(random()%255)/255.0;
	tri->color[3]=(random()%170)/255.0;

	vectorCopy3f(tri->vertice_orig[0],v1);
	vectorCopy3f(tri->vertice_orig[1],v2);
	vectorCopy3f(tri->vertice_orig[2],v3);

//	vectorAdd(tri->vertice[0],spawn_pos);
//	vectorAdd(tri->vertice[1],spawn_pos);
//	vectorAdd(tri->vertice[2],spawn_pos);
	
	obj->triangles.add(tri);
	
	system_add(obj);
	
}

//setDirection()
// 1.add to force  
void setDirectionSpeed(Object *obj,float s)
{
	float v1[3];
	{
		vectorNormalize(obj->direction);
		vectorCopy3f(v1,obj->direction);
		vectorScale(v1,s);	
	//	vectorAdd(obj->force,v1); // moving continue!
		vectorCopy3f(obj->force,v1); // 
	}	
}

void TEST_setDirectionSpeed(Object *obj,float s)
{
	float t;
	float v1[3];
	static float oldv[3]={0,0,0};
	

	t=vectorDotProduct3f(obj->direction,obj->force);
	t=s-t;
	//if(t==0) return;

	{
		vectorCopy3f(v1,obj->direction);
		vectorScale(v1,t);	
		vectorAdd(obj->force,v1);
	}	
}


void Viewer::input_event()
{
	float		_speed=1.0;
	static int	button_stat;
	
	//SDL_EnableKeyRepeat(int delay, int interval);

	int		sym;
	int		x_prev,y_prev;	
	SDL_Event	event;
	if(obj==NULL) 
		obj=this;

	if(obj==this) 
		_speed=0.5;
	else 
		_speed=0.3;

	while (SDL_PollEvent(&event))
	{
		system_input(&event);
		switch(event.type){

//			case  SDL_QUIT :	done = 1; 		break;
			case  SDL_KEYDOWN:  // Ű   keydown() ȣ
				sym=event.key.keysym.sym;
				if(sym== SDLK_ESCAPE) 		
					done = 1;  
				switch(sym) 
				{
					case 'W':    
					case 'w':
					//	obj->setSpeed(_speed);
						setDirectionSpeed(this,_speed);
					//	printf("pressed\n"); // repeat
						break;
					case 'S':    
					case 's':    
						//obj->setSpeed(-_speed);
						setDirectionSpeed(this,-_speed);
						break;
					case 'a':    
						break;
					case 'd':    
						break;
					
					case SDLK_F6:
						if(obj==this)
							setObject(system_find_object("terror"));
						else
							setObject(this);
						break;

					default :  
						break;
				} // switch	
				
				break;
			case  SDL_KEYUP :
				//obj->setSpeed(0);
				setDirectionSpeed(this,0);
				break;			
			case  SDL_MOUSEBUTTONDOWN:

				launch_experiment();
				break;	
			case  SDL_MOUSEBUTTONUP:
				
				break;	
			case  SDL_MOUSEMOTION:
				// DRAFT 
				//if(event.motion.state)
				if(SDL_WM_GrabInput(SDL_GRAB_QUERY)==SDL_GRAB_OFF) break;
				//if(event.motion.x!=(640/2) or event.motion.y!=(480/2))
				if(system_checkMouseCenter(event.motion.x, event.motion.y)==0)
				{
					//setDirection2Target(v3f);
					//setDirectionSpeed(obj,-(obj->speed));
					
					vector	right[3],_up[3]={0,1,0};
					t_rotX=float(event.motion.xrel);
					t_rotY=float(event.motion.yrel);
				
					// ٷοκ, up  direction ȸ 
					//  up  ٲ ¿...
					///vectorCopyf(_up,obj->up);
					vectorCrossProduct(right,obj->direction,_up);		
					
					// direction
					float h,p;

					vectorRotate(obj->direction,h=RADIAN(-t_rotX)/3,_up);		// heading 
					vectorRotate(obj->direction,p=RADIAN(-t_rotY)/3,right);		// pitching 
					obj->rotate[0]+=h;			
					obj->rotate[1]+=p;			
					// up 
					vectorCrossProduct(obj->up,right,obj->direction);  
					vectorNormalize(obj->up);	
					system_mouse_center();
				}
				break;
		} 
		
		if(event.button.state==SDL_PRESSED)
		{
		}
		
	}
	float v[3];
	///TEST_setDirectionSpeed(obj,obj->speed);
	//vectorCopyf(v,obj->direction);
	//vectorScale(v,obj->speed);
	//vectorCopyf(obj->force,obj->direction);
	//vectorScale(obj->force,obj->speed);

}

