#include "system.h"
#include "ui/ui.h"
#include "gl.h"
#include "./object/octree.h"
#include <stdarg.h>

SDL_Event		event;
SDL_Surface		*screen;
List<Object*>		objects;
UserInterface		UI;

int screen_width;
int screen_height;
int flag_input_enable=1;

int	done=0;

Uint32 	t,T0;
Uint32 	iDeltaTime;
Uint32 	stamp=0;

Console *console;
Object	*camera=NULL;
Object	*map_object=NULL;
Object	space;
List<Object *> lastDraws;
List<Object *> postDraws;

void console_printf(const char *fmt,...)
{
    va_list		arg_ptr;
    static char buffer[64];   
	va_start(arg_ptr, fmt); 
    vsprintf(buffer, fmt, arg_ptr);
    console->addline(buffer);
}

void debug_printf(int tok,const char *fmt,...)
{
    va_list		arg_ptr;
    static char buffer[64];   
	va_start(arg_ptr, fmt); 
    vsprintf(buffer, fmt, arg_ptr);
    console->debug(tok,buffer);
}

//int debug_gentoken()
int debug_token()
{
	return console->debug_token();
}

int get_debug_token()
{
	return console->debug_token();
}


void system_set_camera(Object *obj)
{
	camera=obj;
}


int system_geti(int id)
{
	if(id==SYSTEM_HEIGHT)
		return screen_height;
	else 
	if(id==SYSTEM_WIDTH)
		return screen_width;
}

//void console_printf(
void system_insert(Object *obj)
{
	//objects.add(obj);
	objects.add(obj);
}

void system_add(Widget *w)
{
	UI.add(w);
}

void system_add(Object *o)
{
	space.add(o);
	objects.add(o);
}

void system_event_set(int e,char *str,Object *obj)
{

}

void system_event_set(char *str,Object *obj)
{

}

void system_event_call(char *str)
{

}

void system_event_call(int e)
{

}

int system_checkMouseCenter(int x,int y)
{
	if(x!=(screen_width/2) or y!=(screen_height/2))
		return 0;
	else 
		return 1;
}

void system_mouse_center()
{
	SDL_WarpMouse(screen_width/2,screen_height/2); 
}

void system_exit()
{
	SDL_Quit();
	exit(0);
}
void Init_SDL()
{

	int flags=0;
	int value;
	char *text;
	
	//if(SDL_Init(SDL_INIT_EVERYTHING) < 0) {
	//	fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
	//	exit(1);
	//}
	if(SDL_Init(SDL_INIT_TIMER)<0) system_error("SDL Timer");
	if(SDL_Init(SDL_INIT_VIDEO)<0) system_error("SDL Video init ");
	//DEL if(SDL_Init(SDL_INIT_AUDIO)<0) system_error("SDL Audio init ");
	//	Init_Audio();   
	//	InitJoyStick();
	screen_width=800;
	screen_height=600;	
	flags|= SDL_OPENGL;
	//flags|= SDL_FULLSCREEN; 

	screen = SDL_SetVideoMode(screen_width, screen_height,16,   flags);
	if (screen  == NULL ) {
		fprintf(stderr, "Unable to create OpenGL screen: %s\n", SDL_GetError());
		system_exit();
	}

	SDL_WM_SetCaption("ver. alpha", NULL);
	
	const GLubyte *str; 
	int glPolyOffExtAvailable; 
	str = glGetString (GL_EXTENSIONS); 
	//glPolyOffExtAvailable = (strstr((const char *)str, "GL_EXT_polygon_offset") != NULL);
	printf("OpenGL Version:%s\n",glGetString(GL_VERSION));
	
	if(0)
	{
 		//   SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
		//    SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 8 );
		SDL_GL_GetAttribute(SDL_GL_DOUBLEBUFFER,&value);
		printf("SDL_GL_DOUBLEBUFFER=%d\n",value);
		SDL_GL_GetAttribute(SDL_GL_DEPTH_SIZE,&value);
		printf("SDL_GL_DEPTH_SIZE=%d\n",value);
		SDL_GL_GetAttribute(SDL_GL_STENCIL_SIZE,&value);
		printf("SDL_GL_STENCIL_SIZE=%d\n",value);
		glGetIntegerv(GL_AUX_BUFFERS,&value);
	}
	
//	SDL_WarpMouse(HalfScreenWidth,HalfScreenHeight); // 콺 Ŀ ȭ ߰ 
//	SDL_ShowCursor(0);  // 콺 Ŀ  ߱
//	SDL_WM_GrabInput(SDL_GRAB_OFF);
}

void system_init()
{
	Init_SDL();
	init_filelist("./data");
	UI.Init(screen);

	console=new Console(0,0,screen_width,160);
	system_add(console);
//	init_Network();
}

void system_input_disable()
{
	flag_input_enable=0;	
}

// Idea: ǻͻ Ѹ Էϱ⶧ Է Ʈ ϳ̴.
//  Է ʿ ġϵ . 
void system_input(SDL_Event *event)  
{
	int sym;
	if(event)
	{
		switch(event->type){  
			case  SDL_QUIT :
				done = 1;  break;
			case  SDL_KEYDOWN:  // Ű   keydown() ȣ
				sym=event->key.keysym.sym;
				if(sym== SDLK_ESCAPE)
					done = 1;  
				if(sym== SDLK_LALT && (SDL_GetModState() & KMOD_LCTRL) ) 
				{
					console_printf("ALT Key !!");
					SDL_ShowCursor(1);  
					SDL_WM_GrabInput(SDL_GRAB_OFF);
					if(SDL_WM_GrabInput(SDL_GRAB_QUERY)==SDL_GRAB_OFF)
					{
						//Console_printf("SDL_GRAP_OFF");
					}
					else{
						//Console_printf("SDL_GRAP_ON");
					}
				}
				switch(sym)
				{
					case SDLK_F12:
						SDL_WM_ToggleFullScreen(screen);
						break;
					case SDLK_F2:
						extern int  flag_depth_test;
						flag_depth_test=!flag_depth_test;
						break;
					case SDLK_F5:
						extern int  flag_depth_draw;
						flag_depth_draw=!flag_depth_draw;
						break;
					case SDLK_F3:
						extern Frame *win_radar;
						win_radar->visible=!win_radar->visible;
						break;
					case SDLK_F4:
						extern int flag_opacity;
						flag_opacity=!flag_opacity;
						break;
					case SDLK_KP_PLUS:
						extern float radar_zoom;
						radar_zoom+=1;
						break;
					case SDLK_KP_MINUS:
						extern float radar_zoom;
						radar_zoom-=1;
						break;
				}
				
				break;
			case  SDL_MOUSEBUTTONUP:
				if(SDL_WM_GrabInput(SDL_GRAB_QUERY)==SDL_GRAB_OFF)
				{
				//	SDL_ShowCursor(0);  
					SDL_WM_GrabInput(SDL_GRAB_ON);
				}
				break;	

			default : 	    
				break;

		}
	}
}

void system_input() 
{
	int sym;
	if (flag_input_enable==0) return;
	
   	while (SDL_PollEvent(&event)){
		system_input(&event);
	// ̴̹ 
	/*	if(Camera!=NULL) 
		{
			if(player!=NULL )
			{
				if(player->InputFunc!=NULL)	player->InputFunc(player);
			}
			
			else 
			  	if(Camera->InputFunc!=NULL)	Camera->InputFunc(Camera);
		}
	*/
	}// while
   
}

struct sFrustrum {
	float left,right,bottom,top;
	float Near,Far;
	float width,height;
	vector LB[4],LT[4],RB[4],RT[4];
	vector BL[4],BR[4],TL[4],TR[4];
	vector nL[4],nT[4],nB[4],nR[4];
	plane_t	sides[5];
} Frustrum;

void initFrustrum()
{
	float ratio=1;
	float v1[3];

	ratio=(float)screen_height/screen_width;
	glViewport (0, 0, screen_width,  screen_height); 

	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();

	Frustrum.left= -5;
	Frustrum.right= 5;
	Frustrum.bottom= -5*ratio;
	Frustrum.top= 5*ratio;
	Frustrum.Near=5;
	Frustrum.Far=100*UNIT;

	Frustrum.width=Frustrum.right - Frustrum.left;
	Frustrum.height=Frustrum.top - Frustrum.bottom;
	glFrustum(Frustrum.left,Frustrum.right, Frustrum.bottom, Frustrum.top, Frustrum.Near, Frustrum.Far);
	///gluPerspective(60.0,1.0,0.1,5000);
}

// 
//	FOV  ϱ Լ  View of Field
// 	1. ʱⰪ (0,0,-1)   ..
extern float rot_mat[4][4];
extern float PM[4][4];

void update_Frustrum()
{   
	float v1[3],v2[3];
	float r;

	GLfloat m[4][4];

	r=Frustrum.Far/Frustrum.Near;
	
	Frustrum.LT[0]= Frustrum.left*r;
	Frustrum.LT[1]= Frustrum.top*r;
	Frustrum.LT[2]=-Frustrum.Far;

	Frustrum.RT[0]= Frustrum.right *r;
	Frustrum.RT[1]= Frustrum.top *r;
	Frustrum.RT[2]=-Frustrum.Far;

	Frustrum.LB[0]= r*Frustrum.left;
	Frustrum.LB[1]= r*Frustrum.bottom;
	Frustrum.LB[2]=-Frustrum.Far;

	Frustrum.RB[0]= r*Frustrum.right;
	Frustrum.RB[1]= r*Frustrum.bottom;
	Frustrum.RB[2]=-Frustrum.Far;

	vector out[4];
	matrixMultvector(rot_mat,Frustrum.LT ,out);
	//matrixMultvector(PM,Frustrum.LT ,out);
	vectorCopyf(Frustrum.LT,out);
	matrixMultvector(rot_mat,Frustrum.LB ,out);
	//matrixMultvector(PM,Frustrum.LB ,out);
	vectorCopyf(Frustrum.LB,out);
	matrixMultvector(rot_mat,Frustrum.RT ,out);
	//matrixMultvector(PM,Frustrum.RT ,out);
	vectorCopyf(Frustrum.RT,out);
	matrixMultvector(rot_mat,Frustrum.RB ,out);
	//matrixMultvector(PM,Frustrum.RB ,out);
	vectorCopyf(Frustrum.RB,out);

	// *** SEQUENCE VERY IMPORTANT !!!!  ---> ??????
	vectorCrossProduct(Frustrum.nL,Frustrum.LT,Frustrum.LB);
	vectorCrossProduct(Frustrum.nR,Frustrum.RB,Frustrum.RT);
	vectorCrossProduct(Frustrum.nT,Frustrum.RT,Frustrum.LT);
	vectorCrossProduct(Frustrum.nB,Frustrum.LB,Frustrum.RB);

	vectorNormalize(Frustrum.nL);
	vectorNormalize(Frustrum.nR);
	vectorNormalize(Frustrum.nT);
	vectorNormalize(Frustrum.nB);

	vectorAdd(Frustrum.LT,camera->position);
	vectorAdd(Frustrum.LB,camera->position);
	vectorAdd(Frustrum.RT,camera->position);
	vectorAdd(Frustrum.RB,camera->position);

	// additional 
	vectorCopyf(Frustrum.sides[0].normal,Frustrum.nL);
	vectorCopyf(Frustrum.sides[1].normal,Frustrum.nR);
	vectorCopyf(Frustrum.sides[2].normal,Frustrum.nT);
	vectorCopyf(Frustrum.sides[3].normal,Frustrum.nB);
	vectorCopyf(Frustrum.sides[4].normal,camera->direction);  // near 
	vectorScale(Frustrum.sides[4].normal,-1);  // near 

	Frustrum.sides[0].distance=vectorDotProduct3f(Frustrum.sides[0].normal,Frustrum.LT);
	Frustrum.sides[1].distance=vectorDotProduct3f(Frustrum.sides[1].normal,Frustrum.RB);
	Frustrum.sides[2].distance=vectorDotProduct3f(Frustrum.sides[2].normal,Frustrum.LT);
	Frustrum.sides[3].distance=vectorDotProduct3f(Frustrum.sides[3].normal,Frustrum.RB);
	Frustrum.sides[4].distance=vectorLength(camera->position);
	Frustrum.sides[4].distance+=Frustrum.Near;
}  


//  1. glRotatef ݽð ȸѴ. !!
//  2. roatate then translate ! ? ->  matrix ִ ̹..
//  3.   glȣÿ ݴ밢 ־شٴ° ϱ 
//  4. rotate(ȸ) ƴ directionͷ ȸϴ    .

void glLookAt_(float  eye[3], float center[3],float up[3] );
void setView()
{

	initFrustrum();

	if(camera==NULL) return;

	glMatrixMode (GL_PROJECTION); 
	// No_glLoadIdentity()
	// inherent Frustrum matrix
	{
		float eye[3];
		float target[3];

		vectorCopyf(eye,camera->position);
		vectorCopyf(target,camera->direction);
		vectorAdd(target,eye);

		glLookAt_(eye,target,camera->up);
		//console_printf("up(%0.2f %0.2f %0.2f) ",camera->up[0],camera->up[1],camera->up[2]);
		update_Frustrum();
	}
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
}


void check_inFOV(Object *cell);

// very short job  ( 200ms )
void system_DoSomthing()
{
	static Object *obj=NULL;

	if(obj==NULL)
		objects.begin();
	
	obj=objects.current();
	
	if(obj)
	{
		check_inFOV(obj);
//		obj->common_update(msec);
//		obj->Update(msec);
//		obj=objects.next();
	}

}

int sort_distance(Object *a,Object *b)
{
	if(a->FOV_distance > b->FOV_distance)
		return 1;
	if(a->FOV_distance== b->FOV_distance)
		return 0;
	else return -1;
}

extern int dcount;
Object *dam_obj=0;
int flag_opacity=1;

void depth_clear();
void draw_depth();
void system_loop()
{
	int i;
	int size;
	Uint32  msec;

	T0 = SDL_GetTicks(); // T0ʱȭ 
	int token_dcount=debug_token();
	int token_debug1=debug_token();

	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);
	//glDepthFunc()
	while ( ! done ) 
	{
		stamp++;

		t = SDL_GetTicks();  	// return value is  mili seconds !!!!
   		msec = t - T0;			// seconds = mseconds / 1000;
   		T0 = t;		

		system_input();
		for(objects.begin();objects.current()!=NULL;objects.next())
		{
			Object *obj=objects.current();
			// if moved then change map_position(new map_node) change cell
			// if a obj in FOV, then draw the obj
//			check_inFOV(obj);
			obj->addmsec=obj->common_update(msec+obj->addmsec);
			obj->Update(msec);
		}
		UI.Draw();
		SDL_GL_SwapBuffers(); // go to Viewr? better? 
	}
	system_exit();
}

//good , used
Object *system_find_object(const char *obj_name)
{
	int i,size;
	Object *obj;
	Object *objs[64];
	int n=0;
	size=objects.size();
	for(i=0;i<size;i++)
	{
		obj=objects[i];
		if(strstr(obj->name,obj_name))
			objs[n++]=obj;
	}
	
	if(n>0)
	{
		i=random()%n;
		return objs[i];
	}
	
	return NULL;
}


PlaneViewer::PlaneViewer():Object("PlaneViewer")
{
	vector v1[3];
	setPosition(20,20,20);
	vectorSet(v1,0,0,0);
	setDirection(v1);
	camera=this;
	PlaneObject=new Object("plane sets");
}

void PlaneViewer::addLine(Line *line)
{
	Line *l=new Line();
	vectorCopyf(l->normal,line->normal);
	vectorCopyf(l->onPoint,line->onPoint);
	lines.add(l);
}

void PlaneViewer::addVertex(Vertex *v)
{
	Vertex *v1=new Vertex();
	v1->x=v->x;
	v1->y=v->y;
	v1->z=v->z;
	vertexs.add(v1);
}
static int xidx=0;
void PlaneViewer::addPlane(Plane *p,int idx)
{
	xidx=idx;
	planes.add(p);
}

float t_rot=0;
float t_rotY=0;

void draw_axes();
int PlaneViewer::Update(Uint32 msec){ 
	int i;	
	vector v1[3];
	vector v3[3];
	vector vt[3];
	Plane *p;
	system_input_disable();
	event();
//	setDirection(v1);
//	glLoadIdentity ();     
//	glMatrixMode (GL_PROJECTION);
//	console_printf("(%0.1f %0.1f  %0.1f)",position[0],position[1],position[2]);	
	glEnable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
//	glBlendFunc (GL_SRC_ALPHA, GL_ONE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
	
	//glutWireCube (1.0);
	glColor4ub(255,255,0,128);
	//glColor3f(128,128,0);
	//glutSolidTeapot(10.0);
	//glutWireTeapot(10.0);
	glLoadIdentity ();
	draw_axes();

	vectorSet(vt,0,0,0);	
	for(i=0;i<planes.size();i++)
	{
		p=planes[i];
		vectorSet(v1,0,0,0);

		vectorAdd(v1,p->onPoint);
		vectorAdd(v1,p->onPoint2);
		vectorAdd(v1,p->onPoint3);
		vectorScale(v1,0.3333);
		vectorAdd(vt,v1);
	}

	vectorScale(vt,1.0/planes.size());
	
	vectorCopyf(v3,up);
	vectorCrossProduct(v3,up,direction);
	glRotatef(-t_rotY,v3[0],v3[1],v3[2]);
	glRotatef(t_rot,up[0],up[1],up[2]);
	glTranslatef(-vt[0],-vt[1],-vt[2]);

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);


	for(i=0;i<planes.size();i++)
	{
		if(i==xidx)			
			glColor4ub(128,255,255,168);
		else
			glColor4ub(128,255,128,168);

		p=planes[i];
		glBegin(GL_TRIANGLES);	
	    {
		    glVertex3fv(p->onPoint);
		    glVertex3fv(p->onPoint2);
		    glVertex3fv(p->onPoint3);
	    }
		glEnd(); 
	}
	
	glLineWidth(2.0);
	glColor4ub(255,255,128,255);
	for(i=0;i<planes.size();i++)
	{
		p=planes[i];
		glBegin(GL_LINE_LOOP);	
	    {
		    glVertex3fv(p->onPoint);
		    glVertex3fv(p->onPoint2);
		    glVertex3fv(p->onPoint3);
	    }
		glEnd(); 
	}
	
	glPointSize(7.0);
	glColor4ub(255,0,0,255);
	glBegin(GL_POINTS);	
	for(i=0;i<vertexs.size();i++)
	{
		glVertex3fv(&vertexs[i]->x);
	}
	glEnd(); 


	glLineWidth(2.0);
	glColor4ub(128,0,255,255);
	glBegin(GL_LINE_STRIP);	
	for(i=0;i<vertexs.size();i++)
	{
		glVertex3fv(&vertexs[i]->x);
	}
	glEnd(); 
	glLineWidth(5.0);
	glColor4ub(0,0,255,255);
	//glBegin(GL_LINES);	
	glBegin(GL_LINE_STRIP);	
	for(i=0;i<lines.size();i++)
	{
		glVertex3fv(lines[i]->normal);
		glVertex3fv(lines[i]->onPoint);
	}
	glEnd(); 
}

void PlaneViewer::event()
{
	static int button_stat;
	SDL_Event event;
	int sym;
	float speed=10.4;
	while ( SDL_PollEvent(&event)){

		switch(event.type){  

			case  SDL_QUIT :
				done = 1; 
				break;
			case  SDL_KEYDOWN:  // Ű   keydown() ȣ
				sym=event.key.keysym.sym;
				// keydown();
				//		    if(GetPlayerKey) PlayerKey();
				if(sym== SDLK_ESCAPE) 
					done = 1;  
				switch(sym) 
				{
					case 'W':    
					case 'w':
						setSpeed(speed);
						break;
					case 'S':    
					case 's':    
						setSpeed(-speed);
						break;
					default : 	    
						break;

				} // switch	
				
				break;	
			case  SDL_KEYUP :
				setSpeed(0);
				break;			
			case  SDL_MOUSEBUTTONDOWN:
				//printf("SDL_MOUSEBUTTONDOWN\n");
				break;			
			case  SDL_MOUSEBUTTONUP:
				//printf("SDL_MOUSEBUTTONDOWN\n");
				break;			

			case  SDL_MOUSEMOTION:
				if(event.motion.state)
				{
					t_rot+=float(event.motion.xrel);
					t_rotY+=float(event.motion.yrel);
				}
				break;			
		}
	}
}

// draw axis  x(red),y(green),z 
void draw_axes()
{
	// X axis  RED
	glColor3ub(255, 0, 0);
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(1.0, 0.0, 0.0);
    glVertex3f(0.75, 0.25, 0.0);
    glVertex3f(0.75, -0.25, 0.0);
    glVertex3f(1.0, 0.0, 0.0);
    glVertex3f(0.75, 0.0, 0.25);
    glVertex3f(0.75, 0.0, -0.25);
    glVertex3f(1.0, 0.0, 0.0);
    glEnd();
	
	// Y axis GREEN
	glColor3ub(0, 255, 0);
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(0.0, 1.0, 0.0);
    glVertex3f(0.0, 0.75, 0.25);
    glVertex3f(0.0, 0.75, -0.25);
    glVertex3f(0.0, 1.0, 0.0);
    glVertex3f(0.25, 0.75, 0.0);
    glVertex3f(-0.25, 0.75, 0.0);
    glVertex3f(0.0, 1.0, 0.0);
    glEnd();
	
	// Z axis BLUE
	glColor3ub(0, 0, 255);
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.0, 0.0, 0.0);
    glVertex3f(0.0, 0.0, 1.0);
    glVertex3f(0.25, 0.0, 0.75);
    glVertex3f(-0.25, 0.0, 0.75);
    glVertex3f(0.0, 0.0, 1.0);
    glVertex3f(0.0, 0.25, 0.75);
    glVertex3f(0.0, -0.25, 0.75);
    glVertex3f(0.0, 0.0, 1.0);
    glEnd();
}

