#include "font.h"

int getWindowHeight();
#define WCHAR_SIZE 256*4
static int fsize=0;
Font::Font(int sizea)
{
	int i;

	
	fsize=13;
	m_font_height = fsize;
	
	if(!TTF_WasInit() )
	{
		if(TTF_Init()==-1) {
			printf("TTF_Init: %s\n", TTF_GetError());
			exit(1);
		}
	}
	//font=TTF_OpenFont("VERDANAB.TTF", fsize);
	font=TTF_OpenFont(get_pathname("tahoma.ttf"), fsize);
	if(!font) {
		printf("TTF_OpenFont: %s\n", TTF_GetError());
		exit(1);
	}
	
	m_list_base = glGenLists (WCHAR_SIZE);

	for( i=0;i<WCHAR_SIZE;i++)
		wchars[i]=-1;
	wchars_count=0;
}

//MACRO 
void Font::make_wcahr_cache(wchar_t wch)
{
	if(wchars[wch]<0)
	{
		if(wchars_count>1024)
		{
			// remove a item;
		}
		make_font_wchar(wch);
		wchars[wch]=1;
	}
	///return self.wchars[char]
}

void Font::make_font_wchar(wchar_t ch)
{
	int w,max_h;
	int tw,th;
	GLuint tex_id;

	wchar_t str[2];
	SDL_Surface *text_surface;
	SDL_Color fcolor={0,0,0}; //???

	str[0]=ch;
	str[1]=0;

	// ***** not a height of the char !! max height==tex_h !! 
	if(TTF_SizeText(font,str,&w,&max_h)) {
		printf("TTF_SizeText: %s\n", TTF_GetError());
		exit(0);
	} 

	int minx, maxx, miny, maxy, advance;
	TTF_GlyphMetrics(font, ch, &minx,&maxx, &miny, &maxy, &advance);

	if(!(text_surface=TTF_RenderText_Solid(font,str, fcolor))) {
		printf("TTF_RenderText_Solid: %s\n", TTF_GetError());
		exit(0);
	}
	tw=text_surface->w;
	th=text_surface->h;


	//if(h!=21)
	
	
	if(text_surface->format->BitsPerPixel==32)
	{
		system_error("format =4 \n");
	}
	else if(text_surface->format->BitsPerPixel==24)
	{
		system_error("format =3 \n");
	}
	else if(text_surface->format->BitsPerPixel==8) // this works *********
	{
		// palette 8bit format !!
		//printf("format =8 \n");
		//printf("line size=%d \n",text_surface->pitch);
		//printf("BytePerPixel=%d \n",text_surface->format->BytesPerPixel);
	}
	else 
		system_error("format x \n");
	
	int i,j;
	unsigned char *b;
	b=(unsigned char *)text_surface->pixels;
	// make new color
	tw=text_surface->pitch;
	int len=th*tw;
	for(i=0; i< len ;i++) //	printf("%d\n",b[i]);
		if(b[i]>0)	b[i]=255; //1=>255


	if(0)
	for(i=0; i<th;i++)
	{
		for(j=0;j<tw;j++)
		{
			if(b[i*tw+j]>0)
				printf("#");
			else printf(" ");
		}
		printf("\n");
	}

	//printf("[%c|%d] fsize=%d h=%d th=%d w=%d tw=%d min_y=%d ymax=%d \n",ch,ch,fsize,max_h,th,w,tw,miny,maxy);
	char fname[32];
	//sprintf(fname,"%d.bmp",ch);	
	//SDL_SaveBMP (text_surface,fname);

	
	glGenTextures (1,&tex_id);
	glBindTexture (GL_TEXTURE_2D, tex_id);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,GL_CLAMP);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,GL_CLAMP);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	
	//this need OpenGL 2.0 more , not 2n size 
	//GL_ARB_texture_non_power_of_two
	//glTexImage2D( GL_TEXTURE_2D, 0,GL_LUMINANCE, text_surface->w, text_surface->h
	//		,0, GL_LUMINANCE, GL_UNSIGNED_BYTE, text_surface->pixels);
	int result;
	result=gluBuild2DMipmaps(GL_TEXTURE_2D,1,text_surface->w,text_surface->h,
			GL_LUMINANCE,GL_UNSIGNED_BYTE,text_surface->pixels);
	if(result) system_error("gluBuild2DMipmaps!");	    
		
	glNewList (m_list_base + ch, GL_COMPILE);
	glBindTexture (GL_TEXTURE_2D, tex_id);
	glBegin(GL_QUADS);
	// upside-down
	
	glTexCoord2f(0,1.0); 
	glVertex2f(0,0);
	glTexCoord2f(1.0,1.0); 
	glVertex2f(w,0);
	glTexCoord2f(1.0,0); 
	glVertex2f(w,max_h);
	glTexCoord2f(0,0); 
	glVertex2f(0,max_h);
	
//	glTexCoord2f(0,1.0); glVertex2f(0,max_h);
//	glTexCoord2f(0,0); glVertex2f(0,0);
//	glTexCoord2f(1.0,0); glVertex2f(w,0);
//	glTexCoord2f(1.0,1.0); glVertex2f(w,max_h);
	
	glEnd();
	glTranslatef(w, 0, 0);
	glEndList();

	SDL_FreeSurface(text_surface);
}

int Font::drawString (int x,int y,const wchar_t *str)
{
	int i;
	int len;
	float mat[16];

	y= getWindowHeight() - y - m_font_height;
	
//	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST); // Faster !
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_ONE,GL_DST_ALPHA);
	glBlendFunc(GL_ONE,GL_ONE);
		
	glLoadIdentity ();
	//#glListBase(self.m_list_base)
	glTranslatef (x,y,0);

	len=strlen(str);
	for( i=0 ;i<len;i ++)
	{
		make_wcahr_cache(str[i]);
		glCallList ( m_list_base +str[i] );
	}
	
	glGetFloatv(GL_MODELVIEW_MATRIX,mat);
	
	int width=(int)mat[12];
	width=width-x;
	return width; 

	//glBlendFunc(GL_ONE,GL_ZERO); // opengl default
}
