#ifndef UI_H
#define UI_H

#include "../system.h"
#include "widgets.h"
#include "font.h"


void setWindowHeight(int h);
void setFont(Font *);
void drawPoint(float x,float y,float z) ;

class UserInterface :public Widget
{
	public:
	UserInterface()
	{
	
	}
	UserInterface(SDL_Surface *surf):Widget()
	{
		Init(surf);
	}
	void Init(SDL_Surface *s)
	{
		width=s->w;
		height=s->h;
		setFont(new Font(13));
	}
	void setup2D()
	{
		glMatrixMode(GL_PROJECTION);
	//	glPushMatrix();
		glLoadIdentity();
		glOrtho( 0, width,0, height, -1, 1 );		
		glViewport(0,0,width,height);

		glMatrixMode(GL_MODELVIEW);
	//	glPushMatrix();
		glLoadIdentity();

		glDisable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);// #!!!
		glEnable(GL_SCISSOR_TEST);
		glDisable(GL_BLEND);
	//	glEnable(GL_BLEND);
	//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}

	void restore2D()
	{
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
	}

	void event(SDL_Event *e)
	{
		for(int i=0;i<children.size();i++)
			children[i]->handleEvent(e);
	}

	void setWindow(int x,int y,int w,int h) // clipping
	{
		int view[4];
		glGetIntegerv(GL_VIEWPORT, view );
		setWindowHeight(h);

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glOrtho( 0, w ,0,h, -10, 10 );
		if(x<0)
			glViewport(width-x,UserInterface::height- y -h + 1,w+2,h);
		else
			glViewport(x,UserInterface::height- y -h + 1,w+2,h);
		//glViewport(view[0]+x,view[1]+ h - y ,w,h);
		//glGet with argument GL_VIEWPORT
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

	//	glDisable(GL_DEPTH_TEST);
	//	glDisable(GL_TEXTURE_2D);// #!!!
	//	glEnable(GL_SCISSOR_TEST);
		glEnable(GL_BLEND);
	//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}

	void draw_widget(Widget *w)
	{
		Widget *ch;
		setWindow(w->x,w->y,w->width,w->height);
		//setWindow(w->x,w->y,w->width,w->height);
		w->Draw();
		//printf("draw_widget =%d\n",w->children.size());
		for(int i=0;i<w->children.size();i++)
		{
		//	printf("draw_widget\n");
			ch=w->children[i];
			draw_widget(ch);
		}
	}

	void Draw()
	{	
		Widget *w;
		setup2D();
		//printf("sizeui=%d\n",widgets.size());
		for(int i=0;i<children.size();i++)
		{
			w=children[i];
			if(w->visible) draw_widget(w);
		}
	}
	
/*	void Add(Widget *w)
	{
		widgets.add(w);
	}
*/
	private:
//	List <Widget*> widgets;
//	int width;
//	int height;
};

#endif
