#include "ui.h"
#include "widgets.h"



void Widget::addChild( Widget *w)
{
	children.add(w);
}

void Widget::add( Widget *w)
{
	children.add(w);
	w->setParent(this);
}


void Widget::setParent(Widget *parent_)
{
	parent=parent_;
}

void Widget::move(int x, int y)
{
	if( x < 0 and parent!=NULL )
		Widget::x=parent->width+x;
	else
		Widget::x=x;
	if( y < 0 and parent!=NULL )
		Widget::y=parent->height+y;
	else
		Widget::y=y;
}


void Widget::resize(int w, int h)
{
	width=w;
	height=h;
}

//SDL
void Widget::registerEvent(int eventType,void *handler)
{
	UI_Event *e =new UI_Event();
//	e->type;
//	e->handler=handler;
	
	events.add(e);
}


int Widget::handleEvent(SDL_Event *event)
{

	UI_Event *ev;

	for(int i=0;i<children.size();i++)
		if(children[i]->handleEvent(event)) 
			return 1;

	for(int i=0;i<events.size();i++)
	{
		ev=events[i];
		if (ev->type==UI_MOUSEBUTTONUP) 
		{
			ev->handler();
			return 1;
		}
		else
		if (ev->type==UI_MOUSEBUTTONUP) 
		{
			ev->handler();
			return 1;
		}
		else
		if (ev->type==UI_MOUSEMOTION) 
		{
			ev->handler();
			return 1;
		}
	
	}

	if (ev->type == SDL_MOUSEMOTION)
	{
	//	e->motion.state
	//	e->motion.x
	//	e->motion.y
	}
	return 0;
}

Frame::Frame(int x, int y,int w,int h) :Widget()
{
	move(x,y);
	resize(w,h);
	draw_func=NULL;
}

Frame::Frame(int x, int y,int w,int h,void (*drawx)()) :Widget()
{
	move(x,y);
	resize(w,h);
	//drawx();
	draw_func=drawx;
}


void Frame::Draw()
{
	if(draw_func)
	{
		draw_func();
		return;
	}
	//printf("Frame\n");
	setColor(32,64,32,32);
//	drawRect(0,0,width,height);
	setColor(128,128,128,255);
	//drawLine(0,0,width,0);
	//drawLine(0,1,width,1);
	//drawRectLine(0,0,width,height);
	//console_printf("Frame w=%d h=%d\n",width,height);
	setColor(0,0,255,128);
	drawString(0,0,"a Frame");
}

Console::Console(int x, int y,int w,int h) :Widget()
{
	move(x,y);
	resize(w,h);
}
// SLOW !!
void Console::Draw()
{
	//glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	setColor(32,64,32,64); drawRect(0,0,width,height); // very slow why ? LP 6%
	setColor(32,0,0,64); drawRectLine(0,0,width,height);
	
	setColor(32,255,32,255);
	// remove lines
	int s=lines.size()-7;
	if(s>0)
	{
		for(int i=0;i<s;i++)
			free(lines.pop_front());
		
		lines.reindex();
	}
	int i=0,l0=0;
	//printf("debugs.size=%d\n",debugs.size());
	int w=0;
	w+=drawString(w,0+2,"DEBUG: ");
	for(i=0;i<debugs.size();i++)	
	{
		//w+=drawString(w,0+2,debugs[i]) +20;
		drawString(w,0+2,debugs[i]);
		w+=strlen(debugs[i])*12;
	}

	l0=1;
	for(i=0;i<lines.size();i++) drawString(0,(l0+i)*20,lines[i]);

}

void Console::clear()
{
	lines.clear();		
}

void Console::addline(char *str)
{
	lines.add_str(str);		
}

void Console::debug(int token,char *str)
{
	char *p=debugs.replace(token,strdup(str));
	//console_printf("token=%x",p);
	if(p)		free(p);
	//free(debugs.replace(token,str));
}

int Console::debug_token()
{
	//int tok=debugs.size();
	//return tok;
	return debugs.add_str(" ");
}


void Console::debugclear()
{
	debugs.clear();		
}



void Console::printf(char *fmt,...)
{
			
}

Debug::Debug(int x, int y,int w,int h) :Widget()
{
	move(x,y);
	resize(w,h);
}

void Debug::Draw()
{
	setColor(32,64,32,64);
	drawRect(0,0,width,height);
	setColor(32,0,0,64);
	drawRectLine(0,0,width,height);
	
	setColor(64,215,64,255);
	for(int i=0;i<lines.size();i++)
		drawString(0,i*20,lines[i]);

}


void Debug::add(char *str)
{

};

