`timescale 1ns / 1ps
// ***********************************************************
// Copyright (c) VLSI & CAD Lab., Chungnam National Univ.
//                All rights reserved
//
// Design name      : 
// File name        : module1.v
// Author           : VLSI & CAD Lab
//
// Synthesis Library: 
// Simulator        : Model#Sim, ISE
// Limitations      : 
// Description      : 
// ***********************************************************?
module module1(clk,rst,inp,en,
				out1,out2,out3,out4,out5,out6,out7,out8,out9,out10,
				cnt32_out,cnt10_out,cnt30_out,cnt8_out,
				bl_m1,bl_m2,bl_m3,bl_m4,bl_m5,bl_m6,bl_m7,bl_m8,bl_m9,bl_m10,
				block_mean_vaild
			  );
	input clk, rst,en;
	input [7:0] inp;

  	output [18:0] out1;
  	output [18:0] out2;
  	output [18:0] out3;
  	output [18:0] out4;
  	output [18:0] out5;
  	output [18:0] out6;
  	output [18:0] out7;
  	output [18:0] out8;
  	output [18:0] out9;
  	output [18:0] out10;	
	
	output [9:0] bl_m1;
	output [9:0] bl_m2;
	output [9:0] bl_m3;
	output [9:0] bl_m4;
	output [9:0] bl_m5;
	output [9:0] bl_m6;
	output [9:0] bl_m7;
	output [9:0] bl_m8;
	output [9:0] bl_m9;
	output [9:0] bl_m10;
	
	output block_mean_vaild;
	reg block_mean_vaild;
	
	reg [9:0] bl_m1;
	reg [9:0] bl_m2;
	reg [9:0] bl_m3;
	reg [9:0] bl_m4;
	reg [9:0] bl_m5;
	reg [9:0] bl_m6;
	reg [9:0] bl_m7;
	reg [9:0] bl_m8;
	reg [9:0] bl_m9;
	reg [9:0] bl_m10;
	reg clear1,clear2,clear3,clear4,clear5,clear6,clear7,clear8,clear9,clear10;
	output [2:0] cnt8_out;
	output [3:0] cnt10_out;
	output [4:0] cnt30_out;
	output [4:0] cnt32_out;
	wire carry8,carry10,carry30,carry32;
	wire en1,en2,en3,en4,en5,en6,en7,en8,en9,en10;
	wire [7:0] inp;
		
	acc acc1 (clk,clear1 ,en1 ,inp, out1);
	acc acc2 (clk,clear2 ,en2 ,inp, out2);
	acc acc3 (clk,clear3 ,en3 ,inp, out3);
	acc acc4 (clk,clear4 ,en4 ,inp, out4);
	acc acc5 (clk,clear5 ,en5 ,inp, out5);
	acc acc6 (clk,clear6 ,en6 ,inp, out6);
	acc acc7 (clk,clear7 ,en7 ,inp, out7);
	acc acc8 (clk,clear8 ,en8 ,inp, out8);
	acc acc9 (clk,clear9 ,en9 ,inp, out9);
	acc acc10(clk,clear10,en10,inp,out10);
	
	cnt32 cnt32(clk,rst,en,cnt32_out,carry32);
	
	cnt10 cnt10(clk,rst,carry32,cnt10_out,carry10);
	
	cnt30 cnt30(clk,rst,carry10,cnt30_out,carry30);
	
	cnt8 cnt8(clk,rst,carry30,cnt8_out,carry8);
	
	cnt80 cnt80(clk,rst,block_mean_vaild,cnt80_out,);
	
	assign   en1 = (en & cnt10_out==0)  ? 1'b1 : 1'b0;
	assign   en2 = (en & cnt10_out==1)  ? 1'b1 : 1'b0;
	assign   en3 = (en & cnt10_out==2)  ? 1'b1 : 1'b0;
	assign   en4 = (en & cnt10_out==3)  ? 1'b1 : 1'b0;		
	assign   en5 = (en & cnt10_out==4)  ? 1'b1 : 1'b0;
	assign   en6 = (en & cnt10_out==5)  ? 1'b1 : 1'b0;
	assign   en7 = (en & cnt10_out==6)  ? 1'b1 : 1'b0;
	assign   en8 = (en & cnt10_out==7)  ? 1'b1 : 1'b0;
	assign   en9 = (en & cnt10_out==8)  ? 1'b1 : 1'b0;
	assign   en10 =(en & cnt10_out==9)  ? 1'b1 : 1'b0;
	
	always@(posedge clk or negedge rst)
		begin
			if (!rst)
				begin
					bl_m1<=0;bl_m2<=0;bl_m3<=0;bl_m4<=0;bl_m5<=0;bl_m6<=0;bl_m7<=0;bl_m8<=0;bl_m9<=0;bl_m10<=0;
					clear1 <=0;clear10 <=0;clear2 <=0;clear3 <=0;clear4 <=0;
					clear5 <=0;clear6 <=0;clear7 <=0; clear8 <=0;clear9<=0;
				end
			else if (cnt30_out==29 & cnt32_out==31)
				begin
					case (cnt10_out)              
						 0 : begin bl_m1  <= out1  [18:10]; block_mean_vaild <=1; clear1  <=0 ; end
						 1 : begin bl_m2  <= out2  [18:10]; block_mean_vaild <=1; clear2  <=0 ; end
						 2 : begin bl_m3  <= out3  [18:10]; block_mean_vaild <=1; clear3  <=0 ; end
						 3 : begin bl_m4  <= out4  [18:10]; block_mean_vaild <=1; clear4  <=0 ; end
						 4 : begin bl_m5  <= out5  [18:10]; block_mean_vaild <=1; clear5  <=0 ; end
						 5 : begin bl_m6  <= out6  [18:10]; block_mean_vaild <=1; clear6  <=0 ; end
						 6 : begin bl_m7  <= out7  [18:10]; block_mean_vaild <=1; clear7  <=0 ; end
						 7 : begin bl_m8  <= out8  [18:10]; block_mean_vaild <=1; clear8  <=0 ; end
						 8 : begin bl_m9  <= out9  [18:10]; block_mean_vaild <=1; clear9  <=0 ; end
						 9 : begin bl_m10 <= out10 [18:10]; block_mean_vaild <=1; clear10 <=0 ; end
						default
							begin	bl_m1<=0;bl_m2<=0;bl_m3<=0;bl_m4<=0;bl_m5<=0;bl_m6<=0;bl_m7<=0;bl_m8<=0;bl_m9<=0;bl_m10<=0; end
					endcase
				end
			else
				begin
					bl_m1<=0;bl_m2<=0;bl_m3<=0;bl_m4<=0;bl_m5<=0;bl_m6<=0;bl_m7<=0;bl_m8<=0;bl_m9<=0;bl_m10<=0;
			   		block_mean_vaild <=0;
			   		clear1 <=1;clear10 <=1;clear2 <=1;clear3 <=1;clear4 <=1;clear5 <=1;clear6 <=1;clear7 <=1;
			   		clear8 <=1;clear9<=1;
			    end
		end
 	
endmodule

module acc(clk,rst,en,inp,out); //  ###########################################
	input clk, rst,en; //Ŭ, , ο̺
	input [7:0] inp;   // 8bit Է
	output [15:0] out;  // 16bit 
	reg [15:0] out;
always@(posedge clk or negedge rst)
	begin
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		    out <=out+inp;
		else out <= out;
	end
endmodule       // #########################################################################


module cnt8(clk,rst,en,out,carry); // 8 ī ###########################################
	input clk, rst,en;
	output [2:0] out;
	output carry;
	reg [2:0] out;
	wire q7;
always@(posedge clk)
	begin
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q7) out <=0;
		else out <=out+1;
	end
assign q7 = (out==7);
assign carry = q7 & en;
endmodule       // #########################################################################

module cnt10(clk,rst,en,out,carry); // 10 ī ###########################################
	input clk, rst,en;
	output [3:0] out;
	output carry;
	reg [3:0] out;
	wire q9;
always@(posedge clk)
	begin
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q9) out <=0;
		else out <=out+1;
	end
assign q9 = (out==9);
assign carry = q9 & en;
endmodule       // #########################################################################

module cnt32(clk,rst,en,out,carry);  // 32 ī  ####################################
	input clk, rst,en;
	output [4:0] out;
	output carry;
	reg [4:0] out;
	wire q31;
always@(posedge clk)
	begin
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q31) out <=0;
		else out <=out+1;
	end
assign q31 = (out==31);
assign carry = q31 & en;
endmodule       // #########################################################################

module cnt30(clk,rst,en,out,carry); // 30 ī ###########################################
	input clk, rst,en;
	output [4:0] out;
	output carry;
	reg [4:0] out;
	wire q29;
always@(posedge clk)
	begin
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q29) out <=0;
		else out <=out+1;
	end
assign q29 = (out==29);
assign carry = q29 & en;
endmodule       // #########################################################################

module cnt80(clk,rst,en,out,carry); // 80 ī ###########################################
	input clk, rst,en;
	output [6:0] out;
	output carry;
	reg [6:0] out;
	wire q79;
always@(posedge clk)
	begin
		if(!rst) out <= 0;     // negative Reset 
		else if (en)		
		if(q79) out <=0;
		else out <=out+1;
	end
assign q79 = (out==79);
assign carry = q79 & en;
endmodule       // #########################################################################
