//
//  ٺ?
//
`timescale 1ns/1ps

module tw_tb_0;
    reg rst = 1'b1;
    reg clk = 1'b0;
    reg en = 1'b0;
    reg [7:0] inp = 8'b00000000;
    wire [17:0] out1;
    wire [17:0] out2;
    wire [17:0] out3;
    wire [17:0] out4;
    wire [17:0] out5;
    wire [17:0] out6;
    wire [17:0] out7;
    wire [17:0] out8;
    wire [17:0] out9;
    wire [17:0] out10;
    wire [4:0] cnt32_out;
    wire [4:0] cnt30_out;
    wire [3:0] cnt10_out;
    wire [2:0] cnt8_out;
    wire [6:0] block_mean_addr;
    wire [7:0] block_mean;
    wire frame_end;

    parameter PERIOD = 100;
    parameter real DUTY_CYCLE = 0.5;
    parameter OFFSET = 0;

    initial    // Clock process for clk
    begin
        #OFFSET;
        forever
        begin
            clk = 1'b0;
            #(PERIOD-(PERIOD*DUTY_CYCLE)) clk = 1'b1;
            #(PERIOD*DUTY_CYCLE);
        end
    end

    module1 UUT (
        .rst(rst),
        .clk(clk),
        .en(en),
        .inp(inp),
        .out1(out1),
        .out2(out2),
        .out3(out3),
        .out4(out4),
        .out5(out5),
        .out6(out6),
        .out7(out7),
        .out8(out8),
        .out9(out9),
        .out10(out10),
        .cnt32_out(cnt32_out),
        .cnt30_out(cnt30_out),
        .cnt10_out(cnt10_out),
        .cnt8_out(cnt8_out),
        .block_mean_addr(block_mean_addr),
        .block_mean(block_mean),
        .frame_end(frame_end)
);

        integer TX_ERROR = 0;
        
        initial begin  // Open the results file...
            #1100 // Final time:  1100 ns
            if (TX_ERROR == 0) begin
                $display("No errors or warnings.");
                end else begin
                    $display("%d errors found in simulation.", TX_ERROR);
                    end
                    $stop;
                end

                initial begin
                    // -------------  Current Time:  35ns
                    #35;
                    rst = 1'b0;
                    // -------------------------------------
                    // -------------  Current Time:  65ns
                    #30;
                    CHECK_frame_end(1'b0);
                    CHECK_out1(18'b000000000000000000);
                    CHECK_out2(18'b000000000000000000);
                    CHECK_out3(18'b000000000000000000);
                    CHECK_out4(18'b000000000000000000);
                    CHECK_out5(18'b000000000000000000);
                    CHECK_out6(18'b000000000000000000);
                    CHECK_out7(18'b000000000000000000);
                    CHECK_out8(18'b000000000000000000);
                    CHECK_out9(18'b000000000000000000);
                    CHECK_out10(18'b000000000000000000);
                    CHECK_cnt32_out(5'b00000);
                    CHECK_cnt30_out(5'b00000);
                    CHECK_cnt10_out(4'b0000);
                    CHECK_cnt8_out(3'b000);
                    CHECK_block_mean_addr(7'b0000000);
                    CHECK_block_mean(8'b00000000);
                    // -------------------------------------
                    // -------------  Current Time:  235ns
                    #170;
                    rst = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  335ns
                    #100;
                    en = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  365ns
                    #30;
                    CHECK_cnt32_out(5'b00001);
                    // -------------------------------------
                    // -------------  Current Time:  465ns
                    #100;
                    CHECK_cnt32_out(5'b00010);
                    // -------------------------------------
                    // -------------  Current Time:  565ns
                    #100;
                    CHECK_cnt32_out(5'b00011);
                    // -------------------------------------
                    // -------------  Current Time:  665ns
                    #100;
                    CHECK_cnt32_out(5'b00100);
                    // -------------------------------------
                    // -------------  Current Time:  765ns
                    #100;
                    CHECK_cnt32_out(5'b00101);
                    // -------------------------------------
                    // -------------  Current Time:  865ns
                    #100;
                    CHECK_cnt32_out(5'b00110);
                    // -------------------------------------
                    // -------------  Current Time:  965ns
                    #100;
                    CHECK_cnt32_out(5'b00111);
                    // -------------------------------------
                end

                task CHECK_out1;
                    input [17:0] NEXT_out1;

                    #0 begin
                        if (NEXT_out1 !== out1) begin
                            $display("Error at time=%dns out1=%b, expected=%b", $time, out1, NEXT_out1);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out2;
                    input [17:0] NEXT_out2;

                    #0 begin
                        if (NEXT_out2 !== out2) begin
                            $display("Error at time=%dns out2=%b, expected=%b", $time, out2, NEXT_out2);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out3;
                    input [17:0] NEXT_out3;

                    #0 begin
                        if (NEXT_out3 !== out3) begin
                            $display("Error at time=%dns out3=%b, expected=%b", $time, out3, NEXT_out3);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out4;
                    input [17:0] NEXT_out4;

                    #0 begin
                        if (NEXT_out4 !== out4) begin
                            $display("Error at time=%dns out4=%b, expected=%b", $time, out4, NEXT_out4);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out5;
                    input [17:0] NEXT_out5;

                    #0 begin
                        if (NEXT_out5 !== out5) begin
                            $display("Error at time=%dns out5=%b, expected=%b", $time, out5, NEXT_out5);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out6;
                    input [17:0] NEXT_out6;

                    #0 begin
                        if (NEXT_out6 !== out6) begin
                            $display("Error at time=%dns out6=%b, expected=%b", $time, out6, NEXT_out6);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out7;
                    input [17:0] NEXT_out7;

                    #0 begin
                        if (NEXT_out7 !== out7) begin
                            $display("Error at time=%dns out7=%b, expected=%b", $time, out7, NEXT_out7);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out8;
                    input [17:0] NEXT_out8;

                    #0 begin
                        if (NEXT_out8 !== out8) begin
                            $display("Error at time=%dns out8=%b, expected=%b", $time, out8, NEXT_out8);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out9;
                    input [17:0] NEXT_out9;

                    #0 begin
                        if (NEXT_out9 !== out9) begin
                            $display("Error at time=%dns out9=%b, expected=%b", $time, out9, NEXT_out9);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_out10;
                    input [17:0] NEXT_out10;

                    #0 begin
                        if (NEXT_out10 !== out10) begin
                            $display("Error at time=%dns out10=%b, expected=%b", $time, out10, NEXT_out10);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_cnt32_out;
                    input [4:0] NEXT_cnt32_out;

                    #0 begin
                        if (NEXT_cnt32_out !== cnt32_out) begin
                            $display("Error at time=%dns cnt32_out=%b, expected=%b", $time, cnt32_out, NEXT_cnt32_out);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_cnt30_out;
                    input [4:0] NEXT_cnt30_out;

                    #0 begin
                        if (NEXT_cnt30_out !== cnt30_out) begin
                            $display("Error at time=%dns cnt30_out=%b, expected=%b", $time, cnt30_out, NEXT_cnt30_out);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_cnt10_out;
                    input [3:0] NEXT_cnt10_out;

                    #0 begin
                        if (NEXT_cnt10_out !== cnt10_out) begin
                            $display("Error at time=%dns cnt10_out=%b, expected=%b", $time, cnt10_out, NEXT_cnt10_out);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_cnt8_out;
                    input [2:0] NEXT_cnt8_out;

                    #0 begin
                        if (NEXT_cnt8_out !== cnt8_out) begin
                            $display("Error at time=%dns cnt8_out=%b, expected=%b", $time, cnt8_out, NEXT_cnt8_out);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_block_mean_addr;
                    input [6:0] NEXT_block_mean_addr;

                    #0 begin
                        if (NEXT_block_mean_addr !== block_mean_addr) begin
                            $display("Error at time=%dns block_mean_addr=%b, expected=%b", $time, block_mean_addr, NEXT_block_mean_addr);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_block_mean;
                    input [7:0] NEXT_block_mean;

                    #0 begin
                        if (NEXT_block_mean !== block_mean) begin
                            $display("Error at time=%dns block_mean=%b, expected=%b", $time, block_mean, NEXT_block_mean);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_frame_end;
                    input NEXT_frame_end;

                    #0 begin
                        if (NEXT_frame_end !== frame_end) begin
                            $display("Error at time=%dns frame_end=%b, expected=%b", $time, frame_end, NEXT_frame_end);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
       

            endmodule

